#!/usr/bin/wish

# Copyright (c) 2002-2014, Botik Technologies, Ltd.
# See license.txt for more information.

# ================= Client =========================================================
# 
#
#     startClient { }
#     restartClient { {errLevel 1} }
#     writeLogChangeStatus { level typeState text }
#
# 
#
#     $botikkey(port)
#     $botikkey(d_password)
#     $botikkey(region_request)
#     $botikkey(region_by_server)
#     $botikkey(region_by_user)
#
#   
#
global bkClientRestartTime bkClientTimeOut bkClientPings bkClientSuccPings bkClientExpected bkClientSock bkClientExpectedRegion

set    bkClientRestartTime    3 ; #  ,   
set    bkClientTimeOut       60 ; #  , TimeOut      
set    bkClientPings          3 ; #  ping-       ...
set    bkClientSuccPings      1 ; # ...       ping-
set    bkClientExpected      { }; #    ()  -
set    bkClientSock          "" ; #  ( )
set    bkClientExpectedRegion WORLD ; #  

#  ping- -   
# $bkClientPings ,  $bkClientSuccPings .
#  0 --  ,   -- .

proc pingTest { host } {
   global bkClientPings bkClientSuccPings
   set lost 0
   set rec  0
   for {set i 1} {$i <= $bkClientPings} {incr i} {
      array set ping [rawPing $host] ; #  size=32 timeout=1000
      if {$ping(rec) == 1} {
         incr rec
         if {$rec >= $bkClientSuccPings} {
            return 0
         }
      } else {
         incr lost
      }
   }
   return $lost
}
proc restartClient {{errLevel 1}} {
   global bkClientRestartTime botikkey bkClientSock
   if {$botikkey(gbk)} {
       sendToGbk "give_me_status_name\n"
       sendToGbk "give_me_log\n$botikkey(gbk_logtime)"
       set botikkey(client_started) 1
       return
   }
   catch { disableReadableSocketHandler }
   catch { close $bkClientSock }
   set botikkey(client_started)   0
   set botikkey(region_by_server) NONE
   writeLogChangeStatus 0 RED "[strTime]  "
   if {$errLevel > 0} {
      forceLogWindow
   }
   return
}
proc startClient { } {
   global botikkey bkClientSock bkClientPings
   writeLogChangeStatus 3 GRAY "[strTime]  "
   if {$botikkey(gbk)} {
       sendToGbk "give_me_status_name\n"
       sendToGbk "give_me_log\n$botikkey(gbk_logtime)"
       set botikkey(client_started) 1
       connectKeyService
       return
   }
   set ip ""
   if {$botikkey(addr) eq ""} {
      #  IP Key-      :
      set ip [rawGateway]
      #set botikkey(addr) $ip
      if {[info exists ::bkOptions(addr)] && $::bkOptions(addr) eq "" && $ip != -1} {set ::bkOptions(addr) $ip}
      set ip ""
   } else {set ip $botikkey(addr)}
   if {[info exists ::bkOptions(addr)] && $::bkOptions(addr) eq "" && $ip != -1} {set ::bkOptions(addr) $ip}
   if {$ip eq -1} {
      writeLogChangeStatus 1 RED "[strTime] :    IP-  (rawGateway == -1)"
      restartClient
      return
   }
   if {$ip eq ""} {return}
   set lost [pingTest $ip]
   if {$lost > 1} {
      writeLogChangeStatus 1 RED \
         "[strTime] :   - \[$ip\] :  $bkClientPings ping- $lost "
      restartClient
      return
   } else {
      writeLogChangeStatus 3 YELLOW \
         "[strTime]  ping- \[$ip\] ([expr $bkClientPings-$lost]  $bkClientPings)"
   }
   writeLogChangeStatus 2 GRAY "[strTime]   -- open socket \[$ip:$botikkey(port)\]..."
   set ok 0
   set botikkey(server_address) $ip
   catch {
      catch {close $bkClientSock}
      set sock [socket $ip $botikkey(port)]
      fconfigure $sock -encoding koi8-r
      set ok 1
   } rc
   if {!$ok} {
      catch {close $sock}
      writeLogChangeStatus 1 RED "[strTime] :     -- [mkErrorCode $rc ", "]"
      restartClient
      return
   }
   writeLogChangeStatus 1 YELLOW "[strTime]  "
   set botikkey(client_started) 1
   set botikkey(time_last_read) [clock seconds]
   set bkClientSock $sock
   setExpected {BOTIKKEY}
   enableReadableSocketHandler
   return
}

proc enableReadableSocketHandler { } {
   global bkClientSock
   catch {fileevent $bkClientSock readable {readSocketHandler}}
   #after 100;
   return
}

proc disableReadableSocketHandler { } {
   global bkClientSock
   fileevent $bkClientSock readable ""
   return
}

proc readSocketHandler { } {
   global botikkey bkClientSock bkClientExpectedRegion bkClientTimeOut

   array set region2color { WORLD GREEN    LOCAL GREEN     NONE RED }
   disableReadableSocketHandler ; # -----------------  "readSocketHandler"

   set ok 0
   catch {
      set eof_sock [eof $bkClientSock]
      set ok 1
   } rc
   if { ! $ok } {
      writeLogChangeStatus 1 YELLOW "[strTime] :     \"eof\" -- [mkErrorCode $rc ", "]"
      restartClient
      return 0
   }
   if { $eof_sock } {
      writeLogChangeStatus 1 YELLOW "[strTime] :     -  \"end of file\""
      restartClient
      return 0
   }

   set ok 0
   catch {
      set text [gets $bkClientSock]
      set ok 1
   } rc
   if { ! $ok } {
      writeLogChangeStatus 1 YELLOW "[strTime] :     - -- [mkErrorCode $rc ", "]"
      restartClient
      return 0
   }

   set botikkey(time_last_read) [clock seconds]

   set tag unknown
   regexp {^(CHALLENGE|MESSAGE|BOTIKKEY|GOOD|SORRY|INFO) *(.*)[\r\n]*$} $text skip tag txt
   set expected [nowExpected]
   
   if { [lsearch -exact $expected $tag] < 0 } {
      writeLogChangeStatus 1 YELLOW \
            "[strTime] : protocol error --   - \{$expected\}, a : $text"
      restartClient
      return
   } else {
      switch $tag {
         BOTIKKEY  {
            set time 60
            writeLogChangeStatus 0 YELLOW "[strTime]   -: $text"
            foreach srv_kw $text {
                if {![string match "*=*" $srv_kw]} {continue}
                set spl [split $srv_kw "="]
                set param [lindex $spl 0]
                set value [lindex $spl 1]
                switch -- $param {
                    "TIMEOUT" {
                        catch {set time1 [expr {int($value)}]
                        if {$time1 > 0} {set time $time1}}
                    }
                    default {}
                }
            }
            set bkClientTimeOut $time
            writeLogChangeStatus 2 GRAY "[strTime]     -: $time ."
            setExpected {CHALLENGE MESSAGE INFO}
            connectKeyService
         }
         MESSAGE {
            set str "[strTime]     \"$::net(name)\":\n$txt"
            writeLogChangeStatus 0 BLUE $str
            forceLogWindow 1
            setExpected [nowExpected]; # nowExpected  
            displayInfo $str
         }
         INFO {
             displayInfo $txt
         }
         CHALLENGE {
            writeLogChangeStatus 2 GRAY "[strTime]    (challenge)..."
            set r1 0.0
            set r2 0.0
            set r3 0.0
            catch {set r1 [expr rand()]}
            catch {set r2 [expr rand()]}
            catch {set r3 [expr rand()]}
            set random [string tolower [::md5::md5 -hex -- "${r1}-${r2}-$r3"]]
            set bkClientExpectedRegion $botikkey(region_request) ; # WORLD | LOCAL | NONE
            set t "$txt$random$bkClientExpectedRegion$botikkey(d_password)"
            set digest [string tolower [::md5::md5 -hex -- $t]]
            writeLogChangeStatus 2 GRAY \
               "[strTime]    (response),   $bkClientExpectedRegion ..."
            set ok 0
            catch {
               set msg "RESPONSE $digest $random $bkClientExpectedRegion\n"
               puts -nonewline $bkClientSock $msg
               flush $bkClientSock
               set ok 1
            } rc
            if { ! $ok } {
               writeLogChangeStatus 1 YELLOW \
                  "[strTime] :     -- [mkErrorCode $rc ", "]"
               restartClient
               return 0
            }
            setExpected {GOOD SORRY MESSAGE INFO}
         }
         GOOD {
            #    /  ?
            set region $bkClientExpectedRegion
            regexp {^(WORLD|LOCAL|NONE)} $txt skip region
            set color YELLOW
            catch { set color $region2color($region) }
            set botikkey(region_request) [set botikkey(region_by_server) $region]
            write_accessmode
            if {$region ne $bkClientExpectedRegion} {
               #    $bkClientExpectedRegion,  : $region
               writeLogChangeStatus 0 $color "[strTime]  $bkClientExpectedRegion,\
                                                ,    $region,\
                                              - : $text"
               set botikkey(region_by_user) $region
               forceLogWindow
            } else {
               writeLogChangeStatus 0 $color "[strTime]   , - : $text"
            }
            setExpected {CHALLENGE MESSAGE INFO}
         }
         SORRY {
            writeLogChangeStatus 0 RED "[strTime]   , - : $text"
            if { $botikkey(region_by_server) ne "NONE" } {
               set botikkey(region_by_server) "NONE"
               forceLogWindow
            }
            setExpected {CHALLENGE MESSAGE INFO}
         }
      }
   }
  enableReadableSocketHandler
  return 1
}
proc setExpected {list} {
   set ::bkClientExpected $list
}
proc nowExpected {} {
   return $::bkClientExpected
}
proc readBatData {chan} {
    if {[eof $chan] || [catch {gets $chan data}]} {
        catch {close $chan}
        after 5000; # reconnect in 5 sec
        connectKeyService
        return
    }
    catch {fileevent $chan readable {}}
    set ::botikkey(time_recv) [clock seconds]
    if {![info exists data]} {return}
    foreach srv_kw $data {
        if {![string match "*=*" $srv_kw]} {continue}
        set spl [split $srv_kw "="]
        set param [lindex $spl 0]
        set value [lindex $spl 1]
        switch -- $param {
            "QUOTA" - "TIMEQUOTA" {
                catch {set ::botikkey(timequota) [expr {int($value/60)}]}
            }
            "USED" - "TIMEUSED" {
                catch {set ::botikkey(timeused)  [expr {int($value/60)}]}
            }
            "LEFT" - "TIMELEFT" {
                catch {set ::botikkey(timeused)  [expr {int(($::botikkey(timequota) - $value)/60)}]}
                if {$::botikkey(timeused) < 0} {set ::botikkey(timeused) 0}
            }
            "VERSION" {}
            default {}
        }
    }
    fileevent $chan readable [list readBatData $chan]
}
# find the nearest server with open battery port
proc bat_testChan {addr chan} {
    set ::botikkey(server_address) $addr
    catch {close $chan}
}
proc bat_findGateway {} {
    global ping
    set port 12050
    catch {
    rawTraceroute nadmin.$::net(domain)
    for {set i 1} {$i < $ping(trrt_ip,N)} {incr i} {
        catch {
            set addr $ping(trrt_ip,$i)
            set chan [socket $addr $port]
            after 5000 "catch {close $chan}"
            fconfigure $chan -buffering line -blocking 0
            fileevent $chan readable [list bat_testChan $addr $chan]
        }
    }}
}
proc connectKeyService {} {
    set port 12050
    if {$::botikkey(server_address) eq ""} {bat_findGateway}
    if {$::botikkey(server_address) eq ""} {return}
    set server $::botikkey(server_address)
    catch {close $::botikkey(batchan)}
    catch {
        set ::botikkey(batchan) [socket $server $port]
        fconfigure $::botikkey(batchan) -buffering line -blocking 0
        fileevent $::botikkey(batchan) readable [list readBatData $::botikkey(batchan)]
    }
}
proc writeLogChangeStatus { level typeState text } {
   if {$::botikkey(gbk)} {return}
   dolog $text
   writeLog $level $typeState $text
   if {[lsearch -exact {RED YELLOW GREEN} $typeState] >= 0} {
      changeStatus $typeState
   }
   return
}
proc tk_dialog_ok {w title text bitmap default args} {
    global tcl_platform
    variable ::tk::Priv
    if {[string is integer -strict $default]} {
        if {$default >= [llength $args]} {
            return -code error "default button index greater than number of\
                    buttons specified for tk_dialog"
        }
    } elseif {"" eq $default} {
        set default -1
    } else {
        set default [lsearch -exact $args $default]
    }
    set windowingsystem [tk windowingsystem]
    if {$windowingsystem eq "aqua"} {
        option add *Dialog*background systemDialogBackgroundActive widgetDefault
        option add *Dialog*Button.highlightBackground \
                systemDialogBackgroundActive widgetDefault
    }
    destroy $w
    toplevel $w -class Dialog
    wm title $w $title
    wm iconname $w Dialog
    #wm protocol $w WM_DELETE_WINDOW { }
    if {[winfo viewable [winfo toplevel [winfo parent $w]]] } {
        wm transient $w [winfo toplevel [winfo parent $w]]
    }
    if {$windowingsystem eq "aqua"} {
        ::tk::unsupported::MacWindowStyle style $w moveableModal {}
    }
    frame $w.bot
    frame $w.top
    if {$windowingsystem eq "x11"} {
        $w.bot configure -relief raised -bd 1
        $w.top configure -relief raised -bd 1
    }
    pack $w.bot -side bottom -fill both
    pack $w.top -side top -fill both -expand 1
    grid anchor $w.bot center
    option add *Dialog.msg.wrapLength 3i widgetDefault
    option add *Dialog.msg.font TkCaptionFont widgetDefault
    label $w.msg -justify left -text $text
    pack $w.msg -in $w.top -side right -expand 1 -fill both -padx 3m -pady 3m
    if {$bitmap ne ""} {
        if {$windowingsystem eq "aqua" && $bitmap eq "error"} {
            set bitmap "stop"
        }
        label $w.bitmap -bitmap $bitmap
        pack $w.bitmap -in $w.top -side left -padx 3m -pady 3m
    }
    set i 0
    foreach but $args {
        button $w.button$i -text $but -command "destroy $w"
        if {$i == $default} {
            $w.button$i configure -default active
        } else {
            $w.button$i configure -default normal
        }
        grid $w.button$i -in $w.bot -column $i -row 0 -sticky ew \
                -padx 10 -pady 4
        grid columnconfigure $w.bot $i
        if {$windowingsystem eq "aqua"} {
            set tmp [string tolower $but]
            if {$tmp eq "ok" || $tmp eq "cancel"} {
                grid columnconfigure $w.bot $i -minsize 90
            }
            grid configure $w.button$i -pady 7
        }
        incr i
    }
    if {$default >= 0} {
        bind $w <Return> "destroy $w"
    }
    wm withdraw $w
    update idletasks
    set x [expr {[winfo screenwidth $w]/2 - [winfo reqwidth $w]/2 \
            - [winfo vrootx [winfo parent $w]]}]
    set y [expr {[winfo screenheight $w]/2 - [winfo reqheight $w]/2 \
            - [winfo vrooty [winfo parent $w]]}]
    if {$x < 0} {
        set x 0
    }
    if {$y < 0} {
        set y 0
    }
    wm maxsize $w [winfo screenwidth $w] [winfo screenheight $w]
    wm geometry $w +$x+$y
    wm deiconify $w
    return 1
}
#    .    "OK",
#    .  ,    
#      
proc displayInfo {msg} {
    for {set i 0} {$i < 10} {incr i} {
        if {![winfo exists .mw.dlg$i]} {
            if {[catch {
                tk_dialog_ok .mw.dlg$i "" $msg "" 0 "OK"; # no wait for user reaction
            }]} {
                tk_dialog .mw.dlg$i "" $msg "" 0 "OK"
            }
            return 1
        }
    }
    return 0
}
proc bk_exe {} {
    return [expr {[info exists ::bt_exe] && $::bt_exe}]
}
proc debug {msg} {dolog "[strTime] $msg"}
# ;
#  BotikKey     C:\Program Files\Botik Tools\Botik\,
#   %APPDATA%\BotikTools\,      .
proc dolog {msg} {
    set ok 0
    catch {
        set f [open $::botikkey(log) a]
        set ok 1
    }
    if {!$ok} {
        set ::botikkey(log) [appFile botikkey.log]
        catch {
            set f [open $::botikkey(log) a]
            set ok 1
        }
    }
    if {!$ok} {return}
    set str [string trimright "$msg" "\n"]
    catch {
        puts $f $str
        close $f
    }
    set fsz 0
    if {[file exists $::botikkey(log)]} {
        catch {
            set fsz [file size $::botikkey(log)]
            if {$fsz >= 5*1024*1024} { # 5 MB
                file delete -force $::botikkey(log)
            }
        }
    }
}
proc write_accessmode {} {
    global botikkey
    if {[llength $botikkey(region_by_server)]} {
        catch {
            set fd [open $botikkey(mode_file) w]
            puts $fd "$botikkey(region_by_server) [clock seconds]"
            close $fd
        }
    }
}
proc sendToGbk {msg} {
    global botikkey
    if {[info exists ::bkOptions(addr)] && [llength $::bkOptions(addr)]} {
        set ip $::bkOptions(addr)
    } else {
        set ip $botikkey(gbk_ip)
    }
    set chan ""
    catch {
        set chan [socket -async $ip 7737]
    }
    if {![llength $chan]} {return}
    after 10000 "catch {close $chan}"
    fconfigure $chan -buffering line -blocking 0 -translation binary
    fileevent $chan writable [list gbk_writeData $chan $msg]
}
proc gbk_writeData {chan msg} {
    catch {fileevent $chan writable {}}
    catch {
        puts $chan $msg; flush $chan
        fileevent $chan readable [list gbk_readData $chan]
    }
    return
}
proc gbk_readData {chan} {
    if {[eof $chan] || [catch {gets $chan data}]} {
        catch {close $chan}
        return
    }
    if {![llength $data]} {return}
    set data [string trimright $data [list \n \r]]
    array set region2color { WORLD GREEN LOCAL GREEN NONE RED }
    # analyze answer in $data
    switch -glob -- $data {
        WORLD - LOCAL - NONE {
            set ::botikkey(region_by_server) $data
            set clr $region2color($data)
            changeStatus $clr
        }
        https* {
            set ::botikkey(gbk_link) $data
        }
        UNKNOWN - ok {}
        default {
            foreach line [split $data \n] {
                if {$line eq "startoflog" || $line eq "endoflog"} {continue}
                set t [lindex $line 0]
                if {[string is integer -strict $t]} {
                    set ::botikkey(gbk_logtime) $t
                    set line [lrange $line 1 end]
                }
                set parts [split $line ";"]
                set date [lindex $parts 0]
                set pri [lindex $parts 1]
                set msg [lindex $parts 2]
                set newpri 0
                set clr "YELLOW"
                set colors {BLUE GRAY GRAY RED RED YELLOW GREEN}
                if {[string is integer -strict $pri] && $pri >= 1 && $pri <= 5} {
                    set newpri [expr {4 - $pri}]
                    if {$newpri < 0} {set newpri 0}
                    set clr [lindex $colors $pri]
                    if {$pri == 3} {
                        if {[string match *WORLD* $msg] || [string match *LOCAL* $msg]} {
                            set clr "GREEN"
                        } elseif {[string match *NONE* $msg] || [string match *SORRY* $msg]} {
                            set clr "RED"
                        }
                    }
                    if {$pri == 1 && [string match *Connected* $msg]} {
                        set clr "BLUE"
                    }
                }
                writeLog $newpri $clr [getStr "$date $msg"]
            }
        }
    }
    return
}
proc getStr {str} {
    return [string trim [string map {\{ "" \} "" | ""} $str]]
}
proc ftime {} {
    return [clockFormat "%Y-%m-%d %X"]
}
proc chooseEnding {min} {
    if {![string is integer $min] || $min < 0} {return}
    if {$min <= 60} {
        # if less than hour
        set rem10  [expr {$min % 10}]
        set rem100 [expr {$min % 100}]
        if {($rem100 >= 11 && $rem100 <= 14) || $rem10 == 0 || ($rem10 >= 5 && $rem10 <= 9)} {
            return " $min "
        }
        if {[lsearch -exact -integer {2 3 4} $rem10] > -1} {
            return " $min "
        }
        if {$rem10 == 1} {
            return " $min "
        }
    } else {
        # if more than hour left until tariff ends
        set hours  [expr {int($min/60)}]
        set rem10  [expr {$hours % 10}]
        set rem100 [expr {$hours % 100}]
        if {($rem100 >= 11 && $rem100 <= 14) || $rem10 == 0 || ($rem10 >= 5 && $rem10 <= 9)} {
            return "  $hours "
        }
        if {[lsearch -exact -integer {2 3 4} $rem10] > -1} {
            return "  $hours "
        }
        if {$rem10 == 1} {
            return "  $hours "
        }
    }
    return
}
proc initNotifcn {n msg} {
    global botikkey
    hideNotifcn $n
    set botikkey(notifcn$n,show)    0
    set botikkey(notifcn$n,access)  $botikkey(notifcn,str_nochange)
    set botikkey(notifcn$n,access_) $botikkey(notifcn$n,access)
    set botikkey(notifcn$n,icon)    ""
    set botikkey(notifcn$n)         $msg
    set botikkey(notifcn$n,short)   $msg
}
proc logNotifcn {text} {
   dolog "[strTime] $text"
   writeLog 0 YELLOW "[strTime] $text"
}
proc fromkoi {str} {
    return [encoding convertfrom koi8-r $str]
}
proc set_info_time {} {
    set ::botikkey(time_last_info_read) [clock seconds]
}
# save last msgID
proc update_msgid {newid} {
    global botikkey
    set botikkey(lastmsgid) $newid
    catch {set f [open $botikkey(msgid_file) w]
    puts -nonewline $f $newid; close $f}
}
#  ,     
proc process_informer_data {info} {
    global botikkey
    if {[llength $info] == 0} {return 1}
    set info [split $info \n]
    set firstline [string tolower [lindex $info 0]]
    if {[string match "*sorry*" $firstline]} {set_info_time; return 1}
    foreach line $info {
        set line [string trimright $line]
        if {$line eq "" || [string index $line 0] eq "#"} {continue}
        set spl   [split $line ":"]
        set param [string trim [string tolower [lindex $spl 0]]]
        set value [string trim [lrange $spl 1 end] {\{ \} " "}]
        if {[string is integer -strict $param] && [string length $param]==14} {
            set cpos [string first ":" $line]
            set msg [string range $line [incr cpos] end]
            if {$param > $botikkey(lastmsgid) && [displayInfo $msg]} {
                update_msgid $param
            }
            continue
        }
        if {[llength $value]} {
            set botikkey(notifcn,$param) $value
            if {$param eq "left" && [string is double -strict $value]} {
                set botikkey(balance) [format "%.2f" $value]
                set botikkey(notifcn,left) $botikkey(balance)
            }
        } else {
            switch -- $param {
                "org" - "ip" - "name" {
                    set botikkey(notifcn,$param) ""
                }
                "time" - "left" - "pb" - "tarifftime" - "tariff_speed" - "port_speed" - "fromcache" {
                    set botikkey(notifcn,$param) 0
                }
                "tariff" - "nexttariff" {
                    set botikkey(notifcn,$param) $botikkey(notifcn,str_smallwalk)
                }
                default {
                    debug "  ,   : $line"
                    continue
                }
            }
            if {$param eq "left"} {
                set botikkey(balance) "N/A"
                set botikkey(notifcn,left) $botikkey(balance)
            }
        }
        if {$param eq "tariff"} {
            set botikkey(notifcn,tariff) [string trim [wrapLines 12 $botikkey(notifcn,tariff)]]
            set botikkey(tariff) $botikkey(notifcn,tariff)
            update idletasks
        }
    }
    if {[string is integer -strict $botikkey(notifcn,time)] && $botikkey(notifcn,time) > 0} {
        set botikkey(notifcn,timeskew) [expr {[clock seconds] - $botikkey(notifcn,time)}]
    }
    if {$botikkey(balance) ne "N/A" && [clock seconds] - $botikkey(lastdebug) >= 5*60} {
        set botikkey(lastdebug) [clock seconds]; # every 5 minutes:
        logNotifcn "($botikkey(notifcn,org))   : $botikkey(balance) ., : $botikkey(notifcn,pb) ., : [strTime3 $botikkey(notifcn,time)]"
    }
    set_info_time
    return 0
}
#     ,  
proc infoHandler {token} {
    global botikkey
    upvar #0 $token state
    #debug $state(body)
    if {[info exists state(http)] && [lindex $state(http) 1] == 500} {set_info_time; return}
    if {![info exists state(status)] || $state(status) eq "timeout"} {set_info_time; return}
    if {![info exists state(body)] || $state(body) eq ""} {set_info_time; return}
    if {![process_informer_data $state(body)]} {
        checkAbonInfo
        setMainIconText
    }
    return
}
proc readAbonInfo {} {
    global botikkey
    set_info_time
    if {[windowsPlatform]} {
        make_async_informer_request
        return
    }
    if {!$botikkey(notifcn,on)} {return}
    set query [get_informer_query]
    #debug "$botikkey(url_info)?$query"
    set hostname [lindex [split [lindex [file split $botikkey(url_info)] 1] .] 0]
    if {[connTest $hostname]} {
        http::geturl $botikkey(url_info) -query $query -command infoHandler -timeout 20000
    } else {
        checkAbonInfo
    }
    return
}
# tooltip       
proc getMainIconText {} {
    global botikkey
    array set names $botikkey(modenames)
    set res ""
    set mode $names($botikkey(region_by_server))
    if {$botikkey(notifcn,left) ne "N/A" && [string is double -strict $botikkey(notifcn,left)]} {
        set maininfo ": $botikkey(notifcn,left) .\n: $botikkey(notifcn,tariff)\n: $botikkey(notifcn,pb) .\n: [strTime3 $botikkey(notifcn,time)]"
        #set addinfo "\n: $botikkey(notifcn,org)"
        set addinfo ""; set addinfo2 ""
        if {[string is integer -strict $botikkey(notifcn,tarifftime)] && $botikkey(notifcn,tarifftime) > 0} {
            set addinfo2 "\n : [strTime3 $botikkey(notifcn,tarifftime)]"
        }
        #if {[string is integer -strict $botikkey(notifcn,tariff_speed)] && $botikkey(notifcn,tariff_speed) > 0}
        #  append addinfo2 "\n  : [expr {$botikkey(notifcn,tariff_speed)/1000}] /"
        if {[string is integer -strict $botikkey(notifcn,port_speed)] && $botikkey(notifcn,port_speed) > 0} {
            append addinfo2 "\n  : [expr {$botikkey(notifcn,port_speed)/1000}] /"
        }
        set len [string length $maininfo$addinfo$addinfo2]
        #      127 ,    
        if {$len < 128} {
            append res $maininfo$addinfo$addinfo2
        } else {
            set len [string length $maininfo$addinfo2]
            if {$len < 128} {
                append res $maininfo$addinfo2
            } else {
                append res $maininfo
            }
        }
    } else {set res $mode}
    return $res
}
proc setMainIconText {} {
    catch {set pos 0; set pos [lindex [findTraybarIconPos] 0]}
    catch {winico taskbar modify $::botikkey(mainicon) -pos $pos -text [getMainIconText]}
}
proc checkAbonInfo {} {
    global botikkey
    #    ,       ;
    #    , ,      ,
    if {!$botikkey(notifcn,on)} {return}; #   
    #    :
    if {$botikkey(balance) ne "N/A"} {
        if {$botikkey(balance) < $botikkey(notifcn,pb)} {
            # 1)  < 
            set botikkey(notifcn1,short) "    ($botikkey(balance) .)    ($botikkey(notifcn,pb) .)."
            set botikkey(notifcn1) "$botikkey(notifcn1,short)   ."
            if {!$botikkey(notifcn1,show) && $botikkey(notifcn1,access) ne $botikkey(notifcn,str_nochange) && $botikkey(notifcn1,access) ne $botikkey(region_request)} {
                logNotifcn "$botikkey(notifcn1,short)    ,   $botikkey(notifcn1,access)."
                newAccessRegion2 $botikkey(notifcn1,access)
                forceLogWindow
            }
            showNotifcn 1
        } else {
            set botikkey(notifcn1,show) 0
            hideNotifcn 1
        }
    }
    set delta [expr {$botikkey(notifcn,tarifftime) - ([clock seconds] - $botikkey(notifcn,timeskew))}]
    if {$botikkey(notifcn,tariff) ne $botikkey(notifcn,nexttariff) && $delta >= 0 && $delta <= 3600*24} {
        # 2)     (  )
        set mins [expr {int($delta/60)}]
        if {$mins > 0} {
            set left [chooseEnding $mins]
        } else {
            set left "  "
        }
        set botikkey(notifcn2,short) "     \"$botikkey(notifcn,tariff)\" $left"
        #set botikkey(notifcn2) "$botikkey(notifcn2,short);        $botikkey(notifcn,nexttariff)".
        set botikkey(notifcn2) $botikkey(notifcn2,short)
        if {!$botikkey(notifcn2,show) && $botikkey(notifcn2,access) ne $botikkey(notifcn,str_nochange) && $botikkey(notifcn2,access) ne $botikkey(region_request)} {
            logNotifcn "$botikkey(notifcn2,short).    ,   $botikkey(notifcn2,access)."
            newAccessRegion2 $botikkey(notifcn2,access)
            forceLogWindow
        }
        showNotifcn 2
    } elseif {$botikkey(notifcn,tariff) ne "N/A" && $botikkey(notifcn,nexttariff) ne "N/A"} {
        set botikkey(notifcn2,show) 0
        hideNotifcn 2
    }
    if {[info exists botikkey(notifcn,message)]} {
        # just for the case
        initNotifcn 3 $botikkey(notifcn,message)
        showNotifcn 3
        unset botikkey(notifcn,message)
    }
    return
}
proc notifcn_init_values {} {
    global botikkey
    set botikkey(tariff)             "N/A"; #  
    set botikkey(notifcn,left)       "N/A"
    set botikkey(balance)            "N/A"
    set botikkey(notifcn,pb)         0
    set botikkey(notifcn,tarifftime) 0
    set botikkey(notifcn,time)       0
    set botikkey(notifcn,timeskew)   0
}

#    
proc make_async_informer_request {} {
    if {!$::botikkey(notifcn,on)} {return}
    set url "$::botikkey(url_info)?[get_informer_query]"
    if {$::botikkey(gbk) && [info exists ::botikkey(gbk_link)]} {
        set url $::botikkey(gbk_link)
        sendToGbk "give_me_informer_url\n"
    } elseif {$::botikkey(gbk)} {
        sendToGbk "give_me_informer_url\n"
    }
    notifcn_init_values
    #    (thread)  HTTPS-  ;
    #    ,    URL  ;
    #    5       :
    informer_start $url
    set info ""
    catch {
        set info [get_informer_data]
    }
    if {[llength $info] && ![process_informer_data $info]} {
        setMainIconText
    }
    checkAbonInfo
}
proc get_informer_data {} {
    set data  [informer_data]; #   
    set text  [encoding convertfrom koi8-r $data]
    set flist {org ip time name left pb tariff nexttariff tarifftime fromcache}
    set res   ""
    foreach line [split $text \n] {
        if {![llength $line]} {continue}
        set par [lindex [split $line :] 0]
        #   ,   HTTP:
        if {[lsearch $flist $par] > -1 || [string is integer -strict $par]} {
            append res $line\n
        }
    }
    return $res
}
proc get_informer_query {} {
    catch {set r1 0.0; set r1 [expr rand()]}
    catch {set r2 0.0; set r2 [expr rand()]}
    catch {set r3 0.0; set r3 [expr rand()]}
    set random [string tolower [md5::md5 -hex -- "${r1}-${r2}-$r3"]]
    set digest [string tolower [md5::md5 -hex -- "$random$::botikkey(d_password)"]]
    set query "type=botikkey&random=${random}&digest=$digest&info=$::botikkey(lastmsgid)"
    return $query
}
proc isidletime {str} {
    return [expr {[string match "*s" $str] || [string match "*:*" $str]}]
}
proc idletimesec {str} {
    set tm -1
    catch {
    if {[string match "*s" $str]} {
        set s [string range $str 0 end-1]
        set tm [expr {int($s)}]
    } elseif {[string match "*:*m" $str]} {
        set s [string range $str 0 end-1]
        set spl [split $s ":"]
        set hours [lindex $spl 0]
        set mins [lindex $spl 1]
        set tm [expr {$hours * 3600 + $mins * 60}]
    } else {
        set spl [split $str ":"]
        set mins [lindex $spl 0]
        set sec [lindex $spl 1]
        set tm [expr {$mins * 60 + $sec}]
    }}
    return $tm
}
proc getUnixIdletime {} {
    set user ""
    set itime -1
    catch {set user $::env(USER)}
    catch {
    set res [exec w]
    set spl [split $res \n]
    foreach line $spl {
        if {![llength $line]} {continue}
        set u [lindex $line 0]
        set tm [string trim [lindex $line 4]]
        if {$u eq $user && [isidletime $tm]} {
            set time [idletimesec $tm]
            if {$itime < 0 && $time >= 0} {
                set itime $time
            } elseif {$itime >= 0 && $time >= 0 && $time < $itime} {
                set itime $time; # the smallest idle time
            }
        }
    }}
    return $itime
}
proc getMacIdletime {} {
    set user ""
    set itime -1
    catch {set user $::env(USER)}
    catch {
    set res [exec w]
    set spl [split $res \n]
    foreach line $spl {
        if {![llength $line]} {continue}
        set u [lindex $line 0]
        set tm [string trim [lindex $line 4]]
        if {$tm eq "-"} {set tm 0}
        if {[string match "*:*" $tm]} {
            set spl [split $tm ":"]
            set hours [lindex $spl 0]
            set mins [lindex $spl 1]
            set tm [expr {$hours * 3600 + $mins * 60}]
        } elseif {[string match "*days" $tm]} {
            set tm [string range $tm 0 end-4]
            set tm [expr {$tm * 24 * 3600}]
        } elseif {[string is integer -strict $tm]} {
            set tm [expr {$tm * 60}]; # mins to seconds
        }
        if {$u eq $user && [string is integer -strict $tm]} {
            set time $tm
            if {$itime < 0 && $time >= 0} {
                set itime $time
            } elseif {$itime >= 0 && $time >= 0 && $time < $itime} {
                set itime $time; # the smallest idle time
            }
        }
    }}
    return $itime
}
# detect user idle time (in seconds)
proc user_idle_time {} {
    set t 0
    if {[windowsPlatform]} {
        catch {set t [informer_idle_time]}
    } elseif {[unixPlatform]} {
        set t [getUnixIdletime]
        if {$t < 0} {set t 0}
    } elseif {[macPlatform]} {
        set t [getMacIdletime]
        if {$t < 0} {set t 0}
    }
    return $t
}
proc checkIdleTime {} {
    if {![isBatteryTariff]} {return}
    if {[winfo ismapped .]} {
        draw_battery_frame
    }
    set t [user_idle_time]
    updateBatRegion
    set ut [lindex $::botikkey(stoptime) 0]
    if {[string is integer -strict $ut]} {
        if {$t/60 >= $ut && $::botikkey(region_by_user) ne "NONE"} {
            setBatRegion
        }
    }
}
proc clientMainLoop {} {
    while {1} {
        checkIdleTime
        if {!$::botikkey(client_started)} {
            startClient
        } elseif {[clock seconds] - $::botikkey(time_last_read) > $::bkClientTimeOut} {
            writeLogChangeStatus 0 RED "[strTime]      "
            restartClient
        }
        if {[clock seconds] - $::botikkey(time_last_info_read) >= $::botikkey(info_timeout)} {
            catch {readAbonInfo}
        }
        after [expr {1000*$::botikkey(restart_check_timeout)}] {set ::botikkey(nextaction) 1}
        vwait ::botikkey(nextaction)
    }
}
