#!/usr/bin/wish

# Copyright (c) 2003-2014, Botik Technologies, Ltd.
# See license.txt for more information.

proc initValues {} {
   global botikkey whoami positions

   # ,      :
   set botikkey(name)       "Botik Key"         ; # 
   set botikkey(ver)        1.65                ; #  
   set botikkey(ver_date)   "15  2014 "   ; #   
   set botikkey(addr)       ""                        ; #  -a,    ,     IP 
   set botikkey(port)       12040                     ; # 
   set botikkey(d_password) [pswdToKey  ""] ;          #  
   set botikkey(md5_empty)  $botikkey(d_password);     # :   
   set botikkey(save_pswd) 1 ;                         # 1 ==   ; 2 ==   ;
                                                       # 3 ==    ; 4 ==    
   set botikkey(user_pswd_file) "**  **" ; #     
   set botikkey(dflt_pswd_file) [appFile botik_key.pswd]; #     
   set botikkey(init_file)      [appFile botik_key.init]; #   
   set botikkey(mode_file)      [appFile accessmode.txt]; #     
   
   set ::botiktools(progname) $botikkey(name)
   set botikkey(verbose)    1 ;             #   (0,1,2,3)
   set botikkey(minimized)  1 ;             #   ? (0 1)
   set botikkey(showLog)    0 ;             #       (0 1)
   set botikkey(icontype)   2 ;             #   (0, 1, 2 -- )
   set botikkey(iconwindow) .icon
   #
   #    (    $botikkey(icontype)):
   #
   #                  -Windows: 0          1 - Windows               2 - Windows +   
   set botikkey(RED)         {img/botik_none.gif    img/botik_red.ico         img/red.ico}
   set botikkey(YELLOW)      {img/botik_wait.gif    img/botik_yellow.ico      img/yellow.ico}
   set botikkey(GREEN)       {img/botik_world.gif   img/botik_green.ico       img/green.ico}
   set botikkey(GREEN_LOCAL) {img/botik_local.gif   img/botik_green_local.ico img/green_local.ico}
   set botikkey(gbk) 0
   set botikkey(gbk_logtime) 1
   set botikkey(gbk_ip) 192.168.1.1

   array set positions {img/green.ico 0 img/green_local.ico 1 img/red.ico 2 img/yellow.ico 3 img/botik_green.ico 0 img/botik_green_local.ico 1 img/botik_red.ico 2 img/botik_yellow.ico 3}
   set botikkey(modenames) {WORLD " " LOCAL " " NONE " "}
   #
   if {[windowsPlatform]} {
       set botikkey(currentIcon) [lindex $botikkey(YELLOW) 2]
       set botikkey(info_timeout) 60
   } else {
       set botikkey(currentIcon) [lindex $botikkey(YELLOW) 0]
       set botikkey(info_timeout) [expr {5*60}]; # (seconds)  5   -     ( ,      .)
   }
   set botikkey(timeForNextShowMessage) [expr {[clock seconds] - 10}]
   #
   set botikkey(start_date) "19  2003 "             ; #   
   set botikkey(url)        http://www.botik.ru/~botik/key/   ; #   
   set botikkey(url_tools)  http://www.botik.ru/~botik/tools/ ; #   
   set botikkey(url_dload)  "http://www.$::net(domain)/~botik/tools/download.ru.html#sWin" ; # .
   set botikkey(url_info)   https://informer.$::net(domain)/informer.fcgi
   set botikkey(url_NadminAbPswd) http://nadmin.$::net(domain)      ; #    
   set botikkey(version) "$botikkey(name) v.$botikkey(ver)"   ; #    
   set botikkey(region_init)       WORLD
   set botikkey(region_by_user)    WORLD
   set botikkey(region_request)    WORLD
   set botikkey(region_by_server)  NONE
   set botikkey(currentUColorName) YELLOW
   set botikkey(client_started)    0
   set botikkey(chk_version)       1
   set botikkey(url_chk_version)   http://www.$::net(domain)/~botik/download/versions.txt
   set botikkey(url_whoami)        https://nadmin.$::net(domain)/~nadmin/whoami.cgi
   set botikkey(time_last_read)    0
   set botikkey(restart_check_timeout) 3; # timeout ( .)   "   "
   set botikkey(log) [appFile botikkey.log 1]
   set botikkey(showballoons) 1
   #    
   set botikkey(time_last_info_read) 0
   set botikkey(notifcn,on) 1; #     
   set botikkey(notifcn,on_) $botikkey(notifcn,on); #     
   set botikkey(notifcn,str_nochange) " "
   set botikkey(notifcn,str_smallwalk) " "
   set botikkey(notifcn1,access)  $botikkey(notifcn,str_nochange)
   set botikkey(notifcn2,access)  $botikkey(notifcn,str_nochange)
   set botikkey(notifcn1,access_) $botikkey(notifcn1,access)
   set botikkey(notifcn2,access_) $botikkey(notifcn2,access)
   set botikkey(notifcn,limit) 4; #     + 1
   set botikkey(notifcn1,show) 0; #  1-    ,  0,  1
   set botikkey(notifcn2,show) 0; #  2-    ,  0,  1
   set botikkey(notifcn1,icon) ""; # 1- 
   set botikkey(notifcn2,icon) ""; # 2- 
   set botikkey(notifcn1)      ""; # 1-  ()
   set botikkey(notifcn2)      ""; # 2-  ()
   set botikkey(notifcn1,short) ""; # 1-  ()
   set botikkey(notifcn2,short) ""; # 2-  ()
   # 
   set botikkey(balance) "N/A"; #  
   set botikkey(tariff)  "N/A"; #  
   set botikkey(notifcn,left)       "N/A"
   set botikkey(notifcn,tariff)     $botikkey(notifcn,str_smallwalk)
   set botikkey(notifcn,nexttariff) $botikkey(notifcn,str_smallwalk)
   set botikkey(notifcn,org)        ""
   set botikkey(notifcn,pb)         0
   set botikkey(notifcn,time)       0; # in seconds
   set botikkey(notifcn,tarifftime) 0; # in seconds
   set botikkey(notifcn,timeskew)   0; # in seconds
   set botikkey(notifcn,tariff_speed) 0; # in Mbit/s
   set botikkey(notifcn,port_speed) 0; # in Mbit/s
   set botikkey(lastdebug)          0
   set botikkey(lastmsgid)          0x0
   set botikkey(nextaction)         0
   set botikkey(msgid_file)         [appFile "msgid.txt"]
   set botikkey(stoptime)           "5 "
   set botikkey(batframe)           .bat
   set botikkey(timequota)          0
   set botikkey(timeused)           0
   set botikkey(time_recv)          0
   set botikkey(battery_rtime)      0
   set botikkey(server_address)     ""
   set botikkey(batchan)            ""
   set botikkey(chk_version_time)   [clock seconds]
   if {[file exists $botikkey(msgid_file)]} {
      set f [open $botikkey(msgid_file) r]
      gets $f id; close $f; # read last msgID
      if {[string is integer -strict $id]} {
         set botikkey(lastmsgid) $id
      }
   }
   return
}

proc analyzeDataFromUrl { url data } {
   global botikkey

   switch -regexp $url {
      versions.txt {
         # -------------------------------------------------- versions.txt
         set tokens [scolSplit $data]
         foreach {pgm ver} $tokens {
            if [string is double -strict $ver] {
               set versions_http($pgm) $ver
            }
         }
         if {![info exists versions_http(BotikTools)]} {set versions_http(BotikTools) 0}
         catch {
            if { double($versions_http(BotikKey)) > double($botikkey(ver)) } {
               #showHelp HelpDownload
               set answer [selfUpdate $botikkey(name) $botikkey(ver) $versions_http(BotikKey) $versions_http(BotikTools)]
               if {$answer eq "yes"} {showURL $botikkey(url_dload)}
            }
         }
      }
      default {
      }
   }
   return
}

#   ( Windows)   BotikKeyPro  BotikKeyC
proc other_clients {} {
    if {![windowsPlatform]} {return 0}
    foreach {process desc} {bkpsvc32.exe "BotikKeyPro ( bkpsvc32.exe)"} {
        set info [twapi::get_process_ids -name $process]
        if {![lempty $info]} {
            return [list 1 $desc]
        }
    }
    return 0
}
#     BKey-   ,  
#       .  BKey 
#    $botikkey(port). ,    :
#         ().
proc checkSingleInvocationOfBotikKey {} {
    global botikkey
    catch {set res 0; set res [other_clients]}
    if {[lindex $res 0]} {
        set pname [lindex $res 1]
        message warning "      $pname.\
                          $botikkey(name)  [lindex $pname 0] .\
                          $botikkey(name)   ."
        doExit 0
    }
    set ok 0
    #       12040
    catch {
        socket -server newConnectionOnMyBKserver $botikkey(port)
        set ok 1
    }
    #   ,     ;
    # ,     
    # TCP- so_reuseaddr   0 (off)
    if {$ok} {return}
    if {[windowsPlatform]} {
        #  netstat,       ;
        # netstat   ,    
        set allps {}
        #    
        set clients {wish.exe botikkeyc.exe BotikKey.exe}
        catch {
            exec netstat.exe -anop TCP | findstr $botikkey(port)
        } res
        foreach line [split $res \n] {
            if {[string match *TCP*:$botikkey(port)*LISTENING* $line] ||
                [string match *TCP*:$botikkey(port)*ESTABLISHED* $line]} {
                set PID [lindex $line end]
                if {![string is integer -strict $PID]} {continue}
                set procname ""
                catch {
                    set procname [lindex [twapi::get_process_info $PID -name] end]
                }
                if {[lempty $procname]} {continue}
                lappend allps $procname $PID
                if {$::tcl_version < 8.5} {
                    set found [string match -nocase *$procname* $clients]
                } else {
                    # -nocase option exists only in Tcl >= 8.5
                    set found [expr {[lsearch -nocase $clients $procname] > -1}]
                }
                if {$found} {
                    message warning "  $botikkey(name)   ( $procname).\
                                         ."
                    doExit 0
                }
            }
        }
        foreach {procname PID} $allps {
            #    ,  third-party application,
            #      12040,
            #         
            set file [appFile $procname.txt]
            if {[file exists $file]} {continue}
            set ans [alertQuestion "     $procname ( $PID),\
                                        $botikkey(port).   \
                                       $botikkey(name).\
                                    ,   \
                                     /   $botikkey(name), \
                                         .\
                                    \n  ,      $botikkey(name)\
                                         $procname, \
                                            .\
                                    \n\n     ?"]
            if {$ans eq "yes"} {
                set pinfo ""
                catch {
                    #       
                    set pinfo [twapi::get_process_info $PID -all]
                }
                #    
                if {![lempty $pinfo]} {sendmail "Unknown BotikKey client $procname.\n$pinfo"}
            } else {
                set ans [alertQuestion "  ?"]
                if {$ans eq "yes"} {
                    #      
                    catch {close [open $file w]}
                }
            }
            continue
        }
    }
    set msg "   $botikkey(name)  .     ."
    if {[windowsPlatform]} {
        append msg "   ,    /         ."
    }
    message warning $msg
    doExit 0
}

proc newConnectionOnMyBKserver {channel clientAddress clientPort} {
   catch {close $channel}
   return   
}
