# This script is called every time a user clicks hyperlink "botikmap://...".
# It passes that link to BotikMap via local socket.

proc alert {msg} {
    tk_messageBox -icon info -type ok -title "" -message "$msg"
}
proc writeData {chan data} {
    catch {fileevent $chan writable {}}
    catch {
        puts $chan $data
        flush $chan
    } code
    if {[string length $code] > 0 && [string match "*not connected*" $code]} {
        after cancel $::aid
        catch {close $::chan}
        runApp $data
    }
    doExit
}
proc doExit {} {
    catch {close $::chan}
    exit
}
proc windowsPlatform {} {
    return [expr {$::tcl_platform(platform) eq "windows"}]
}
proc runApp {url} {
    if {![windowsPlatform]} {return}
    set exe [info nameofexecutable]
    set dir [file join [file dirname $exe] .. Botik]
    set bm  [file join $dir BotikMap.tcl]
    if {![file exists $bm]} {return}
    cd $dir
    exec $exe $bm $url
}
proc doConnect {} {
    set ::chan [socket -async -myaddr 127.0.0.1 127.0.0.1 8556]
    set ::aid [after 6000 doExit]
    fconfigure $::chan -buffering line -blocking 0
    fileevent $::chan writable [list writeData $::chan $::argv]
}

wm withdraw .
doConnect

# for Linux:
#gconftool-2 -s /desktop/gnome/url-handlers/botikmap/command 'wish /usr/share/botiktools/proto.tcl %s' --type String
#gconftool-2 -s /desktop/gnome/url-handlers/botikmap/enabled --type Boolean true
# http://kb.mozillazine.org/Register_protocol
