#!/usr/bin/wish

# Copyright (c) 2005-2014, Botik Technologies, Ltd.
# See license.txt for more information.

#    BotikLook (http://www.botik.ru/~botik/look/),
#    .
#   : 2  2005 .

proc configure {} {
    global auth stats sensorids colsensors colunits workdir stypename pvar ttypes hints blook \
        knownsensors traftype coltitles dodebug dbgverbosity trafid botiklook modestitles colunitstitles \
        deltmp
    if {[svc]} {
        cd [file dirname [info script]]
        set ::env(APPDATA) "."
    }
    source net.tcl
    #  
    set botiklook(pname)    "BotikLook"
    #  
    set botiklook(pversion) 3.48
    #    
    set botiklook(dbversion) 343; # must be incremented if new sensor added
    # URL BotikLook-
    set auth(srvurl)   "https://nadmin.$::net(domain)/look.cgi"
    # URL  "Who Am I"
    set auth(whoamiurl) "https://nadmin.$::net(domain)/~nadmin/whoami.cgi"
    #  :
    set auth(org)      ""
    set auth(torg)     ""
    set auth(login)    ""
    set auth(password) ""
    set auth(anyorg)   0
    # ,     
    set auth(done)     0
    # ,     "   ".
    set auth(offline)  0
    #  cookie,   
    set auth(cookie)   {}
    # -  ( )
    set auth(timeout) [expr {3*60*60}]
    #   
    set auth(start)   0
    #   
    set botiklook(version)        "$botiklook(pname) v.$botiklook(pversion)"
    #    
    set botiklook(user_version) 0
    set ::botiktools(progname) $botiklook(pname)
    #   Windows:
    set botiklook(winicon)      [file join . img botiklook.ico]
    catch {wm iconbitmap . -default $botiklook(winicon)}
    #   Unix:
    set botiklook(unixicon)     [file join . img botiklook.xbm]
    #  
    set botiklook(initfilepath) [appFile "init.cfg"]
    #   ,       
    set botiklook(errorfile)    [appFile "errors.dat"]
    #  
    set botiklook(mailserver)   "mail.$::net(domain)"
    #  email- 
    set botiklook(devemails)    "botik-tools@botik.ru"
    #    
    set botiklook(footerfont)   {Helvetica 11 bold}
    #   ( Who Am I)
    set botiklook(time)     ""
    # -  http- ( )
    set botiklook(httpto) 15000
    # URL     
    set botiklook(versionurl)   "http://www.$::net(domain)/~botik/download/versions.txt"
    # URL      
    set botiklook(counterurl)   "http://www.$::net(domain)/cgi-bin/Count.cgi?df="
    set botiklook(downloadpage) "http://www.$::net(domain)/~botik/tools/download.ru.html#sWin"
    # .  ,     ,
    #   ( nfiles)   -  -
    #   .
    set botiklook(maxfiles) 200
    # .     -, ...
    set botiklook(maxrows)  1000
    #       N 
    set botiklook(every)    200
    #    
    set botiklook(withdrawn) 0
    #       
    set botiklook(showballoons) 1
    #       
    set botiklook(showadv) 0
    #    .  ( )     
    set botiklook(memory)  40
    #    TWAPI:
    set botiklook(twapi) [expr {[windowsPlatform] && ![catch {package require twapi}]}]
    #      (  ):
    set botiklook(profile) [appFile profile.txt]
    #     1  2006 
    set botiklook(pc)   1.18
    #     
    set botiklook(steps) [list " " " " " " " " " "]
    set botiklook(step)  0
    set botiklook(stepname) [lindex $botiklook(steps) $botiklook(step)]
    #           ( )
    set botiklook(minspace) [expr 100*1024*1024]
    set botiklook(spaceNotifyFlag) 0
    set botiklook(spacenotify) "!        ( [bytesFmt $::botiklook(minspace)]).        $::botiklook(pname)."
    set botiklook(reportsent) 1
    set botiklook(detailedTable) 0
    set botiklook(dltmp) [appFile "dltmp_"]
    set blook(uto)      1000; #ms
    set blook(mgrport)  5000
    set blook(svcport)  5001
    set blook(paused)   0
    set blook(synctime) 0
    set blook(log)      svclog.txt
    set blook(busy)     0
    set blook(key)      [binary format H* 0123456789abcdefabcdef01234567890123456789abcdefabcdef0123456789]
    set blook(debugfile) [appFile bldebug.txt]
    #  
    set imgs "alloff  [file join . img all-off.gif]   { } \
        allon     [file join . img all-on.gif]    { }\
        reverse   [file join . img reverse.gif]   {}\
        help      [file join . img help.gif]      {}\
        prev      [file join . img prev.gif]      {}\
        prev2     [file join . img prev2.gif]     { }\
        next      [file join . img next.gif]      {}\
        next2     [file join . img next2.gif]     { }\
        imgopen   [file join . img open.gif]      {}\
        imgclose  [file join . img close2.gif]    { }\
        imgexit   [file join . img exit.gif]      {  }\
        config    [file join . img config.gif]    {}\
        apply     [file join . img yes.gif]       {}\
        applysave [file join . img yes_write.gif] {  }\
        excel     [file join . img excel.gif]     {  Excel}"
    foreach {name filepath hint} $imgs {
        loadImage $name $filepath
        set hints($name) $hint
    }
    # put new sensor in tail only, then increment value of botiklook(dbversion)
    set knownsensors {abplata ip_* exim tproxy_* socks ipphone squid* sockstat apache alien penalty tariff bmoney grossplan claim flow* periodic connstate realip botikkey}
    set n 0
    foreach sensor $knownsensors {
        set id [incr n]
        set sensorids($id) $sensor
        set sensorids($sensor) $id
    }
    #   |   | -   |    .    traffic_nat  traffic_cost  
    set ttypes {abplata {abplata}  0 {real real}\
                mail    {exim}     1 {text real}\
                ip      {ip_* tproxy_* socks flow*} 2 {text real}\
                proxy   {squid*}   3 {text real}\
                phone   {ipphone}  4 {text real}\
                hosted  {apache}   5 {text real}\
                shell   {sockstat} 6 {text real}\
                other   {}         7 {text real}\
                alien   {alien}    8 {text real}\
                penalty {penalty}  9 {text real}\
                tariff  {tariff}   10 {text real}\
                bmoney  {bmoney}   11 {text real}\
                grossplan {grossplan} 12 {text real}\
                claim {claim} 13 {text real}\
                periodic {periodic} 14 {text real}\
                connstate {connstate} 15 {text real}\
                realip {realip} 16 {text real}\
                botikkey {botikkey} 17 {text real}}
    genDefs
    set nc  [expr [llength $ttypes]/4]
    set cls [distinctColors $nc]
    set i   0
    foreach {ttype snsrs tid dbtypes} $ttypes {
        set colsensors($ttype) $snsrs
        set trafid($ttype) $tid
        set trafid($tid) $ttype
        foreach s $snsrs {
            set traftype($s) $ttype
            set traftype($sensorids($s)) $ttype
        }
        set botiklook(color,$tid) [lindex $cls $i]
        incr i
    }
    set cunits {abplata {rub rub} mail {mb rub} ip {mb rub} proxy {mb rub} phone {sec rub} hosted {mb rub} shell {mb rub} alien {mb rub} penalty {rub rub} tariff {rub rub} bmoney {rub rub} other {uunit rub} grossplan {rub rub} claim {rub rub} periodic {rub rub} connstate {rub rub} realip {rub rub} botikkey {uunit rub}}
    foreach {colid uts} $cunits {
        set colunits($colid,nat)  [lindex $uts 0]
        set colunits($colid,cost) [lindex $uts 1]
        if {$colunits($colid,nat) eq "rub" && $colunits($colid,cost) eq "rub"} {
            lappend ::botiklook(rubcols) $colid
        }
    }
    set cunitstitles {uunit " " rub "." mb "" sec "." min "."}
    foreach {ut title} $cunitstitles {
        set colunitstitles($ut) $title
    }
    #    -  
    set modestitles(nat)  ""
    set modestitles(cost) ""
    set show {abplata {. } ip {IP-} mail {} proxy {Web-proxy} phone {IP-} hosted {. } shell {Linux-} alien {} penalty { } tariff { } bmoney {-} other {} grossplan {  } claim { } periodic {. } connstate { } realip { IP-} botikkey {Botik Key}}
    foreach {colID title} $show {
        set coltitles($colID) $title
    }
    #    
    if {[windowsPlatform]} {
        set path1   [file normalize [file join .. bin tar.exe]]
        set path2   [file normalize [file join .  bin tar.exe]]
        if {[file exists $path1]} {
            set tarexe $path1
        } elseif {[file exists $path2]} {
            set tarexe $path2
        } elseif {[bl_exe]} {
            set tarexe "tar.exe"
        } else {
            alertError "   tar.exe.    ."
            exit
        }
        set botiklook(tar) $tarexe
    } else {
        set botiklook(tar) "tar"
    }
    set workdir [pwd]
    set botiklook(tmpfiles) {}
    set dodebug      0; #          
    set dbgverbosity 3; #    : 1 - , 3 - .
    set deltmp       1; #        
    set stypename(connect) ""
    set stypename(penalty) "  "
    set stypename(vhost)   ".  "
    set stypename(shell)   "Linux- "
    set stypename(net)     " "
    set stypename(subnet)  " "
    set stypename(ftp)     "FTP- "
    set stypename(org)     ". "
    set stypename(ipphone) "IP- "
    set stypename(bmoney)  "- "
    set stypename(grossplanservice) "   "
    set stypename(claimservice) "  "
    set stypename(periodicservice) ".  "
    set stypename(connstate) "  "
    set stypename(realip) " IP- "
    set stypename(botikkey) "Botik Key "
    set ::elapsed 0
    set ::starttime 0
    set ::infostring ""
    set pvar 1
    set stats(mode)   "cost"
    set stats(tmode)  $modestitles($stats(mode))
    set stats(filler) "\[+]"
    set ::table3pars(maxrows) 100
    set ::table3pars(rows)    0
    set ::sync(curslice) {}
    set ::sync(datafile) {}
    set ::sync(svcnum) 0
    set ::botiklook(svcname) ""
    set botiklook(resolveRemote) 1; # allow(1) or disallow(0) DNS-resolving of remote addresses
    set botiklook(resolveto)     333; # timeout in ms; small timeout can reduce time of sync.
    set botiklook(tracelog) botiklook.log
    set_default_date_period
    hideStatusWindow
    set ::exportsuccess "  "
    array set ::xlcolors {#000000 1 #FFFFFF 2 #FF0000 3 #00FF00 4 #0000FF 5 #FFFF00 6 \
        #FF00FF 7 #00FFFF 8 #800000 9 #008000 10 #000080 11 #808000 12 #800080 13 \
        #008080 14 #C0C0C0 15 #808080 16 #9999FF 17 #993366 18 #FFFFCC 19 #CCFFFF 20 \
        #660066 21 #FF8080 22 #0066CC 23 #CCCCFF 24 #000080 25 #FF00FF 26 #FFFF00 27 \
        #00FFFF 28 #800080 29 #800000 30 #008080 31 #0000FF 32 #00CCFF 33 #CCFFFF 34 \
        #CCFFCC 35 #FFFF99 36 #99CCFF 37 #FF99CC 38 #CC99FF 39 #FFCC99 40 #3366FF 41 \
        #33CCCC 42 #99CC00 43 #FFCC00 44 #FF9900 45 #FF6600 46 #666699 47 #969696 48 \
        #003366 49 #339966 50 #003300 51 #333300 52 #993300 53 #993366 54 #333399 55 \
        #333333 56}
    #        windows-1251
    set rusalpha ""
    set charlist [split $rusalpha ""]
    for {set i 0} {$i < [llength $charlist]} {incr i} {
        set char [lindex $charlist $i]
        set code [expr {$i + 192}]
        set ::ruscode($char) $code
    }
    set ::ruscode() 168
    set ::ruscode() 184
    if {[bl_exe]} {
        foreach file {ports1.txt ports2.txt ports3.txt} {
            set f [open $file r]
            array set ::netsvc [read $f]
            close $f
        }
        return
    }
    if {[file exists ports.txt]} {
        set f [open ports.txt r]
        array set ::netsvc [read $f]
        close $f
    }
}
proc bl_exe {} {
    return [expr {[info exists ::bt_exe] && $::bt_exe}]
}
proc port2Service {port proto} {
    if {![array exists ::netsvc]} {return}
    if {[info exists ::netsvc($port)]} {return $::netsvc($port)}
    if {[info exists ::netsvc($port/$proto)]} {return $::netsvc($port/$proto)}
    return
}
proc set_default_date_period {} {
    set day   [clockFormat %d]
    set month [clockFormat %m]
    set year  [clockFormat %Y]
    set ::stats(pdate1) ${year}-${month}-01
    set ::stats(pdate2) ${year}-${month}-$day
    set ::stats(rdate1) $year${month}01
    set ::stats(rdate2) $year$month$day
    return
}
#  .   ,   ,    
proc loadImage {name filepath} {
    global errorCode
    if {[imgExists $name]} {return $name}
    try_eval {
        image create photo $name -file $filepath
    } {
        alertError "     \"$filepath\"\n : $errorInfo"
        return
    }
    return $name
}
proc imgExists {name} {
    return [lcontain [image names] $name]
}
proc tokoi {str} {
    return [encoding convertto koi8-r $str]
}
proc fromkoi {str} {
    return $str
    #return [encoding convertfrom koi8-r $str]
}
proc windowsPlatform {} {
   return [expr {$::tcl_platform(platform) eq "windows"}]
}
proc unixPlatform {} {
   return [expr {$::tcl_platform(platform) eq "unix" && $::tcl_platform(os) ne "Darwin"}]
}
proc macPlatform {} {
   return [expr {$::tcl_platform(os) eq "Darwin"}]
}
proc alert {msg} {
    if {[svc]} {
        tofile $::blook(log) ": $msg"
        return
    }
    tk_messageBox -icon info -type ok -title "" -message "$msg"
}
proc alertQuestion {msg {def "yes"}} {
    if {[svc]} {
        tofile $::blook(log) "  \"$msg\"   \"\"."
        return "no"
    }
    return [tk_messageBox -icon question -type yesno -default $def -title "" -parent . -message $msg]
}
proc alertQuestionM {msg {body {}}} {
    if {[svc]} {
        tofile $::blook(log) "  \"$msg\"   \"\"."
        tofile $::blook(log) " : $body"
        return "no"
    }
    return [tk_messageBox -icon question -type yesno -title "" -parent . -message $msg]
}
proc alertWarning {msg} {
    if {[svc]} {
        tofile $::blook(log) ": $msg"
        return
    }
    tk_messageBox -icon warning -type ok -title "" -message $msg
}
proc alertError {msg} {
    if {[svc]} {
        tofile $::blook(log) ": $msg"
        return
    }
    tk_messageBox -icon error -type ok -title "" -message "$msg"
}
proc debug {msg} {
    tofile $::blook(debugfile) $msg
}
proc tofile {filename str} {
    catch {
        #if {![file writable [file dirname $filename]]} {return}
        set f [open $filename a]
        puts $f "$str"
        close $f
    }
    return
}
proc dbg {msg {verb 1}} {
    if {!$::dodebug} {return}
    if {$verb > $::dbgverbosity} {return}
    set suff ""
    if {![lempty $::auth(torg)]} {
        set suff "_$::auth(torg)"
    }
    set time [clockFormat %X]
    tofile [appFile trace$suff.txt] "$time $msg"
}
#  
proc loadPackages {plist} {
    # packages - . ,    -   ,   -  .
    set notsat {}
    foreach {pac ver} $plist {
        #    ,      
        if {![catch {package present $pac}]} {continue}
        if {[catch {package require $pac} eid]} {
            alertError ":     \"$pac\".\n$eid\n\   ."
            catch {deleteTmpFiles}
            exit
        } elseif {$pac eq "tls"} {
            http::register https 443 ::tls::socket
        } elseif {$pac eq "style"} {
            style::use as
        }
        if {![regexp {\S} $ver]} {continue}
        #   ,    .
        #    ,     .
        set versions [package versions $pac]
        set sat 0
        foreach v $versions {
            if {[package vsatisfies $v $ver]} {set sat 1}
        }
        if {!$sat} {lappend notsat $pac $ver}
    }
    if {[regexp {\S} $notsat]} {
        if {[llength $notsat]==2} {
            alert "!   [lindex $notsat 0]\n   ([lindex $notsat 1]).\n   ."
            return
        }
        set packs {}
        set verss {}
        foreach {pac ver} $notsat {
            lappend packs $pac
            lappend verss $ver
        }
        alert "!   $packs\n   ($verss).\n   ."
        return
    }
}
#    
proc whoAmI {} {
    global auth env whoami botiklook
    array unset whoami
    set botiklook(time) ""
    catch {http::geturl $auth(whoamiurl) -handler whoamiHandler -timeout 7000}
}
proc whoamiHandler {socket token} {
    global auth whoami botiklook
    gets $socket line
    set spl   [split $line ":"]
    set kword [lindex $spl 1]
    set value [string range $line [expr [string length $kword] + 2] end]
    set whoami($kword) $value
    if {$kword eq "Time"} {
        set botiklook(time) [ftime]
    }
    return
}
proc reallyExit {w} {
    if {!$::botiklook(reportsent)} {
        set answer [alertQuestion "     .    ?" no]
        return [expr {$answer eq "yes"}]
    } else {return 1}
}
proc doExit {w} {
    if {[reallyExit $w]} {
        if {[info exists ::application]} {
            initStatus 2 " . "
            shiftStatus; #           
            $::application Quit
            unset ::application
            shiftStatus
            finishStatus
        }
        catch {db close}
        closeMDB
        deleteTmpFiles
        writeInitFile
        exit
    }
}
#     
proc deleteTmpFiles {} {
    global botiklook deltmp
    if {![info exists botiklook(tmpfiles)] || [lempty $botiklook(tmpfiles)]} {return}
    set nsteps [llength $botiklook(tmpfiles)]
    if {[info exists botiklook(tempDB)] && [file exists $botiklook(tempDB)]} {
        incr nsteps
    }
    initStatus $nsteps "  . "
    foreach elt $botiklook(tmpfiles) {
        #     
        if {$deltmp} {
            catch {file delete -force $elt}
        }
        shiftStatus
    }
    if {$deltmp} {
        catch {file delete -force $botiklook(tempDB); unset botiklook(tempDB)}
    }
    shiftStatus
    finishStatus
    set botiklook(tmpfiles) {}
}
proc initStatsVars {} {
    global mtimes climtimes files services dbcat stats auth cells \
        depdirs depfiles wwwaddr mindate \
        traffic_cost traffic_nat expences rs exp tmdb tdb \
        table3units table3srv table3tps sync rslines ipdata alltimes
    array unset mtimes
    array unset climtimes
    array unset files
    array unset services
    array unset depdirs; # depository directories
    array unset depfiles
    array unset wwwaddr
    array unset traffic_cost
    array unset traffic_nat
    array unset expences
    array unset rs
    array unset exp
    array unset tmdb
    array unset tdb
    array unset cells
    array unset sizes
    array unset table3units
    array unset table3tps
    array unset table3srv
    array unset sync
    array unset rslines
    array unset ipdata
    array unset alltimes
       set stats(mindate)  19700101000000
       set stats(maxdate)  20200101000000
    set sync(ilimit)    5; # .   -
    set sync(mtime1)    0
    set sync(mtime2)    0
    set sync(curslice)  {}
    set sync(len)       0
    set sync(errors)    [list]
    set sync(content)   [list]
    set sync(dosync)    0
    set sync(dosync2)   0
    set sync(svcnum)    0
    set files(all)      [list]
    set files(todel)    [list]; # ,        
    set mindate [getNadminDate [clock seconds]]; #    
    #   
    set dbcat   $stats(homecat)
    set dbfname $auth(torg).bdb
    set dbfpath [file join $dbcat $dbfname]
    #  
    initDB
}
proc getPageSize {} {
    global dbcat
    set fstype [lindex [file system $dbcat] 1]
    if {$fstype eq "NTFS"} {
        return 512
    } elseif {$fstype eq "FAT"} {
        return 8192
    } else {
        return 4096
    }
}
proc setPragmas {dbcmd {create 0}} {
    $dbcmd eval {PRAGMA cache_size=10240}
    $dbcmd eval {PRAGMA temp_store=FILE}
    #if {[file writable $::dbcat]}
        $dbcmd eval "PRAGMA temp_store_directory='$::dbcat'"
    #else
    #    alertWarning " $::dbcat   . ,        ."
    
    # SQLite     fsync()   ,
    #  ,      .
    if {$dbcmd eq "mdb"} {
        #      ,
        #       
        $dbcmd eval {PRAGMA synchronous=OFF}; #  , fsync()  
    } else {
        $dbcmd eval {PRAGMA synchronous=NORMAL}; #  , fsync() ,       FULL-
    }
    $dbcmd eval {PRAGMA auto_vacuum=0}; #     ,   ( 1)    .
    if {$create} {
        #   ,   
        $dbcmd eval "PRAGMA user_version=$::botiklook(dbversion)"; #  
        set ::botiklook(user_version) $::botiklook(dbversion)
    }
}
#   
proc initDB {} {
    global auth dbcat state rs exp tdb stats botiklook
    if {[lempty $auth(torg)]} {return 0}
    set state "  "; update
    set dbfname $auth(torg).bdb
    set dbfpath [file join $dbcat $dbfname]
    if {$stats(hugeorg)} {
        createMDBf
    } else {
        createMDB
    }
    if {[file exists $dbfpath]} {
        #    
        sqlite3 db $dbfpath
        setPragmas db
        set tabs [getTables]
        foreach t $tabs {set tdb($t) 1}
        try_eval {set v [db eval {PRAGMA user_version}]} {set v 0}
        set botiklook(user_version) $v
        if {[info exists tdb(dns)]} {
            db eval {select ip,name from dns} {
                set ::dns($ip) $name
                set ::dns($name) $ip
            }
        } else {
            createTable "db" "dns"
        }
        if {$v != $botiklook(dbversion)} {
            mendDB; # "" 
            if {$v == 340} {
                dropTable "db" "traffic_nat"
                dropTable "db" "traffic_cost"
                createTable "db" "traffic_nat"
                createTable "db" "traffic_cost"
                catch {countTraffic [getRStables]}
                fillMDB
                dumpMDB
            }
        }
        return
    }
    #    ,      :
    #    ,  
    touch $dbfpath
    #  
    sqlite3 db $dbfpath
    setPragmas db 1
    createTable "db" "services"
    createTable "db" "slices"
    createTable "db" "files"
    createTable "db" "traffic_nat"
    createTable "db" "traffic_cost"
    createTable "db" "dns"
}
#   (definition)    traffic_nat  traffic_cost    ttypes  config'a
proc genDefs {} {
    set ::botiklook(nat_def)  "(day text, service_id int"
    set ::botiklook(cost_def) $::botiklook(nat_def)
    foreach {ttype snsrs tid dbtypes} $::ttypes {
        append ::botiklook(nat_def)  ", " $ttype " " [lindex $dbtypes 0]
        append ::botiklook(cost_def) ", " $ttype " " [lindex $dbtypes 1]
    }
    append ::botiklook(nat_def)  ")"
    append ::botiklook(cost_def) ")"
}
#           
proc mendDB {} {
    set sql    [db eval "select sql from sqlite_master where name='traffic_nat'"]
    set fields [string range [lrange [lindex $sql 0] 3 end] 1 end-1]; #   "("  ")"
    set defs   [split $fields ","]
    foreach def $defs {
        foreach {name type} $def {}
        set have($name) 1
    }
    set nhave [list]; # ,  
    foreach {ttype snsrs tid dbtypes} $::ttypes {
        if {![info exists have($ttype)]} {
            lappend nhave $ttype $dbtypes
        }
    }
    foreach {ttype dbtypes} $nhave {
        db eval "alter table traffic_nat  add column $ttype [lindex $dbtypes 0]"
        db eval "alter table traffic_cost add column $ttype [lindex $dbtypes 1]"
        db eval "update traffic_nat  set $ttype=0"
        db eval "update traffic_cost set $ttype=0"
    }
    db eval "PRAGMA user_version=$::botiklook(dbversion)"
}
proc dropTable {dbcmd tabname} {
    catch {$dbcmd eval "drop table $tabname"}
    if {$dbcmd eq "db"} {unset -nocomplain ::tdb($tabname); return}
    unset -nocomplain ::tmdb($tabname)
}
#        (db  mdb)
proc createTable {dbcmd tabname} {
    if {($dbcmd eq "db" && [info exists ::tdb($tabname)]) || ($dbcmd eq "mdb" && [info exists ::tmdb($tabname)])} {return}
    switch -glob -- $tabname {
        services {
            $dbcmd eval "create table $tabname (service_id int,\
                    name text,\
                    type text)"
            if {$dbcmd eq "db"}  {set ::tdb($tabname) 1}
            if {$dbcmd eq "mdb"} {set ::tmdb($tabname) 1}
        }
        slices {
            if {$dbcmd eq "mdb"} {
                set field "slice_id NULL"
            } else {
                set field "slice_id integer primary key autoincrement"
            }
            $dbcmd eval "create table $tabname ($field,\
                service_id int,\
                sensor_id int,\
                file_path text,\
                file_name text,\
                mtime int,\
                date1 text,\
                date2 text,\
                cost real,\
                cost_in real,\
                cost_out real,\
                count real,\
                count_in int,\
                count_out int,\
                price real,\
                address text)"
            if {$dbcmd eq "db"}  {set ::tdb($tabname) 1}
            if {$dbcmd eq "mdb"} {set ::tmdb($tabname) 1}
        }
        files {
            $dbcmd eval "create table $tabname (slice_id int,\
                service_id int,\
                time int,\
                local_address text,\
                full_url text,\
                cost real,\
                count int)"
            if {$dbcmd eq "db"}  {set ::tdb($tabname) 1}
            if {$dbcmd eq "mdb"} {set ::tmdb($tabname) 1}
        }
        traffic_nat  {
            $dbcmd eval "create table $tabname $::botiklook(nat_def)"
            if {$dbcmd eq "db"}  {set ::tdb($tabname) 1}
            if {$dbcmd eq "mdb"} {set ::tmdb($tabname) 1}
        }
        traffic_cost {
            $dbcmd eval "create table $tabname $::botiklook(cost_def)"
            if {$dbcmd eq "db"}  {set ::tdb($tabname) 1}
            if {$dbcmd eq "mdb"} {set ::tmdb($tabname) 1}
        }
        dns {
            $dbcmd eval "create table $tabname (ip text, name text)"
            if {$dbcmd eq "db"}  {set ::tdb($tabname) 1}
            if {$dbcmd eq "mdb"} {set ::tmdb($tabname) 1}
        }
        "rs_*" {
            #debug "$dbcmd: create table $tabname"
            $dbcmd eval "create table $tabname (slice_id int,\
                sensor_id int,\
                local_address text,\
                local_port int,\
                remote_address text,\
                remote_port int,\
                count_in int,\
                count_out int,\
                protocol text,\
                site_url text,\
                full_url text,\
                sender text,\
                recipient text,\
                phone_number text,\
                call_duration text,\
                zone text,\
                time int)"
            if {$dbcmd eq "db"} {set ::tdb($tabname) 1}
            if {$dbcmd eq "mdb"} {set ::tmdb($tabname) 1}
        }
        "exp_*" {
            $dbcmd eval "create table $tabname (service_id int,\
                traffic_type text,\
                key text,\
                count int,\
                cost real,\
                priority int)"
            if {$dbcmd eq "db"} {set ::tdb($tabname) 1}
            if {$dbcmd eq "mdb"} {set ::tmdb($tabname) 1}
        }
        default {}
    }
}
proc closeMDB {} {
    catch {
    if {$::stats(hugeorg)} {
        mdb close; file delete -force $::botiklook(tempDB)
    } else {
        mdb close
    }
    }
}
proc createMDB {} {
    closeMDB
    sqlite3 mdb :memory:
    mdb eval {PRAGMA temp_store=FILE}
    #if {[file writable $::dbcat]}
    catch {mdb eval "PRAGMA temp_store_directory='$::dbcat'"}
    array unset ::tmdb
}
#     
proc chooseName {dir name ext} {
    for {set i 0} {$i >= 0} {incr i} {
        set fname $name$i.$ext
        set path  [file join $dir $fname]
        if {![file exists $path]} {
            return $path
        }
    }
}
proc createMDBf {} {
    closeMDB
    if {![info exists ::botiklook(tempDB)]} {
        set ::botiklook(tempDB) [chooseName $::dbcat "temp" "db"]
    } else {
        catch {mdb close}
        catch {file delete -force $::botiklook(tempDB)}
        set ::botiklook(tempDB) [chooseName $::dbcat "temp" "db"]
    }
#    if {![file writable $::botiklook(tempDB)]}
#        alert "     .       \" \"   ."
#        return -code error "File not writable:\n$::botiklook(tempDB)"
    sqlite3 mdb $::botiklook(tempDB)
    setPragmas mdb
    array unset ::tmdb
}
proc clearMDB {} {
    set mdbtabs [mdb eval {select name from sqlite_master where type='table'}]
    foreach name $mdbtabs {
        #debug "mdb: dropping table $name"
        mdb eval "drop table $name"
        unset -nocomplain ::tmdb($name)
    }
    array unset ::tmdb
}
#    , init. memory database
proc initMDB {tab} {
    createTable "mdb" $tab
}
#    .   ,   . 
proc dumpMDB {} {
    if {!$::botiklook(spaceNotifyFlag) && ![spaceAvailable $::botiklook(minspace)]} {
        set ::botiklook(spaceNotifyFlag) 1
        alertWarning $::botiklook(spacenotify)
    }
    set dbfpath [file join $::dbcat $::auth(torg).bdb]
    set mdbtabs [mdb eval {select name from sqlite_master where type='table'}]
    if {![lempty $mdbtabs]} {
        dbg "dumping MDB: $mdbtabs ..." 3
    }
    foreach name $mdbtabs {
        #    ,   
        createTable "db" $name
    }
    mdb eval "attach '$dbfpath' as hddb"; # hddb = hard drive database
    foreach name $mdbtabs {
        #  
        #debug "db: inserting data into $name"
        mdb eval "begin;insert into hddb.'$name' select * from '$name';commit"
        #  . 
        #mdb eval "begin;delete from '$name';commit"
    }
    mdb eval "detach hddb"
    clearMDB; #   . 
}
#      
proc touch {file} {
    catch {file mkdir [file dirname $file]}
    catch {close [open $file w]}
}
#  
proc parseError {result} {
           switch -exact -- [lindex $::errorCode 0] {
               CHILDKILLED {
            foreach { - pid sigName msg } $::errorCode break
            # A child process, whose process ID was $pid,
            # died on a signal named $sigName. A human-
            # readable message appears in $msg.
            alertError ":     \"$sigName\":\n$msg"
        }
        CHILDSTATUS {
            foreach { - pid code } $::errorCode break
            # A child process, whose process ID was $pid,
            # exited with a non-zero exit status, $code.
            alertError ":     \"$code\":\n$result"
        }
        CHILDSUSP {
            foreach { - pid sigName msg } $::errorCode break
            # A child process, whose process ID was $pid,
            # has been suspended because of a signal named
            # $sigName. A human-readable description of the
            # signal appears in $msg
            alertError ":     \"$sigName\":\n$msg"
        }
               NONE {
            # The command exited with a normal status, but wrote something
            # to stderr, which is included in $result.
                   alertError ":\n$result"
               }
        POSIX {
            foreach { - errName msg } $::errorCode break
            # One of the kernel calls to launch the command
            # failed. The error code is in $errName, and a
            # human-readable message is in $msg.
            alertError ":\n$errName:\n$msg"
        }
           }
}
proc tryexec {args} {
    global done startcut stats
    set startcut [expr [string length $stats(homecat)] + 1]
    set pipe [open "|$args" r]
    fconfigure $pipe -buffering line -blocking 0
    fileevent $pipe readable [list gotDirLine $pipe]
    set done 0
    vwait done
}
proc gotDirLine {pipe} {
    set got [gets $pipe]
    set line {}
    if {[string length $got]} {
        set line $got
    }
    if {[fblocked $pipe]} {
        set line "[read -nonewline $pipe]"
    }
    set len [llength $line]
    if {[string equal -nocase [lindex $line 0] "directory"]} {
        regsub -all {\\} $line {/} line
        set ::updir [lrange $line 2 end]
        set ::updir [string range $::updir $::startcut end]
        if {[info exists ::depfiles(${::updir}.tar.bz2)] || $::updir eq "$::auth(torg)/account_run" || [lempty $::updir]} {return}
        set ::depdirs($::updir)  {}
        set ::depfiles($::updir) {}
    } elseif {$len==4} {
        if {![info exists ::updir] || [lempty $::updir] || [info exists ::depfiles(${::updir}.tar.bz2)] || $::updir eq "$::auth(torg)/account_run"} {return}
        if {[lindex $line 2] eq "<DIR>"} {
            #  
            set dir [lindex $line end]
            if {[file exists [file join $::stats(homecat) $::updir ${dir}.tar.bz2]]} {
                #      ,
                #         
                lappend ::botiklook(tmpfiles) [file join $::stats(homecat) $::updir $dir]
                return
            }
            if {$dir ne "." && $dir ne ".." && $dir ne "account_run"} {
                lappend ::depdirs($::updir) $dir
            }
        } else {
            #  
            if {![lempty [string index $line 0]]} {
                set file         [lindex $line end]
                if {[file exists [file join $::stats(homecat) $::updir ${file}.bz2]]} {
                    lappend ::botiklook(tmpfiles) [file join $::stats(homecat) $::updir $file]
                    return
                }
                set filepath [file join $::stats(homecat) $::updir $file]
                if {![file exists $filepath]} {return}
                set ::mtimes($::updir/$file) [list [file mtime $filepath]]
                set ::sizes($::updir/$file)  [file size $filepath]
                lappend ::depfiles($::updir) $::updir/$file
                set filedate         [getLoDate $file]
                if {$filedate < $::mindate} {set ::mindate $filedate}
            }
        }
    }
    if {[eof $pipe]} {
        set ::done 1
        set status [catch {close $pipe} result]
        if {$status != 0} {
            parseError $result
        }
    }
}
#   
proc findDepStat {} {
    global env stats auth
    if {[unixPlatform]} {return}
    initStatus 0 "   . "
    set dir [file nativename [file join $stats(homecat) $auth(torg)]]
    try_eval {tryexec $env(COMSPEC) /c dir $dir /S /-C} {
        alertError "     ."
        asksendmail "     ."
    }
    finishStatus
    deleteTmpFiles
    updateServices
}
proc findServices {} {
    global services services2
    db eval {select * from services} {
        set services(${type}-$name) $service_id
        set services($service_id)   $name
        set services2($service_id)  ${type}-$name
        incr ::sync(svcnum)
    }
}
#    
proc updateServices {} {
    global auth depdirs services services2 state
    set state "   . "
    set num 0
    #       
    db eval {select * from services} {
        set services(${type}-$name) $service_id
        set services($service_id)   $name
        set services2($service_id) ${type}-$name
        incr num
    }
    if {![info exists depdirs($auth(torg))] || [lempty $depdirs($auth(torg))]} {return}
    #      
    initStatus [llength $depdirs($auth(torg))] "   . "
    foreach service $depdirs($auth(torg)) {
        if {![info exists services($service)]} {
            set id   [incr num]
            set type [lindex [split $service "-"] 0]
            set name [string range $service [expr [string length $type] + 1] end]
            db eval {insert into services values($id,$name,$type)}
            set services($service) $id
            set services($id)      $name
            set services2($id)     ${type}-$name
        }
        shiftStatus
    }
    finishStatus
}
proc findDBStat {} {
    set ::state " . "; update
    set total 1
    catch {set total [expr [db eval {select max(slice_id) from slices}]+1]}
    initStatus $total " . "
    array unset ::climtimes
    db eval {select * from slices} {
        set ::climtimes($file_path) [list $mtime]
        shiftStatus
    }
    set rstabs  [db eval {select name from sqlite_master where type='table' and name like 'rs_%'}]
    set exptabs [db eval {select name from sqlite_master where type='table' and name like 'exp_%'}]
    foreach rstab $rstabs {
        set day [lindex [split $rstab "_"] 1]
        if {![lcontain $exptabs exp_$day]} {
            set ::rs(rs_$day) 1
        }
    }
    shiftStatus
    finishStatus
}
# Final date  
# yyyymmddhhmmss
proc getHiDate {file} {
    return [string range [file tail $file] 15 28]
}
# Initial date  
# yyyymmddhhmmss
proc getLoDate {file} {
    return [string range [file tail $file] 0 13]
}
# site.com -> www.site.com
proc siteFmt {addr} {
    if {![isip $addr]} {
        return [expr {[string match www.* $addr] ? "$addr" : "www.$addr"}]
    } else {
        return $addr
    }
}
proc bytesFmt {x} {
    set k 0
    set y $x
    if {$y < 1000} {
        return [format "%7.0f " $y]
    }
    for {set k 0} { ($k <= 7) && (double($y) > 999.0) } {incr k} {
        set y [expr double($y) / 1024.0]
    }
    # "E" ("exa-", "-")  ,  2   60
    return [format "%7.3f%1s" $y [lindex { " " "k" "M" "G" "T" "P" "E" } $k]]
}
proc getSensorIDBySensorName {sn} {
    set n 0
    foreach sensorpattern $::knownsensors {
        set id [incr n]
        if {[string match $sensorpattern $sn]} {
            return $id
        }
    }
    return
}
proc getTrafIDBySensorID {sid} {
    return $::trafid($::traftype($::sensorids($sid)))
}
proc getDay {date} {
    return [string range $date 0 7]
}
proc isip {addr} {
    return [regexp {^\d{1,3}\.\d{1,3}\.\d{1,3}\.\d{1,3}$} $addr]
}
proc isArchive {file} {
    return [string match *.tar.bz2 $file]
}
proc add2DNS {ip name} {
    if {![isLocal $name $ip]} {
        db eval "insert into dns values('$ip','$name')"
    }
}
proc resolve {val {local {1}}} {
    #  $val -  IP-,         
        #  ,  hostname(ipaddress)
        #  ,   (hostname) 
            #  , . hostname(ipaddress)
            #   , . $val
    #  $val -  hostname,        IP-
        #  , . hostname(ipaddress)
        #  ,   (IP-) 
            #  , . hostname(ipaddress)
            #   , . $val
    if {[string match "*:*" $val]} {
        return $val
    }
    if {[info exists ::dns($val)]} {
        if {[isip $val]} {
            return $::dns($val)\($val\)
        } else {
            return $val\($::dns($val)\)
        }
    }
    if {!$local && !$::botiklook(resolveRemote)} {
        return $val
    }
    #      DNS-
    if {[catch {\
        set res [::dns::result [::dns::resolve $val -nameserver "dns1.$::net(domain)" -timeout $::botiklook(resolveto)]]\
    }] && [catch {\
        set res [::dns::result [::dns::resolve $val -nameserver "dns2.$::net(domain)" -timeout $::botiklook(resolveto)]]\
    }]} {
        dbg "resolve failed: $val" 2
        set ::dns($val) $val
        return $val
    }
    set res [lindex $res end end]
    if {[lempty $res]} {return $val}
    if {[isip $val]} {
        set ::dns($val) [list $res]
        set ::dns($res) [list $val]
        add2DNS $val $res
        return ${res}\($val\)
    }
    set ::dns($val) [list $res]
    set ::dns($res) [list $val]
    add2DNS $res $val
    return ${val}\($res\)
}
proc getTables {} {
    return [db eval {select name from sqlite_master where type='table'}]
}
proc daysWord {q} {
    set r [expr $q % 10]
    if {$r == 1 && $q != 11} {
        return "$q "
    } elseif {[lcontain {2 3 4} $r] && ![lcontain {12 13 14} $q]} {
        return "$q "
    } else {
        return "$q "
    }
}
proc filesWord {q} {
    set r [expr $q % 10]
    if {$r == 1 && $q != 11} {
        return "$q "
    } elseif {[lcontain {2 3 4} $r] && ![lcontain {12 13 14} $q]} {
        return "$q "
    } else {
        return "$q "
    }
}
#  ,    
proc removeData {} {
    global files
    if {[llength $files(todel)]==0} {return}
    set ::state " . "; update
    set paths \'[join $files(todel) "','"]\'
    set delids [db eval "select slice_id from slices where file_path in ($paths)"]
    if {[llength $delids]==0} {
        set files(todel) [list]
        return
    }
    set tabs [getTables]
    foreach t $tabs {set tables($t) {}}
    set delids [join $delids ","]
    set days   {}
    set res    [list "slices" "files"]
    db eval "select date1 from slices where slice_id in ($delids)" {
        set day [getDay $date1]
        lappend days $day
        set ::rs(rs_$day) 1
    }
    set days [lsort -unique $days]
    foreach day $days {
        if {[info exists tables(rs_$day)]} {
            lappend res rs_$day
        }
    }
    initStatus [llength $res] " . "
    db eval {begin}
    foreach tab $res {
        dbg "deleting old data from $tab ..."
        db eval "delete from $tab where slice_id in ($delids)"
        shiftStatus
    }
    db eval {commit}
    finishStatus
    set files(todel) [list]
    return
}
proc spaceAvailable {space} {
    return 1
    if {!$::botiklook(twapi)} {
        #    twapi:
        return 1
    }
    return [twapi::user_drive_space_available [homeDrive] $space]
}
#       
proc compareData {{del 1}} {
    global mtimes climtimes files mindate sizes
    if {![array exists mtimes]} {return}
    set total [array size mtimes]
    if {$del && [array exists climtimes]} {
        incr total [array size climtimes]
    }
    initStatus $total " . "
    #       ;
    #   ,   ,  ,
    #   (modification times) 
    #    ,    .
    set totalfiles 0
    set sid [array startsearch mtimes]
    set totalsize 0
    while {[array anymore mtimes $sid]} {
        set file [array nextelement mtimes $sid]
        if {![info exists climtimes($file)]} {
            lappend files(all) $file
            incr totalfiles
            incr totalsize $sizes($file)
        } elseif {abs($mtimes($file) - $climtimes($file)) > 2} {
            lappend files(todel) $file
            lappend files(all) $file
            incr totalfiles
            incr totalsize $sizes($file)
        }
        shiftStatus
    }
    incr totalsize $totalsize; #    (  ,  )  2       
    if {![spaceAvailable $totalsize]} {
        alertWarning "!     [homeDrive]."
    }
    array unset sizes
    array donesearch mtimes $sid
    #      ,    .
    #      .
    if {$del && [array exists climtimes]} {
        set sid [array startsearch climtimes]
        while {[array anymore climtimes $sid]} {
            set file_path [array nextelement climtimes $sid]
            if {[getLoDate $file_path] >= $mindate && ![info exists mtimes($file_path)]} {
                lappend files(todel) $file_path
            }
            shiftStatus
        }
        array donesearch climtimes $sid
        array unset climtimes
    }
    finishStatus
    removeData
}
proc getDrive {catalog} {
    return [lindex [file split $catalog] 0]
}
proc homeDrive {} {
    return [getDrive $::stats(homecat)]
}
proc driveType {drive} {
    if {!$::botiklook(twapi)} {
        return "unknown"
    }
    return [twapi::get_drive_type $drive]
}
#  .     .
proc processSlice {path data filename} {
    set split      [file split $path]
    set service    [lindex $split 1]
    set service_id $::services($service)
    set sensor     [lindex $split 2]
    set sensor_id  [getSensorIDBySensorName $sensor]
    if {$sensor_id eq ""} {
        debug "No sensor_id found for $path"
        return
    }
    set data           [split $data "\n"]
    set kwords(date1)  [getLoDate $filename]
    set kwords(date2)  [getHiDate $filename]
    set kwords(price)  ""
    set kwords(zone)   ""
    set kwords(tariff) ""
    set day            [getDay $kwords(date1)]
    if {[isArchive $path]} {
        dbg "slice: $day (arch): $path/$filename" 2
    } else {
        dbg "slice: $day: $path" 2
    }
    set emline 0
    foreach line $data {
        if {$line eq ""} {
            #  "" ,  ,   
            incr emline
            if {$emline > 1} {break}
            set cost     0
            set costin   0
            set costout  0
            set count    0
            set countin  0
            set countout 0
            set from     ""
            set shost    ""
            if {![info exists kwords(id)] || $sensor eq "penalty" || $sensor eq "grossplan" || $sensor eq "claim" || $sensor eq "periodic"} {
                set kwords(id) ""
                set resolved   ""
            } elseif {$::traftype($sensor_id) ne "shell" && $::traftype($sensor_id) ne "hosted"} {
                set resolved [resolve $kwords(id)]
            } else {set resolved ""}
            #  
            if {[info exists kwords(cost)]} {
                set cost $kwords(cost)
            }
            if {[info exists kwords(cost_in)] || [info exists kwords(cost_out)]} {
                catch {set costin  $kwords(cost_in)}
                catch {set costout $kwords(cost_out)}
                if {![string is integer -strict $costin]} {set costin 0}
                if {![string is integer -strict $costout]} {set costout 0}
                if {$cost==0} {set cost [expr {$costin+$costout}]}
            }
            #     
            #if {$cost==0 && ![string match gross_plan* $kwords(tariff)]} {return}
            if {[info exists kwords(date1)] && $kwords(date1) < 20060801000000} {
                set cost [expr $cost*$::botiklook(pc)]
            }
            #   
            if {[info exists kwords(count)]} {
                set count $kwords(count)
            }
            if {[info exists kwords(count_in)] || [info exists kwords(count_out)]} {
                catch {set countin $kwords(count_in)}
                catch {set countout $kwords(count_out)}
                if {![string is integer -strict $countin]} {set countin 0}
                if {![string is integer -strict $countout]} {set countout 0}
                if {$count == 0} {set count [expr {$countin+$countout}]}
            }
            if {[info exists kwords(count_miss)]} {
                set count $kwords(count_miss)
            }
            if {[info exists kwords(traf_in)] || [info exists kwords(traf_out)]} {
                catch {set countin  $kwords(traf_in)}
                catch {set countout $kwords(traf_out)}
                if {![string is integer -strict $countin]} {set countin 0}
                if {![string is integer -strict $countout]} {set countout 0}
                if {$count == 0} {set count [expr {$countin+$countout}]}
            }
            if {[info exists kwords(call_duration)]} {
                set count $kwords(call_duration)
            }
            if {[lsearch $::botiklook(rubcols) $sensor] >= 0} {
                set count $cost
            }
            if {$::traftype($sensor_id) eq "mail" || $::traftype($sensor_id) eq "abplata"} {
                set address $resolved
            } else {set address ""}
            # ID  
            incr ::sliceid
            if {![info exists ::mtimes($path)]} {
                set mtime 0
            } else {
                set mtime $::mtimes($path)
            }
            mdb eval "insert into slices values (NULL,\
                                 '$service_id',\
                                 '$sensor_id',\
                                 '$path',\
                                 '$filename',\
                                 '$mtime',\
                                 '$kwords(date1)',\
                                 '$kwords(date2)',\
                                 '$cost',\
                                 '$costin',\
                                 '$costout',\
                                 '$count',\
                                 '$countin',\
                                 '$countout',\
                                 '$kwords(price)',\
                                 '$address')"
            set ::rs(rs_$day) 1
            continue
        }; # "if" finished
        if {$emline} {
            if {$line eq ""} {continue}
            #   
            set line           [string map {"{" "" "}" "" "'" "" "\"" ""} $line]
            set local_address  $resolved
            set local_port     ""
            set remote_address ""
            set remote_port    ""
            set count_in       0
            set count_out      0
            set protocol       ""
            set site_url       ""
            set full_url       ""
            set sender         ""
            set recipient      ""
            set phone_number   ""
            set call_duration  0
            set zone           $kwords(zone)
            if {$zone eq "" && $kwords(tariff) ne ""} {
                if {$kwords(tariff) eq "day"} {
                    set zone "D"
                } elseif {$kwords(tariff) eq "holiday"} {
                    set zone "H"
                } elseif {$kwords(tariff) eq "night"} {
                    set zone "N"
                } elseif {[string match *unlim* $kwords(tariff)]} {
                    set zone "U"
                }
            }
            #   ,      
            switch -glob -- $sensor {
                ip_* - flow* {
                    if {[info exists kwords(date2)] && [string is integer -strict [string range $kwords(date2) 0 1]]} {
                        set time [clock scan [ftime3 $kwords(date2)]]
                    } else {
                        set time [clock scan [ftime3 $day]]
                    }
                    set spl       [split [lindex $line 0] ":"]
                    set count_in  [lindex $spl 0]; # countin
                    set count_out [lindex $spl 1]; # countout
                    set protocol  [string toupper [lindex $line end]]
                    switch -- $protocol {
                        "TCP" - "UDP" {
                            # . 
                            set local_port [string range [lindex $line 2] 2 end]
                            # .   
                            set remaddrp [lindex $line 1]
                            # . 
                            set remote_port [lindex [split $remaddrp "."] end]
                            set remote_address [string range $remaddrp 0 end-[expr {[string length $remote_port]+1}]]
                        }
                        "PING" {
                            set remote_address [lindex $line 1]
                            # ping- -   ,   icmp-
                            set protocol "ICMP"
                        }
                        default {set remote_address [lindex $line 1]}
                    }
                }
                tproxy_* {
                    set timestr [string map {"/" "-"} [lrange $line 0 1]]
                    set time    [clock scan $timestr]
                    set stat    [string tolower [lindex $line 2]]
                    if {[string match request* $stat]} {
                        set full_url [lindex $line end]
                        set ::wwwaddr([lindex $line 3]) [list $full_url]
                    } elseif {$stat eq "finished"} {
                        set reqid [lindex $line 4]
                        if {[info exists ::wwwaddr($reqid)]} {
                            set local_address [resolve [lindex $line 3]]
                            set count_in  [lindex $line end-1]
                            set count_out [lindex $line end]
                            set full_url  $::wwwaddr($reqid)
                            set site_url  [siteFmt [lindex [file split $full_url] 1]]
                            unset ::wwwaddr($reqid)
                        }
                    }
                }
                socks {
                    if {[string is integer -strict [lindex $line 3]]} {
                        set timestr [lrange $line 0 3]
                    } else {set timestr [lrange $line 0 2]}
                    set time      [clock scan $timestr]
                    set count_in  [lindex $line end-2]
                    set count_out [lindex $line end-5]
                    set protocol  [lindex $line 6]
                    if {$protocol eq "TCP"} {
                        set remaddrp [string range [lindex $line 12] 0 end-1]
                        set locaddrp [string range [lindex $line 10] 1 end]
                        set spl      [split $remaddrp ":"]
                        set spl2     [split $locaddrp ":"]
                        set local_address  [resolve [lindex $spl2 0]]
                        set local_port     [lindex $spl2 1]
                        set remote_address [lindex $spl 0]
                        set remote_port    [lindex $spl 1]
                    } elseif {$protocol eq "UDP"} {
                        set locaddrp [string range [lindex $line 9] 1 end-1]
                        set spl      [split $locaddrp ":"]
                        set local_address [resolve [lindex $spl 0]]
                        set local_port    [lindex $spl 1]
                    } else {continue}
                }
                exim {
                    set timestr [lrange $line 0 1]
                    set time    [clock scan $timestr]
                    set dir     [lindex $line 3]
                    if {$dir eq "<="} {
                        set msgid  [lindex $line 2]
                        set from   [lindex $line 4]
                        set pos    [lsearch -glob $line "S=*"]; if {$pos==-1} {continue}
                        set size   [lindex [split [lindex $line $pos] "="] 1]
                        set shpos  [lsearch -glob $line "H=*"]; if {$shpos==-1} {continue}
                        set shost  [lindex [split [lindex $line $shpos] "="] 1]; # sender's host
                        set ::wwwaddr($msgid) [list $from $shost $size]
                    } elseif {$dir eq "=>" || $dir eq "->"} {
                        set msgid  [lindex $line 2]
                        if {![info exists ::wwwaddr($msgid)]} {continue}
                        foreach {sender shost size} $::wwwaddr($msgid) {}
                        set recipient   [lindex $line 4]
                        set orig_to [lindex $line 5]
                        if {[string match <*> $orig_to]} {set recipient [string range $orig_to 1 end-1]}
                        set rhpos   [lsearch -glob $line "H=*"]; if {$rhpos==-1} {continue}
                        set pos     [lsearch -glob $line "S=*"]; if {$pos==-1} {continue}
                        set rhost   [lindex [split [lindex $line $rhpos] "="] 1]; # recipient's host
                        set sloc    [isLocal $sender $sender]; # whether sender is local
                        set rloc    [isLocal $recipient $recipient]; # whether recipient is local
                        if {$sloc && $rloc} {continue}; # if both are local, continue
                        if {$rloc} {set size [lindex [split [lindex $line $pos] "="] 1]}
                        if {$sloc} {
                            set local_address  [resolve $shost]
                            set remote_address $rhost
                            set count_out      $size
                        } else {
                            set local_address  [resolve $rhost]
                            set remote_address $shost
                            set count_in       $size
                        }
                        unset ::wwwaddr($msgid)
                    }
                }
                squid* {
                    set timestr [file rootname [lindex $line 0]]
                    set time    $timestr
                    set stat    [lindex $line 3]
                    set method  [lindex $line 5]
                    if {$method eq "ICP_QUERY"} {continue}
                    if {[string match *REFRESH_HIT* $stat]} {
                        set count_in 201; # avg_reply_hdr_size
                    } elseif {![string match *_HIT* $stat]} {
                        set count_in [lindex $line 4]
                    } else {continue}
                    set full_url [lindex $line 6]
                    set site_url [siteFmt [lindex [file split $full_url] 1]]
                    set local_address [resolve [lindex $line 2]]
                }
                ipphone {
                    set spl [split $line "|"]
                    set str [lindex $spl 4]
                    if {$str ne "unconnected"} {
                        set timestr "[lindex $str 2] [lindex $str 1] [lindex $str 4] [lindex $str 3]"
                        set time    [clock scan $timestr]
                    } else {set time [clock scan [ftime3 $day]]}
                    set lf  [lindex $spl 0]
                    if {$lf ne "CDR"} {continue}
                    set addrp    [split [lindex $spl 6] ":"]
                    set local_address [resolve [lindex $addrp 0]]
                    set phone_number  [lindex [split [lindex $spl 10] ":"] 0]
                    set call_duration [lindex $spl 3]
                }
                sockstat {
                    # forum 1020 1 0 2 193.232.174.37:40800 212.48.138.18:80 3419 118 20060707000001 20060707000101
                    set locaddrp       [lindex $line 5]
                    set remaddrp       [lindex $line 6]
                    set local_address  [lindex [split $locaddrp ":"] 0]
                    set local_port     [lindex [split $locaddrp ":"] 1]
                    set remote_address [lindex [split $remaddrp ":"] 0]
                    set remote_port    [lindex [split $remaddrp ":"] 1]
                    set count_in       [lindex $line 7]
                    set count_out      [lindex $line 8]
                    set time           [clock scan [ftime3 [lindex $line 9]]]
                }
                apache {
                    # old format: 85.21.193.105 - - [16/Jul/2006:20:01:32 +0400] molodoi.pereslavl.ru "GET /forum/ipb/index.php?showtopic=9306&st=0 HTTP/1.1" 403 296 1445
                    # new format: 91.205.124.13 - - [28/Feb/2009:22:00:03 +0300] 0 museum.pereslavl.ru "GET /gorod/sreten.htm HTTP/1.1" 200 352 3607
                    set local_address  [lindex $line 6]
                    set remote_address [lindex $line 0]
                    set site_url       [siteFmt $local_address]
                    set method     [lindex $line 7]
                    if {$method eq "ICP_QUERY"} {continue}
                    set page       [lindex $line 8]
                    set full_url   $site_url$page
                    set count_in   [lindex $line end-1]
                    set count_out  [lindex $line end]
                    set date       [string range [lindex $line 3] 1 end]
                    set spl1       [split $date ":"]
                    set spl2       [split [lindex $spl1 0] "/"]
                    # time = seconds("16-Jul-2006 20:01:32");
                    set timestr    "[lindex $spl2 0]-[lindex $spl2 1]-[lindex $spl2 2] [lindex $spl1 1]:[lindex $spl1 2]:[lindex $spl1 3]"
                    set time       [clock scan $timestr]
                }
                default {
                    #        (  )
                    break
                }
            }; # switch finished
            if {[string match (*) $remote_address]} {
                set remote_address [string range $remote_address 1 end-1]
            }
            if {![string is integer -strict $count_in]} {set count_in 0}
            if {![string is integer -strict $count_out]} {set count_out 0}
            if {![string is integer -strict $call_duration]} {set call_duration 0}
            if {![string is integer -strict $count]} {set count 0}
            if {![string is double -strict $cost]} {set cost 0}
            set bytecost [expr {($count==0) ? 0 : [sciToRealFmt [expr {double($cost)/double($count)}]]}]
            set nval     [expr {$count_in+$count_out+$call_duration}]
            set linecost [expr {$bytecost*$nval}]
            #if {$linecost==0} {continue}; #    - 
            #resolve $remote_address 0; # too slow
            initMDB "rs_$day"
            #debug "mdb: inserting data into rs_$day"
            mdb eval "insert into rs_$day values ('$::sliceid',\
                                   '$sensor_id',\
                                   '$local_address',\
                                   '$local_port',\
                                   '$remote_address',\
                                   '$remote_port',\
                                   '$count_in',\
                                   '$count_out',\
                                   '$protocol',\
                                   '$site_url',\
                                   '$full_url',\
                                   '$sender',\
                                   '$recipient',\
                                   '$phone_number',\
                                   '$call_duration',\
                                   '$zone',\
                                   '$time')"
            set cost_in  [expr {$bytecost*$count_in}]
            if {![lempty [file extension $full_url]]} {
                initMDB "files"
                mdb eval "insert into files values ('$::sliceid',\
                                     '$service_id',\
                                     '$time',\
                                     '$local_address',\
                                     '$full_url',\
                                     '$cost_in',\
                                     '$count_in')"
            }
        }; # "if" finished
        set kword [string trimright [string tolower [lindex $line 0]] {":" " "}]
        set value [string trim [lindex $line 1]]
        set kwords($kword) $value
    }; # "foreach" finished
    if {!$::botiklook(spaceNotifyFlag) && ![spaceAvailable $::botiklook(minspace)]} {
        set ::botiklook(spaceNotifyFlag) 1
        alertWarning $::botiklook(spacenotify)
    }
}
proc getNadminDate {time} {
    return [clockFormat %Y%m%d%H%M%S $time]
}
#    :
# 
proc initStatus {totl str} {
    global aid infostring total current starttime elapsedtime2 done2 elapsed state botiklook
    set total        $totl
    set current      0
    set starttime    [clock seconds]
    set elapsedtime2 0
    set done2        0
    set elapsed      0
    set infostring   $str
    set state        $str; update
    showStatusWindow
    wm title . "($done2%) $infostring$botiklook(version)"
    set aid [after 0 changeTime]
}
#   num  ( %)
proc shiftStatus {{num 1}} {
    global botiklook
    incr ::current $num
    if {$::total <= 0} {return}
    catch {
    #   ": N%"
    set done1 [expr {int((double($::current)/double($::total))*100)}]
    if {$done1-$::done2 >= 1} {
        #     
        setFeedBack $done1
        set ::done2 $done1
        wm title . "($done1%) $::infostring$botiklook(version)"
    }
    }
    update
}
#  (...)   
proc changeTime {} {
    set elapsedtime1 [expr {[clock seconds]-$::starttime}]
#    if {$::auth(done) &&\
        [clock seconds]-$::auth(start) >= $::auth(timeout) &&\
        [array exists ::files] &&\
        ![lempty $::files(all)]}
#            reAuth
    if {$::current==0} {
        set ::elapsed [timeFmt $elapsedtime1]
        set ::state   "${::infostring} $::elapsed."; update
        after 1000 changeTime
        return
    }
    if {[expr {$elapsedtime1-$::elapsedtime2}] >= 1} {
        #    
        set remaintime 0
        catch {
            set remaintime [expr {int((double($::total)/double($::current)-1.0)*[set ::elapsedtime2 $elapsedtime1])}]
        }
        set ::elapsed [timeFmt $elapsedtime1]
        set remain    [timeFmt $remaintime]
        set ::state   "${::infostring} $::elapsed,  $remain."; update
    }
    after 1000 changeTime
}
#         ::
proc timeFmt {secvalue} {
    set hours   [expr {$secvalue / 3600}]
    set mod     [expr {$secvalue % 3600}]
    set mins    [expr {$mod / 60}]
    set seconds [expr {$mod % 60}]
    if {[string length $hours]   == 1} {set hours   "0$hours"}
    if {[string length $mins]    == 1} {set mins    "0$mins"}
    if {[string length $seconds] == 1} {set seconds "0$seconds"}
    return $hours:$mins:$seconds
}
#         :
proc timeFmt2 {secvalue} {
    set secvalue [expr round($secvalue)]
    set mins    [expr {$secvalue / 60}]
    set seconds [expr {$secvalue % 60}]
    if {[string length $mins]    == 1} {set mins    "0$mins"}
    if {[string length $seconds] == 1} {set seconds "0$seconds"}
    return $mins:$seconds
}
#   
proc finishStatus {} {
    global aid state infostring botiklook fb
    after cancel $aid
    set state ""; update
    setFeedBack 0
    wm title . " . $botiklook(version)"
    writeTime
    set infostring ""
    set fb(ltext)  ""
}
proc writeTime {} {
    if {$::elapsed == 0 || $::elapsed eq "00:00:00"} {
        if {$::starttime == 0} {return}
        set ::elapsed [timeFmt [expr {[clock seconds]-$::starttime}]]
        if {$::elapsed ne "00:00:00"} {
            tofile $::botiklook(profile) "[ftime_ru] \[$::auth(torg)] ${::infostring}$::elapsed"
        }
    } else {
        tofile $::botiklook(profile) "[ftime_ru] \[$::auth(torg)] ${::infostring}$::elapsed"
    }
}
#   
proc ftime {} {
    return [clockFormat "%Y-%m-%d %X"]
}
proc ftime_ru {} {
    return [clockFormat "%d-%m-%Y %X"]
}
#     "-- ::"
proc ftime2 {{v 0}} {
    set fmt [clockFormat "%Y-%m-%d %X" $v]
    if {[lindex $fmt 1] eq "0:00:00"} {return [lindex $fmt 0]}
    return $fmt
}
# "" --> "-- ::"
proc ftime3 {{date 0}} {
    if {[string length $date] < 8} {return 0}
    set year  [string range $date 0 3]
    set month [string range $date 4 5]
    set day   [string range $date 6 7]
    set hrs   [string range $date 8 9]
    set mins  [string range $date 10 11]
    set ss    [string range $date 12 13]
    set fmt   "${year}-${month}-$day $hrs:$mins:$ss"
    if {[lempty $hrs] || [lempty $mins] || [lempty $ss]} {return [lindex $fmt 0]}
    set hrs   [string trimleft $hrs  "0"]
    set mins  [string trimleft $mins "0"]
    set ss    [string trimleft $ss   "0"]
    if {[lempty $hrs] && [lempty $mins] && [lempty $ss]} {return [lindex $fmt 0]}
    return $fmt
}
#     ".. ::"
proc ftime4 {{v 0}} {
    set fmt [clockFormat "%d-%m-%Y--%X" $v]
    if {[lindex $fmt 1] eq "0:00:00"} {return [lindex $fmt 0]}
    return $fmt
}
#     
proc sciToRealFmt {x} {
    return [format "%.15f" $x]
}
proc sciToRealFmt2 {x} {
    return [format "%.2f" $x]
}
proc initMemory {} {
    if {!$::botiklook(twapi)} {return}
    set ::iniavail [lindex [twapi::get_memory_info -availphysical] 1]; #  .  ( )
    #    (<30 )
    if {$::iniavail < 30*1024*1024} {
        #alertWarning "!   .\n,    \n    \"\"."
    }
}
#    .    ;
#  true,      $maxpc % 
#  ,   
proc enoughMemory {} {
    if {!$::botiklook(twapi)} {return 1}
    # 
    set avail [lindex [twapi::get_memory_info -availphysical] 1]
    #  
    set pc    [expr {int((double($avail)/double($::iniavail))*100.0)}]
    # 
    if {$pc > 100-$::botiklook(memory)} {return 1}
    return 0
}
#      
proc timerInit {} {
    catch {array unset ::timer}
}
proc timerStart {fun} {
    set ::timer(itime,$fun) [clock seconds]
}
proc timerStop {fun} {
    set ::timer(time,$fun) [expr [clock seconds]-$::timer(itime,$fun)]
    if {![info exists ::timer(N,$fun)]} {
        set ::timer(N,$fun) 1
        set ::timer(times,$fun) 0
    } else {
        incr ::timer(N,$fun)
    }
    incr ::timer(times,$fun) $::timer(time,$fun)
}
proc timerDump {} {
    tofile [appFile times.txt] $::auth(torg):
    set idxs [array names ::timer times,*]
    foreach idx $idxs {
        set fun [lindex [split $idx ,] 1]
        set totaltime $::timer(times,$fun)
        set avgtime [expr $totaltime/$::timer(N,$fun)]
        tofile [appFile times.txt] "$fun $avgtime s."
    }
    timerInit
}
proc applyCounter {key service_id traffic_type count cost pri {nofast 1}} {
    if {$nofast && $::stats(fastsync)} {return}
    mdb eval "insert into exp_tmp values ('$service_id','$traffic_type','$key','$count','$cost','$pri')"
}    
#    
proc makeExpences {} {
    global traffic_cost traffic_nat expences auth services coltitles \
        traftype sensorids rs tdb stats trafid botiklook
    #  ,    
    set tabs0 [lsort [array names rs]]
    set tabs  {}
    set total [llength $tabs0]
    set rtotal 0
    #       -:
    initStatus $total "   . "
    #    ,    
    foreach tab $tabs0 {
        if {![info exists tdb($tab)]} {continue}
        lappend tabs $tab
        set cnt 0
        catch {
            set cnt [db eval "select count(*) from $tab"]
            incr rtotal $cnt
        }
        shiftStatus
    }
    incr rtotal 2
    finishStatus
    catch {countTraffic $tabs}
    fillMDB
    clearTrafficTabs $tabs
    dumpMDB
    if {[llength $tabs] == 0} {return}
    clearExpTabs $tabs
    initStatus $rtotal " . "
    db eval {select * from slices} {
        set sliceinfo($slice_id) $service_id
        set bytecost($slice_id)  [expr {($count==0) ? 0 : [sciToRealFmt [expr {double($cost)/double($count)}]]}]
    }
    initMemory
    if {$stats(hugeorg)} {
        createMDBf
    } else {
        createMDB
    }
    createTDB
    shiftStatus
    set days [list]
    foreach tab $tabs {
        set day [lindex [split $tab "_"] 1]
        lappend days "date1 like \'${day}%\'"
    }
    if {[lempty $days]} {
        set days 1
    } else {
        set days [join $days " or "]
        set days ($days)
    }
    shiftStatus
    unset days

    set rcount 0; # row count
    foreach tab $tabs {
        set day [lindex [split $tab "_"] 1]
        dbg "analysing day $day ..."
        mdb eval {begin}
        db eval "select * from $tab" {
            if {![info exists sliceinfo($slice_id)]} {continue}
            set service_id $sliceinfo($slice_id)
            set count      [expr {$count_in+$count_out}]
            set cost       [expr {$count*$bytecost($slice_id)}]
            #if {$cost == 0} {continue}
            set cost_in    [expr {$count_in*$bytecost($slice_id)}]
            set cost_out   [expr {$count_out*$bytecost($slice_id)}]
            set ttype      $traftype($sensor_id)
            if {$ttype eq "phone"} {
                set count     $call_duration
                set count_in  0
                set count_out $call_duration
                set cost      [expr {$count*$bytecost($slice_id)}]
                set cost_in   0
                set cost_out  $cost
            }
            if {$sensor_id == $sensorids(ip_*) || $sensor_id==$sensorids(flow*)} {
                applyCounter "\[. $auth(torg)] <=>  $protocol" $service_id $ttype $count $cost 1
                applyCounter "\[. $auth(torg)] <==  $protocol" $service_id $ttype $count_in $cost_in 2
                applyCounter "\[. $auth(torg)] ==>  $protocol" $service_id $ttype $count_out $cost_out 2
                applyCounter "\[$services($service_id)] <=>  $protocol" $service_id $ttype $count $cost 3
                applyCounter "\[$local_address] <=>  $protocol" $service_id $ttype $count $cost 3
                applyCounter "\[$services($service_id)] <==  $protocol" $service_id $ttype $count_in $cost_in 4
                applyCounter "\[$services($service_id)] ==>  $protocol" $service_id $ttype $count_out $cost_out 4
                applyCounter "\[$local_address] <==  $protocol" $service_id $ttype $count_in $cost_in 4
                applyCounter "\[$local_address] ==>  $protocol" $service_id $ttype $count_out $cost_out 4
            }
            if {$sensor_id==$sensorids(ip_*) || $sensor_id==$sensorids(flow*) || $sensor_id==$sensorids(socks) || $sensor_id==$sensorids(sockstat)} {
                catch {
                    set svc [port2Service $remote_port $protocol]
                    if {![lempty $svc]} {
                        append remote_port " ($svc)"
                    }
                }
                catch {
                    set svc [port2Service $local_port $protocol]
                    if {![lempty $svc]} {
                        append local_port " ($svc)"
                    }
                }
                applyCounter "\[. $auth(torg)] <=>  $remote_address" $service_id $ttype $count $cost 1 0
                applyCounter "\[. $auth(torg)] <=> .  $remote_port" $service_id $ttype $count $cost 1 0
                applyCounter "\[. $auth(torg)]  $local_port <=> " $service_id $ttype $count $cost 1 0
                applyCounter "\[. $auth(torg)] <==  $remote_address" $service_id $ttype $count_in $cost_in 2
                applyCounter "\[. $auth(torg)] ==>  $remote_address" $service_id $ttype $count_out $cost_out 2
                applyCounter "\[. $auth(torg)]  $local_port <==" $service_id $ttype $count_in $cost_in 2
                applyCounter "\[. $auth(torg)]  $local_port ==>" $service_id $ttype $count_out $cost_out 2
                applyCounter "\[. $auth(torg)] <== .  $remote_port" $service_id $ttype $count_in $cost_in 2
                applyCounter "\[. $auth(torg)] ==> .  $remote_port" $service_id $ttype $count_out $cost_out 2
                applyCounter "\[$services($service_id)] <=> .  $remote_port" $service_id $ttype $count $cost 3
                applyCounter "\[$services($service_id)] <=>  $remote_address" $service_id $ttype $count $cost 3
                applyCounter "\[$local_address] <=> .  $remote_port" $service_id $ttype $count $cost 3
                applyCounter "\[$local_address] <=>  $remote_address" $service_id $ttype $count $cost 3
                applyCounter "\[$services($service_id)] ==> .  $remote_port" $service_id $ttype $count_out $cost_out 4
                applyCounter "\[$services($service_id)] <== .  $remote_port" $service_id $ttype $count_in $cost_in 4
                applyCounter "\[$services($service_id)] ==>  $remote_address" $service_id $ttype $count_out $cost_out 4
                applyCounter "\[$services($service_id)] <==  $remote_address" $service_id $ttype $count_in $cost_in 4
                applyCounter "\[$local_address] <== .  $remote_port" $service_id $ttype $count_in $cost_in 4
                applyCounter "\[$local_address] ==> .  $remote_port" $service_id $ttype $count_out $cost_out 4
                applyCounter "\[$local_address] <==  $remote_address" $service_id $ttype $count_in $cost_in 4
                applyCounter "\[$local_address] ==>  $remote_address" $service_id $ttype $count_out $cost_out 4
                applyCounter "\[. $auth(torg)] <==  $remote_address $coltitles($ttype)" $service_id $ttype $count_in $cost_in 4
                applyCounter "\[. $auth(torg)] ==>  $remote_address $coltitles($ttype)" $service_id $ttype $count_out $cost_out 4
            }
            switch -- $sensorids($sensor_id) {
                exim {
                    if {$count_out > 0} {
                        #   
                        applyCounter "\[$sender]" $service_id $ttype $count $cost 1 0
                        applyCounter "\[$sender] ==>" $service_id $ttype $count_out $cost_out 2
                        applyCounter "\[$services($service_id)] ==>  $recipient" $service_id $ttype $count_out $cost_out 3
                    } else {
                        #   
                        applyCounter "\[$recipient]" $service_id $ttype $count $cost 1 0
                        applyCounter "\[$recipient] <==" $service_id $ttype $count_in $cost_in 2
                        applyCounter "\[$services($service_id)] <==  $sender" $service_id $ttype $count_in $cost_in 3
                        applyCounter "\[. $auth(torg)] <==  $remote_address $coltitles($ttype)" $service_id $ttype $count_in $cost_in 4
                    }
                }
                tproxy_* - squid* {
                        applyCounter "\[. $auth(torg)] <=>  $site_url" $service_id $ttype $count $cost 1 0
                        applyCounter "\[. $auth(torg)] <==  $site_url" $service_id $ttype $count_in $cost_in 2
                        applyCounter "\[. $auth(torg)] ==>  $site_url" $service_id $ttype $count_out $cost_out 2
                        applyCounter "\[$services($service_id)] <=>  $site_url" $service_id $ttype $count $cost 3
                        applyCounter "\[$local_address] <=>  $site_url" $service_id $ttype $count $cost 3
                        applyCounter "\[$services($service_id)] <==  $site_url" $service_id $ttype $count_in $cost_in 4
                        applyCounter "\[$services($service_id)] ==>  $site_url" $service_id $ttype $count_out $cost_out 4
                        applyCounter "\[$local_address] <==  $site_url" $service_id $ttype $count_in $cost_in 4
                        applyCounter "\[$local_address] ==>  $site_url" $service_id $ttype $count_out $cost_out 4
                }
                ipphone {
                    applyCounter "\[. $auth(torg)] ==>   $phone_number" $service_id $ttype $count $cost 2 0
                    applyCounter "\[$services($service_id)] ==>   $phone_number" $service_id $ttype $count $cost 4
                    applyCounter "\[$local_address] ==>   $phone_number" $service_id $ttype $count $cost 4
                    if {![lempty $zone]} {
                        applyCounter "\[. $auth(torg)] ==>   \"$zone\"" $service_id $ttype $count $cost 2
                        applyCounter "\[$services($service_id)] ==>   \"$zone\"" $service_id $ttype $count $cost 4
                        applyCounter "\[$local_address] ==>   \"$zone\"" $service_id $ttype $count $cost 4
                    }
                }
                apache {
                    applyCounter "\[. $auth(torg)] <=>  $remote_address" $service_id $ttype $count $cost 1 0
                    applyCounter "\[. $auth(torg)] <==  $remote_address" $service_id $ttype $count_in $cost_in 2
                    applyCounter "\[. $auth(torg)] ==>  $remote_address" $service_id $ttype $count_out $cost_out 2
                    applyCounter "\[. $auth(torg)] <==  $remote_address $coltitles($ttype)" $service_id $ttype $count_in $cost_in 4
                    applyCounter "\[. $auth(torg)] ==>  $remote_address $coltitles($ttype)" $service_id $ttype $count_out $cost_out 4
                    applyCounter "\[$local_address] <=>  $remote_address" $service_id $ttype $count $cost 3
                    applyCounter "\[$local_address] <==  $remote_address" $service_id $ttype $count_in $cost_in 4
                    applyCounter "\[$local_address] ==>  $remote_address" $service_id $ttype $count_out $cost_out 4
                    applyCounter "\[$services($service_id)] <=>  $remote_address" $service_id $ttype $count $cost 3
                    applyCounter "\[$services($service_id)] ==>  $remote_address" $service_id $ttype $count_out $cost_out 4
                    applyCounter "\[$services($service_id)] <==  $remote_address" $service_id $ttype $count_in $cost_in 4
                    applyCounter "\[ $full_url]" $service_id $ttype $count $cost 1
                    applyCounter "\[ $full_url] <=>  $remote_address" $service_id $ttype $count $cost 1
                    applyCounter "\[ $site_url] <=>  $remote_address" $service_id $ttype $count $cost 1
                    applyCounter "\[ $site_url] =>  $remote_address" $service_id $ttype $count_out $cost_out 1
                    applyCounter "\[ $site_url] <=  $remote_address" $service_id $ttype $count_in $cost_in 1
                }
                default {}
            }; #"switch" finished
            applyCounter "\[. $auth(torg)]" $service_id $ttype $count $cost 1 0
            applyCounter "\[. $auth(torg)] $coltitles($ttype)" $service_id $ttype $count $cost 1 0
            applyCounter "\[. $auth(torg)] <==" $service_id $ttype $count_in $cost_in 2
            applyCounter "\[. $auth(torg)] ==>" $service_id $ttype $count_out $cost_out 2
            applyCounter "\[. $auth(torg)] <== $coltitles($ttype)" $service_id $ttype $count_in $cost_in 2
            applyCounter "\[. $auth(torg)] ==> $coltitles($ttype)" $service_id $ttype $count_out $cost_out 2
            applyCounter "\[$services($service_id)]" $service_id $ttype $count $cost 1 0
            applyCounter "\[$services($service_id)] <== " $service_id $ttype $count_in $cost_in 2
            applyCounter "\[$services($service_id)] ==>" $service_id $ttype $count_out $cost_out 2
            applyCounter "\[$services($service_id)] $coltitles($ttype)" $service_id $ttype $count $cost 3
            applyCounter "\[$services($service_id)] <== $coltitles($ttype)" $service_id $ttype $count_in $cost_in 2
            applyCounter "\[$services($service_id)] ==> $coltitles($ttype)" $service_id $ttype $count_out $cost_out 2
            applyCounter "\[$local_address]" $service_id $ttype $count $cost 1
            applyCounter "\[$local_address] <==" $service_id $ttype $count_in $cost_in 2
            applyCounter "\[$local_address] ==>" $service_id $ttype $count_out $cost_out 2
            applyCounter "\[$local_address] $coltitles($ttype)" $service_id $ttype $count $cost 3
            applyCounter "\[$local_address] <== $coltitles($ttype)" $service_id $ttype $count_in $cost_in 4
            applyCounter "\[$local_address] ==> $coltitles($ttype)" $service_id $ttype $count_out $cost_out 4
            if {[string length $zone]==1} {
                if {$zone eq "N"} {
                    set trtype " "
                } elseif {$zone eq "H"} {
                    set trtype "  "
                } elseif {$zone eq "D"} {
                    set trtype " "
                } elseif {$zone eq "U"} {
                    set trtype " "
                }
                applyCounter "\[$services($service_id)] $trtype" $service_id $ttype $count $cost 1
                applyCounter "\[$services($service_id)] <== $trtype" $service_id $ttype $count_in $cost_in 2
                applyCounter "\[$services($service_id)] ==> $trtype" $service_id $ttype $count_out $cost_out 2
                applyCounter "\[. $auth(torg)] $trtype" $service_id $ttype $count $cost 1 0
                applyCounter "\[. $auth(torg)] <== $trtype" $service_id $ttype $count_in $cost_in 2
                applyCounter "\[. $auth(torg)] ==> $trtype" $service_id $ttype $count_out $cost_out 2
                applyCounter "\[$local_address] $trtype" $service_id $ttype $count $cost 3
                applyCounter "\[$local_address] <== $trtype" $service_id $ttype $count_in $cost_in 4
                applyCounter "\[$local_address] ==> $trtype" $service_id $ttype $count_out $cost_out 4
            }
            if {0 == [incr rcount] % $::botiklook(maxrows)} {
                shiftStatus $::botiklook(maxrows)
            }
            update
        }; #"select" finished
        set senscrit {}
        foreach colid $::botiklook(rubcols) {
            lappend senscrit $sensorids($colid)
        }
        set senscrit [join $senscrit ","]
        db eval "select service_id,count,cost,address,sensor_id from (select service_id,count,cost,address,sensor_id,date1 from slices where sensor_id in ($senscrit) and date1 like '${day}%')" {
            set ttype $::traftype($sensor_id)
            applyCounter "\[. $auth(torg)]" $service_id $ttype $count $cost 1 0
            applyCounter "\[. $auth(torg)] $coltitles($ttype)" $service_id $ttype $count $cost 1 0
            applyCounter "\[$services($service_id)]" $service_id $ttype $count $cost 1 0
            applyCounter "\[$services($service_id)] $coltitles($ttype)" $service_id $ttype $count $cost 3 0
            applyCounter "\[$address]" $service_id $ttype $count $cost 1
            applyCounter "\[$address] $coltitles($ttype)" $service_id $ttype $count $cost 3
        }
        mdb eval {commit}
        dumpTDB $day
    }; #"foreach" finished
    #clearMDB
    closeMDB
    set total [llength $tabs]
    set ::infostring "  ([daysWord $total]). "
    finishStatus
    array unset bytecost
    array unset sliceinfo
}
proc countTraffic {tabs} {
    global traffic_nat traffic_cost traftype ttypes
    dbg "countTraffic ..."
    set numtypes 0; #   
    foreach {type snsrs num dbtypes} $ttypes {
        set tplace($type) $num
        incr numtypes
    }
    set zeros [string repeat "0 " $numtypes]
    db eval {select * from slices} {
        set day [getDay $date1]
        if {[lsearch $tabs rs_$day] == -1} {continue}
        set ttype $traftype($sensor_id)
        if {![info exists traffic_nat($day,$service_id)]} {
            set traffic_nat($day,$service_id) $zeros
        }
        set oldval [lindex $traffic_nat($day,$service_id) $tplace($ttype)]
        lset traffic_nat($day,$service_id) $tplace($ttype) [expr {$oldval+$count}]
        if {![info exists traffic_cost($day,$service_id)]} {
            set traffic_cost($day,$service_id) $zeros
        }
        set oldval [lindex $traffic_cost($day,$service_id) $tplace($ttype)]
        lset traffic_cost($day,$service_id) $tplace($ttype) [expr {$oldval+$cost}]
    }
}
proc createTDB {} {
    set tab "exp_tmp"
    catch {mdb eval "drop table $tab"}
    createTable "mdb" $tab
    #set sql    [mdb eval "select sql from sqlite_master where name='$tab'"]
    #set fields "[lrange [lindex $sql 0] 3 end]"
    #catch {mdb eval [subst "create temp table tmp $fields"]}
}
#      ,   :
proc dumpTDB {day} {
    if {!$::botiklook(spaceNotifyFlag) && ![spaceAvailable $::botiklook(minspace)]} {
        set ::botiklook(spaceNotifyFlag) 1
        alertWarning $::botiklook(spacenotify)
    }
    dbg "dumping TDB ..." 3
    set dbfpath [file join $::dbcat $::auth(torg).bdb]
    createTable "db" exp_$day
    mdb eval "attach '$dbfpath' as hddb"; # hddb = hard drive database
    mdb eval "begin;insert into hddb.'exp_$day' select service_id,traffic_type,key,sum(count),sum(cost),priority from exp_tmp\
             group by service_id,traffic_type,key,priority;commit"
    mdb eval {detach hddb}
    mdb eval {begin;delete from exp_tmp;commit}
}
#  .    traffic_cost traffic_nat expences:
proc fillMDB {{tab {}}} {
    dbg "fillMDB ..." 3
    if {[array exists ::traffic_nat]} {
        set sid [array startsearch ::traffic_nat]
        initMDB "traffic_nat"
        mdb eval "begin"
        while {[array anymore ::traffic_nat $sid]} {
            set elt   [array nextelement ::traffic_nat $sid]
            set spl   [split $elt ","]
            set day   [lindex $spl 0]
            set service_id [lindex $spl 1]
            set vals  \'[join $::traffic_nat($elt) "','"]\'
            mdb eval "insert into traffic_nat values('$day','$service_id',[subst $vals])"
        }
        mdb eval "commit"
        array donesearch ::traffic_nat $sid
        array unset ::traffic_nat
    }
    if {[array exists ::traffic_cost]} {
        set sid [array startsearch ::traffic_cost]
        initMDB "traffic_cost"
        mdb eval "begin"
        while {[array anymore ::traffic_cost $sid]} {
            set elt   [array nextelement ::traffic_cost $sid]
            set spl   [split $elt ","]
            set day   [lindex $spl 0]
            set service_id [lindex $spl 1]
            set vals  \'[join $::traffic_cost($elt) "','"]\'
            mdb eval "insert into traffic_cost values('$day','$service_id',[subst $vals])"
        }
        mdb eval "commit"
        array donesearch ::traffic_cost $sid
        array unset ::traffic_cost
    }
}
proc clearTrafficTabs {rstabs} {
    foreach tab $rstabs {
        set day [lindex [split $tab "_"] 1]
        db eval "begin;delete from traffic_nat where day='$day';\
             delete from traffic_cost where day='$day';commit"
    }
}
proc clearExpTabs {rstabs} {
    foreach tab $rstabs {
        set day [lindex [split $tab "_"] 1]
        if {[info exists ::tdb(exp_$day)]} {db eval "drop table exp_$day"; unset ::tdb(exp_$day)}
    }
}
#  
proc reAuth {} {
    global auth
    set query [http::formatQuery do_auth 1 ORG $auth(org) LOGIN $auth(login) PASSWORD [tokoi $auth(password)]]
    set token [http::geturl $auth(srvurl) -query $query -timeout $::botiklook(httpto)]
    upvar \#0 $token state
    if {![info exists state(meta)]} {
        catch {http::cleanup $token}
        return
    }
    array set meta $state(meta)
    if {[info exists meta(Set-Cookie)]} {
        #$meta(Set-Cookie) == {NADMIN_AUTH=00429135708055028; path=/; secure}
        set spl  [split $meta(Set-Cookie) ";"]
        set spl2 [split [lindex $spl 0] "="]
        if {[lindex $spl2 0] eq "NADMIN_AUTH"} {
            set auth(cookie) $meta(Set-Cookie)
            set auth(start)  [clock seconds]
            set auth(done) 1
        } else {set auth(done) 0}
    }
    catch {http::cleanup $token}
}
proc doAuth {} {
    global auth state stats sync botiklook
    if {$auth(offline)} {
        initStatus 0 " . "
        incrCounter "offlinework"
        offlineWork
        return
    } elseif {[file exists [file join $stats(homecat) $auth(org)]]} {
        set msg "    \n\  .\n       ?"
        set answer [alertQuestion $msg]
        if {$answer eq "yes"} {
            incrCounter "syncoffline"
            set auth(torg) $auth(org)
            initStatsVars
            try_eval {convertLocalStorage} {
                alertError "    .\n$errorInfo"
                asksendmail "    .\n[ftime] $errorInfo"
                showAuthWindow
                return 0
            }
            incrCounter "syncofflinedone"
            showChooseStatWindow
            return
        } else {
            set msg "     ?"
            set answer [alertQuestion $msg "no"]
            if {$answer eq "yes"} {
                try_eval {
                    initStatus 0 "    . "
                    if {![lempty $auth(org)]} {
                        catch {file delete -force -- [file join $stats(homecat) $auth(org)]}
                    }
                    finishStatus
                } {
                    alertError "    .\n$errorInfo"
                }
            }
        }
    }
    initStatus 0 " . "
    try_eval {
     incrCounter "authtry"
     finishStatus
     initStatus 0 ". "
     set query [http::formatQuery do_auth 1 ORG $auth(org) LOGIN $auth(login) PASSWORD [tokoi $auth(password)]]
     set token [http::geturl $auth(srvurl) -query $query -handler authHandler -timeout $botiklook(httpto)]
     parseMeta $token
     if {!$auth(done)} {finishStatus; showAuthWindow; return}
     incrCounter "authdone"
     finishStatus
     if {$auth(anyorg)} {
         showTOrgWindow
        if {[lempty $auth(torg)]} {showAuthWindow; return}
     } else {
         set auth(torg) $auth(org)
     }
     initStatsVars
    } {
     alertError "  .\n$errorInfo"
     set state " "; update
     catch {http::cleanup $token}
     set auth(done) 0
     finishStatus
     asksendmail "  .\n[ftime] $errorInfo"
     showAuthWindow
     return
    }
    incrCounter "synctry"
    try_eval {
        checkDoSync
        if {$sync(dosync)} {
            #    -
            loop i 0 $sync(ilimit) {
                set sync(unavail) {}
                synchronize
                if {[lempty $sync(unavail)]} {break}
            }
            #    $sync(ilimit)     ,
            #    
            if {![lempty $sync(unavail)]} {
                lappend sync(errors) \n$sync(unavail)
            }
        }
        if {$sync(dosync2)} {
            synchronize2
        }
    } {
        alertError "  .\n$errorInfo"
        set msg "  .\n[ftime] $errorInfo"
        if {![lempty $sync(errors)]} {
            append msg "\nSync. errors: $sync(errors)"
        }
        asksendmail $msg
        showAuthWindow
        return 0
    }
    if {![lempty $sync(errors)]} {
        dbg errors:$sync(errors)
    }
    try_eval {makeExpences} {
        alertError "  .\n$errorInfo"
        asksendmail "   ().\n[ftime] $errorInfo"
        showAuthWindow
        return 0
    }
    showChooseStatWindow
    if {![lempty $sync(errors)]} {
        alertError "   .\n\
                   ,\n\
                    \n\
                  ."
        asksendmail " .\n$sync(errors)"
        set sync(errors) {}
        incrCounter "syncerrors"
    } else {
        incrCounter "syncdone"
    }
}
proc authHandler {socket token} {
    global auth 
    gets $socket line
    set d [string is xdigit -strict [string trim $line]]
    set n [string length $line]
    if {$d || [lempty $line]} {return $n}
    if {[string match <*> $line] || [lempty $line]} {return $n}
    foreach {ok anyorg} $line {}
    set auth(done)   [expr {$ok eq "OK"}]
    set auth(anyorg) [expr {$anyorg eq "ANYORG"}]
    if {!$auth(done)} {
        if {[string match <p>* $line]} {
            set line [fromkoi [string range $line 3 end]]
        }
        alertError "  .\n$line"
        #asksendmail "  .\n[ftime] $line"
    }
    return $n
}
proc parseMeta {token} {
    upvar \#0 $token stat
    if {![info exists stat(meta)]} {
        catch {http::cleanup $token}
        return
    }
    foreach {name value} $stat(meta) {
        if {$name eq "Set-Cookie"} {
            parseCookie $value
        }
    }
    catch {http::cleanup $token}
}
proc parseCookie {cookie} {
    global auth state
    set split [split $cookie ";"]
    foreach par $split {
        set spl   [split $par "="]
        set pname [lindex $spl 0]
        set pval  [lindex $spl 1]
        switch -- $pname {
            "NADMIN_AUTH" {
                set auth(cookie) $cookie
                set auth(start)  [clock seconds]
                return
            }
            "NADMIN_ERROR" {
                set auth(done) 0
                set state "  . "; update
                alertError "  .  ,\n    . "
                #asksendmail "  .   .\n[ftime]"
                showAuthWindow
                return
            }
            "NADMIN_EXPIRE" {doAuth}
            default {}
        }
    }
}
proc getHeaders {} {
    initStatus 0 "  . "
    array unset ::mtimes
    array unset ::sizes
    set ::mindate [getNadminDate [clock seconds]]
    if {$::sync(mtime2)==0} {set ::sync(mtime2) [clock seconds]}
    set newmtime1 [clock seconds]
    doList
    if {$::botiklook(svcname) ne "" && (![info exists ::depdirs($::auth(torg))] || $::depdirs($::auth(torg)) ne "connect-$::botiklook(svcname)")} {
        alertWarning "   : $::botiklook(svcname)"
        finishStatus
        showAuthWindow
        return 0
    }
    set ::sync(mtime1) $newmtime1
    finishStatus
}
proc listHandler {socket token} {
    gets $socket line
    #debug $line
    set d [string is xdigit -strict [string trim $line]]
    set n [string length $line]
    if {$d || [lempty $line]} {return $n}
    if {[string match <p>* $line]} {
        alertError "    .\n$line"
        #asksendmail "    .\n[ftime] $line"
        showAuthWindow
        return 0
    }
    gotLSLine $line
    return [llength $line]
}
proc listCommand {token} {
    upvar #0 $token state
    puts -nonewline $::lsd $state(body)
}
proc doList {} {
    if {[windowsPlatform]} {
        doList_windows
        return
    }
    doList_unix
    seek $::lsd 0
    while {![eof $::lsd]} {
        gets $::lsd line
        gotLSLine $line
    }
    close $::lsd
}
proc doList_unix {} {
    set fpath [appFile $::botiklook(pname).ls]
    set ::lsd [open $fpath w+]
    lappend ::botiklook(tmpfiles)  $fpath
    fconfigure $::lsd -translation binary
    set query [http::formatQuery do_list 1 ORG $::auth(torg)]
    set token [http::geturl $::auth(srvurl) \
            -query $query \
            -command listCommand \
            -timeout 0 \
            -headers "Cookie $::auth(cookie)"]
    http::wait $token
    return 1
}
proc doList_windows {} {
    set query [http::formatQuery do_list 1 ORG $::auth(torg)]
    set token [http::geturl $::auth(srvurl) \
            -query $query \
            -handler listHandler \
            -timeout 0 \
            -headers "Cookie $::auth(cookie)"]
    return 1
}
proc trim {s} {
    return [string trim $s {/ \\ : ;}]
}
proc datesIntersect {a b c d} {
    return [expr {!($c > $b || $d < $a)}]
}
proc correctServiceDir {dir} {
    return [expr {$::botiklook(svcname) ne "" && ($dir eq $::auth(torg) || [string match "$::auth(torg)/connect-$::botiklook(svcname)*" $dir])}]
}
proc gotLSLine {elt} {
    set len [llength $elt]
    #      "total []",    
    if {$len == 0 || $len==2} {return}
    #    
    if {$len == 1} {
        #  ":"   
        set ::updir [string range $elt 0 end-1]
        #         -
        set ::updir [string replace $::updir 0 0 $::auth(torg)]
        if {$::updir eq "$::auth(torg)/account_run" || [lempty $::updir]} {return}
        if {$::botiklook(svcname) eq "" || [correctServiceDir $::updir]} {
            #debug "accept1:$::updir; lsline=$elt; svcname=$::botiklook(svcname)"
            set ::depdirs($::updir) {}
        }
        return
    }
    #        
    if {$::updir eq "$::auth(torg)/account_run" || [lempty $::updir]} {return}
    if {$::botiklook(svcname) ne "" && ![correctServiceDir $::updir]} {return}
    #debug "accept2:$::updir; lsline=$elt; svcname=$::botiklook(svcname)"
    set modes [lindex $elt 0]
    set t     [string index $modes 0]
    if {$t eq "d"} {
        #   :
        set dir [trim [lindex $elt end]]
        if {$dir ne "." && $dir ne ".." && $dir ne "account_run"} {
            if {$::botiklook(svcname) eq "" || ($::updir eq $::auth(torg) && $dir eq "connect-$::botiklook(svcname)")} {
                   lappend ::depdirs($::updir) $dir
               }
        }
    } elseif {$t eq "-"} {
        #   :
        set mdate [lrange $elt 4 end-1]
        set md2   $mdate
        set spl   [split [lindex $mdate end-1] "."]
        if {[llength $spl] == 2} {
            #     .000000000
            set date  [lindex $spl 0]
            set mdate [list [lrange $mdate 0 end-2] $date]
        }
        set file     [trim [lindex $elt end]]
        set filedate [getLoDate $file]
        if {[info exists ::stats(rdate1)] && [info exists ::stats(rdate2)]} {
            #       ,
            #       
            set day1 [getDay [getLoDate $file]]
            set day2 [getDay [getHiDate $file]]
            if {![datesIntersect $::stats(rdate1) $::stats(rdate2) $day1 $day2]} {return}
        }
        set filepath [file join $::stats(homecat) $::updir $file]
        set mtime    [clock scan $mdate]
        if {$mtime < $::sync(mtime1) || $mtime > $::sync(mtime2)} {return}
        set ::mtimes($::updir/$file) [list $mtime]
        set ::sizes($::updir/$file) [lindex $elt 3]
        if {$filedate < $::mindate} {set ::mindate $filedate}
    }
    return
}
proc showStatusWindow {} {
    global state botiklook
    if {$botiklook(withdrawn)} {
        wm state . normal
        #      
        #wm geometry . +100+100
        update
        set botiklook(withdrawn) 0
    }
    if {[winfo exists .status]} {return}
    wm title     . " . $botiklook(version)"
    wm resizable . 0 0
    wm protocol  . WM_DELETE_WINDOW {
        doExit .
    }
    if {[windowsPlatform]} {catch {wm iconbitmap . -default $botiklook(winicon)}}
    focus -force .
    frame .status
    pack .status -padx 15 -fill both -expand 1
    showFeedBack .status
    label .status.state -textvariable state -font {Helvetica 12 bold}
    button .status.pause -text "" -command {doPause .status.pause} \
        -font {Helvetica 10} -bd 3
    pack .status.state .status.pause -pady 4 -side top
    bind . <KeyPress-Return> ".status.pause invoke"
    bind . <KeyPress-Escape> "wm iconify ."
    bind . <Control-w>       "doExit ."
    set state ""; update
}
proc hideStatusWindow {} {
    wm withdraw .
    wm title     . $::botiklook(version)
    update
    set ::botiklook(withdrawn) 1
}
proc doPause {but} {
    global pvar
    $but configure -text ""
    $but configure -command "doUnpause $but"
    vwait pvar
}
proc doUnpause {but} {
    global pvar
    $but configure -text ""
    $but configure -command "doPause $but"
    set pvar 1
}
proc showFeedBack {fr} {
    global fb
    if {[info exists fb(f)] && [winfo exists $fb(f)]} {
        setFeedBack
        return
    }
    set f      $fr.feedback
    set fb(f)      $f
    #  ": X%"
    set fb(ltext)  ""
    # -
    set fb(symbol) "|"
    set fb(repchar) " "
    set fb(ftext)   [string repeat $fb(repchar) 50]
    # -
    set fb(fill) $f.fill
    frame $f
    label $f.l -textvar fb(ltext) -font {Helvetica 12 bold}
    if {[unixPlatform]} {
        label $fb(fill) -textvar fb(ftext) -bg white -fg blue \
            -font {Courier 11 bold} -relief sunken
    } else {
        ttk::progressbar $fb(fill) -variable ::fbprogress -mode determinate -length 500
    }
    set ::fbprogress 0
    pack $f -padx 8 -pady 4 -fill x
    pack $f.l -pady 2
    pack $fb(fill)
    update
}
#  
proc setFeedBack {{percent 0}} {
    catch {
    set ::fb(ltext) ": $percent%"
    if {$percent != 0 && $percent % 2} {return}
    if {$percent < 0 || $percent > 100} {return}
    if {[unixPlatform]} {
        set newleft    [string repeat $::fb(symbol) [set percent [expr $percent / 2]]]
        set spaces     [string repeat $::fb(repchar) [set spacelen [expr 50-$percent]]]
        set ::fb(ftext)  $newleft$spaces
    }
    if {$::fbprogress != $percent} {set ::fbprogress $percent}
    update
    }
}
proc date_chooser {w args} {
    global datefield

    array set defaults {
        mn,en {
        . January February March April May June July August September October November December
        }
        weekdays,en {Sun Mon Tue Wed Thu Fri Sat}

        mn,ru {
        .            
        }
        weekdays,ru {
                  
        }
    }    
    
    array set datefield [array get defaults]

    set now [clock scan now]
    set datefield(year) [clockFormat "%Y" $now]
    scan [clockFormat "%m" $now] %d datefield(month)
    scan [clockFormat "%d" $now] %d datefield(day)

    array set datefield {
        -font {Arial 10} -titlefont {Arial 12} -bg snow1
        -highlight orange -mon 0 -language ru -textvariable {}
        -command {} -clockformat "%Y/%m/%d" -showpast 1
    }
    # The -mon switch gives the position of Monday (1 or 0)
    array set datefield $args
    set datefield(canvas) [canvas $w -bg $datefield(-bg) -width 200 -height 180]
    focus -force $datefield(canvas)
    bind $datefield(canvas) <FocusOut> "date_HandleCallback %W"

    $w bind day <1> {
        set item [%W find withtag current]
        catch {set datefield(day) [%W itemcget $item -text]}
        date_display %W
        date_HandleCallback %W
    }

    if {$datefield(-textvariable) ne {}} {
        set tmp [set $datefield(-textvariable)]
        if {$tmp ne {}} {
            set date [clock scan $tmp]
            set datefield(thisday)   [clockFormat %d $date]
            set datefield(thismonth) [clockFormat %m $date]
            set datefield(thisyear)  [clockFormat %Y $date]
        }
    }

    date_cbutton $w 60  10 << {date_adjust %W  0 -1}
    date_cbutton $w 80  10 <  {date_adjust %W -1  0}
    date_cbutton $w 120 10 >  {date_adjust %W  1  0}
    date_cbutton $w 140 10 >> {date_adjust %W  0  1}
    date_display $w
}
proc date_adjust {w dmonth dyear} {
    global datefield

    incr datefield(year)  $dyear
    incr datefield(month) $dmonth
    if {$datefield(month)>12} {set datefield(month) 1; incr datefield(year)}
    if {$datefield(month)<1}  {set datefield(month) 12; incr datefield(year) -1}
    set maxday [date_numberofdays $datefield(month) $datefield(year)]
    if {$maxday < $datefield(day)} {set datefield(day) $maxday}
    date_display $w
}
proc date_display {w} {
    global datefield

    set c $datefield(canvas)
    foreach tag {title otherday day} {$c delete $tag}
    set x0 20; set x $x0; set y 50
    set dx 25; set dy 20
    set xmax [expr {$x0+$dx*6}]
    set datefield(date) [clock scan $datefield(month)/$datefield(day)/$datefield(year)]
    set title [date_formatMY $w [date_monthname $w $datefield(month)] $datefield(year)]
    $c create text [expr ($xmax+$dx)/2] 30 -text $title -fill blue -font $datefield(-titlefont) -tag title
    set weekdays $datefield(weekdays,$datefield(-language))
    if !$datefield(-mon) {lcycle weekdays}
    foreach i $weekdays {
        $c create text $x $y -text $i -fill blue -font $datefield(-font) -tag title
        incr x $dx
    }
    set first $datefield(month)/1/$datefield(year)
    set weekday [clockFormat %w [clock scan $first]]
    if !$datefield(-mon) {set weekday [expr {($weekday+6)%7}]}
    set x [expr {$x0+$weekday*$dx}]
    set x1 $x; set offset 0
    incr y $dy
    while {$weekday} {
        set t [clock scan "$first [incr offset] days ago"]
        scan [clockFormat "%d" $t] %d day
        $c create text [incr x1 -$dx] $y -text $day -fill grey -font $datefield(-font) -tag otherday
        incr weekday -1
    }
    set dmax [date_numberofdays $datefield(month) $datefield(year)]
    for {set d 1} {$d<=$dmax} {incr d} {
        if {($datefield(-showpast) == 0) && ($d<$datefield(thisday)) && ($datefield(month) <= $datefield(thismonth)) && ($datefield(year) <= $datefield(thisyear)) } {
            set id [$c create text $x $y -text $d -fill grey -tag otherday -font $datefield(-font)]
        } else {
            set id [$c create text $x $y -text $d -tag day -font $datefield(-font)]
        }
        if {$d==$datefield(day)} {
            eval $c create rect [$c bbox $id] -fill $datefield(-highlight) -outline $datefield(-highlight) -tag day
        }
        $c raise $id
        if {[incr x $dx]>$xmax} {
            set x $x0
            incr y $dy
        }
    }
    if {$x != $x0} {
        for {set d 1} {$x<=$xmax} {incr d; incr x $dx} {
            $c create text $x $y -text $d -fill grey -font $datefield(-font) -tag otherday
        }
    }
    if { $datefield(-textvariable) ne {} } {
        # puts "[info level 0]: $datefield(-clockformat)"
        set $datefield(-textvariable) [clockFormat $datefield(-clockformat) $datefield(date)]
    }
}

proc date_HandleCallback {w} {
    global datefield
    if {$datefield(-command) ne {}} {
        uplevel \#0 $datefield(-command)
    }
}

proc date_formatMY {w month year} {
    global datefield

    if ![info exists datefield(format,$datefield(-language))] {
        set format "%m %y" ;# default
    } else {set format $datefield(format,$datefield(-language))}
    foreach {from to} [list %m $month %y $year] {
        regsub $from $format $to format
    }
    subst $format
}
proc date_monthname {w month {language default}} {
    global datefield

    if {$language=="default"} {set language $datefield(-language)}
    if {[info exists datefield(mn,$language)]} {
        set res [lindex $datefield(mn,$language) $month]
    } else {set res $month}
}
proc date_numberofdays {month year} {
    if {$month==12} {set month 0; incr year}
    clockFormat %d [clock scan "[incr month]/1/$year 1 day ago"]
}
proc lcycle {_list} {
    upvar $_list list
    set list [concat [lrange $list 1 end] [list [lindex $list 0]]]
}
proc date_cbutton {w x y text command} {
    set txt [$w create text $x $y -text " $text "]
    set btn [eval $w create rect [$w bbox $txt] -fill grey -outline grey]
    $w raise $txt
    foreach i [list $txt $btn] {$w bind $i <1> $command}
}
proc showCalendar {tw x y clockformat var} {
    set w $tw.cal
    catch {destroy $w}
    toplevel $w
    wm overrideredirect $w 1

    frame $w.f
    date_chooser $w.f.d -language ru \
        -command "set ::SEMA$tw close" \
        -textvariable $var -clockformat $clockformat
    pack $w.f.d
    pack $w.f

    lassign [winfo pointerxy .] x y
    wm geometry $w "+${x}+${y}"

    set _w [grab current]
    if {$_w ne {}} {
        grab release $_w
        grab set $w
    }
    set ::SEMA$tw ""
    tkwait variable ::SEMA$tw
    if {$_w ne {}} {
        grab release $w
        grab set $_w
    }
    destroy $w
}
proc showConnectionPrompt {} {
    global auth botiklook
    set w .conn
    catch {destroy $w}
    catch {toplevel $w}
    wm title $w "  . $botiklook(version)"
    if {[windowsPlatform]} {catch {wm iconbitmap $w $botiklook(winicon)}}
    wm resizable $w 0 0
    focus -force $w
    frame $w.f1
    label $w.f1.l -text "  :" -font $botiklook(footerfont)
    entry $w.f1.e -width 40 -takefocus 1 -textvar ::botiklook(svcname); # -validate key -vcmd {string is graph -strict %P}
    frame $w.f2
    button $w.f2.enter -text "" -takefocus 1 -bd 3 \
        -font {Helvetica 10} -command "destroy $w"
    button $w.f2.cancel -text "" -takefocus 1 -bd 3 \
        -font {Helvetica 10} -command "set ::botiklook(svcname) {}; destroy $w"
    pack $w.f1 $w.f2 -fill x
    pack $w.f1.l $w.f1.e -padx 13 -pady 5
    pack $w.f2.cancel $w.f2.enter -side left -pady 5 -expand 1
    focus -force $w.f1.e
    bind $w <KeyPress-Return> "$w.f2.enter invoke"
    bind $w <KeyPress-Escape> "$w.f2.cancel invoke"
    update
}
proc showPeriodWindow {w} {
    hideStatusWindow
    set p $w.period
    catch {destroy $p}
    catch {toplevel $p}
    wm title $p " . $::botiklook(version)"
    set x [expr [winfo rootx $w] + 30]
    set y [expr [winfo rooty $w] + 30]
    wm geometry $p +${x}+$y
    wm resizable $p 0 0
    focus -force $p
    frame $p.f1
    frame $p.f2
    set clockformat "%Y-%m-%d"
    set ::datestart [clockFormat $clockformat]
    button $p.f1.de1b -command "showCalendar {} %X %Y $clockformat ::datestart" -text ":" -font {Arial 10} -width 5
    entry $p.f1.de1e -textvariable ::datestart -width 11 -font {Arial 11}
    set ::datefinish [clockFormat $clockformat]
    button $p.f1.de2b -command "showCalendar {} %X %Y $clockformat ::datefinish" -text ":" -font {Arial 10} -width 5
    entry $p.f1.de2e -textvariable ::datefinish -width 11 -font {Arial 11}
    button $p.f2.ok -text "" -font {Helvetica 10} -command "setPeriod $p $p.f1.de1e $p.f1.de2e" -bd 3
    button $p.f2.cancel  -text "" -font {Helvetica 10} -command "destroy $p" -bd 3
    pack $p.f1 $p.f2 -side top -fill x
    pack $p.f1.de1b $p.f1.de1e -side left -fill x -padx 3 -pady 3
    pack $p.f1.de2b $p.f1.de2e -side left -fill x -padx 3 -pady 3
    pack $p.f2.cancel $p.f2.ok -side left -padx 10 -pady 10 -expand 1
    bind $p <KeyPress-Return> "$p.f2.ok invoke"
    bind $p <KeyPress-Escape> "$p.f2.cancel invoke"
    if {[info exists ::stats(pdate1)] && [info exists ::stats(pdate2)]} {
        $p.f1.de1e delete 0 end
        $p.f1.de2e delete 0 end
        $p.f1.de1e insert 0 $::stats(pdate1)
        $p.f1.de2e insert 0 $::stats(pdate2)
    }
    update
}
proc setPeriod {w e1 e2} {
    if {[catch {
        set date1  [$e1 get]
        set scan1  [clock scan $date1]
        set rdate1 [clockFormat %Y%m%d $scan1]
        set date2  [$e2 get]
        set scan2  [clock scan $date2]
        set rdate2 [clockFormat %Y%m%d $scan2]
    } desc] || $rdate1 > $rdate2} {
        alertError "   ."
        focus -force $w
        return
    }
    set ::stats(pdate1) $date1
    set ::stats(pdate2) $date2
    set ::stats(rdate1) $rdate1
    set ::stats(rdate2) $rdate2
    destroy $w
    return
}
proc showAuthWindow {} {
    global auth botiklook whoami
    hideStatusWindow
    set a .auth
    catch {destroy $a}
    catch {toplevel $a}
    wm title $a ". $botiklook(version)"
    if {[windowsPlatform]} {catch {wm iconbitmap $a -default $botiklook(winicon)}}
    wm protocol $a WM_DELETE_WINDOW {
        doExit .auth
    }
    wm resizable $a 0 0
    #if {[unixPlatform]} {wm iconbitmap $a @$botiklook(unixicon)}
    focus -force $a
    frame $a.f
    frame $a.f.f1
    frame $a.f.f2
    frame $a.f.fol
    frame $a.f.f3
    pack $a.f $a.f.f1 $a.f.f2 $a.f.fol $a.f.f3 -fill both
    label $a.f.f1.label -text ",   \n      \"$::net(name)\"."\
        -font {Helvetica 12 bold}
    pack $a.f.f1.label -expand 1 -padx 5 -pady 10
    frame $a.f.f2.labels
    frame $a.f.f2.entries
    pack $a.f.f2.labels $a.f.f2.entries -side left -expand 1
    set l $a.f.f2.labels
    set e $a.f.f2.entries
    label $l.org   -text "  :" -anchor w -font {Helvetica 11}
    label $l.login -text " :"     -anchor w -font {Helvetica 11}
    label $l.pswd  -text " :"       -anchor w -font {Helvetica 11}
    pack $l.org $l.login $l.pswd -pady 2 -padx 3 -fill x
    entry $e.org   -width 20 -takefocus 1 -textvar auth(org); # -validate key -vcmd {checkOrg %P}
    entry $e.login -width 20 -takefocus 1 -textvar auth(login); # -validate key -vcmd {checkLogin %P}
    entry $e.pswd  -width 20 -takefocus 1 -textvar auth(password) -show "*" ; #         ,        
    pack $e.org $e.login $e.pswd -pady 4
    set auth(password) ""
    checkbutton $a.f.fol.cb -text "   " -variable auth(offline) -relief flat -command "showOfflineWindow $a"
    button $a.f.fol.p -text " " -command "showPeriodWindow $a" -bd 2
    pack $a.f.fol.cb $a.f.fol.p -side top
    bind $a <Control-Alt-s> "showConnectionPrompt"
    showFooter $a
    update
    #  :         
    if {[lempty $auth(org)]} {
        whoAmI
        catch {set auth(org) $whoami(UserName)}
    }
    catch {
    if {[lempty $auth(org)]} {
        focus -force $e.org
    } elseif {[lempty $auth(login)]} {
        focus -force $e.login
    } elseif {[lempty $auth(password)]} {
        focus -force $e.pswd
    }
    }
}
proc checkOrg {org} {
    return [regexp {^[a-zA-Z0-9_]*$} $org]
}
proc checkLogin {login} {
    return [regexp {^[_a-zA-Z0-9][-_a-zA-Z0-9]*$} $login]
}
proc showTOrgWindow {} {
    global auth botiklook
    hideStatusWindow
    set w .torg
    catch {destroy $w}
    catch {toplevel $w}
    wm title $w "   \"$::net(name)\". $botiklook(version)"
    if {[windowsPlatform]} {catch {wm iconbitmap $w $botiklook(winicon)}}
    wm protocol $w WM_DELETE_WINDOW {
        doExit .torg
    }
    wm resizable $w 0 0
    #if {[unixPlatform]} {wm iconbitmap $w @$botiklook(unixicon)}
    focus -force $w
    frame $w.f1
    label $w.f1.l -text "  :" -font $botiklook(footerfont)
    entry $w.f1.e -width 40 -takefocus 1 -textvar auth(torg); # -validate key -vcmd {string is graph -strict %P}
    frame $w.f2
    button $w.f2.enter -text "" -takefocus 1 -bd 3 \
        -font {Helvetica 10} -command "destroy $w"
    button $w.f2.cancel -text "" -takefocus 1 -bd 3 \
        -font {Helvetica 10} -command "set auth(torg) {}; destroy $w"
    pack $w.f1 $w.f2 -fill x
    pack $w.f1.l $w.f1.e -padx 13 -pady 5
    pack $w.f2.cancel $w.f2.enter -side left -pady 5 -expand 1
    focus -force $w.f1.e
    bind $w <KeyPress-Return> "$w.f2.enter invoke"
    bind $w <KeyPress-Escape> "$w.f2.cancel invoke"
    update
    tkwait window $w
}
proc showOfflineWindow {a} {
    global stats botiklook auth
    hideStatusWindow
    if {!$auth(offline)} {return}
    destroy $a; update
    set orgs [glob -directory $stats(homecat) -nocomplain *.bdb]
    if {[lempty $orgs]} {
        set msg "  .\n    ."
        alert $msg
        set auth(offline) 0
        showAuthWindow
        return
    }
    set res {}
    foreach file $orgs {
        if {[file readable $file]} {
            set org [file rootname [file tail $file]]
            if {![lempty $org]} {lappend res $org}
        }
    }
    if {[lempty $res]} {
        set msg "   .\n    ."
        alert $msg
        set auth(offline) 0
        showAuthWindow
        return
    }
    set res [lsort $res]
    set o .offline
    catch {destroy $o}
    catch {toplevel $o}
    wm title $o " . $botiklook(version)"
    wm protocol $o WM_DELETE_WINDOW {
        doExit .offline
    }
    focus -force $o
    frame $o.mfr
    pack $o.mfr -side top
    label $o.mfr.l -text " :" -font {Helvetica 12 bold}
    pack $o.mfr.l -side top
    set ::selectedButton [lindex $res 0]
    if {[lcontain $res $auth(org)]} {
        set ::selectedButton $auth(org)
    }
    set num  [llength $res]
    set fnum [expr {int(ceil(double($num)/10.0))}]
    for {set i 1} {$i <= $fnum} {incr i} {
        frame $o.mfr.f$i
        pack $o.mfr.f$i -side left -fill y
    }
    set i 1
    foreach org $res {
        set fr [expr {int(ceil(double($i)/10.0))}]
        radiobutton $o.mfr.f$fr.rb$org -text $org -takefocus 1 -anchor w -value $org -font {Helvetica 11 bold}
        pack $o.mfr.f$fr.rb$org -side top -pady 2 -fill x -ipadx 15
        incr i
    }
    if {![info exists ::selectedButton] || [lempty $::selectedButton]} {
        set ::selectedButton [lindex $res 0]
    }
    showFooter $o
}
proc initOffline {} {
    global auth
    set auth(offline) 1
    set auth(torg)    $::selectedButton
    initStatsVars
}
proc showFooter {w {badinit 0}} {
    switch -glob -- $w {
        .offline {footerOffline $w}
        .tuning  {footerTuning $w $badinit}
        .chart   {footerChart $w}
        .auth    {footerAuth $w}
        .csw     {footerChooseStat $w}
        .sw      {footerStat $w}
        .ew      {footerExps $w}
        .uf      {footerUFS $w}
        .uf2     {footerUFSTab $w}
        .ft      {footerFilesTab $w}
        default  {}
    }
}
proc footerUFS {w} {
    global botiklook
    set fr $w.footer
    frame $fr
    pack $fr -pady 5 -expand 1 -fill y
    button $fr.bexit -text "" -font $botiklook(footerfont) -command "doExit $w"
    if {[imgExists imgexit]} {$fr.bexit configure -image imgexit -width 24 -height 24; setBalloon $fr.bexit imgexit}
    button $fr.bhelp -text "" -font $botiklook(footerfont) -command "showHelp $w"
    if {[imgExists help]} {$fr.bhelp configure -image help -width 24 -height 24; setBalloon $fr.bhelp help}
    button $fr.btune -text "" -font $botiklook(footerfont) -command "showConfigWindow"
    if {[imgExists config]} {$fr.btune configure -image config -width 24 -height 24; setBalloon $fr.btune config}
    button $fr.bexport -text "   Excel" -font {Helvetica 11 bold} -command "exportUFSToCSV; catch {focus -force $w}"
    if {[imgExists excel]} {$fr.bexport configure -image excel -width 24 -height 24; setBalloon $fr.bexport excel; setBalloon $fr.bexport excel}
    button $fr.bclose -text "" -font $botiklook(footerfont) -command "destroy $w"
    if {[imgExists imgclose]} {$fr.bclose configure -image imgclose -width 24 -height 24; setBalloon $fr.bclose imgclose}
    pack $fr.bexit $fr.bhelp $fr.btune $fr.bexport $fr.bclose -side left -padx 5 -pady 5 -expand 1
    bind $w <KeyPress-Escape> "destroy $w"
    bind $w <Control-w>       "doExit $w"
}
proc footerUFSTab {w} {
    global botiklook
    set fr $w.footer
    frame $fr
    pack $fr -pady 5 -expand 1 -fill both
    frame $fr.fa
    frame $fr.fb
    pack $fr.fa -side left -fill both -expand 1
    pack $fr.fb -side right -fill both -expand 1
    button $fr.fa.bprev -text " << " -font $botiklook(footerfont) -command "destroy $w; update; showChooseStatWindow"
    if {[imgExists prev]} {$fr.fa.bprev configure -image prev -width 24 -height 24; setBalloon $fr.fa.bprev prev}
    button $fr.fa.bexit -text "" -font $botiklook(footerfont) -command "doExit $w"
    if {[imgExists imgexit]} {$fr.fa.bexit configure -image imgexit -width 24 -height 24; setBalloon $fr.fa.bexit imgexit}
    button $fr.fa.bhelp -text "" -font $botiklook(footerfont) -command "showHelp .uf 1"
    if {[imgExists help]} {$fr.fa.bhelp configure -image help -width 24 -height 24; setBalloon $fr.fa.bhelp help}
    button $fr.fa.btune -text "" -font $botiklook(footerfont) -command "showConfigWindow"
    if {[imgExists config]} {$fr.fa.btune configure -image config -width 24 -height 24; setBalloon $fr.fa.btune config}
    button $fr.fa.bexport -text "   Excel" -font {Helvetica 11 bold} -command "exportUFSToCSV; catch {focus -force $w}"
    if {[imgExists excel]} {$fr.fa.bexport configure -image excel -width 24 -height 24; setBalloon $fr.fa.bexport excel; setBalloon $fr.fa.bexport excel}
    showSteps $fr.fb.om 0
    button $fr.fb.bnext -text " >> " -font $botiklook(footerfont) -command "destroy $w; update; selectDisposition"
    if {[imgExists next]} {$fr.fb.bnext configure -image next -width 24 -height 24; setBalloon $fr.fb.bnext next}
    pack $fr.fa.bprev -side left -padx 3 -pady 5
    pack $fr.fa.bexport $fr.fa.btune $fr.fa.bhelp $fr.fa.bexit -side right -padx 3 -pady 5
    pack $fr.fb.bnext $fr.fb.om -side right -padx 3 -pady 5
    bind $w <KeyPress-Return> "$fr.fb.bnext invoke"
    bind $w <KeyPress-Escape> "wm iconify $w"
    bind $w <Control-w>       "doExit $w"
}
proc showSteps {w n} {
    global botiklook
    set botiklook(step) $n
    set botiklook(stepname) [lindex $botiklook(steps) $botiklook(step)]
    menubutton $w -textvariable botiklook(stepname) -menu $w.menu -indicatoron 1\
        -relief raised -bd 2 -highlightthickness 2 -anchor c -direction flush -font {Helvetica 10 bold}
    menu $w.menu -tearoff 0
    set v -1
    foreach name $botiklook(steps) {
        $w.menu add radiobutton -label $name -variable botiklook(step) -value [incr v] -font {Helvetica 10 bold} -command "set botiklook(stepname) \"$name\""
    }
}
proc footerFilesTab {w} {
    global botiklook
    set fr $w.footer
    frame $fr
    pack $fr -pady 5 -expand 1 -fill both
    frame $fr.fa
    frame $fr.fb
    pack $fr.fa -side left -fill both -expand 1
    pack $fr.fb -side right -fill both -expand 1
    button $fr.fa.bprev -text " << " -font $botiklook(footerfont) -command "destroy $w; update; showChooseStatWindow"
    if {[imgExists prev]} {$fr.fa.bprev configure -image prev -width 24 -height 24; setBalloon $fr.fa.bprev prev}
    button $fr.fa.bexit -text "" -font $botiklook(footerfont) -command "doExit $w"
    if {[imgExists imgexit]} {$fr.fa.bexit configure -image imgexit -width 24 -height 24; setBalloon $fr.fa.bexit imgexit}
    button $fr.fa.bhelp -text "" -font $botiklook(footerfont) -command "showHelp $w"
    if {[imgExists help]} {$fr.fa.bhelp configure -image help -width 24 -height 24; setBalloon $fr.fa.bhelp help}
    button $fr.fa.btune -text "" -font $botiklook(footerfont) -command "showConfigWindow"
    if {[imgExists config]} {$fr.fa.btune configure -image config -width 24 -height 24; setBalloon $fr.fa.btune config}
    button $fr.fa.bexport -text "   Excel" -font {Helvetica 11 bold} -command "exportFilesTableToCSV; catch {focus -force $w}"
    if {[imgExists excel]} {$fr.fa.bexport configure -image excel -width 24 -height 24; setBalloon $fr.fa.bexport excel}
    showSteps $fr.fb.om 4
    button $fr.fb.bnext -text " >> " -font $botiklook(footerfont) -command "destroy $w; update; selectDisposition"
    if {[imgExists next]} {$fr.fb.bnext configure -image next -width 24 -height 24; setBalloon $fr.fb.bnext next}
    pack $fr.fa.bprev -side left -padx 3 -pady 5
    pack $fr.fa.bexport $fr.fa.btune $fr.fa.bhelp $fr.fa.bexit -side right -padx 3 -pady 5
    pack $fr.fb.bnext $fr.fb.om -side right -padx 3 -pady 5
    bind $w <KeyPress-Return> "$fr.fb.bnext invoke"
    bind $w <KeyPress-Escape> "wm iconify $w"
    bind $w <Control-w>       "doExit $w"
}
proc footerChart {w} {
    global botiklook
    set fr $w.footer
    frame $fr
    pack $fr -pady 5 -expand 1 -fill both
    frame $fr.fa
    frame $fr.fb
    pack $fr.fa -side left -fill both -expand 1
    pack $fr.fb -side right -fill both -expand 1
    button $fr.fa.bprev -text " << " -font $botiklook(footerfont) -command "destroy $w; update; showChooseStatWindow"
    if {[imgExists prev]} {$fr.fa.bprev configure -image prev -width 24 -height 24; setBalloon $fr.fa.bprev prev}
    button $fr.fa.bexit -text "" -font $botiklook(footerfont) -command "doExit $w"
    if {[imgExists imgexit]} {$fr.fa.bexit configure -image imgexit -width 24 -height 24; setBalloon $fr.fa.bexit imgexit}
    button $fr.fa.bhelp -text "" -font $botiklook(footerfont) -command "showHelp $w"
    if {[imgExists help]} {$fr.fa.bhelp configure -image help -width 24 -height 24; setBalloon $fr.fa.bhelp help}
    button $fr.fa.btune -text "" -font $botiklook(footerfont) -command "showConfigWindow"
    if {[imgExists config]} {$fr.fa.btune configure -image config -width 24 -height 24; setBalloon $fr.fa.btune config}
    button $fr.fa.bexport -text "   Excel" -font {Helvetica 11 bold} -command "exportChartToCSV; catch {focus -force $w}"
    if {[imgExists excel]} {$fr.fa.bexport configure -image excel -width 24 -height 24; setBalloon $fr.fa.bexport excel}
    showSteps $fr.fb.om 3
    button $fr.fb.bnext -text " >> " -font $botiklook(footerfont) -command "destroy $w; update; selectDisposition"
    if {[imgExists next]} {$fr.fb.bnext configure -image next -width 24 -height 24; setBalloon $fr.fb.bnext next}
    pack $fr.fa.bprev -side left -padx 3 -pady 5
    pack $fr.fa.bexport $fr.fa.btune $fr.fa.bhelp $fr.fa.bexit -side right -padx 3 -pady 5
    pack $fr.fb.bnext $fr.fb.om -side right -padx 3 -pady 5
    bind $w <KeyPress-Return> "$fr.fb.bnext invoke"
    bind $w <KeyPress-Escape> "wm iconify $w"
    bind $w <Control-w>       "doExit $w"
}
proc footerOffline {w} {
    global auth botiklook
    set fr $w.footer
    frame $fr
    pack $fr -pady 5 -expand 1
    button $fr.bprev -text " << " -font $botiklook(footerfont) -command "set auth(offline) 0; destroy $w; update; showAuthWindow"
    if {[imgExists prev]} {$fr.bprev configure -image prev -width 24 -height 24; setBalloon $fr.bprev prev}
    button $fr.bexit -text "" -font $botiklook(footerfont) -command "doExit $w"
    if {[imgExists imgexit]} {$fr.bexit configure -image imgexit -width 24 -height 24; setBalloon $fr.bexit imgexit}
    button $fr.bhelp -text "" -font $botiklook(footerfont) -command "showHelp $w"
    if {[imgExists help]} {$fr.bhelp configure -image help -width 24 -height 24; setBalloon $fr.bhelp help}
    button $fr.btune -text "" -font $botiklook(footerfont) -command "showConfigWindow"
    if {[imgExists config]} {$fr.btune configure -image config -width 24 -height 24; setBalloon $fr.btune config}
    button $fr.bnext -text " >> " -font $botiklook(footerfont) -command "initOffline; destroy $w; destroy .auth; doAuth"
    if {[imgExists next]} {$fr.bnext configure -image next -width 24 -height 24; setBalloon $fr.bnext next}
    pack $fr.bprev $fr.bexit $fr.bhelp $fr.btune $fr.bnext -side left -padx 5 -pady 5 -expand 1
    bind $w <KeyPress-Return> "$fr.bnext invoke"
    bind $w <KeyPress-Escape> "wm iconify $w"
    bind $w <Control-w>       "doExit $w"
}
proc footerTuning {w badinit} {
    global botiklook
    set fr $w.footer
    frame $fr
    pack $fr -pady 5 -expand 1
    button $fr.bexit -text "" -font $botiklook(footerfont) -command "doExit $w"
    if {[imgExists imgexit]} {$fr.bexit configure -image imgexit -width 24 -height 24; setBalloon $fr.bexit imgexit}
    button $fr.bhelp -text "" -font $botiklook(footerfont) -command "showHelp $w"
    if {[imgExists help]} {$fr.bhelp configure -image help -width 24 -height 24; setBalloon $fr.bhelp help}
    button $fr.b1 -text "" -font $botiklook(footerfont) -command "applyChanges $badinit; catch {$fr.b3 invoke}"
    if {[imgExists apply]} {$fr.b1 configure -image apply -width 24 -height 24; setBalloon $fr.b1 apply}
    button $fr.b2 -text "\n " -font $botiklook(footerfont) -command "applyAndSave $badinit; catch {$fr.b3 invoke}"
    if {[imgExists applysave]} {$fr.b2 configure -image applysave -width 24 -height 24; setBalloon $fr.b2 applysave}
    if {$badinit} {
        button $fr.b3 -text " >> " -font $botiklook(footerfont) -command "checkAndClose $w {showAuthWindow}"
        if {[imgExists next]} {$fr.b3 configure -image next -width 24 -height 24; setBalloon $fr.b3 next}
        bind $w <KeyPress-Return> "$fr.b2 invoke"
        bind $w <KeyPress-Escape> "wm iconify $w"
    } else {
        button $fr.b3 -text "" -font $botiklook(footerfont) -command "checkAndClose $w"
        if {[imgExists imgclose]} {$fr.b3 configure -image imgclose -width 24 -height 24; setBalloon $fr.b3 imgclose}
        bind $w <KeyPress-Return> "$fr.b2 invoke; destroy $w"
        bind $w <KeyPress-Escape> "destroy $w"
    }
    pack $fr.bexit $fr.bhelp $fr.b2 $fr.b1 $fr.b3 -side left -padx 5 -pady 5 -expand 1
    bind $w <Control-w> "doExit $w"
}
#    
proc footerAuth {w} {
    global botiklook
    set fr $w.footer
    frame $fr
    pack $fr -pady 5 -expand 1
    button $fr.bexit -text "" -font $botiklook(footerfont) -command "doExit $w"
    if {[imgExists imgexit]} {$fr.bexit configure -image imgexit -width 24 -height 24; setBalloon $fr.bexit imgexit}
    button $fr.bhelp -text "" -font $botiklook(footerfont) -command "showHelp $w"
    if {[imgExists help]} {$fr.bhelp configure -image help -width 24 -height 24; setBalloon $fr.bhelp help}
    button $fr.btune -text "" -font $botiklook(footerfont) -command "showConfigWindow"
    if {[imgExists config]} {$fr.btune configure -image config -width 24 -height 24; setBalloon $fr.btune  config}
    button $fr.bnext -text " >> " -font $botiklook(footerfont) -command "authStart $w"
    if {[imgExists next]} {$fr.bnext configure -image next -width 24 -height 24; setBalloon $fr.bnext next}
    pack $fr.bexit $fr.bhelp $fr.btune $fr.bnext -side left -padx 5 -pady 5 -expand 1
    bind $w <KeyPress-Return> "$fr.bnext invoke"
    bind $w <KeyPress-Escape> "wm iconify $w"
    bind $w <Control-w>       "doExit $w"
}
proc authStart {w} {
    if {[lempty $::auth(org)]} {
        alertError "     "
        return
    }
    destroy $w; update
    showStatusWindow
    doAuth
}
proc footerChooseStat {w} {
    global botiklook
    set fr $w.footer
    frame $fr
    pack $fr -pady 5 -expand 1 -fill both
    frame $fr.fa
    frame $fr.fb
    pack $fr.fa -side left -fill x -expand 1
    pack $fr.fb -side right -fill x -expand 1
    button $fr.fa.bprev -text " << " -font $botiklook(footerfont) -command "stepChooseStat $w"
    if {[imgExists prev]} {$fr.fa.bprev configure -image prev -width 24 -height 24; setBalloon $fr.fa.bprev prev}
    button $fr.fa.bexit -text "" -font $botiklook(footerfont) -command "doExit $w"
    if {[imgExists imgexit]} {$fr.fa.bexit configure -image imgexit -width 24 -height 24; setBalloon $fr.fa.bexit imgexit}
    button $fr.fa.bhelp -text "" -font $botiklook(footerfont) -command "showHelp $w"
    if {[imgExists help]} {$fr.fa.bhelp configure -image help -width 24 -height 24; setBalloon $fr.fa.bhelp help}
    button $fr.fa.btune -text "" -font $botiklook(footerfont) -command "showConfigWindow"
    if {[imgExists config]} {$fr.fa.btune configure -image config -width 24 -height 24; setBalloon $fr.fa.btune config}
    showSteps $fr.fb.om 0
    button $fr.fb.bnext -text " >> " -font $botiklook(footerfont) -command "processChooseStat $w"
    if {[imgExists next]} {$fr.fb.bnext configure -image next -width 24 -height 24; setBalloon $fr.fb.bnext next}
    pack $fr.fa.bprev -side left -padx 3 -pady 5
    pack $fr.fa.btune $fr.fa.bhelp $fr.fa.bexit -side right -padx 3 -pady 5
    pack $fr.fb.bnext $fr.fb.om -side right -padx 3 -pady 5
    bind $w <KeyPress-Return> "$fr.fb.bnext invoke"
    bind $w <KeyPress-Escape> "wm iconify $w"
    bind $w <Control-w>       "doExit $w"
}
#    
proc footerStat {w} {
    global botiklook
    set fr $w.footer
    frame $fr
    pack $fr -pady 5 -expand 1 -fill both
    frame $fr.fa
    frame $fr.fb
    pack $fr.fa -side left -fill x -expand 1
    pack $fr.fb -side right -fill x -expand 1
    button $fr.fa.bprev -text " << " -font $botiklook(footerfont) -command "destroy $w; update; showChooseStatWindow"
    if {[imgExists prev]} {$fr.fa.bprev configure -image prev -width 24 -height 24; setBalloon $fr.fa.bprev prev}
    button $fr.fa.bexit -text "" -font $botiklook(footerfont) -command "doExit $w"
    if {[imgExists imgexit]} {$fr.fa.bexit configure -image imgexit -width 24 -height 24; setBalloon $fr.fa.bexit imgexit}
    button $fr.fa.bhelp -text "" -font $botiklook(footerfont) -command "showHelp $w"
    if {[imgExists help]} {$fr.fa.bhelp configure -image help -width 24 -height 24; setBalloon $fr.fa.bhelp help}
    button $fr.fa.btune -text "" -font $botiklook(footerfont) -command "showConfigWindow"
    if {[imgExists config]} {$fr.fa.btune configure -image config -width 24 -height 24; setBalloon $fr.fa.btune config}
    button $fr.fa.bexport -text "   Excel" -font {Helvetica 11 bold} -command "exportTrafTableToCSV; catch {focus -force $w}"
    if {[imgExists excel]} {$fr.fa.bexport configure -image excel -width 24 -height 24; setBalloon $fr.fa.bexport excel}
    showSteps $fr.fb.om 1
    button $fr.fb.bnext -text " >> " -font $botiklook(footerfont) -command "destroy $w; update; selectDisposition"
    if {[imgExists next]} {$fr.fb.bnext configure -image next -width 24 -height 24; setBalloon $fr.fb.bnext next}
    pack $fr.fa.bprev -side left -padx 3 -pady 5
    pack $fr.fa.bexport $fr.fa.btune $fr.fa.bhelp $fr.fa.bexit -side right -padx 3 -pady 5
    pack $fr.fb.bnext $fr.fb.om -side right -padx 3 -pady 5
    bind $w <KeyPress-Return> "$fr.fb.bnext invoke"
    bind $w <KeyPress-Escape> "wm iconify $w"
    bind $w <Control-w>       "doExit $w"
}
#     
proc footerExps {w} {
    global botiklook
    set fr $w.footer
    frame $fr
    pack $fr -pady 5 -expand 1 -fill both
    frame $fr.fa
    frame $fr.fb
    pack $fr.fa -side left -fill both -expand 1
    pack $fr.fb -side right -fill both -expand 1
    button $fr.fa.bprev -text " << " -font $botiklook(footerfont) -command "destroy $w; update; showChooseStatWindow"
    if {[imgExists prev]} {$fr.fa.bprev configure -image prev -width 24 -height 24; setBalloon $fr.fa.bprev prev}
    button $fr.fa.bexit -text "" -font $botiklook(footerfont) -command "doExit $w"
    if {[imgExists imgexit]} {$fr.fa.bexit configure -image imgexit -width 24 -height 24; setBalloon $fr.fa.bexit imgexit}
    button $fr.fa.bhelp -text "" -font $botiklook(footerfont) -command "showHelp $w"
    if {[imgExists help]} {$fr.fa.bhelp configure -image help -width 24 -height 24; setBalloon $fr.fa.bhelp help}
    button $fr.fa.btune -text "" -font $botiklook(footerfont) -command "showConfigWindow"
    if {[imgExists config]} {$fr.fa.btune configure -image config -width 24 -height 24; setBalloon $fr.fa.btune config}
    button $fr.fa.bexport -text "   Excel" -font {Helvetica 11 bold} -command "exportExpTableToCSV; focus -force $w"
    if {[imgExists excel]} {$fr.fa.bexport configure -image excel -width 24 -height 24; setBalloon $fr.fa.bexport excel}
    showSteps $fr.fb.om 2
    button $fr.fb.bnext -text " >> " -font $botiklook(footerfont) -command "destroy $w; update; selectDisposition"
    if {[imgExists next]} {$fr.fb.bnext configure -image next -width 24 -height 24; setBalloon $fr.fb.bnext next}
    pack $fr.fa.bprev -side left -padx 3 -pady 5
    pack $fr.fa.bexport $fr.fa.btune $fr.fa.bhelp $fr.fa.bexit -side right -padx 3 -pady 5
    pack $fr.fb.bnext $fr.fb.om -side right -padx 3 -pady 5
    bind $w <KeyPress-Return> "$fr.fb.bnext invoke"
    bind $w <KeyPress-Escape> "wm iconify $w"
    bind $w <KeyPress-F5>     "showExpsWindow"
    bind $w <Control-w>       "doExit $w"
}
proc setBalloon {b img} {
    if {[info exists ::hints($img)]} {balloon $b $::hints($img)}
}
proc balloon {w helptext} {
    bind $w <Any-Enter> "after 500 [list balloon_show %W [list $helptext]]"
    bind $w <Any-Leave> "destroy %W.balloon"
}
proc balloon_show {w arg} {
    if {!$::botiklook(showballoons)} {return}
    if {[eval winfo containing [winfo pointerxy .]]!=$w} {return}
    set top $w.balloon
    catch {destroy $top}
    toplevel $top -bd 1 -bg black
    wm overrideredirect $top 1
    if {$::tcl_platform(platform) == "macintosh"} {
        unsupported1 style $top floating sideTitlebar
    }
    pack [message $top.txt -aspect 700 -bg lightyellow -text $arg]
    set wmx [winfo rootx $w]
    set wmy [expr [winfo rooty $w]+[winfo height $w]]
    wm geometry $top [winfo reqwidth $top.txt]x[winfo reqheight $top.txt]+$wmx+$wmy
    raise $top
}
proc showFirstWindow {} {
    if {[readInit]} {
        showAuthWindow
    } else {showConfigWindow 1}
}
proc doSource {file {globals {}}} {
    if {![file exists $file]} {return}
    foreach var $globals {
        global $var
    }
    set f [open $file r]
    while {![eof $f]} {
        gets $f line
        if {[lindex $line 0] ne "set"} {continue}
        eval [subst -nocommands -novariables $line]
    }
    close $f
}
#   .     -    ,
#     
proc readInit {} {
    global stats botiklook
    set stats(homecat)   ""
    set stats(csvsep)    ""
    set stats(decpoint)  ""
    set stats(hugeorg)   ""
    set stats(fastsync)  ""
    set botiklook(doask) ""
    #    . 
    set f [open "$botiklook(initfilepath)" r]
    #     
       gets $f line
    close $f
    set pversion [lindex $line 2]
    if {$pversion ne $botiklook(pversion)} {return 0}
    #      ,   
    catch {
        doSource $botiklook(initfilepath) [list stats botiklook auth]
    }
    checkHomecat
    set result [expr !([lempty $stats(homecat)] || [lempty $stats(csvsep)] || [lempty $stats(decpoint)] || [lempty $stats(hugeorg)] || [lempty $stats(fastsync)] || [lempty $botiklook(doask)])]
    if {[lempty $stats(hugeorg)]} {
        set stats(hugeorg) 0
    }
     if {[lempty $stats(fastsync)]} {
        set stats(fastsync) 1
     }
    return $result
}
proc checkHomecat {} {
    if {[info exists ::stats(homecat)] && ![lempty $::stats(homecat)] && [file exists $::stats(homecat)] && ![file writable $::stats(homecat)]} {
        #alertWarning "!   \"$::stats(homecat)\"   .\n    ,      ."
        return 0
    }
    if {[regexp {[--]} $::stats(homecat)]} {
        alertError "!     \"$::stats(homecat)\"   .     ,         ."
        return 1
    }
    return 0
}
proc initLocale {} {
    global csvsep decpoint stats
    set decvals {"." ","}
    set csvvals {";" ","}
    if {!$::botiklook(twapi)} {
        set decpoint  [expr {[lempty $stats(decpoint)]  ? [lindex $decvals 0] : $stats(decpoint)}]
        set csvsep    [expr {[lempty $stats(csvsep)]    ? [lindex $csvvals 0] : $stats(csvsep)}]
        return
    }
    #  Windows API   
    set list     [twapi::get_locale_info [twapi::get_user_default_lcid] -sdecimal -slist]
    set decpoint [lindex $list 1]
    set csvsep   [lindex $list 3]
}
#    ,      .
#   -Windows .   URL
#         Web-
proc showHelpPath {path} {
    global botiklook
    set w .h
    catch {destroy $w}
    catch {toplevel $w}
    wm title $w ". $botiklook(version)"
    #if {[unixPlatform]} {wm iconbitmap $w @$botiklook(unixicon)}
    focus -force $w
    label $w.l -text "   :" -font {Helvetica 11}
    entry $w.e -width 30 -readonlybackground white -takefocus 1 \
        -font {Helvetica 11}
    pack $w.l $w.e -padx 4 -pady 4
    focus -force $w.e
    $w.e insert 0 $path
    $w.e selection range 0 end
    $w.e configure -state readonly
    bind $w <KeyPress-Escape> "destroy $w"
    bind $w <KeyPress-Return> "destroy $w"
}
#     
proc showHelp {w {stage {0}}} {
    global botiklook env
    set htmlhelpfile [file join . doc $botiklook(pname).html]
    set chmhelpfile  [file join . doc $botiklook(pname).chm]
    set htmlpath     [file normalize ${htmlhelpfile}\#[string trimleft $w {\.}]].html
    set chmpath      "/html/[string trimleft $w {\.}].html"
    if {![windowsPlatform]} {
        if {![file exists $htmlhelpfile]} {
            alertError "   "
            return
        }
        showHelpPath $htmlpath
        return
    }
       if {[bl_exe]} {
           set page [string trimleft $w {\.}]
           showURL http://www.$::net(domain)/~botik/look/$page.html
           return
       }
    try_eval {
        package require winhelp 1.0
        if {!$stage} {
            winhelp $w $chmhelpfile $chmpath
        } else {
            winhelp .uf2 $chmhelpfile $chmpath
        }
        if {![file exists $chmhelpfile]} {
            showURL $htmlhelpfile
        }
    } {
        alertError "    .\n :\n$errorInfo"
        asksendmail "    .\n :\n$errorInfo"
    }
}
proc showConfigWindow {{badinit 0}} {
    global stats env homecat csvsep decpoint doask botiklook hugeorg fastsync
    hideStatusWindow
    set t .tuning
    catch {destroy $t}
    catch {toplevel $t}
    wm title $t " $botiklook(version)"
    if {[windowsPlatform]} {catch {wm iconbitmap $t -default $botiklook(winicon)}}
    #if {[unixPlatform]} {wm iconbitmap $t @$botiklook(unixicon)}
    wm protocol $t WM_DELETE_WINDOW {
        set txt [.tuning.footer.b3 cget -text]
        if {[string match "*>>*" $txt]} {
            doExit .tuning
        } else {destroy .tuning}
    }
    focus -force $t
    set env(HOME) [file normalize $env(HOME)]
    set homecat   $stats(homecat)
    initLocale
    set hugeorg   [expr {[lempty $stats(hugeorg)]   ? 0 : $stats(hugeorg)}]
    set fastsync  [expr {[lempty $stats(fastsync)]  ? 1 : $stats(fastsync)}]
    set doask     [expr {[lempty $botiklook(doask)] ? 1 : $botiklook(doask)}]
    labelframe $t.lf -text " " -font {Helvetica 10}
    entry $t.lf.e -textvariable homecat -width 40 -state readonly
    button $t.lf.b -text " ... " -font {Helvetica 10} -command "chooseDir; catch {focus -force $t}" -state disabled
    if {[winfo exists .auth] || $badinit} {
        $t.lf.e configure -state normal
        $t.lf.b configure -state normal
        $t.lf configure -font {Helvetica 10 bold}
    }
    if {[imgExists imgopen]} {$t.lf.b configure -image imgopen -width 24 -height 24; setBalloon $t.lf.b imgopen}
    pack $t.lf -side top -expand 1 -fill both -padx 3 -pady 3
    pack $t.lf.e $t.lf.b -side left -padx 3
    labelframe $t.lf4 -text "  " -font {Helvetica 10 bold}
    checkbutton $t.lf4.donotask -text "   " -font {Helvetica 10} -variable doask -relief flat
    pack $t.lf4 -expand 1 -fill both -padx 3 -pady 3
    pack $t.lf4.donotask -side left -padx 3
    #setAdvButn $t
    #frame $t
    #pack $t -side top -fill both
    set csvvals {";" ","}
    set decvals {"." ","}
    labelframe $t.cb -text "" -font {Helvetica 10 bold}
    pack $t.cb -fill both -expand 1
    checkbutton $t.cb.ho -text " " -font {Helvetica 10} -variable hugeorg -relief flat
    checkbutton $t.cb.qa -text " " -font {Helvetica 10} -variable fastsync -relief flat
    pack $t.cb.ho $t.cb.qa -side top -padx 3 -pady 3 -fill both
    labelframe $t.lf2 -text "  CSV" -font {Helvetica 10 bold}
    frame $t.lf2.f1
    frame $t.lf2.f2
    label $t.lf2.f1.l1 -text " CSV-:" -font {Helvetica 10}
    label $t.lf2.f2.l2 -text " :          " -font {Helvetica 10}
    eval [subst {tk_optionMenu $t.lf2.f1.om1 csvsep $csvvals}]
    eval [subst {tk_optionMenu $t.lf2.f2.om2 decpoint $decvals}]
    pack $t.lf2 -expand 1 -fill both -padx 3 -pady 3
    pack $t.lf2.f1 $t.lf2.f2 -side top -fill both
    pack $t.lf2.f1.l1 $t.lf2.f1.om1 $t.lf2.f2.l2 $t.lf2.f2.om2 -side left -padx 3
    showFooter $t $badinit
    update
    if {$badinit} {
        set homecat [expr {[lempty $homecat] ? [findBestHomecat] : $homecat}]
    }
    tkwait window $t
}
#       
#       .
proc findBestHomecat {} {
    # "" 
    set reservedrv [file normalize [file join "~" .$::botiklook(pname)]]
    catch {set reservedrv [file join $::env(APPDATA) $::botiklook(pname)]}
    if {!$::botiklook(twapi)} {return $reservedrv}
    try_eval {
        #     :   
        set fittypes   [list removable fixed]
        #     
        set alldrives  [twapi::find_logical_drives -type $fittypes]
        #     :  NTFS  FAT
        set fitfstypes [list NTFS FAT]
        set maxspace   0
        set bestdrive   {}
        foreach drive $alldrives {
            try_eval {
                set fstype [lindex [twapi::get_volume_info $drive -fstype] 1]
            } {set fstype {}}
            #     ,
            if {[lcontain $fitfstypes $fstype]} {
                try_eval {
                    set space [lindex [twapi::get_volume_info $drive -freespace] 1]
                } {set space 0}
                #     ,
                if {$space > $maxspace} {
                    #   ,   
                    set maxspace $space
                    set bestdrive $drive
                }
            }
        }
        if {[lempty $bestdrive]} {
            return $reservedrv
        }
        set homecat [file join $bestdrive/ $::botiklook(pname)]
        return $homecat
    } {return $reservedrv}
}
proc setAdvButn {w} {
    global botiklook
    set txt [expr {($botiklook(showadv)) ? " << " : " >> "}]
    button $w.advbut -text $txt -command "showOrHideAdvanced $w" -font {Helvetica 10 bold}
    pack $w.advbut -side top
    frame $w.advframe
    pack $w.advframe -side top -fill both
    if {$botiklook(showadv)} {showAdvanced $w}
}
proc showAdvanced {w} {
    global csvsep decpoint hugeorg fastsync
    set t $w.advframe.frame
    frame $t
    pack $t -side top -fill both
    set csvvals {";" ","}
    set decvals {"." ","}
    labelframe $t.cb -text "" -font {Helvetica 10 bold}
    pack $t.cb -fill both -expand 1
    checkbutton $t.cb.ho -text " " -font {Helvetica 10} -variable hugeorg -relief flat
    checkbutton $t.cb.qa -text " " -font {Helvetica 10} -variable fastsync -relief flat
    pack $t.cb.ho $t.cb.qa -side top -padx 3 -pady 3
    labelframe $t.lf2 -text "  CSV" -font {Helvetica 10 bold}
    frame $t.lf2.f1
    frame $t.lf2.f2
    label $t.lf2.f1.l1 -text " CSV-:" -font {Helvetica 10}
    label $t.lf2.f2.l2 -text " :          " -font {Helvetica 10}
    eval [subst {tk_optionMenu $t.lf2.f1.om1 csvsep $csvvals}]
    eval [subst {tk_optionMenu $t.lf2.f2.om2 decpoint $decvals}]
    pack $t.lf2 -expand 1 -fill both -padx 3 -pady 3
    pack $t.lf2.f1 $t.lf2.f2 -side top -fill both
    pack $t.lf2.f1.l1 $t.lf2.f1.om1 $t.lf2.f2.l2 $t.lf2.f2.om2 -side left -padx 3
}
proc showOrHideAdvanced {w} {
    global botiklook
    set botiklook(showadv) [expr !$botiklook(showadv)]
    set txt [expr {($botiklook(showadv)) ? " << " : " >> "}]
    $w.advbut configure -text $txt
    if {!$botiklook(showadv)} {
        catch {destroy $w.advframe.frame}
        catch {
            destroy $w.advframe
                   frame $w.advframe
            pack $w.advframe -side top -after $w.advbut -fill both
        }
        return
    }
    showAdvanced $w
}
proc applyChanges {{badinit 0}} {
    global botiklook stats homecat csvsep decpoint doask hugeorg fastsync
    if {![winfo exists .auth] && !$badinit} {
        alert "    \n      \n  $botiklook(version)."
    } else {
        if {[lempty $homecat]} {set homecat "~"}
        set homecat [file normalize $homecat]
        set dtype [driveType [getDrive $homecat]]
        if {$dtype eq "removable"} {
            alertWarning "!     \n  .    $botiklook(pname)\n     ."
        }
        set stats(homecat) $homecat
        if {![checkHomecat]} {
            file mkdir $stats(homecat)
        }
    }
    set stats(csvsep)    $csvsep
    set stats(decpoint)  $decpoint
    set stats(hugeorg)   $hugeorg
    set stats(fastsync)  $fastsync
    set botiklook(doask) $doask
}
proc writeInitFile {} {
    global stats botiklook auth
    set titleline "\# $botiklook(pname) $botiklook(pversion) init file\n"
    set hint1 "\# Statistics directory:"
    set hint2 "\# CSV values separator:"
    set hint3 "\# Decimal point:"
    set hint5 "\# Whether to ask for sending error reports (1 - ask, 0 - don't ask):"
    set hint6 "\# Whether we synchronize with a huge or a small org.:"
    set hint7 "\# Whether to use fast analysis algorithm:"
    set hint8 "\# Organization:"
    set hint9 "\# User login:"
    write_file $botiklook(initfilepath) $titleline \
                $hint1 \
                "set stats(homecat)   \"$stats(homecat)\"" \
                $hint2 \
                "set stats(csvsep)    \"$stats(csvsep)\"" \
                $hint3 \
                "set stats(decpoint)  \"$stats(decpoint)\"" \
                $hint5 \
                "set botiklook(doask) \"$botiklook(doask)\"" \
                $hint6 \
                "set stats(hugeorg)   \"$stats(hugeorg)\"" \
                $hint7 \
                "set stats(fastsync)   \"$stats(fastsync)\"" \
                $hint8 \
                "set auth(org)         \"$auth(org)\"" \
                $hint9 \
                "set auth(login)       \"$auth(login)\""
    #alert "   ."
}
proc applyAndSave {{badinit 0}} {
    applyChanges $badinit
    writeInitFile
}
proc checkAndClose {w {code {}}} {
    global stats botiklook
    if {[lempty $stats(homecat)] || [lempty $stats(csvsep)] || [lempty $stats(decpoint)] || [lempty $botiklook(doask)] || [lempty $stats(hugeorg)] || [lempty $stats(fastsync)]} {
        alertWarning "   "
        return 0
    } else {destroy $w; eval $code; return 1}
}
proc chooseDir {} {
    global homecat
    set oldcat $homecat
    set homecat [tk_chooseDirectory -mustexist 0 -initialdir $homecat -title "    "]
    if {[lempty $homecat]} {
        set homecat $oldcat
    } else {
        set homecat [file normalize $homecat]
    }
}
proc validString {val} {
    return [expr ![lempty $val]]
}
proc validPercent {val} {
    return [expr {[lempty $val] || ([string is integer -strict $val] && $val >= 0 && $val <= 100)}]
}
#    .   ,
#    . .
proc appFile {fname} {
    global botiklook
    set d [file normalize "~"]
    catch {set d $::env(APPDATA)}
    set appfile $fname
    if {![lempty $d]} {
        file mkdir [file join $d $botiklook(pname)]
        set appfile [file join $d $botiklook(pname) $fname]
    }
    if {[unixPlatform]} {
        set d "~/.$botiklook(pname)"
        file mkdir $d
        set appfile [file join $d $fname]
    }
    #   ,   
    if {![file exists $appfile]} {touch $appfile}
    return $appfile
}
#   -     
proc convertLocalStorage {} {
    global mtimes files auth stats state wwwaddr \
        elapsed dns botiklook nfiles sliceid
    findDepStat
    findDBStat
    compareData 0
    set len [llength $files(all)]
    initStatus $len " . "
    initMDB "slices"
    set nfiles  0;  #   
    set sliceid 0
    catch {set sliceid [db eval {select seq from SQLITE_SEQUENCE}]}
    if {[lempty $sliceid] || ![string is integer -strict $sliceid]} {set sliceid 0}
    #   (+):
    initMemory
    processFiles $files(all)
    dumpMDB
    #   
    if {$::deltmp} {
        catch {file delete -force -- [file join $stats(homecat) $auth(torg)]}
    }
    set ::infostring "  ([filesWord $len]). "
    finishStatus
    set arrs {files mtimes wwwaddr dns}
    initStatus [llength $arrs] " . "
    foreach arr $arrs {
        array unset $arr
        shiftStatus
    }
    finishStatus
    makeExpences; #    
}
# date is yyyymmddhhmmss
# returns "+1 day" in same format
proc dayForward {date} {
    set fdate [ftime3 $date]
    return [clockFormat %Y%m%d%H%M%S [clock scan "+1 day" -base [clock scan $fdate]]]
}
proc checkDoSync {} {
    if {[info exists ::stats(rdate1)] && [info exists ::stats(rdate2)]} {
        if {$::stats(rdate1) < 20090301} {
            set ::sync(dosync) 1
            set date1 20090301000000
        } else {
            set date1 ${::stats(rdate1)}000000
        }
        if {$::stats(rdate2) >= 20090301} {
            set ::sync(dosync2) 1
        }
        set date2 ${::stats(rdate2)}235959
    } else {
        set ::sync(dosync)  1
        set ::sync(dosync2) 1
        set date1 20090301000000
        set date2 [getNadminDate [clock seconds]]
    }
    if {$::sync(dosync2)} {
        set ::sync(sync2date1) $date1
        set ::sync(sync2date2) $date2
        set ::sync(sync2ndays) [ndays $date1 $date2]
    }
}
proc synchronize2 {} {
    global sync auth sliceid nfiles
    set sync(cursvc) ""
    set sync(svcnum) 0
    set sync(curlen) 0
    findServices
    if {!$sync(dosync)} {
        findDBStat
        initStatus $sync(sync2ndays) " . "
    }
    initMDB "slices"
    set sync(errors) {}
    set nfiles       0
    set sliceid      0
    catch {set sliceid [db eval {select seq from SQLITE_SEQUENCE}]}
    if {[lempty $sliceid] || ![string is integer -strict $sliceid]} {set sliceid 0}
    set date $sync(sync2date1)
    loop d 0 $sync(sync2ndays) {
        set nextdate [dayForward $date]
        set day [getDay $date]
        download2 $date $nextdate
        set date $nextdate
        shiftStatus
    }
    dumpMDB
    set arrs {::files ::mtimes ::wwwaddr ::dns}
    foreach arr $arrs {
        catch {array unset $arr}
    }
    finishStatus
    if {$sync(dosync)} {deleteTmpFiles}
}
proc download2 {date1 date2} {
    global auth
    set tf  [open $::botiklook(dltmp) r+]
    set org [expr {($auth(anyorg)) ? $auth(torg) : $auth(org)}]
    set query "do_get_rawstat=1;ORG=$org;DATE1=$date1;DATE2=$date2"
    set token [http::geturl $auth(srvurl) \
        -query $query \
        -binary true \
        -channel $tf \
        -headers "Cookie $auth(cookie)"]
    catch {http::cleanup $token}
    seek $tf 0
    while {![eof $tf]} {
        sync2Handler $tf {}
    }
    close $tf
    touch $::botiklook(dltmp); # truncate it
}
proc sync2Handler {socket token} {
    gets $socket line
    if {[lindex $line 0] eq "Service:"} {
        set ::sync(cursvc) [lindex $line 1]
        if {$::botiklook(svcname) ne "" && $::botiklook(svcname) ne $::sync(cursvc)} {return [string length $line]}
        if {![info exists ::services($::sync(cursvc))]} {
            set id   [incr ::sync(svcnum)]
            set type [lindex [split $::sync(cursvc) "-"] 0]
            set name [string range $::sync(cursvc) [expr [string length $type] + 1] end]
            db eval {insert into services values($id,$name,$type)}
            set ::services($::sync(cursvc)) $id
            set ::services($id)      $name
            set ::services2($id)     ${type}-$name
        }
        return [string length $line]
    } elseif {[lindex $line 0] eq "Length:"} {
        set ::sync(curlen) [lindex $line 1]
        return [string length $line]
    } elseif {[lindex $line 0] eq "Error:"} {
        set msg [lrange $line 1 end]
        lappend ::sync(errors) "\n[ftime] $msg"
        set ::sync(curlen) 0
        return [string length $line]
    } elseif {$line eq ""} {
        if {$::sync(curlen) == 0 || $::sync(cursvc) eq ""} {
            #debug "[ftime]: return1: $::sync(curlen) == 0 || lempty $::sync(cursvc)"
            set ::sync(curlen) 0
            return 0
        }
        fconfigure $socket -buffering full -buffersize $::sync(curlen) -blocking 1
        catch {
            set data [read $socket $::sync(curlen)]
        }
        if {$::botiklook(svcname) ne "" && $::botiklook(svcname) ne $::sync(cursvc)} {
            set len $::sync(curlen)
            set ::sync(curlen) 0
            return $len
        }
        if {[lempty $data]} {
            debug "[ftime]: Empty data; length=$::sync(curlen)."
            set len $::sync(curlen)
            set ::sync(curlen) 0
            return $len
        }
        set slicedata [split $data "\n"]
        foreach sline $slicedata {
            if {$sline eq ""} {break}
            set kword [string trimright [string tolower [lindex $sline 0]] {":" " "}]
            set value [string trim [lindex $sline 1]]
            set kwords($kword) $value
        }
        if {![info exists kwords(date1)] || $kwords(date1) eq "" || ![info exists kwords(date2)]} {
            debug "[ftime]: No date in slice:\n$data\nService:$::sync(cursvc)\n"
            set len $::sync(curlen)
            set ::sync(curlen) 0
            return $len
        }
         set sensor ""
         if {[info exists kwords(sensor_type)] && $kwords(sensor_type) ne ""} {
            set st [lindex [split $kwords(sensor_type) ":"] 0]
            foreach sens $::knownsensors {
                if {[string match $st* $sens]} {
                    set sensor $sens
                    break
                }
            }
            if {$sensor eq ""} {
                debug "[ftime]: No sensor found for $kwords(sensor_type)!"
                set len $::sync(curlen)
                set ::sync(curlen) 0
                return $len
            }
        }
        set path "root/$::sync(cursvc)/$sensor"
        if {[info exists ::climtimes($path)]} {
            set len $::sync(curlen)
            set ::sync(curlen) 0
            return $len
        }
        set filename ${kwords(date1)}-$kwords(date2)
        processSlice $path $data $filename
        if {[incr ::nfiles] % $::botiklook(maxfiles) == 0} {
            dumpMDB
            initMDB "slices"
            set ::nfiles 0
        }
        set len $::sync(curlen)
        set ::sync(curlen) 0
        update
        return $len
     } else {
         if {$line ne ""} {
            set msg "\n[ftime] Protocol violation: got [fromkoi $line]"
            debug $msg
            lappend ::sync(errors) $msg
        }
        set ::sync(curlen) 0
        return [string length $line]
    }
}
#    files(all)
proc synchronize {} {
    global files nfiles stats auth botiklook sync mtimes wwwaddr dns sliceid
    getHeaders
    updateServices
    findDBStat
    compareData
    set alllen [llength $files(all)]
    set numiters [expr int(ceil(double($alllen)/double($botiklook(every))))]
    set numsteps $numiters
    if {$sync(dosync2)} {
        incr numsteps $::sync(sync2ndays)
    }
    initStatus $numsteps " . "
    initMDB "slices"
    set nfiles  0;  #   
    set sync(errors) {}
    set sliceid 0
    catch {set sliceid [db eval {select seq from SQLITE_SEQUENCE}]}
    if {[lempty $sliceid] || ![string is integer -strict $sliceid]} {set sliceid 0}
    set dir [file join $stats(homecat) $auth(torg)]
    if {![file exists $dir]} {
        lappend botiklook(tmpfiles) $dir
    }
    #   (+)
    initMemory
    if {[unixPlatform]} {
        set dfpath [appFile data.bin]
        set ::sync(datafile) [open $dfpath w+]
        fconfigure $::sync(datafile) -translation binary
        set allfiles {}
        lappend botiklook(tmpfiles) $dfpath
    }
    for {set sync(i) 0} {$sync(i) < $numiters} {incr sync(i)} {
        set sync(filescount) 0
        set sync(dfiles) [lrange $files(all) [expr {$sync(i)*$botiklook(every)}] [expr {($sync(i)+1)*${botiklook(every)}-1}]]; #  
        foreach file $sync(dfiles) {
            set dir [file join $stats(homecat) [file dirname $file]]
            if {![file exists $dir]} {
                file mkdir $dir
                lappend botiklook(tmpfiles) $dir
            }
        }
        dbg "processing [expr $sync(i)+1] of $numiters ..."
        download $sync(dfiles)
        if {[unixPlatform]} {
            set allfiles [concat $allfiles $sync(dfiles)]
        } else {
            processFiles $sync(dfiles)
        }
        shiftStatus
    }
    if {[unixPlatform]} {
        seek $::sync(datafile) 0
        while {![eof $::sync(datafile)]} {
            syncHandler $::sync(datafile) {}
        }
        close $::sync(datafile)
        processFiles $allfiles
    }
    dumpMDB
    if {!$sync(dosync2)} {
        set ::infostring "  ([filesWord $alllen]). "
        finishStatus
        deleteTmpFiles
        set arrs {files mtimes wwwaddr dns}
        foreach arr $arrs {
            array unset $arr
        }
    }
}
proc download {dfiles} {
    if {[windowsPlatform]} {
        download_windows $dfiles
        return
    }
    download_linux $dfiles
}
proc download_linux {dfiles} {
    global botiklook stats
    foreach file $dfiles {
        #      -  ".",  
        # do_get_rawstat      -
        lappend files ./[join [lrange [file split $file] 1 end] "/"]
        lappend botiklook(tmpfiles) [file join $stats(homecat) $file]
    }
    set files [join $files ";FILE="]
    set query [expr {($::auth(anyorg)) ? "do_get_rawstat=1;ORG=$::auth(torg);FILE=$files" : "do_get_rawstat=1;FILE=$files"}]
    set token [http::geturl $::auth(srvurl) \
        -query $query \
        -binary true \
        -command sCommand \
        -headers "Cookie $::auth(cookie)"]
    http::wait $token
    catch {http::cleanup $token}
}
proc download_windows {dfiles} {
    global botiklook stats
    foreach file $dfiles {
        #      -  ".",  
        # do_get_rawstat      -
        lappend files ./[join [lrange [file split $file] 1 end] "/"]
        lappend botiklook(tmpfiles) [file join $stats(homecat) $file]
    }
    set files [join $files ";FILE="]
    set query [expr {($::auth(anyorg)) ? "do_get_rawstat=1;ORG=$::auth(torg);FILE=$files" : "do_get_rawstat=1;FILE=$files"}]
    set token [http::geturl $::auth(srvurl) \
        -query $query \
        -binary true \
        -handler syncHandler \
        -headers "Cookie $::auth(cookie)"]
    catch {http::cleanup $token}
}
proc sCommand {token} {
    upvar #0 $token state
    puts -nonewline $::sync(datafile) $state(body)
}
proc syncHandler {socket token} {
    gets $socket line
    if {[string equal -nocase "File:" [lindex $line 0]]} {
        set ::sync(file) [string replace [lindex $line 1] 0 0 $::auth(torg)]
        set efile [lindex $::sync(dfiles) $::sync(filescount)]; # expected file
        if {$::sync(file) ne $efile} {
            lappend ::sync(errors) "\n[ftime] $::sync(file) out of order"
            set ::sync(len) 0
            incr ::sync(filescount)
        }
        return [string length $line]
    } elseif {[string equal -nocase "Length:" [lindex $line 0]]} {
        set ::sync(len) [lindex $line 1]
        return [string length $line]
    } elseif {[string equal -nocase "Error:" [lindex $line 0]]} {
        set msg "[lrange $line 1 end]"
        if {$msg eq "file unavailable"} {
            #       
            set ::sync(mtime2) [clock seconds]
            lappend ::sync(unavail) "\n[ftime] $::sync(file):$msg"
        } else {
            lappend ::sync(errors) "\n[ftime] $::sync(file):$msg"
        }
        set ::sync(len) 0
        incr ::sync(filescount)
        return [string length $line]
    } elseif {[lempty $line]} {
        if {$::sync(len) == 0 || [lempty $::sync(file)]} {return 0}
        fconfigure $socket -buffering full -buffersize $::sync(len) -blocking 1
        set filepath [file join $::stats(homecat) $::sync(file)]
        set ::sync(channel) [open $filepath w]
        fconfigure $::sync(channel) -translation binary -buffersize $::sync(len)
        catch {
          set data [read $socket $::sync(len)]
          puts -nonewline $::sync(channel) $data
        }
        close $::sync(channel)
        file mtime $filepath $::mtimes($::sync(file))
        set ::climtimes($::sync(file)) [list $::mtimes($::sync(file))]
        incr ::sync(filescount)
        set ::sync(file) ""
        set len $::sync(len)
        set ::sync(len) 0
        update
        return $len
    } else {
        if {[fromkoi $line] eq "<p>  "} {
            foreach file $::sync(dfiles) {
                set path [file join $::stats(homecat) $file]
                if {[file exists $path]} {
                    catch {file delete -force -- $path}
                }
            }
            reAuth
            incr ::sync(i) -1
            return [string length $line]
        }
        set msg "\n[ftime] Protocol violation: got [fromkoi $line]"
        lappend ::sync(errors) $msg
        debug $msg
        return [string length $line]
    }
    return 0
}
#       ,    
# this is faster
proc unpackArchive {file} {
    set fullpath [file join $::stats(homecat) $file]
    if {![file exists $fullpath]} {return}
    set idate [getLoDate $file]
    set fdate [getHiDate $file]
    set fdirname [file dirname $file]
    set dir [file join $::stats(homecat) $fdirname ${idate}-$fdate]
    lappend ::botiklook(tmpfiles) $dir
    if {![file isdirectory $dir]} {
        file mkdir $dir
        cd $dir
        if {[bl_exe]} {
            catch {
                bzip2 -dfkq $fullpath
                tar::untar [file rootname $fullpath]
                #file delete -force [file rootname $fullpath]
            }
        } else {
            catch {exec $::botiklook(tar) -xjf $fullpath}
        }
        cd $::workdir
    }
    set res  {}
    set list [readdir $dir]
    foreach elt $list {
        set fpath [file join $dir $elt]
        if {[file isfile $fpath] && ![string match *.tar $elt]} {
            lappend res [file join $fdirname $idate-$fdate $elt]
        }
    }
    return [list $dir $res]
}
proc processFiles {files} {
    #mdb eval {begin}
    foreach file $files {
        set fpath [file join $::stats(homecat) $file]
        if {![file exists $fpath]} {
            continue
        }
        if {[isArchive $file]} {
            set unpack    [unpackArchive $file]
            set dir       [lindex $unpack 0]
            set archfiles [lindex $unpack 1]
            lappend ::botiklook(tmpfiles) $dir
            foreach slice $archfiles {
                if {[info exists ::stats(rdate1)] && [info exists ::stats(rdate2)]} {
                    set day1 [getDay [getLoDate $slice]]
                    set day2 [getDay [getHiDate $slice]]
                    if {![datesIntersect $::stats(rdate1) $::stats(rdate2) $day1 $day2]} {continue}
                }
                set ::sync(curslice) $slice
                set fullpath [file join $::stats(homecat) $slice]
                processSlice $file [read_file $fullpath] [file tail $slice]
                set ::sync(curslice) {}
                if {[incr ::nfiles] % $::botiklook(maxfiles) == 0} {
                    #mdb eval {commit}
                    dumpMDB
                    initMDB "slices"
                    #mdb eval {begin}
                    set ::nfiles 0
                }
                update
            }
            #       
            if {$::deltmp} {
                catch {file delete -force -- $dir}
            }
        } else {
            if {[info exists ::stats(rdate1)] && [info exists ::stats(rdate2)]} {
                set day1 [getDay [getLoDate $file]]
                set day2 [getDay [getHiDate $file]]
                if {![datesIntersect $::stats(rdate1) $::stats(rdate2) $day1 $day2]} {continue}
            }
            set ::sync(curslice) $file
            set fullpath [file join $::stats(homecat) $file]
            processSlice $file [read_file $fullpath] [file tail $file]
            set ::sync(curslice) {}
            if {[incr ::nfiles] % $::botiklook(maxfiles) == 0} {
                #mdb eval {commit}
                dumpMDB
                initMDB "slices"
                #mdb eval {begin}
                set ::nfiles 0
            }
            update
        }
        #     
        if {$::deltmp} {
            catch {file delete -force -- [file join $::stats(homecat) $file]}
        }
        update
    }
    #catch {mdb eval {commit}}
}
proc allOn {col} {
    global table1 t1chbox
    loop i 0 $table1(m) {
        set cell $i,$col
        #set s [$table1(path).cb$i,$col cget -state]
        if {$t1chbox($cell) ne "disabled"} {
            set t1chbox($cell) 1
            #$table1(path).cb$i,$col select
        }
    }
}
proc reverseCol {col} {
    global table1 t1chbox
    loop i 0 $table1(m) {
        $table1(path).cb$i,$col invoke
    }
}
proc allOff {col} {
    global table1 t1chbox
    loop i 0 $table1(m) {
        set cell $i,$col
        #set s [$table1(path).cb$i,$col cget -state]
        if {$t1chbox($cell) ne "disabled"} {
            set t1chbox($cell) 0
            #$table1(path).cb$i,$col deselect
        }
    }
}
#    
proc fillTable1 {t} {
    global table1 t1chbox
    loop j 0 $table1(n) {
        frame $t.f$j -bg $table1(titlebg) -cursor top_left_arrow
        button $t.f$j.b1 -text "\[V]" -bg white -command "allOn $j"
        if {[imgExists allon]} {$t.f$j.b1 configure -image allon; setBalloon $t.f$j.b1 allon}
        button $t.f$j.b2 -text "\[O]" -bg white -command "reverseCol $j"
        if {[imgExists reverse]} {$t.f$j.b2 configure -image reverse; setBalloon $t.f$j.b2 reverse}
        button $t.f$j.b3 -text "\[ ]" -bg white -command "allOff $j"
        if {[imgExists alloff]} {$t.f$j.b3 configure -image alloff; setBalloon $t.f$j.b3 alloff}
        pack $t.f$j.b1 $t.f$j.b2 $t.f$j.b3 -side left -padx 2
        $t window config -2,$j -window $t.f$j -sticky news
        set wid [expr [string length $table1(-1,$j)]+3]
        set wid [expr {($wid > 11) ? $wid+3 : 15}]
           $t width $j $wid
    }
    loop i 0 $table1(m) {
        loop j 0 $table1(n) {
            set c $i,$j
            if {$t1chbox($c) == "disabled"} {
                set cb [checkbutton $t.cb$c -relief sunken -state disabled -anchor c]
            } else {
                set cb [checkbutton $t.cb$c -variable t1chbox($c) -relief sunken -anchor c]
            }
            $t window config $c -window $cb -sticky news
            set conf [$t tag config [rowTagCmd $i]]
            foreach opt $conf {
                set name [lindex $opt 0]
                set val  [lindex $opt end]
                if {$name eq "-background"} {
                    $cb configure $name $val
                }
            }
        }
        $table1(path) tag cell aleft $i,-2
        $table1(path) tag cell aright $i,-1
    }
    loop j 0 $table1(n) {
        $table1(path) tag cell aleft -1,$j
    }
}
proc rowTagCmd {row} {
    if {$row==-2} {
        return r3
    } elseif {$row==-1} {
        return r0
    } elseif {$row %2} {
        return r2
    } else {
        return r1
    }
}
proc colTagCmd2 {ind} {
    return r1
}
proc findMinMaxDates {} {
    #set exptabs [db eval {select name from sqlite_master where type='table' and name like 'exp_%' order by name}]
    #set name1   [string range [lindex $exptabs 0] 4 end]
    #set name2   [string range [lindex $exptabs end] 4 end]
    #foreach {::stats(mindate) ::stats(maxdate)} [list ${name1}000000 ${name2}000000] {}
    set minmax [db eval {select min(date1),max(date1) from slices}]
    foreach {::stats(mindate) ::stats(maxdate)} $minmax {}
    if {([lempty $::stats(mindate)] && [lempty $::stats(mindate)]) || ($::stats(mindate)==0 && $::stats(maxdate)==0)} {
        set ::stats(mindate) 19700101000000
        set ::stats(maxdate) 20380101000000
    }
}
proc offlineWork {} {
    #    $stats(homecat)/$auth(torg).bdb
    updateServices
    finishStatus
    showChooseStatWindow
}
proc showChooseStatWindow {} {
    global stats table1 auth botiklook
    freeMemory
    findMinMaxDates
    set stats(traf)    0
    set stats(sources) 0
    set stats(files)   0
    set stats(chart)   0
    hideStatusWindow
    set w .csw
    catch {destroy $w}
    catch {toplevel $w}
    wm title $w " . $botiklook(version)"
    wm protocol $w WM_DELETE_WINDOW {
        doExit .csw
    }
    focus -force $w
    frame $w.f1
    pack $w.f1 -fill both -expand 1
    label $w.f1.l -text "    \"$auth(torg)\"" -font {Helvetica 13 bold} -anchor c
    pack $w.f1.l -fill x -expand 1 -padx 5 -pady 5 -side top
    set t $w.f1.t
    set table1(path) $t
    initTable1
    table $t \
        -rows [expr $table1(m)+2] \
        -cols [expr $table1(n)+2] \
        -width 20 \
        -height 10 \
        -titlerows 2 \
        -titlecols 2 \
        -roworigin -2 \
        -colorigin -2 \
        -xscrollcommand "$w.sx set" \
        -yscrollcommand "$w.f1.sy set" \
        -colstretchmode all \
        -rowstretchmode all \
        -colstretch unset \
        -rowstretch unset \
        -sparsearray 1 \
        -variable table1 \
        -rowtagcommand rowTagCmd \
        -rowheight 2 \
        -wrap 0 \
        -justify left \
        -ipadx 3 \
        -cursor top_left_arrow \
        -state disabled
    $t tag config r0 -font {Helvetica 9 bold}
    $t tag config r1 -font {Helvetica 10 bold} -bg white
    $t tag config r2 -font {Helvetica 10 bold} -bg white
    $t tag config aleft  -anchor w
    $t tag config aright -anchor e
    set table1(titlebg) grey
    $t tag config title -bg $table1(titlebg) -font {Helvetica 10 bold} -fg black
    fillTable1 $t
    catch {setTable1Col0Width $t}
    scrollbar $w.sx -command "$t xview" -orient horizontal
    scrollbar $w.f1.sy -command "$t yview"
    pack $w.sx -fill x
    pack $w.f1.sy -side right -fill y
    pack $t -fill both -expand 1
    frame $w.f3
    pack $w.f3 -fill both -expand 1    
    frame $w.f2
    pack $w.f2 -fill both -expand 1    

    frame $w.f2.df1
    frame $w.f2.df2
    pack $w.f2.df1 $w.f2.df2 -side left -expand yes

    set clockformat "%Y-%m-%d"
    set ::datestart [clockFormat $clockformat]
    button $w.f2.df1.de1b -command "showCalendar {} %X %Y $clockformat ::datestart" -text ":" -font {Arial 10} -width 5
    entry $w.f2.df1.de1e -textvariable ::datestart -width 11 -font {Arial 11}

    set ::datefinish [clockFormat $clockformat]
    button $w.f2.df2.de2b -command "showCalendar {} %X %Y $clockformat ::datefinish" -text ":" -font {Arial 10} -width 5
    entry $w.f2.df2.de2e -textvariable ::datefinish -width 11 -font {Arial 11}

    pack $w.f2.df1.de1b $w.f2.df1.de1e -side left -expand yes -padx 5 -pady 10
    pack $w.f2.df2.de2b $w.f2.df2.de2e -side left -expand yes -padx 5 -pady 10
    set date1 [ftime3 [string range $stats(mindate) 0 7]]
    set date2 [ftime3 [string range $stats(maxdate) 0 7]]
    label $w.f3.l2 -text "   $date1  $date2" -font {Helvetica 11 bold} -anchor c
    pack $w.f3.l2 -fill x -expand 1 -padx 5 -pady 5 -side top
    bind $w <KeyPress-Escape> "wm iconify $w"
    bind $t <MouseWheel> "wheelEvent %X %Y %D"
    if {[info exists ::stats(cdate1)] && [info exists ::stats(cdate2)] && ![lempty $::stats(cdate1)] && ![lempty $::stats(cdate2)]} {
        $w.f2.df1.de1e delete 0 end
        $w.f2.df2.de2e delete 0 end
        $w.f2.df1.de1e insert 0 $::stats(cdate1)
        $w.f2.df2.de2e insert 0 $::stats(cdate2)
    } elseif {[info exists ::stats(pdate1)] && [info exists ::stats(pdate2)] && ![lempty $::stats(pdate1)] && ![lempty $::stats(pdate2)]} {
        $w.f2.df1.de1e delete 0 end
        $w.f2.df2.de2e delete 0 end
        $w.f2.df1.de1e insert 0 $::stats(pdate1)
        $w.f2.df2.de2e insert 0 $::stats(pdate2)
    }
    showFooter $w
    if {[windowsPlatform]} {
        ::autoscroll::autoscroll $w.sx
        ::autoscroll::autoscroll $w.f1.sy
    }
}
proc setTable1Col0Width {t} {
    global table1
    set max [string length $table1(0,-2)]
    loop i 0 $table1(m) {
        set len [string length $table1($i,-2)]
        if {$len > $max} {set max $len}
    }
    $t width -2 [expr $max+5]
    $t width -1 20
}
#        ,
#    
proc initTable1 {} {
    global auth coltitles table1 t1chbox stypename ttypes services services2
    set table1(rows)   {}
    set table1(colids) {}
    set tlist          {}
    set sums           {}
    set str            {}
    set numtypes       0
    foreach {type snsrs num dbtypes} $ttypes {
        lappend tlist $type
        incr numtypes
    }
    loop i 0 $numtypes {
        set type [lindex $tlist $i]
        lappend sums "sum($type) as s$i"
        lappend str "\$s$i"
    }
    set sum     [join $str "+"]
    set query   "select service_id,[join $sums {,}] from traffic_nat group by service_id"
    db eval $query {
        #if {[expr $sum] != 0}
        lappend table1(rows) $services2($service_id)
        loop j 0 $numtypes {
            set val [set s$j]
            if {$val != 0 && ![info exists iscolzero($j)]} {
                set iscolzero($j) 0
            }
            set vals($services2($service_id),[lindex $tlist $j]) $val
        }
    }
    set table1(rows) [lsort $table1(rows)]
    loop j 0 $numtypes {
        if {[info exists iscolzero($j)]} {lappend table1(colids) [lindex $tlist $j]}
    }
    set table1(n) [llength $table1(colids)]
    set table1(m) [llength $table1(rows)]
    #if {$table1(m) == 0}
    #    alertError ":       $auth(torg)"
    #    asksendmail ":     .\n[ftime]"
    #    showAuthWindow
    #    return
    set table1(-1,-2) " "
    set table1(-1,-1) " "
    set up1 $table1(m)
    set up2 $table1(n)
    loop i 0 $up1 {
        set service [lindex $table1(rows) $i]
        set stype   [lindex [split $service "-"] 0]
        set table1($i,-2) [string range $service [expr [string length $stype] + 1] end]
        set table1($i,-1) [expr {([info exists stypename($stype)]) ? $stypename($stype) : $stype}]
    }
    loop j 0 $up2 {
        set table1(-1,$j) $coltitles([lindex $table1(colids) $j])
    }
    loop i 0 $up1 {
        set service [lindex $table1(rows) $i]
        loop j 0 $up2 {
            if {[info exists t1chbox($i,$j)]} {continue}
            set colid [lindex $table1(colids) $j]
            if {$vals($service,$colid)==0} {
                set t1chbox($i,$j) "disabled"
            } else {set t1chbox($i,$j) 1}
        }
    }
}
proc mName {mnum} {
    if {[lempty $mnum]} {set mnum 0}
    return [lindex {{}            } $mnum]
}
#  
proc mNameGenitive {mnum} {
    if {[lempty $mnum]} {set mnum 0}
    return [lindex {{}            } $mnum]
}
proc mNameShort {mnum} {
    if {[lempty $mnum]} {set mnum 0}
    return [lindex {{}            } $mnum]
}
proc getPeriod {date1 date2} {
    set spl1 [split $date1 "-"]
    set spl2 [split $date2 "-"]
    set y1 [string trimleft [lindex $spl1 0] {0}]
    set y2 [string trimleft [lindex $spl2 0] {0}]
    set m1 [string trimleft [lindex $spl1 1] {0}]
    set m2 [string trimleft [lindex $spl2 1] {0}]
    set d1 [string trimleft [lindex $spl1 2] {0}]
    set d2 [string trimleft [lindex $spl2 2] {0}]
    if {$y1 == $y2 && $m1 == $m2 && $d1 == $d2} {
        return "$d1 [mNameGenitive $m1] $y1 ."
    } elseif {$y1 == $y2 && $m1 == $m2 && $d2 != [lastDay $y2 $m2]} {
        return "${d1}-$d2 [mNameGenitive $m1] $y1 ."
    } elseif {$y1 == $y2 && $m1 == $m2 && $d1 == 1 && $d2 == [lastDay $y2 $m2]} {
        return "[mName $m1] $y1 ."
    } elseif {$y1 == $y2 && $m1 == 1 && $m2 == 12 && $d1 == 1 && $d2 == [lastDay $y2 $m2]} {
        return "$y1 ."
    } elseif {$y1 == $y2 && $m1 != $m2 && $d1 == 1 && $d2 == [lastDay $y2 $m2]} {
        return "[mName $m1]-[mName $m2] $y1 ."
    } elseif {$y1 != $y2 && $m1 == 1 && $m2 == 12 && $d1 == 1 && $d2 == [lastDay $y2 $m2]} {
        return "${y1}-$y2 ."
    } elseif {$y1 == $y2} {
        return "  $d1 [mNameGenitive $m1]  $d2 [mNameGenitive $m2] $y1 ."
    } else {
        return "  $d1 [mNameGenitive $m1] $y1 .  $d2 [mNameGenitive $m2] $y2 ."
    }
}
proc lastDay {year month} {
    return [clockFormat %d [clock scan "+1 month -1 day" -base [clock scan "$month/01/$year"]]]
}
#      -   .     
proc stepChooseStat {w} {
    if {$::auth(offline)} {
        showOfflineWindow $w
    } else {
        destroy $w; update
        showAuthWindow
    }
}
proc incrCounter {df} {
    if {[windowsPlatform]} {
        #catch {http::geturl $::botiklook(counterurl)$df -timeout 1000}
    }
}
proc processChooseStat {w} {
    if {[foundStat $w.f2.df1.de1e $w.f2.df2.de2e $w]} {
        selectDisposition
    } else {showChooseStatWindow}
}
#       
proc selectDisposition {} {
    switch -- $::botiklook(step) {
        0 {
            findTrafStat
            showStatWindow
        }
        1 {
            findSourcesStat
            showExpsWindow
        }
        2 {
            initChartData
            findChartData
            showChartWindow
        }
        3 {
            findFilesStat
            showFilesWindow
        }
        4 {
            findUFSstat
        }
        default {}
    }
}
#        
proc foundStat {entry1 entry2 w} {
    global stats t1data table1 t1chbox table2 ttypes services cells trafid table3clist table3list services2 colunits
    set ::state " . "
    if {[catch {
        # 1-  :
        set stats(cdate1)   [$entry1 get]
        set scan1           [clock scan $stats(cdate1)]
        set stats(date1)    [clockFormat %Y%m%d $scan1]
        # 2-  :
        set stats(cdate2)   [$entry2 get]
        set scan2           [clock scan $stats(cdate2)]
        set stats(date2)    [clockFormat %Y%m%d $scan2]
    } desc] || $stats(date1) > $stats(date2)} {
        alertError "   ."
        return 0
    }
    #  ,  ;
    if {"${stats(date1)}000000" < $stats(mindate)} {
        set stats(date1)  [string range $stats(mindate) 0 7]
        set stats(cdate1) [ftime3 $stats(date1)]
    }
    if {"${stats(date2)}000000" > $stats(maxdate)} {
        set stats(date2)  [string range $stats(maxdate) 0 7]
        set stats(cdate2) [ftime3 $stats(date2)]
    }
    set stats(intdate1) $stats(cdate1)
    set stats(intdate2) $stats(cdate2)
    #    
    set stats(period) " [getPeriod $stats(intdate1) $stats(intdate2)]"
    #    ($stats(date1)  $stats(date2)),
    #      .
    set alltabs [getTables]
    set exptabs {}
    foreach tab $alltabs {
        if {[string match exp_* $tab]} {
            set day [lindex [split $tab "_"] 1]
            if {$day >= $stats(date1) && $day <= $stats(date2)} {
                lappend exptabs $tab
            }
        }
    }
    set num [db eval "select count(*) from slices where date1 between ${stats(date1)}000000 and ${stats(date2)}000000"]
    if {$num==0} {
        alert "     ."
        focus -force $w
        return 0
    }
    set ischecked 0; #       
    #     
    loop i 0 $table1(m) {
        set vals 0
        loop j 0 $table1(n) {
            set val 1
            if {$t1chbox($i,$j) != 1} {set val 0} else {set ischecked 1}
            incr vals $val
            if {[info exists colfull($j)]} {
                incr colfull($j) $val
            } else {set colfull($j) $val}
        }
        set linefull($i) $vals
    }
    if {!$ischecked} {
        alert "   ."
        focus -force $w
        return 0
    }
    findServices
    array unset cells
    array unset table2
    set table3clist    {}
    set table3list     {}
    set table2(rows)   {}
    set table2(cols)   {}
    set stats(sids)    {}
    set stats(exptabs) $exptabs
    #      1:
    loop i 0 $table1(m) {
        if {!$linefull($i)} {continue}
        set service [lindex $table1(rows) $i]
        lappend stats(sids) $services($service)
        lappend table2(rows) $service
        loop j 0 $table1(n) {
            if {!$colfull($j)} {continue}
            set colid [lindex $table1(colids) $j]
            set t1data($services($service),$colid) [expr {$t1chbox($i,$j)==1}]
            set table2(cols) [union $table2(cols) $colid]
            set cells($service,$colid,cost) 0
            set cells($service,$colid,nat)  0
        }
    }
    set table2(rows) [lsort $table2(rows)]
    destroy $w; update
    return 1
}
#     
proc findTrafStat {} {
    global table2 stats t1data cells services2
    if {$stats(traf)} {return}
    set sums     {}
    set tlist    $table2(cols)
    set numtypes [llength $table2(cols)]
    loop i 0 $numtypes {
        set type [lindex $tlist $i]
        lappend sums "sum($type) as s$i"
    }
    set sumsjoin [join $sums {,}]
    set ids      [join $stats(sids) ","]
    initStatus 2 " . "
    set query    "select service_id,$sumsjoin from traffic_nat where service_id in ($ids) and day between '$stats(date1)' and '$stats(date2)' group by service_id"
    db eval $query {
        loop j 0 $numtypes {
            set colid [lindex $table2(cols) $j]
            if {![info exists t1data($service_id,$colid)]} {continue}
            if {$t1data($service_id,$colid)==1} {
                set val [set s$j]
                set cells($services2($service_id),$colid,nat) $val
            } else {
                set cells($services2($service_id),$colid,nat) 0
            }
        }
    }
    shiftStatus
    set query "select service_id,$sumsjoin from traffic_cost where service_id in ($ids) and day between '$stats(date1)' and '$stats(date2)' group by service_id"
    db eval $query {
        loop j 0 $numtypes {
            set colid [lindex $table2(cols) $j]
            if {![info exists t1data($service_id,$colid)]} {continue}
            if {$t1data($service_id,$colid)==1} {
                set val [set s$j]
                set cells($services2($service_id),$colid,cost) $val
            } else {
                set cells($services2($service_id),$colid,cost) 0
            }
        }
    }
    shiftStatus
    finishStatus
       set stats(traf) 1
    return 1
}
#      
proc findSourcesStat {} {
    global stats table3units table3srv table3tps table3clist 
    if {$stats(sources)} {return}
    initStatus [llength $stats(exptabs)] " . "
    #      
    catch {db eval {drop table tmp}}
    #       exp-.
    #      exp- 
    if {[lempty $stats(exptabs)]} {return}
    set tab    [lindex $stats(exptabs) 0]
    set sql    [db eval "select sql from sqlite_master where name='$tab'"]
    set fields "[lrange [lindex $sql 0] 3 end]"
    set query  [subst "create temp table tmp $fields"]
    db eval $query
    array unset table3units
    array unset table3srv
    array unset table3tps
    catch {db function correct areCorrect}
    set ids [join $stats(sids) {,}]
    set i 0
    foreach t $stats(exptabs) {
        db eval "begin;insert into tmp select service_id,traffic_type,key,\
                 sum(count) as sumcount,sum(cost) as sumcost,priority from $t\
                 where service_id in ($ids) group by service_id,traffic_type,\
                 key,priority having correct(service_id,traffic_type,key);commit"
        shiftStatus
    }
    finishStatus
    initStatus 0 " . "
    set max     0
    set table3clist {}
    db eval {select key,sum(count) as sumcount,sum(cost) as sumcost,priority from tmp group by key} {
        if {$sumcost < 0} {;# never happens; was:1.0
            catch {unset table3units($key)}
            catch {unset table3srv($key)}
            catch {unset table3tps($key)}
            continue
        }
        if {$sumcost > $max} {set max $sumcost}
        if {[info exists table3units($key)]} {
            if {[llength $table3units($key)] > 1} {
                set table3units($key) "rub"
                set sumcount $sumcost
            }
        }
        lappend table3clist [list $key $sumcost $sumcount $priority]
    }
    db eval {drop table tmp}
    set table3clist [lsort -real -index 1 -decreasing $table3clist]
    #    
    set len [llength $table3clist]
    for {set i 1} {$i < $len} {incr i} {
        set eli     [lindex $table3clist $i]
        set eli1    [lindex $table3clist [expr {$i-1}]]
        set costi   [lindex $eli 1]
        set costi1  [lindex $eli1 1]
        if {$costi != $costi1} {continue}
        set prii    [lindex $eli 3]
        set prii1   [lindex $eli1 3]
        catch {
        if {$prii1 >= $prii} {
            lvarpop table3clist $i
            if {($costi1/$max)*100.0 < 0} {
                lvarpop table3clist [expr {$i-1}]
                incr i -2
                incr len -2
                continue
            }
        } else {
            lvarpop table3clist [expr {$i-1}]
            if {($costi/$max)*100.0 < 0} {
                lvarpop table3clist $i
                incr i -2
                incr len -2
                continue
            }
        }
        }
        incr i -1
        incr len -1
    }
    finishStatus
    set cnt 0
    foreach line $table3clist {
        set field [lindex $line 0]
        if {[lsearch $field {}] >= 0} {
            set apos [expr [lsearch $field ""]+1]
            set addr [lindex $field $apos]
            if {[isip $addr] && ![info exists ::dns($addr)]} {incr cnt}
        }
    }
    initStatus $cnt "DNS-. "
    set i 0
    foreach line $table3clist {
        set field [lindex $line 0]
        if {[lsearch $field {}] >= 0} {
            set apos [expr [lsearch $field ""]+1]
            set addr [lindex $field $apos]
            if {[isip $addr]} {
                if {[info exists ::dns($addr)]} {
                    set newaddr $::dns($addr)\($addr\)
                } else {
                    set newaddr [resolve $addr 0]
                    shiftStatus
                }
                set subcnt   [string map {"{" "" "}" ""} [lrange $field 0 [expr $apos-1]]]
                set newfield [concat $subcnt $newaddr [lrange $field [expr $apos+1] end]]
                set newline  [concat [list $newfield] [lrange $line 1 end]]
                lset table3clist $i $newline
                set ::table3units($newfield) $::table3units($field)
                set ::table3srv($newfield)   $::table3srv($field)
                set ::table3tps($newfield)   $::table3tps($field)
            }
        }
        incr i
    }
    finishStatus
    set stats(sources) 1
    return 1
}
proc areCorrect {service_id traffic_type key} {
    if {![info exists ::t1data($service_id,$traffic_type)] \
        || !$::t1data($service_id,$traffic_type)} {return 0}
    if {[info exists ::table3units($key)]} {
        set ::table3units($key) [lsort -unique [lappend ::table3units($key) $::colunits($traffic_type,nat)]]
    } else {
        set ::table3units($key) $::colunits($traffic_type,nat)
    }
    if {[info exists ::table3srv($key)]} {
        set ::table3srv($key) [lsort -unique [lappend ::table3srv($key) $service_id]]
    } else {
        set ::table3srv($key) $service_id
    }
    if {[info exists ::table3tps($key)]} {
        set ::table3tps($key) [lsort -unique [lappend ::table3tps($key) $traffic_type]]
    } else {
        set ::table3tps($key) $traffic_type
    }
    return 1
}
#     
proc findFilesStat {} {
    global stats
    if {$stats(files)} {return}
    set list {}
    set d1   [clock scan [ftime3 ${stats(date1)}000000]]
    set d2   [clock scan [ftime3 ${stats(date2)}235959]]
    set ids  [join $stats(sids) ","]
    initStatus 1 " . "
    db eval "select * from files where service_id in ($ids) and time between '$d1' and '$d2'" {
        lappend list [list $time $local_address $full_url $cost $count]
    }
    set list     [lsort -real -index 3 -decreasing $list]
    set max      [lindex $list 0 3]
    set ::ftlist {}
    foreach elt $list {
        set cost [lindex $elt 3]
        if {($cost/$max)*100.0 >= 0} {
            lappend ::ftlist $elt
        }
    }
    shiftStatus
    finishStatus
    set stats(files) 1
    return 1
}
#   
proc fillTable2 {} {
    global botiklook table2 cells stats colunits colunitstitles coltitles
    set rows $table2(rows)
    set cols $table2(cols)
    array unset table2
    set table2(rows) $rows
    set table2(cols) $cols
    set table2(m)    [llength $table2(rows)]
    set table2(n)    [llength $table2(cols)]
    #  3 
    set table2(-2,-3) " "
    set table2(-2,-2) " "
    set table2(-2,-1) ""
    loop i 0 $table2(m) {
        set service [lindex $table2(rows) $i]
        set stype   [lindex [split $service "-"] 0]
        set sname   [string range $service [expr [string length $stype] + 1] end]
        set table2($i,-3) $sname
        set table2($i,-2) $stype
    }
    #    
    loop j 0 $table2(n) {
        set colid  [lindex $table2(cols) $j]
        set ctitle $coltitles($colid)
        #set utitle $colunitstitles($colunits($colid,$stats(mode)))
        #set table2(-1,$j) "$ctitle ($utitle)"
        set table2(-2,$j) $ctitle
    }
    #   .
    #  .     ,   
    loop i 0 $table2(m) {
        set service [lindex $table2(rows) $i]
        loop j 0 $table2(n) {
            set colid   [lindex $table2(cols) $j]
            set colunit $colunits($colid,$stats(mode))
            set mode    [expr {($colunit eq "rub") ? "cost" : "nat"}]
            set table2($i,$j) $cells($service,$colid,$mode)
        }
    }
    #   
    set table2(-1,-2) ""
    set tsum  0
    set units {}
    loop j 0 $table2(n) {
        unset -nocomplain sum
        loop i 0 $table2(m) {
            if {[info exists table2($i,$j)]} {
                if {[info exists sum]} {
                    set sum [wideSum $sum $table2($i,$j)]
                } else {set sum $table2($i,$j)}
            }
        }
        if {[info exists sum]} {
            set table2(-1,$j) $sum
            set tsum [wideSum $tsum $sum]
        } else {
            set table2(-1,$j) $stats(filler)
        }
        set colid   [lindex $table2(cols) $j]
        set colunit $colunits($colid,$stats(mode))
        lappend units $colunit
    }
    set units [lsort -unique $units]
    #   
    set table2(-2,-1) ""
    if {[llength $units] > 1} {
        #     . ,
        #    ;    "[+]"
        loop i -1 $table2(m) {
            set table2($i,-1) $stats(filler)
        }
        return
    }
    if {$stats(mode) eq "nat"} {
        if {$units eq "rub"} {
            set tsum [rublesFmt $tsum]
        } elseif {$units eq "mb"} {
            set tsum [bytesFmt $tsum]
        } elseif {$units eq "sec"} {
            set tsum [timeFmt2 $tsum]
        }
    }
    set table2(-1,-1) $tsum
    loop i 0 $table2(m) {
        set service [lindex $table2(rows) $i]
        set sum 0
        loop j 0 $table2(n) {
            set colid [lindex $table2(cols) $j]
            if {[info exists cells($service,$colid,$stats(mode))]} {
                set sum [wideSum $sum $cells($service,$colid,$stats(mode))]
            }
        }
        if {$stats(mode) eq "nat"} {
            if {$units eq "rub"} {
                set sum [rublesFmt $sum]
            } elseif {$units eq "mb"} {
                set sum [bytesFmt $sum]
            } elseif {$units eq "sec"} {
                set sum [timeFmt2 $sum]
            }
        }
        set table2($i,-1) $sum
    }
}
proc rightDots {len str} {
    set l [string length $str]
    if {$l <= $len} {
        return $str;
    }
    return [string range $str 0 [expr $len-4]]...
}
proc namesFmt {x} {
    return [rightDots 22 $x]
}
proc rublesFmt {x} {
    global colunitstitles
    set s [sciToRealFmt2 $x]
    if {[string length $s] < 7} {
        return "$s $colunitstitles(rub)"
    }
    #    
    set S ","
    set sEnd [string range $s end-5 end] 
    set sBeg [string range $s 0   end-6]
    while {[string length $sBeg] > 3} {
        set sEnd "[string range $sBeg end-2 end]$S$sEnd" 
        set sBeg  [string range $sBeg 0   end-3]
    }
    return "$sBeg$S$sEnd $colunitstitles(rub)"
}
proc formatValue {s colid} {
    global stats colunits colunitstitles
    if {$colunits($colid,$stats(mode)) eq "rub"} {
        return [rublesFmt $s]
    } elseif {$colunits($colid,$stats(mode)) eq "mb"} {
        return [bytesFmt $s]
    } elseif {$colunits($colid,$stats(mode)) eq "sec"} {
        return [timeFmt2 $s]
    }
    return $s
}
proc table2Cmd {t cell} {
    global table2 stats stypename
    set spl  [split $cell ","]
    set rown [lindex $spl 0]; # row number
    set coln [lindex $spl 1]; # column number
    #   
    if {$coln == -3 && $rown >= 0} {
        return [namesFmt $table2($cell)]
    }
    #   
    if {$coln == -2} {
        if {[info exists table2($cell)]} {
            if {[info exists stypename($table2($cell))]} {return $stypename($table2($cell))}
            return $table2($cell)
        }
    }
    #   
    if {$rown >= -1 && $coln >= -1} {
        if {[info exists table2($cell)]} {
            if {"$rown,$coln" eq "-1,-2"} {return $table2($cell)}
            $t tag cell aright $cell
            if {$coln == -1} {
                if {$stats(mode) ne "nat"} {return [rublesFmt $table2($cell)]}
                return $table2($cell)
            } else {
                set colid [lindex $table2(cols) $coln]
                return [formatValue $table2($cell) $colid]
            }
        }
    }
    #   
    if {[info exists table2($cell)]} {
        return $table2($cell)
    }
    return
}
proc showStatWindow {} {
    global table1 table2 botiklook stats auth modestitles
    #   
    fillTable2
    hideStatusWindow
    set w .sw
    catch {destroy $w}
    catch {toplevel $w}
    wm title $w "  \"$auth(torg)\". $botiklook(version)"
    wm protocol $w WM_DELETE_WINDOW {
        doExit .sw
    }
    focus -force $w
    frame $w.f1
    pack $w.f1 -fill both -expand 1
    label $w.f1.l -text "  \"$auth(torg)\"\n$stats(period)" -font {Helvetica 13 bold} -anchor c
    pack $w.f1.l -fill x -expand 1 -padx 5 -pady 5
    set t $w.f1.t
    set table2(path) $t
    table $t \
        -command [list table2Cmd $t %C] \
        -rows [expr $table2(m)+2] \
        -cols [expr $table2(n)+3] \
        -width 20 \
        -height 10 \
        -titlerows 2 \
        -titlecols 3 \
        -roworigin -2 \
        -colorigin -3 \
        -xscrollcommand "$w.sx set" \
        -yscrollcommand "$w.f1.sy set" \
        -colstretchmode all \
        -rowstretchmode all \
        -sparsearray 1 \
        -rowtagcommand colTagCmd2 \
        -coltagcommand colTagCmd2 \
        -wrap 0 \
        -rowheight 2 \
        -justify center \
        -ipadx 3 \
        -cursor top_left_arrow \
        -selecttitle 1 \
        -selectmode single \
         -state disabled
    $t tag config r0 -font {Helvetica 9 bold}
    $t tag config r1 -font {Helvetica 10 bold} -bg white
    $t tag config r2 -font {Helvetica 10 bold} -bg white
    $t tag config total -font {Helvetica 10 bold} -bg snow3
    $t tag config title -bg $table1(titlebg) -font {Helvetica 10 bold} -fg black
    $t tag config aleft  -anchor w
    $t tag config aright -anchor e
    #    
    loop i 0 $table2(m) {
        $t tag cell aleft $i,-3
        $t tag cell aright $i,-2
    }
    setTable2ColsWidth $t
    scrollbar $w.sx -command "$t xview" -orient horizontal
    scrollbar $w.f1.sy -command "$t yview"
    pack $w.sx -fill x
    pack $w.f1.sy -side right -fill y
    pack $t -fill both -expand 1
    frame $w.f2
    label $w.f2.l -text " : " -font {Helvetica 10 bold}
    tk_optionMenu $w.f2.mode stats(tmode) $modestitles(cost) $modestitles(nat)
    trace add variable stats(tmode) write "changeMode $t"
    pack $w.f2 -fill y -expand 1
    pack $w.f2.l $w.f2.mode -side left -padx 4 -pady 4
    bind $t <Double-Button-1> "T2showRawStat %W"
    bind $t <Button-3>        "T2showRawStat %W"
    bind $t <MouseWheel>      "wheelEvent %X %Y %D"
    showFooter $w
    if {[windowsPlatform]} {
        ::autoscroll::autoscroll $w.sx
        ::autoscroll::autoscroll $w.f1.sy
    }
}
proc T2showRawStat {t} {
    global table2 coltitles services auth stats ufs
    set cell  [$t cursel]
    if {[lempty $cell]} {return}
    set spl   [split $cell ","]
    set row   [lindex $spl 0]
    set col   [lindex $spl 1]
    set serv  [lindex $table2(rows) $row]
    set ttype [lindex $table2(cols) $col]
    set sname $services($services($serv))     
    set cname $coltitles($ttype)
    set ufs(ltext) "   $auth(torg)  $cname  $sname $stats(period)"
    initUFS
    findUFS $serv $ttype ${stats(date1)}000000 ${stats(date2)}235959
    if {$ufs(npages)==0} {
        hideStatusWindow
        return
    }
    sortUFS
    showUFSTable
    catch {$t selection clear all}
}
proc initUFS {} {
    global ufs ufstab
    array unset ufstab
    set ufs(page)         0; #    
    set ufs(rowsperpage) 200; # .    
    set ufs(maxpages)    10000; # .    
    set ufs(sort)        {19 0}; # ID  -   - (  (0)   (1))
    set ufs(label)       ""
    set ufs(npages)      0
    # :
    set ufs(cols) {{"" real rub}\
                  {"" {}}\
                  {" " {}}\
                  {" " integer}\
                  {"" {}}\
                  {". " {}}\
                  {". " integer}\
                  {". " {}}\
                  {". " integer}\
                  {"" real mb}\
                  {"" real mb}\
                  {"" {}}\
                  {"URL " {}}\
                  {" URL" {}}\
                  {"" {}}\
                  {"" {}}\
                  {". " {}}\
                  {". " integer sec}\
                  {" " {}}\
                  {"" integer date}}

    #   ( ID   ufs(cols))    
    #      -
    set ufs(show)        {19 1 2 0 9 10 7 8 5 6 12 13 14 15 16 17 18}
    set ufstab(list)     {}; #         
    set ufstab(pagelist) {}; #         
}
#    ,        
proc getKeyFilter {key} {
    if {[lempty $key]} {return}
    set filter {}
    if {[lindex $key end-1] eq ""} {
        lappend filter [list 11 "==" [lindex $key end]]
    }
    if {[lindex $key end-1] eq ""} {
        set a [lindex $key end]
        if {[string match *(*) $a]} {
            set spl [split $a "("]
            set a   [string range [lindex $spl end] 0 end-1]
        }
        lappend filter [list 7 "==" $a]
    }
    if {[lindex $key end-2] eq ""} {
        set a [lindex $key 4]
        if {[string match *(*) $a]} {
            set spl [split $a "("]
            set a   [string range [lindex $spl end] 0 end-1]
        }
        lappend filter [list 7 "==" $a]
    }
    if {[string match "*. *" $key]} {
        if {[string match "(*)" [lindex $key end]]} {
            lappend filter [list 8 "==" [lindex $key end-1]]
        } else {
            lappend filter [list 8 "==" [lindex $key end]]
        }
    } elseif {[lindex $key 2] eq ""} {
        if {[string match "(*)" [lindex $key end-1]]} {
            lappend filter [list 6 "==" [lindex $key end-2]]
        } else {
            lappend filter [list 6 "==" [lindex $key end-1]]
        }
    }
    if {[lindex $key end-1] eq "" && [lindex $key end-2] eq "==>"} {
        lappend filter [list 15 "==" [lindex $key end]]
    }
    if {[lindex $key end-1] eq "" && [lindex $key end-2] eq "<=="} {
        lappend filter [list 14 "==" [lindex $key end]]
    }
    if {[lindex $key end-1] eq ""} {
        lappend filter [list 12 "==" [lindex $key end]]
    }
    if {[lindex $key end-2] eq ""} {
        lappend filter [list 16 "==" [lindex $key end]]
    }
    if {[lindex $key end-1] eq ""} {
        lappend filter [list 18 "==" [lindex $key end]]
    }
    if {[string match "*==>*" $key]} {
        lappend filter [list 10 ">" 0]
    }
    if {[string match "*<==*" $key]} {
        lappend filter [list 9 ">" 0]
    }
    return $filter
}
proc applyKeyFilter {filter list} {
    if {$filter eq {}} {return 1}
    foreach cond $filter {
        foreach {col op val} $cond {}
        set lval [lindex $list $col]
        if {$op eq "=="} {
            if {!($lval eq $val)} {return 0}
        } elseif {$op eq ">"} {
            if {!($lval > $val)} {return 0}
        } elseif {$op eq "<"} {
            if {!($lval < $val)} {return 0}
        }
    }
    return 1
}
proc findUFSstat {} {
    global ufs stats auth
    set ufs(ltext) "   $auth(torg) $stats(period)"
    initUFS
    findUFS {} {} ${stats(date1)}000000 ${stats(date2)}235959
    if {$ufs(npages)==0} {
        hideStatusWindow
        showChooseStatWindow
        return
    }
    sortUFS
    showUFSTable 1
}
proc findUFS {servs ttypes dateI dateF {key {}}} {
    global colsensors sensorids services traftype \
        ufstab ufs coltitles stats rslines ipdata alltimes
    if {![lempty $key]} {
        set filter [getKeyFilter $key]
    } else {
        set filter {}
    }
    set senscrit {}; # sensor criteria
    set servids  {}
    set servids2 {}
    foreach ttype $ttypes {
        foreach sns $colsensors($ttype) {
            lappend senscrit $sensorids($sns)
        }
    }
    foreach service $servs {
        lappend servids $services($service)
    }
    if {![lempty $servids]} {
        set servids2 [join $servids ","]
        set servids2 "service_id in ($servids2) and"
    }
    if {![lempty $senscrit]} {
        set senscrit [join $senscrit ","]; # sensor criteria
        set senscrit "sensor_id in ($senscrit) and"
    }
    set allrs  [db eval {select name from sqlite_master where type='table' and name like 'rs_%'}]
    set day1   [string range $dateI 0 7]
    set day2   [string range $dateF 0 7]
    set rstabs {}
    foreach tab $allrs {
        set day [lindex [split $tab "_"] 1]
        if {$day1 <= $day && $day <= $day2} {
            lappend rstabs $tab
        }
    }
    set int [intersect $ttypes $::botiklook(rubcols)]
    #set numsteps [expr {(![lempty $int]) ? [llength $rstabs]+3 : [llength $rstabs]+2}]
    #initStatus $numsteps " . "
    set numsteps [expr [llength $rstabs]+1]
    initStatus $numsteps "... "
    focus -force .
    update
    db eval "select * from slices where $senscrit date1 between ${day1}000000 and ${day2}235959" {
        set sliceinfo($slice_id) $service_id
        set bytecost($slice_id)  [expr {($count==0) ? 0 : [sciToRealFmt [expr {double($cost)/double($count)}]]}]
    }
    shiftStatus
    set tab [lindex $rstabs 0]
    set sql [db eval "select sql from sqlite_master where name='$tab'"]
    set fitypes [string range [lrange [lindex $sql 0] 3 end] 1 end-1]; # fields and types
    set fields  {\$cost \$service \$ttype}
    foreach {field type} $fitypes {
        lappend fields \$$field
    }
    set i 0
    set maxrows [expr $ufs(rowsperpage)*$ufs(maxpages)]
    set dobreak 0
    set from [clock scan [ftime3 $dateI]]
    set to   [clock scan [ftime3 $dateF]]
    set ntabs [llength $rstabs]
#    if {$stats(csvsep) eq ";"}
#        set separator ","
#    else
#        set separator ";"
    set separator ":"
    set nlines 0
    foreach tab $rstabs {
        if {[info exists rslines($tab)]} {
            set res $rslines($tab)
        } else {
            set res [db eval "select count(*) from $tab"]
            set rslines($tab) $res
        }
        incr nlines $res
        shiftStatus
    }
    finishStatus
    initStatus $nlines " . "
    foreach fi $fields {
        set finame [string range $fi 1 end]
        set finames($fi) $finame
        set sumfi($finame) 0
    }
    set sumfields [list cost count_in count_out call_duration]
    foreach sfi $sumfields {
        set sumfi($sfi) 1
    }
    set sids [join $servids ","]
    if {![info exists ipdata($sids,$from,$to)] || (![lempty $ttypes] && ![lcontain $ttypes "ip"])} {
        array unset alltimes
        array unset ipdata
    }
    foreach tab $rstabs {
        if {![info exists alltimes($tab)]} {set alltimes($tab) {}}
        db eval "select * from $tab where $senscrit time between $from and $to" {
            if {![info exists sliceinfo($slice_id)] || ($servids ne {} && [lsearch $servids $sliceinfo($slice_id)] == -1)} {shiftStatus; continue}
            if {$call_duration eq {}} {set call_duration 0}
            if {$local_port eq {}}    {set local_port    0}
            if {$remote_port eq {}}   {set remote_port   0}
            set realcost [expr {double($bytecost($slice_id))*double(($count_in+$count_out+$call_duration))}]
            set cost [sciToRealFmt2 $realcost]
            set list {}
            if {$cost==0} {
                # "flow"-alternative
                set realcost [sciToRealFmt $realcost]
                if {$traftype($sensor_id) eq "ip" && ![info exists ipdata($sids,$from,$to)]} {;#was:$realcost != 0 && 
                    catch {
                        set cost    $realcost
                        set service $services($sliceinfo($slice_id))
                        set ttype   $coltitles(ip)
                        set list [subst -nocommands [subst -nocommands $fields]]
                        foreach el $list fi $fields {
                            set finame $finames($fi)
                            if {![info exists ipdata($time,$finame)]} {
                                set ipdata($time,$finame) $el
                            } else {
                                if {$sumfi($finame)} {
                                    lappend ipdata($time,$finame) $el
                                } else {
                                    if {[lsearch $ipdata($time,$finame) $el] == -1} {
                                        lappend ipdata($time,$finame) $el
                                    }
                                }
                            }
                        }
                        lappend alltimes($tab) $time
                    }
                }
                shiftStatus
                continue
            }
            set service $services($sliceinfo($slice_id))
            set ttype   $coltitles($traftype($sensor_id))
            catch {set list [subst -nocommands [subst -nocommands $fields]]}
            if {[applyKeyFilter $filter $list]} {
                lappend ufstab(list) $list
                if {[incr i] > $maxrows} {
                    alert "  $ufs(maxpages)   .\n,   ."
                    set dobreak 1
                }
            }
            if {$dobreak} {break}
            shiftStatus
        }
        set alltimes($tab) [lsort -unique -integer $alltimes($tab)]
        foreach tm $alltimes($tab) {
            set list {}
            foreach fi $fields {
                set res {}
                catch {
                    set finame $finames($fi)
                    set res $ipdata($tm,$finame)
                    if {$sumfi($finame)} {
                        set res [expr [join $res +]]
                    } else {
                        if {$finame eq "local_port" || $finame eq "remote_port"} {
                            set res [lsort -integer $res]
                        }
                        if {[llength $res] > 10} {
                            set res [lrange $res 0 9]
                            lappend res "..."
                        }
                        set res [join $res $separator]
                    }
                }
                lappend list $res
            }
            #if {[sciToRealFmt2 [lindex $list 0]] == 0} {continue}
            if {$list ne {} && [applyKeyFilter $filter $list]} {
                   lappend ufstab(list) $list
                   if {[incr i] > $maxrows && !$dobreak} {
                        alert "  $ufs(maxpages)   .\n,   ."
                        set dobreak 1
                        break
                   }
            }
        }
        if {$dobreak} {finishStatus; break}
    }
    # .  :
    set criteria {}
    if {[lempty $ttypes] || ((![lempty $int]) && !$dobreak)} {
        foreach {field type} $fitypes {
            set $field {}
        }
        foreach col $::botiklook(rubcols) {
            if {[lempty $ttypes] || [lsearch $ttypes $col] >= 0} {
                lappend criteria $sensorids($col)
            }
        }
        if {![lempty $criteria]} {
            set criteria [join $criteria ","]
            set criteria "sensor_id in ($criteria) and"
        }
        db eval "select * from slices where $criteria $servids2 date1 between $dateI and $dateF" {
            if {![info exists sliceinfo($slice_id)]} {continue}
            set day  [getDay $date1]
            set time [clock scan [ftime3 $day]]
            set call_duration 0
            set local_port    0
            set remote_port   0
            set cost    [sciToRealFmt2 $cost]
            set service $services($sliceinfo($slice_id))
            set ttype   $coltitles($traftype($sensor_id))
            set list    {}
            catch {set list [subst -nocommands [subst -nocommands $fields]]}
            if {[applyKeyFilter $filter $list]} {
                lappend ufstab(list) $list
            }
        }
    }
    set ipdata($sids,$from,$to) 1
    set ufs(npages) [expr int(ceil(double([llength $ufstab(list)])/double($ufs(rowsperpage))))]
    if {$ufs(npages)==0} {
        alert "  ."
        finishStatus
        return
    }
    deleteUFSEmptyCols
    finishStatus
}
proc sortUFS {} {
    global ufs ufstab
    set col [lindex $ufs(sort) 0]
    set sopts "-index $col"
    if {[lindex $ufs(sort) 1]} {
        lappend sopts "-decreasing"
    }
    set type [lindex $ufs(cols) $col 1]
    if {![lempty $type]} {
        lappend sopts "-$type"
    }
    catch {set ufstab(list) [eval [subst -nocommands -novariables "lsort $sopts [list $ufstab(list)]"]]}
}
proc showUFSTable {{stage {0}}} {
    global ufs ufstab auth table1 botiklook
    if {$stage} {
        set w .uf2
        set ::botiklook(detailedTable) 1
    } else {
        set w .uf
        set ::botiklook(detailedTable) 0
    }
    hideStatusWindow
    catch {destroy $w}
    catch {toplevel $w}  
    wm title $w "  $auth(torg). $botiklook(version)"
    wm protocol $w WM_DELETE_WINDOW {
        if {$::botiklook(detailedTable)} {
            doExit .uf2
        } else {
            array unset ufstab
            destroy .uf
        }
    }
    focus -force $w
    frame $w.f1
    pack $w.f1 -fill both -expand 1
    label $w.f1.l -text $ufs(ltext) -font {Helvetica 13 bold} -anchor c
    pack $w.f1.l -fill x -expand 1 -padx 5 -pady 5
    set t $w.f1.t
    set sh [winfo screenheight .]
    if {$sh <= 600} {
        if {$sh <= 480} {
            set theight 6
        } else {
            set theight 9; # Eee PC experience
        }
    } else {
        set theight 15
    }
    table $t \
        -cols [llength $ufs(show)] \
        -width 25 \
        -height $theight \
        -titlerows 1 \
        -titlecols 0 \
        -roworigin -1 \
        -colorigin 0 \
        -xscrollcommand "$w.sx set" \
        -yscrollcommand "$w.f1.sy set" \
        -colstretchmode unset \
        -rowstretchmode unset \
        -sparsearray 0 \
        -state disabled \
        -wrap 0 \
        -rowheight 2 \
        -justify center \
        -ipadx 3 \
        -cursor top_left_arrow \
        -selecttitle 1 \
        -rowtagcommand rowTagCmd \
        -selectmode browse \
        -browsecommand {sortUFSColumn %W %S}
    $t tag config r0 -font {Helvetica 9 bold}
    $t tag config r1 -font {Helvetica 10 bold} -bg white
    $t tag config r2 -font {Helvetica 10 bold} -bg white
    $t tag config OddRow  -font {Helvetica 10 bold} -bg snow3
    $t tag config EvenRow -font {Helvetica 10 bold} -bg white
    $t tag config total -font {Helvetica 10 bold} -bg snow3
    $t tag config title -bg $table1(titlebg) -font {Helvetica 10 bold} -fg black
    $t tag config aleft  -anchor w
    $t tag config aright -anchor e
    scrollbar $w.sx -command "$t xview" -orient horizontal
    scrollbar $w.f1.sy -command "$t yview"
    pack $w.sx -fill x
    pack $w.f1.sy -side right -fill y
    pack $t -fill both -expand 1
    frame $w.f2
    button $w.f2.bprev -text "" -font {Helvetica 10 bold} -command "UFSPage $t prev $w.f2.bprev $w.f2.bnext"
    if {[imgExists prev2]} {$w.f2.bprev configure -image prev2 -width 24 -height 24}
    label $w.f2.l -font {Helvetica 10 bold} -textvariable ufs(label)
    button $w.f2.bnext -text "" -font {Helvetica 10 bold} -command "UFSPage $t next $w.f2.bprev $w.f2.bnext"
    if {[imgExists next2]} {$w.f2.bnext configure -image next2 -width 24 -height 24}
    pack $w.f2 -fill y -expand 1
    pack $w.f2.bprev $w.f2.l $w.f2.bnext -side left -padx 4 -pady 4
    if {$ufs(page) == 0} {
        $w.f2.bprev configure -state disabled
    }
    if {$ufs(page) == $ufs(npages) - 1} {
        $w.f2.bnext configure -state disabled
    }
    initUFSPage $t
    bind $t <MouseWheel>      "wheelEvent %X %Y %D"
    bind $t <Double-Button-1> "changeIP %W"
    update
    showFooter $w
    if {[windowsPlatform]} {
        ::autoscroll::autoscroll $w.sx
        ::autoscroll::autoscroll $w.f1.sy
    }
}
proc tableUFSCmd {t cell} {
    set spl  [split $cell ","]
    set rown [lindex $spl 0]
    set coln [lindex $spl 1]
    if {$rown==-1} {
        return [lindex [lindex $::ufs(cols) [lindex $::ufs(show) $coln]] 0]
    }
    set type [lindex [lindex $::ufs(cols) [lindex $::ufs(show) $coln]] 2]
    set coltype [lindex $::ufs(show) $coln]
    set val  [lindex [lindex $::ufstab(pagelist) $rown] $coltype]
    if {[lempty $val]} {return}
    #   
    if {$coltype==7} {
        if {[isip $val] && [info exists ::dns($val)]} {
            return $::dns($val)
        }
    }
    #   
    if {$coltype==18} {
        if {$val eq "D"} {
            return " "
        }
        if {$val eq "H"} {
            return "  "
        }
        if {$val eq "N"} {
            return " "
        }
    }
    if {$type eq "date"} {
        return [ftime2 $val]
    }
    if {$type eq "rub"} {
        return [rublesFmt $val]
    }
    if {$type eq "mb"} {
        return [bytesFmt $val]
    }
    if {$type eq "sec"} {
        return [timeFmt2 $val]
    }
    return $val
}
proc changeIP {t} {
    set cell  [$t cursel]
    if {[lempty $cell]} {return}
    set spl   [split $cell ","]
    set row   [lindex $spl 0]
    set col   [lindex $spl 1]
    set val   [$t get $cell]
    if {[isip $val] || [info exists ::dns($val)]} {
        set res [resolve $val 0]
        if {$res eq $val} {
            alert "DNS-  $val  ."
        } elseif {[info exists ::dns($val)]} {
            $t set $cell $::dns($val)
        }
    }
    $t selection clear all
}
proc initUFSPage {t} {
    global ufs ufstab
    set ufstab(pagelist) [lrange $ufstab(list) [expr $ufs(page)*$ufs(rowsperpage)] [expr ($ufs(page)+1)*$ufs(rowsperpage)-1]]
    $t configure -rows [expr [llength $ufstab(pagelist)]+1]
    $t configure -command "tableUFSCmd $t %C"
    $t yview moveto 0
    set ufs(label) "[expr $ufs(page)+1]  $ufs(npages)"
    set n [llength $ufs(cols)]
    set gap 5
    loop i 0 $n {
        set str [lindex [lindex $ufs(cols) [lindex $ufs(show) $i]] 0]
        set ufs(width,$i) [string length $str]
    }
    set lim 35
    foreach elt $ufstab(pagelist) {
        set i 0
        foreach el $elt {
            set str  [lindex $elt [lindex $ufs(show) $i]]
            set slen [string length $str]
            if {$ufs(width,$i) < $slen} {
                if {$slen >= $lim} {
                    set ufs(width,$i) $lim
                } elseif {$ufs(width,$i) < $slen} {
                    set ufs(width,$i) $slen
                }
            }
            incr i
        }
    }
    loop i 0 $n {
        $t width $i [expr $ufs(width,$i)+$gap]
        $t tag col aleft $i
    }
}
proc UFSPage {t page pbut nbut} {
    global ufs
    if {$page eq "next"} {
        if {$ufs(page) + 1 < $ufs(npages)} {
            #      
            incr ufs(page)
        } else {return}
    } else {
        if {$ufs(page) - 1 >= 0} {
            #      
            incr ufs(page) -1
        } else {return}
    }
    if {$ufs(page) == 0} {
        $pbut configure -state disabled
    } else {
        $pbut configure -state normal
    }
    if {$ufs(page) == $ufs(npages) - 1} {
        $nbut configure -state disabled
    } else {
        $nbut configure -state normal
    }
    initUFSPage $t
}
#         -
proc deleteUFSEmptyCols {} {
    global ufs ufstab
    foreach line $ufstab(list) {
        set i 0
        foreach cell $line {
            if {![lempty $cell] && $cell ne "0"} {
                set cols($i) 1
            }
            incr i
        }
    }
    if {![array exists cols]} {
        #   
        set ufs(show) {}
        return
    }
    #    ,     
    set fullcols [array names cols]
    set i 0
    set todel {}
    set newshow {}
    foreach col $ufs(show) {
        set srch [lsearch -exact -integer $fullcols $col]
        if {[lempty $srch] || $srch == -1} {
            lappend todel $col
        }
        incr i
    }
    foreach col $ufs(show) {
        set srch [lsearch -exact -integer $todel $col]
        if {[lempty $srch] || $srch == -1} {
            lappend newshow $col
        }
    }
    set ufs(show) $newshow
}
proc sortUFSColumn {t cell} {
    global ufs
    set spl  [split $cell ","]
    set row [lindex $spl 0]
    if {$row > -1} {return}
    set newcol [lindex $ufs(show) [lindex $spl 1]]
    set curcol  [lindex $ufs(sort) 0]
    set curmode [lindex $ufs(sort) 1]
    if {$curcol == $newcol} {
        set newmode [expr !$curmode]
        lset ufs(sort) 1 $newmode
    } else {
        set newmode 0
        lset ufs(sort) 0 $newcol
        lset ufs(sort) 1 $newmode
    }
    sortUFS
    initUFSPage $t
    $t activate 0,0
}
proc changeMode {args} {
    global stats modestitles table2
    set t [lindex $args 0]
    #   
    if {$stats(tmode) eq $modestitles($stats(mode))} {return}
    set stats(mode) [expr {($stats(mode) eq "cost") ? "nat" : "cost"}]
    fillTable2
    $t configure -command "table2Cmd $t %C"
}
proc setTable2ColsWidth {t} {
    global table2
    #    " "
    #set max [string length $table2(0,-2)]
    #loop i 0 $table2(m)-1
    #    set len [string length $table2($i,-2)]
    #    if {$len > $max} {set max $len}
    #$t width -2 [expr $max + 2]
    $t width -3 25
    #    
    set wd 15
    loop j -2 $table2(n) {
        set width [expr [string length $table2(-2,$j)] + 4]
        if {$width < $wd} {set width $wd}
        $t width $j $width
    }
}
proc wheelEvent {x y delta} {
    set act 0
    set widget [winfo containing $x $y]
    if {$widget != ""} {
        if {[catch "$widget cget -yscrollcommand" cmd]} {return}
        if {$cmd != ""} {
            set scroller [lindex $cmd 0]
            set act 1
        }
    }
    if {!$act} {return}
    set xy [$widget yview]
    set factor [expr [lindex $xy 1]-[lindex $xy 0]]
    set cmd "[$scroller cget -command] scroll [expr -int($delta/(200*$factor))] units"
    eval $cmd
}
#      
#   .
# cname -  ;
# range -    ;
# pc -     .
proc createSimpleHist {cname ncols range pc} {
    try_eval {
    $::worksheet Select
    set iniCell [lindex $range 0]
    set finCell [lindex $range end]
    if {$iniCell ne $finCell} {
        set crange [$::worksheet Range $iniCell $finCell]
    } else {
        set crange [$::worksheet Range $iniCell]
    }
    set allvals [$crange Value2]
    # create a stacked histogram:
    set charts [$::workbook Charts]
    set chart [$charts Add]
    $chart Name [string range $cname 0 19]
    $chart ChartWizard $crange 3 3 1 1 1 1 $cname; # histo. creation
    set ::xlColumnStacked 52
    set ::xlColumnStacked100 53
    set ::whiteColorIndex 2
    set ::xlCategoryScale 2
    set ::xlColorIndexNone -4142
    if {$pc} {
        set type $::xlColumnStacked100
    } else {
        set type $::xlColumnStacked
    }
    $chart ApplyCustomType $type
    set seriescol [$chart SeriesCollection]
    set scnt      [$seriescol Count]
    if {$scnt==0} {return $chart}
    for {set i 1} {$i <= $scnt} {incr i} {
        set series [$seriescol Item [expr $i]]
        set svals  [lindex $allvals $i]
        set sname  [lindex $svals 0]
        set alltrs [array names ::coltitles]
        set thistr {}
        foreach tr $alltrs {
            if {[string match "$::coltitles($tr)*" $sname]} {
                set thistr $::trafid($tr); # "this" traffic ID
            }
        }
        if {![lempty $thistr]} {
            set border [$series Border]
            $border ColorIndex [expr $::xlColorIndexNone]; # disable border
            set color $::botiklook(color,$thistr)
            set excel_color [rgb_to_excel_scheme $color]
            [[$series Fill] ForeColor] SchemeColor [expr $excel_color]
        }
    }
    # set white background:
    [[$chart PlotArea] Interior] ColorIndex $::whiteColorIndex
    $chart SizeWithWindow True
    # set the title:
    $chart HasTitle True
    [$chart ChartTitle] Text $cname

    if {$pc} {
        set yaxis [[$chart Axes] Item [expr 2]]
        $yaxis MaximumScale 100
        $yaxis MinimumScale 0
        $yaxis MajorUnit 10
    }
    set xaxis [[$chart Axes] Item [expr 1]]
    $xaxis CategoryType [expr $::xlCategoryScale]
    set yaxis [[$chart Axes] Item [expr 2]]
    [[$xaxis TickLabels] Font] Bold True
    [[$xaxis TickLabels] Font] Size 12
    [[$yaxis TickLabels] Font] Bold True
    [[$yaxis TickLabels] Font] Size 12
    [[$chart ChartTitle] Font] Bold True
    [[$chart ChartTitle] Font] Size 20
    catch {[$chart ChartGroups 1] GapWidth [getGapWidth $ncols]}
    } {
        set msg "   \n\"$cname\".\n\n$errorInfo"
        alertError $msg
        return
    }
    return $chart
}
proc getGapWidth {ncols} {
       set gw [expr int(900.0/double($ncols))]
    if {$gw < 20} {set gw 20}
    return $gw
}
proc splitCoord {c} {
    set nc  [string length $c]
    set col ""
    set row ""
    loop i 0 $nc {
        set char [string index $c $i]
        if {[string is alpha $char]} {
            append col $char
        } elseif {[string is integer $char]} {
            append row $char
        }
    }
    return [list $col $row]
}
proc getRow {c} {
    return [lindex [splitCoord $c] 1]
}
proc getCol {c} {
    return [lindex [splitCoord $c] 0]
}
#      .
# range -   ("A1"),    ("A1 A10").
proc cfBold {range isbold} {
    set first [lindex $range 0]
    set last  [lindex $range end]
    if {$first ne $last} {
        set r [$::worksheet Range $first $last]
    } else {
        set r [$::worksheet Range $first]
    }
    set rf [$r Font]
    if {$isbold} {
        catch {$rf Bold True}
    } else {
        catch {$rf Bold False}
    }
    catch {$r WrapText True}
}
#      $data     ;
#    , ..   :     ,
#    ,            ;
# , {"A1" "D3" "A4"};
# coord -    ,     ;
# data -    ;
# ncols -  .
proc insertTable {coord data ncols} {
    $::worksheet Select
    set irow [getRow $coord]
    set icol [getCol $coord]
    if {![string is integer -strict $irow] || ![string is graph -strict $icol]} {
        set msg "   :   :\n$coord"
        alertError $msg
        return 1
    }
    set datalen [llength $data]
    if {$datalen == 0 || $datalen % $ncols != 0} {
        set msg "   :    ."
        alertError $msg
        return 1
    }
    set currow  $irow
    set nrows   [expr int($datalen/$ncols)]
    set inicell [$::worksheet Range $coord]
    loop i 0 $nrows {
        set rowvalues [lrange $data [expr {$i*$ncols}] [expr {($i+1)*${ncols}-1}]]
        set inicoord $icol$currow
        set inicell [$::worksheet Range $inicoord]
        loop j 0 $ncols {
            set v [lindex $rowvalues $j]
            set newrange [$inicell Offset 0 $j]
            $newrange Value2 $v
            shiftStatus
        }
        incr currow
    }
    set addr     [$newrange Address]
    set lastcell [string map {\$ ""} $addr]
    return $lastcell
}
#   $text     $range.
# $range -     ,    ,
#   ,       ,
#    $text;
#    () .
proc insertValue {range text} {
    $::worksheet Select
    set first [lindex $range 0]
    set last  [lindex $range end]
    set irow  [getRow $first]
    set icol  [getCol $first]
    set merge [expr {$first ne $last}]
    if {![string is integer -strict $irow] || ![string is graph -strict $icol]} {
        set msg "    :   ."
        alertError $msg
        return 1
    }
    $::wscells Item $irow $icol $text
    if {$merge} {
        [$::worksheet Range $first $last] Merge
    }
    return 0
}
#   ,  ///   
proc shiftCell {cell dir {steps {1}}} {
    set iniCell [lindex $cell 0]
    set finCell [lindex $cell end]
    if {$iniCell ne $finCell} {
        set inicell [$::worksheet Range $iniCell $finCell]
    } else {
        set inicell [$::worksheet Range $iniCell]
    }
    switch -- $dir {
        "left" {
            set newrange [$inicell Offset 0 -$steps]
        }
        "right" {
            set newrange [$inicell Offset 0 $steps]
        }
        "up" {
            set newrange [$inicell Offset -$steps 0]
        }
        "down" {
            set newrange [$inicell Offset $steps 0]
        }
        default {
            set newrange [$inicell Offset 0 0]
        }
    }
    set addr [$newrange Address]
    set addr [string map {\$ ""} $addr]
    return $addr
}
#     " ".
#   .
proc getDocDir {} {
    try_eval {
        set docDir [registry get HKEY_LOCAL_MACHINE\\SOFTWARE\\Microsoft\\Windows\\CurrentVersion\\Explorer\\DocFolderPaths $::env(USERNAME)]
    } {
        set docDir "~"
    }
    return $docDir
}

#  HTML-  ;
#     ,
#    .xls;

#      OpenOffice Calc,
#    .html,
#     -> ,
#    " HTML (OpenOffice.org Calc) (*.html;*.htm)"

proc table2html {name ncols table filename info} {
    set tlen  [llength $table]
    set niter [expr int(ceil($tlen/$ncols))]
    initStatus $niter "  HTML. "
    set result "<html><meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\">\n\
        <head><title>$name</title></head><body><table border=1 cellspacing=0>\n\
        <tr><td colspan=$ncols>$info</td></tr>\n"
    loop i 0 $niter {
        set line [lrange $table [expr {$i*$ncols}] [expr {($i+1)*$ncols - 1}]]
        append result "<tr>"
        foreach el $line {
            if {[llength $el]==0} {
                append result "<td>&nbsp;</td>"
            } else {
                append result "<td>$el</td>"
            }
        }
        append result "</tr>\n"
        shiftStatus
    }
    append result "</table></body></html>"
    set fd [open $filename "w"]
    fconfigure $fd -encoding utf-8
    puts $fd $result
    close $fd
    finishStatus; hideStatusWindow
    return 0
}
proc store_int {row col int {bold 0}} {
    if {abs($int) > 65535} {
        set float [expr double($int)]
        return [store_float $row $col $float $bold]
    }
    #INTEGER record: record_type(2) + record_size(2) + row_number(2) + col_number(2) + format(3) + integer_number(2)
    return [binary format s*c*s "0x0002 9 $row $col" "0 [expr $bold<<6] 0" $int]
}
proc store_float {row col float {bold 0}} {
    #NUMBER record: record_type(2) + record_size(2) + row_number(2) + col_number(2) + format(3) + float_number(8)
    return [binary format s*c*d "0x0003 15 $row $col" "0 [expr $bold<<6] 0" $float]
}
proc store_text {row col text {bold 0}} {
    set len [string length $text]
    if {$len > 255} {
        # we have to cut long strings
        set text [string range $text 0 254]
        set len 255
    }
    #      ;
    #       1251
    set codes {}
    foreach char [split $text ""] {
        if {[info exists ::ruscode($char)]} {
            lappend codes $::ruscode($char)
        } else {
            lappend codes [scan $char %c]
        }
    }
    set sz [expr 8+$len]
    #LABEL record: record_type(2) + record_size(2) + row_number(2) + col_number(2) + format(3) + text_length(1) + text($text_length)
    return [binary format s*c*cc* "0x0004 $sz $row $col" "0 [expr $bold<<6] 0" $len $codes]
}
proc store_bof {} {
    #BOF record
    set head [binary format s* "0x0009 4 0x0000 0x0010"]
    #DIMENSION record: is optional
    #append head [binary format s* "0x0000 8 0 65536 0 65536"]
    #CODEPAGE record: windows-1251 (Cyrillic)
    append head [binary format s* "0x0042 2 1251"]
    #FONT records: plain and bold
    append head [binary format s*ca* "0x0031 10 200 0x0000" 5 "Arial"]
    append head [binary format s*ca* "0x0031 10 200 0x0001" 5 "Arial"]
    return $head
}
proc store_eof {} {
    #EOF record
    return [binary format s 0x000A]
}
proc store_value {row col val {bold 0}} {
    if {$row > 65535 || $col > 255} {return}
    if {[string is integer -strict $val]} {
        return [store_int $row $col $val $bold]
    }
    if {[string is double -strict $val]} {
        return [store_float $row $col $val $bold]
    }
    return [store_text $row $col $val $bold]
}
# simple Excel/BIFF2 writer in pure Tcl;
# BIFF2 is an old format for Excel spreadsheets developed in 1987,
# but it is still supported by all modern Excel viewers/editors
proc table2biff {name ncols table filename info} {
    set tlen  [llength $table]
    set niter [expr int(ceil($tlen/$ncols))]
    if {$niter > 65535} {set niter 65535}
    initStatus $niter "  Excel. "
    append xls [store_bof][store_value 0 0 $info]
    for {set i 0} {$i < $niter} {incr i} {
        set line [lrange $table [expr {$i*$ncols}] [expr {($i+1)*$ncols - 1}]]
        set row  [expr {$i + 1}]
        for {set j 0} {$j < $ncols} {incr j} {
            set col $j
            set val [lindex $line $j]
            append xls [store_value $row $col $val [expr {($row==1)?1:0}]]
        }
        shiftStatus
    }
    append xls [store_eof]
    set fd [open $filename w]
    fconfigure $fd -translation binary
    puts -nonewline $fd $xls
    close $fd
    finishStatus; hideStatusWindow
    return 0
}
proc table2excel {name ncols table filename {info _}} {
    set nsteps 4
    set hist 0
    if {$ncols <= 0} {return 1}
    if {[string match -nocase "**" $info]} {
        incr nsteps; # for histogram
        set hist 1
    }
    if {[file exists $filename] && ![file writable $filename]} {
        alert "  $filename   ."
        return 1
    }
    if {![info exists ::application]} {incr nsteps}
    set ext [file extension $filename]
    if {$ext eq ".html"} {
        table2html $name $ncols $table $filename $info
        return 0
    }
    #initStatus $nsteps "  Excel. "
        #if {![info exists ::application]}
            #set ::application [::tcom::ref createobject "Excel.Application"]
            #$::application Visible 0
            #$::application DisplayAlerts False
            #shiftStatus
        #set msg "      .xls. ,     Microsoft Office    Excel.    (.csv)   ."
        #alertWarning $msg
        #finishStatus; hideStatusWindow
    #   MS Office Excel,        BIFF2
    table2biff $name $ncols $table $filename $info
    return 0

    set ::workbook   [[$::application Workbooks] Add]
    set ::worksheets [$::workbook Worksheets]
    set ::worksheet  [$::worksheets Item [expr 1]]
    set ::wscells    [$::worksheet Cells]
    set name [string range $name 0 30]
    $::worksheet Name $name
    set lastcell [shiftCell "A1" right [expr $ncols-1]]
    insertValue [list A1 $lastcell] $info
    cfBold [list A1 $lastcell] 1
    shiftStatus
    set tlen [llength $table]
    if {[catch {
        set result ""
        set niter [expr int(ceil($tlen/$ncols))]
        # note: max 65536 lines in Excel 2003
        loop i 0 $niter {
            set line [lrange $table [expr {$i*$ncols}] [expr {($i+1)*$ncols - 1}]]
            append result [join $line \t]\n
        }
        shiftStatus
        set temp ""
        catch {set temp [clipboard get]}
        clipboard clear
        clipboard append $result
        [$::worksheet Range A2] Select
        $::worksheet -namedarg PasteSpecial Format "Unicode Text"; # faster x1000 (!) times
        clipboard clear
        clipboard append $temp
        shiftStatus
    }]} {
        finishStatus
        initStatus $tlen "  Excel. "
        set lcell [insertTable "A2" $table $ncols]; # last resort, very slow
        finishStatus
    }

    # draw histogram
    if {$hist} {
        set lastcell2 [shiftCell $lastcell down $niter]
        createSimpleHist $info $ncols [list A2 $lastcell2] 0
        shiftStatus
    }
    [$::worksheet Columns] AutoFit
    catch {[$::worksheet Range A1 $lastcell] Select}
    $::workbook SaveAs "$filename"
    $::workbook Saved 1
    $::workbook Close
    unset -nocomplain result ::wscells ::worksheet ::worksheets ::workbook
    shiftStatus; finishStatus; hideStatusWindow
    return 0
}
#              .xls
proc getSaveFile {ifile type} {
    set defext ".xls"
    set savetypes {
        {"Excel Workbook" {.xls}}
        {"CSV File"       {.csv}  TEXT}
        {"HTML File"      {.html} TEXT}
        {"Text file"      {.txt}  TEXT}
    }
    if {[macPlatform]} {append ifile ".xls"}
    set filename [tk_getSaveFile -filetypes $savetypes -title " $type  Excel" \
        -initialfile $ifile -initialdir [getDocDir] -defaultextension $defext]
    if {[lempty $filename]} {return}
    set ext [file extension $filename]
    set xls [expr {$ext eq ".xls" || $ext eq ".html"}]
    update
    return [list $filename $xls]
}
proc exportTrafTableToCSV {} {
    global table1 table2 t1chbox stats auth modestitles coltitles
    if {$stats(intdate1) eq $stats(intdate2)} {
        set datestr $stats(intdate1)
    } else {
        set datestr $stats(intdate1)_$stats(intdate2)
    }
    set ifile "$auth(torg)_$stats(mode)_$datestr"
    set total {}
    set xls   0
    set ncols 0
    set filename {}
    if {$stats(mode) eq "nat"} {
        set mode " "
    } else {
        set mode " "
    }
    set info " ($mode)  $auth(torg) $stats(period)"
    set file_info [getSaveFile $ifile ""]
    foreach {filename xls} $file_info {}
    if {[lempty $filename]} {return}
    loop j -3 0 {
        lappend total $table2(-2,$j)
    }
    set j 0
    foreach colid $table2(cols) {
        set unit  $::colunits($colid,$stats(mode))
        if {$unit eq "mb"} {
            set title ""
        } else {
            set title $::colunitstitles($unit)
        }
        lappend total "$table2(-2,$j) ($title)"
        incr j
    }
    loop i -1 $table2(m) {
        loop j -3 $table2(n) {
            set val {}
            if {[info exists table2($i,$j)]} {
                set val $table2($i,$j)
                if {[string is double $val]} {
                    set val [sciToRealFmt2 $val]
                }
                if {[string is double $val] && $stats(decpoint) ne "."} {
                    set val [string map "\. $stats(decpoint)" $val]
                }
            }
            lappend total $val
        }
    }
    set ncols [expr $table2(n) + 3]
    set success $::exportsuccess

    # .xls export
    if {$xls} {
        set res [table2excel $auth(torg) $ncols $total $filename $info]
        if {!$res} {
            #alert $success
        }
        return
    }
    # .csv export
    set f [open $filename w]
    puts $f $info
    set tlen  [llength $total]
    set niter [expr int(ceil($tlen/$ncols))]
    loop i 0 $niter {
        set line [lrange $total [expr {$i*$ncols}] [expr {($i+1)*$ncols - 1}]]
        puts $f [join $line $stats(csvsep)]
    }
    close $f
    unset total
    #alert $success
    return
}

proc exportExpTableToCSV {} {
    global stats auth table3units table3clist \
        table3 table1 t1chbox table3pars botiklook \
        colunitstitles coltitles
    if {$stats(intdate1) eq $stats(intdate2)} {
        set datestr $stats(intdate1)
    } else {
        set datestr $stats(intdate1)_$stats(intdate2)
    }
    set ifile  "$auth(torg)_expenses_$datestr"
    set total {}
    set xls   0
    set ncols 0
    set filename {}
    set info  "   $auth(torg) $stats(period)"
    set file_info [getSaveFile $ifile ""]
    foreach {filename xls} $file_info {}
    if {[lempty $filename]} {return}
    lappend total $table3(-1,0) $table3(-1,1) $table3(-1,2) $table3(-1,3) $table3(-1,4)
    set ncols 5
    set maxcost [lindex $table3clist 0 1]
    foreach line $table3clist {
        set field  [lindex $line 0]
        set cost   [sciToRealFmt2 [lindex $line 1]]
        set natval [sciToRealFmt2 [lindex $line 2]]
        try_eval {
            set percents [sciToRealFmt2 [expr (double($cost)/double($maxcost))*100]]
            set percents [string map "\. $stats(decpoint)" $percents]
        } {
            set percents 0
        }
        try_eval {
            set unit $colunitstitles($table3units($field))
        } {
            set unit $colunitstitles(uunit)
        }
        set cost   [string map "\. $stats(decpoint)" $cost]
        set natval [string map "\. $stats(decpoint)" $natval]
        lappend total "\"$field\"" $cost $natval $percents $unit
    }
    set success $::exportsuccess

    # .xls export
    if {$xls} {
        set res [table2excel $auth(torg) $ncols $total $filename $info]
        if {!$res} {
            #alert $success
        }
        return
    }

    # .csv export
    set f [open $filename w]
    puts $f $info
    set tlen  [llength $total]
    set niter [expr int(ceil($tlen/$ncols))]
    loop i 0 $niter {
        set line [lrange $total [expr {$i*$ncols}] [expr {($i+1)*$ncols - 1}]]
        puts $f [join $line $stats(csvsep)]
    }
    close $f
    unset total
    #alert $success
    return
}
proc exportFilesTableToCSV {} {
    global stats auth ftlist table1 t1chbox botiklook coltitles
    if {$stats(intdate1) eq $stats(intdate2)} {
        set datestr $stats(intdate1)
    } else {
        set datestr $stats(intdate1)_$stats(intdate2)
    }
    set ifile "$auth(torg)_files_$datestr"
    set total {}
    set xls   0
    set ncols 0
    set filename {}
    set info "  $auth(torg) $stats(period)"
    set file_info [getSaveFile $ifile ""]
    foreach {filename xls} $file_info {}
    if {[lempty $filename]} {return}
    set ncols 5
    lappend total "" "" "" " (.)" " ()"
    foreach line $ftlist {
        set when [lindex $line 0]
        set who  [lindex $line 1]
        set what [lindex $line 2]
        set cost [regsub -all {\.} [lindex $line 3] $stats(decpoint)]
        set size [lindex $line 4]
        lappend total $when $who $what $cost $size
    }
    set success $::exportsuccess
    # .xls export
    if {$xls} {
        set res [table2excel $auth(torg) $ncols $total $filename $info]
        if {!$res} {
            #alert $success
        }
        return
    }

    # .csv export
    set f [open $filename w]
    puts $f $info
    set tlen  [llength $total]
    set niter [expr int(ceil($tlen/$ncols))]
    loop i 0 $niter {
        set line [lrange $total [expr {$i*$ncols}] [expr {($i+1)*$ncols - 1}]]
        puts $f [join $line $stats(csvsep)]
    }
    close $f
    unset total
    #alert $success
    return
}
proc exportUFSToCSV {} {
    global ufs ufstab auth stats 
    if {$stats(intdate1) eq $stats(intdate2)} {
        set datestr $stats(intdate1)
    } else {
        set datestr $stats(intdate1)_$stats(intdate2)
    }
    set ifile "$auth(torg)_rawstat_$datestr"
    set total {}
    set xls   0
    set ncols 0
    set info  $ufs(ltext)
    set filename {}
    set file_info [getSaveFile $ifile ""]
    foreach {filename xls} $file_info {}
    if {[lempty $filename]} {return}
    set ncols [llength $ufs(show)]
    loop col 0 $ncols {
        lappend total [lindex [lindex $ufs(cols) [lindex $ufs(show) $col]] 0]
    }
    foreach line $ufstab(list) {
        loop col 0 $ncols {
            set coltype [lindex $ufs(show) $col]
            set val  [lindex $line $coltype]
            set type [lindex [lindex $ufs(cols) $coltype] 1]
            set type2 [lindex [lindex $ufs(cols) $coltype] 2]
            if {$coltype==7} {
                if {[isip $val] && [info exists ::dns($val)]} {
                    set val $::dns($val)
                }
            }
            if {$type eq "real"} {
                set val [string map "\. $stats(decpoint)" $val]
            }
            if {$type2 eq "date" && $val ne ""} {
                set val [ftime4 $val]
            }
            lappend total $val
        }
    }
    set success $::exportsuccess

    # .xls export
    if {$xls} {
        set res [table2excel $auth(torg) $ncols $total $filename $info]
        if {!$res} {
            #alert $success
        }
        return
    }

    # .csv export
    set f [open $filename w]
    puts $f $info
    set tlen  [llength $total]
    set niter [expr int(ceil($tlen/$ncols))]
    loop i 0 $niter {
        set line [lrange $total [expr {$i*$ncols}] [expr {($i+1)*$ncols - 1}]]
        puts $f [join $line $stats(csvsep)]
    }
    close $f
    unset total
    #alert $success
    return
}
proc applyThreshold {} {
    global table3clist table3list table3pars stats
    set table3pars(curpage) 0
    set table3pars(npages)  1
    if {[lempty $table3clist]} {return}
    set clist $table3clist
    set reslist {}
    set maxcost [lindex $clist 0 1]
    foreach el $clist {
        catch {
            set cost [lindex $el 1]
            set pc   [sciToRealFmt2 [expr (double($cost)/double($maxcost))*100.0]]
            if {$pc >= 0.0} {
                lappend reslist $el
            } 
        }
    }
    set table3list $reslist
    set len [llength $table3list]
    #    . 
    set table3pars(npages) [expr int(ceil(double($len)/double($table3pars(maxrows))))]
    #    .  (, - )
    set table3pars(curpage) 0
}
proc table3Cmd {t cell} {
    global table3 table3units colunitstitles
    set spl  [split $cell ","]
    set rown [lindex $spl 0]
    set coln [lindex $spl 1]
    if {![info exists table3($rown,$coln)]} {return}
    if {$rown==-1} {
        return $table3($rown,$coln)
    }
    if {$coln==0} {
        return $table3($rown,$coln)
    }
    if {$coln==1} {
        return [rublesFmt $table3($rown,$coln)]
    }
    if {$coln==2} {
        if {$table3($rown,4) eq "mb"} {
            return [bytesFmt $table3($rown,$coln)]
        } elseif {$table3($rown,4) eq "rub"} {
            return [rublesFmt $table3($rown,$coln)]
        } elseif {$table3($rown,4) eq "sec"} {
            return [timeFmt2 $table3($rown,$coln)]
        }
    }
    if {$coln==3} {
        return [format "%.2f%%" [expr $table3($rown,$coln)*100.0]]
    }
    if {$coln==4} {
        if {$table3($rown,$coln) eq "rub"} {return $colunitstitles(rub)}
        if {$table3($rown,$coln) eq "mb"} {return $colunitstitles(mb)}
    }
    return $table3($rown,$coln)
}
proc rowProc {row} {
    if {$row > -1} {return [expr {($row % 2) ? OddRow : EvenRow}]}
}
#    
proc showExpsWindow {} {
    global botiklook auth stats table3 table3pars table1
    hideStatusWindow
    set w .ew
    catch {destroy $w}
    catch {toplevel $w}  
    wm title $w "   \"$auth(torg)\". $botiklook(version)"
    wm protocol $w WM_DELETE_WINDOW {
        doExit .ew    
    }
    focus -force $w
    frame $w.f1
    pack $w.f1 -fill both -expand 1
    label $w.f1.l -text "   \"$auth(torg)\"\n$stats(period)" -font {Helvetica 13 bold} -anchor c
    pack $w.f1.l -fill x -expand 1 -padx 5 -pady 5
    set t $w.f1.t
    applyThreshold
    initTable3Page
    set sh [winfo screenheight .]
    if {$sh <= 600} {
        if {$sh <= 480} {
            set theight 6
        } else {
            set theight 9; # Eee PC experience
        }
    } else {
        set theight 15
    }
    table $t \
        -command [list table3Cmd $t %C] \
        -cols 4 \
        -width 22 \
        -height $theight \
        -titlerows 1 \
        -titlecols 0 \
        -roworigin -1 \
        -colorigin 0 \
        -xscrollcommand "$w.sx set" \
        -yscrollcommand "$w.f1.sy set" \
        -colstretchmode all \
        -rowstretchmode all \
        -sparsearray 0 \
        -state disabled \
        -wrap 0 \
        -rowheight 2 \
        -justify center \
        -ipadx 3 \
        -cursor top_left_arrow \
        -selecttitle 1 \
        -rowtagcommand rowTagCmd \
        -selectmode single
    $t tag config r0 -font {Helvetica 9 bold}
    $t tag config r1 -font {Helvetica 10 bold} -bg white
    $t tag config r2 -font {Helvetica 10 bold} -bg white
    $t tag config OddRow  -font {Helvetica 10 bold} -bg snow3
    $t tag config EvenRow -font {Helvetica 10 bold} -bg white
    $t tag config total -font {Helvetica 10 bold} -bg snow3
    $t tag config title -bg $table1(titlebg) -font {Helvetica 10 bold} -fg black
    $t tag config aleft  -anchor w
    $t tag config aright -anchor e
    $t tag col aleft  0
    $t tag col aright 1
    $t tag col aright 2
    $t tag col aright 3
    $t width 0 80
    $t width 3 12
    $t width 4 10
    setTable3ColsWidth $t
    $t configure -rows [expr $table3pars(rows) + 1]
    scrollbar $w.sx -command "$t xview" -orient horizontal
    scrollbar $w.f1.sy -command "$t yview"
    pack $w.sx -fill x
    pack $w.f1.sy -side right -fill y
    pack $t -fill both -expand 1
    frame $w.f2
    button $w.f2.bprev -text "" -font {Helvetica 10 bold} -command "table3Page $t prev $w.f2.bprev $w.f2.bnext"
    if {[imgExists prev2]} {$w.f2.bprev configure -image prev2 -width 24 -height 24}
    label $w.f2.l -font {Helvetica 10 bold} -textvariable table3pars(label)
    button $w.f2.bnext -text "" -font {Helvetica 10 bold} -command "table3Page $t next $w.f2.bprev $w.f2.bnext"
    if {[imgExists next2]} {$w.f2.bnext configure -image next2 -width 24 -height 24}
    pack $w.f2 -fill y -expand 1
    pack $w.f2.bprev $w.f2.l $w.f2.bnext -side left -padx 4 -pady 4
    if {$table3pars(curpage) == 0} {
        $w.f2.bprev configure -state disabled
    }
    if {$table3pars(curpage) == $table3pars(npages) - 1} {
        $w.f2.bnext configure -state disabled
    }
    set botiklook(state) "  "; update
    bind $t <Double-Button-1> "T3showRawStat %W"
    bind $t <Button-3>        "T3showRawStat %W"
    bind $t <MouseWheel>      "wheelEvent %X %Y %D"
    showFooter $w
    if {[windowsPlatform]} {
        ::autoscroll::autoscroll $w.sx
        ::autoscroll::autoscroll $w.f1.sy
    }
}
proc setTable3ColsWidth {t} {
    global table3 table3pars
    set max1 0
    set max2 0
    set gap  3
    loop i 0 $table3pars(rows) {
        set slen1 [string length $table3($i,1)]
        set slen2 [string length $table3($i,2)]
        if {$slen1 > $max1} {set max1 $slen1}
        if {$slen2 > $max2} {set max2 $slen2}
    }
    $t width 1 [expr $max1+$gap]
    $t width 2 [expr $max2+$gap]
}
proc T3showRawStat {t} {
    global table3tps table3srv coltitles services services2 auth stats ufs table3 trafid
    set cell  [$t cursel]
    if {[lempty $cell]} {return}
    set spl   [split $cell ","]
    set row   [lindex $spl 0]
    set col   [lindex $spl 1]
    set key   $table3($row,0)
    if {![info exists table3srv($key)] || ![info exists table3tps($key)]} {return}
    set servs {}
    foreach srv $table3srv($key) {
        lappend servs $services2($srv)
    }
    set ttypes $table3tps($key)
    set snames {}
    set cnames {}
    foreach s $servs {
        lappend snames $services($services($s))
    }
    foreach ttype $ttypes {
        lappend cnames $coltitles($ttype)
    }
    set ufs(ltext) "   $auth(torg)\n"
    if {[llength $cnames] > 1} {
        set ufs(ltext) "${ufs(ltext)} [join $cnames {, }]\n"
    } else {set ufs(ltext) "${ufs(ltext)} $cnames\n"}
    if {[llength $snames] > 1} {
        set ufs(ltext) "${ufs(ltext)} [join $snames {, }]\n"
    } else {
        set ufs(ltext) "${ufs(ltext)} $snames\n"
    }
    set ufs(ltext) "$ufs(ltext)$stats(period)"
    initUFS
    findUFS $servs $ttypes ${stats(date1)}000000 ${stats(date2)}235959 $key
    if {$ufs(npages)==0} {
        alert "  ."
        hideStatusWindow
        return
    }
    sortUFS
    showUFSTable
    catch {$t selection clear all}
}
proc table3Page {t page pbut nbut} {
    global table3pars
    if {$page eq "next"} {
        if {$table3pars(curpage) + 1 < $table3pars(npages)} {
            #      
            incr table3pars(curpage)
        } else {return}
    } else {
        if {$table3pars(curpage) - 1 >= 0} {
            #      
            incr table3pars(curpage) -1
        } else {return}
    }
    if {$table3pars(curpage) == 0} {
        $pbut configure -state disabled
    } else {
        $pbut configure -state normal
    }
    if {$table3pars(curpage) == $table3pars(npages) - 1} {
        $nbut configure -state disabled
    } else {
        $nbut configure -state normal
    }
    initTable3Page
    $t configure -command "table3Cmd $t %C"
    $t configure -rows [expr $table3pars(rows) + 1]
    $t yview moveto 0
    setTable3ColsWidth $t
}
#        
proc initTable3Page {} {
    global duration table3cost table3nat table3units table3list table3 table3pars botiklook
    array unset table3
    # 
    set table3(-1,0) ""
    set table3(-1,1) ""
    set table3(-1,2) ""
    set table3(-1,3) "  %"
    set table3(-1,4) ""
    #  
    if {[lempty $table3list]} {
        set table3pars(rows)  0
        set table3pars(label) ""
        return
    }
    set maxcost [lindex $table3list 0 1]
    set lines   [lrange $table3list [expr $table3pars(curpage)*$table3pars(maxrows)] [expr ($table3pars(curpage)+1)*$table3pars(maxrows)-1]]
    set i       0
    foreach line $lines {
        set field    [lindex $line 0]
        set cost     [lindex $line 1]
        set table3($i,0) $field
        set table3($i,1) $cost
        set table3($i,2) [lindex $line 2]
        set table3($i,3) [expr (double($cost)/double($maxcost))]
        set table3($i,4) $table3units($field)
        incr i
    }
    set table3pars(label) " [expr $table3pars(curpage)+1]  $table3pars(npages)"
    set table3pars(rows) $i
}
#   ,   
proc systemInfo {} {
    if {!$::botiklook(twapi)} {
        set descr ":OS:$::tcl_platform(os) $::tcl_platform(osVersion)"
        if {[windowsPlatform]} {
            set info $descr
        } else {
            catch "exec uname -a" osdescr
            set info "$descr; $osdescr"
        }
    } else {
        set meminfo [twapi::get_memory_info -totalphysical -availphysical]
        set phys    [string trim [bytesFmt [lindex $meminfo 1]]]
        set avail   [string trim [bytesFmt [lindex $meminfo 3]]]
        set info    ":OS:[twapi::get_os_description]"
        append info "\n:Total memory:$phys\n:Avail memory:$avail"
        set lang    ""
        catch {set lang [twapi::map_langid_to_name [twapi::get_user_ui_langid]]}
        if {$lang ne ""} {append info "\n:Language:$lang"}
        append info "\n:CPU frequency:[lindex [twapi::get_processor_info {} -processorspeed] 1] Mhz"
        if {[info exists ::env(NUMBER_OF_PROCESSORS)] && $::env(NUMBER_OF_PROCESSORS) > 1} {
            append info "\n:Number of CPUs:$::env(NUMBER_OF_PROCESSORS)"
        }
    }
    if {[info exists ::wine_used]} {
        append info "\n:Wine:$::wine_used"
    }
    return $info
}
proc sendmail {body} {
    global botiklook env whoami auth stats
    set ::state " . "
    try_eval {
           if {[info exists ::application]} {
            $::application Quit
            unset ::application
        }
        set botiklook(reportsent) 0
        #       WhoAmI
        whoAmI
        set myinfo  ""
        set myemail ""
        if {[array exists whoami]} {
            set all [array get whoami]
            foreach {elt val} $all {
                if {[lempty $elt]} {continue}
                set myinfo "$myinfo\n:$elt:$val"
                if {$elt eq "Time"} {set myinfo "$myinfo\n:Client time:$botiklook(time)"}
            }
        }
        set myinfo "$myinfo\n:ORG:$auth(org)\n:LOGIN:$auth(login)\n:Target ORG:$auth(torg)"
        catch {set myinfo "$myinfo\n:Date1:$stats(cdate1)\n:Date2:$stats(cdate2)"}
        set myinfo "$myinfo\n[systemInfo]"
        #    
        if {[catch {set from ${env(USERNAME)}-$whoami(UserName)}]} {
            if {[catch {set from ${env(USERNAME)}-$env(USERDOMAIN)}]} {
                set from "$botiklook(pname) user <$botiklook(devemails)>"
            }
        }
        if {[info exists whoami(Email)]} {
            set from "\"$from\" <$whoami(Email)>"
            set myemail $whoami(Email)
        }
        set from    [tokoi $from]
        set replyto $myemail
        #     :
        set inits   [read_file $botiklook(initfilepath)]
        #  
        set subject [tokoi BotikTools\::[lindex [split $body "\n"] 0]]
        #  
        set line    [string repeat "-" 50]
        set body    [tokoi "$botiklook(version) ($botiklook(dbversion)/$botiklook(user_version))\n$myinfo\n\n$inits\n$line\n$body\n\n :\n\n[getEnv]"]
        #  
        set parts   [mime::initialize -canonical "text/plain; charset=koi8-r; format=flowed" -string $body -encoding 8bit]
        #    ,    .
        set path    [file join $stats(homecat) $::sync(curslice)]
        if {![lempty $::sync(curslice)] && [file exists $path]} {
            set file [addToArchive $path]; #  
            #    (   9 ):
            if {[file size $file] <= 9*1024*1024} {
                set attachment [mime::initialize -canonical "application/data; name=\"[file tail $file]\"" -file $file]
                lappend parts $attachment
            }
        }
        if {[file exists $::blook(debugfile)]} {
            set attachment [mime::initialize -canonical "text/plain; charset=koi8-r; name=\"$::blook(debugfile)\"" -file $::blook(debugfile)]
            lappend parts $attachment
        }
        if {[file exists $::botiklook(tracelog)] && [file readable $::botiklook(tracelog)]} {
            set file [addToArchive $::botiklook(tracelog)]
            if {[file size $file] <= 9*1024*1024} {
                set attachment [mime::initialize -canonical "application/data; name=\"$file\"" -file $file]
                lappend parts $attachment
            }
        }
        #   
        if {[llength $parts] > 1} {
            set token [mime::initialize -canonical "multipart/mixed" -parts $parts]
        } else {
            set token $parts
        }
        smtp::sendmessage $token \
            -originator $from \
            -recipients $botiklook(devemails) \
            -servers    $botiklook(mailserver) \
            -header     [list To $botiklook(devemails)] \
            -header     [list Subject $subject] \
            -header     [list From $from] \
            -header     [list Reply-To $replyto]
        mime::finalize $token -subordinates all
        if {[info exists file] && [file exists $file]} {
            catch {file delete -force $file}
        }
        set botiklook(reportsent) 1
    } {
        set botiklook(reportsent) 1
        catch {tofile $botiklook(errorfile) "$body\n   .\n$errorInfo"}
        alertError "   .\n$errorInfo"
        return
    }
    if {$botiklook(doask)} {alert "  ."}
}
proc asksendmail {body} {
    global botiklook
    if {[file exists $botiklook(errorfile)]} {
        catch {
            set errs [read_file $botiklook(errorfile)]
            if {![lempty $errs]} {set body "$body\n\nOther errors:\n$errs"}
            catch {file delete -force $botiklook(errorfile)}
        }
    }
    if {[lempty $body]} {return}
    #      ,    
    if {![lempty $botiklook(doask)] && !$botiklook(doask)} {
        sendmail $body
        return
    }
    #   
    set prog " "
    if {[info exists ::botiktools(progname)]} {
        append prog " " $::botiktools(progname)
    } else {
        append prog "  Botik Tools"
    }
    set msg "$prog  .           ?"
    set ans [alertQuestionM "$msg" $body]
    if {$ans eq "yes"} {
        sendmail $body
    } else {
        #   ""  
        if {![lempty $body]} {catch {tofile $botiklook(errorfile) $body}}
    }
}
#    (   )
proc getEnv {} {
    set globals [lsort [info globals]]
    set res     ""
    set vars    {}
    set arrays  {}
    #       
    set exclusions {alltimes ipdata netsvc ftlist ufstab subdates dates chart hist histdata chart_nat chart_cost \
        auth env errorInfo files mtimes wwwaddr dns table3list table3clist \
        cells climtimes depdirs stats sync table1 table2 table3 table3srv \
        table3tps table3units tdb whoami rs bytecost cservices services services2\
        knownsensors ttypes blook coltitles colunits colunitstitles hints modestitles\
        sensorids stypename trafid traftype xlcolors}
    foreach var $globals {
        if {[lsearch $exclusions $var] >= 0} {continue}
        if {[string match tcl_* $var]}   {continue}
        if {[string match tk_* $var]}    {continue}
        if {[string match auto_* $var]}  {continue}
        if {[string match arg* $var]}    {continue}
        if {[array exists ::$var]} {
            lappend arrays $var
        } else {
            lappend vars $var
        }
    }
    foreach var $vars {
        append res "-> [list set $var [set ::$var]]\n"
    }
    foreach var $arrays {
        if {$var eq "botiklook"} {
            set vals    {}
            set excls   {tmpfiles}
            set allvals [array get ::$var]
            foreach {name val} $allvals {
                if {[lsearch $excls $name] == -1} {
                    lappend vals $name $val
                }
            }
        } else {
            set vals [array get ::$var]
        }
        append res "-> [list array set $var $vals]\n"
    }
    return $res
}
#  bz2-   
proc addToArchive {file} {
    if {[bl_exe]} {
        catch {bzip2 -zfk $file}
    }
    if {[file exists $file.bz2]} {
        return $file.bz2
    }
    catch {
        exec "$::botiklook(tar)" -cjf $file.tar.bz2 "$file"
    }
    if {[file exists $file.tar.bz2]} {
        return $file.tar.bz2
    }
    return $file
}
proc showFilesWindow {} {
    global botiklook auth stats table3 table3pars table1 ftlist
    hideStatusWindow
    set w .ft
    catch {destroy $w}
    catch {toplevel $w}  
    wm title $w "    \"$auth(torg)\". $botiklook(version)"
    wm protocol $w WM_DELETE_WINDOW {
        doExit .ft
    }
    focus -force $w
    frame $w.f1
    pack $w.f1 -fill both -expand 1
    label $w.f1.l -text "    \"$auth(torg)\"\n$stats(period)" -font {Helvetica 13 bold} -anchor c
    pack $w.f1.l -fill x -expand 1 -padx 5 -pady 5
    set t $w.f1.t
    table $t \
        -command [list filesTabCmd $t %C] \
        -cols 5 \
        -rows [expr [llength $ftlist]+1] \
        -width 40 \
        -height 15 \
        -titlerows 1 \
        -titlecols 0 \
        -roworigin -1 \
        -colorigin 0 \
        -xscrollcommand "$w.sx set" \
        -yscrollcommand "$w.f1.sy set" \
        -colstretchmode all \
        -rowstretchmode all \
        -sparsearray 0 \
        -state disabled \
        -wrap 0 \
        -rowheight 2 \
        -justify left \
        -ipadx 3 \
        -cursor top_left_arrow \
        -selecttitles 1 \
        -rowtagcommand rowTagCmd \
        -selectmode browse
    $t tag config r0 -font {Helvetica 9 bold}
    $t tag config r1 -font {Helvetica 10 bold} -bg white -justify left
    $t tag config r2 -font {Helvetica 10 bold} -bg white
    $t tag config OddRow  -font {Helvetica 10 bold} -bg white
    $t tag config EvenRow -font {Helvetica 10 bold} -bg white
    $t tag config total -font {Helvetica 10 bold} -bg white
    $t tag config title -bg $table1(titlebg) -font {Helvetica 10 bold} -fg black
    $t tag config aleft  -anchor w
    $t tag config aright -anchor e
    $t tag config acent  -anchor n
    $t width 0 15
    $t width 1 25
    $t width 2 80
    $t width 3 15
    $t width 4 15
    $t tag col aleft 0
    $t tag col aleft 1
    $t tag col aleft 2
    $t tag col aleft 3
    $t tag col aleft 4
    scrollbar $w.sx -command "$t xview" -orient horizontal
    scrollbar $w.f1.sy -command "$t yview"
    pack $w.sx -fill x
    pack $w.f1.sy -side right -fill y
    pack $t -fill both -expand 1
    bind $t <MouseWheel> "wheelEvent %X %Y %D"
    showFooter $w
    if {[windowsPlatform]} {
        ::autoscroll::autoscroll $w.sx
        ::autoscroll::autoscroll $w.f1.sy
    }
}
proc filesTabCmd {t cell} {
    set spl [split $cell ","]
    set row [lindex $spl 0]
    set col [lindex $spl 1]
    # "" :
    if {$row==-1} {
        set caps [list "" "" "" "" ""]
        return [lindex $caps $col]
    }
    set text [lindex $::ftlist $row $col]
    if {$col==0} {return [ftime2 $text]}
    if {$col==1} {return $text}
    if {$col==2} {
        if {[winfo exists $t.l$cell]} {return}
        set htext     [string map {"%" "%%"} $text]
        set spl       [file split $text]
        set proto     [lindex $spl 0]
        set domain    [lindex $spl 1]
        set strhttp   $proto//$domain
        set file      [file tail $text]
        set site_url  [siteFmt $domain]
        #      
        if {$text eq "$strhttp/$file"} {
            set shortlink "$site_url/$file"
        } else {
            set shortlink "$site_url/.../$file"
        }
        set l [label $t.l$cell -text $shortlink\
                    -bg white\
                    -fg blue\
                    -cursor hand2\
                    -font {Helvetica 10 bold}\
                    -anchor w]
        $t window config $cell -window $l -sticky w -bg white
        $t tag cell r1 $cell
        bind $t.l$cell <1> "showURL $htext"
        menu $t.l$cell.m -tearoff 0
        $t.l$cell.m add command -label "" -command "copyToClipboard $text"
        bind $t.l$cell <3> "$t.l$cell.m post %X %Y"
        balloon $t.l$cell "$htext"
        return
    }
    if {$col==3} {
        return [rublesFmt $text]
    }
    if {$col==4} {
        return [bytesFmt $text]
    }
}
proc copyToClipboard {text} {
    if {$::botiklook(twapi)} {
        twapi::open_clipboard; #       
        twapi::empty_clipboard; #  
        twapi::write_clipboard_text $text; #    
        twapi::close_clipboard; #  
    } else {
        alertError "     .\n$errorInfo"
    }
}
proc findExecutable {progname varname} {
    upvar 1 $varname result
    set progs [auto_execok $progname]
    if {[llength $progs]} {
        set result [lindex $progs 0]
    }
    return [llength $progs]
}
proc findBrowser {} {
    if {[info exists ::env(BROWSER)]} {
        return $::env(BROWSER)
    }
    # a lot of GUI browsers exist for Linux/UNIX
    set browsers {firefox mozilla-firefox epiphany epiphany-browser seamonkey iceweasel \
                icecat iceape chimera2 galeon mozilla konqueror hotjava \
                netscape opera dillo netsurf flock-browser conkeror \
                kazehakase midori strata skipstone swiftfox amaya google-chrome \
                x-www-browser safari xdg-open}
    set tmp {}
    foreach bro $browsers {
        if {[findExecutable $bro tmp]} {
            set ::env(BROWSER) $tmp
            return $tmp
        }
    }
    return
}
proc showURL {url} {
    if {[unixPlatform]} {
        findBrowser
        if {[info exists ::env(BROWSER)] && [catch {exec $::env(BROWSER) $url} err]} {
            alertError "   URL (by $::env(BROWSER)):\n$url\n$err"
            asksendmail "   URL (by $::env(BROWSER)):\n$url\n$err"
        }
    } elseif {[windowsPlatform]} {
        # Win95 and earlier
        if {$::tcl_platform(osVersion) <= 4.0} {
            showURL2 $url
            return
        }
        # Win98
        if {$::tcl_platform(osVersion)==4.10} {
            regsub -all "/" $url "\\\\" url
        }
        regsub -all "&" $url "^&" url
        if {$::tcl_platform(osVersion) < 5.0} {
            # Win 98/ME
            if {[catch {
                eval exec [auto_execok start] [list $url]
            } err]} {
                alertError "   URL:\n$url\n$err"
                asksendmail "   URL:\n$url\n$err"
            }
        } else {
            # Win 2K/XP/2K3/Vista/2K8/7
            if {[catch {
                if {[string match *.htm $url]} {
                    set url [regsub -nocase {\.htm} $url {\.ht%6D}]; # rundll32     htm-
                }
                exec rundll32 url.dll,FileProtocolHandler $url
            } err]} {
                alertError "   URL:\n$url\n$err"
                asksendmail "   URL:\n$url\n$err"
            }
        }
    } elseif {[macPlatform]} {
        # if MacOS:
        exec open $url; # this just opens default web browser on Mac OS
    }
    return
}
#  (  )      Windows
#     
proc showURL2 {url} {
    set x $::env(COMSPEC)
    if {$x eq ""} {
        set msg "     \n  COMSPEC."
        alertError $msg
        asksendmail $msg
        return
    }
    if {[catch {
        set tmpfile "tmp.url"
        set f [open $tmpfile w]
        puts $f "\[InternetShortcut]\nURL=$url"
        close $f
    }]} {
        set msg "   URL:\n$url\n$errorInfo"
        alertError $msg
        asksendmail $msg
    } else {
        catch {exec $x /c start $tmpfile}
        #catch {file delete -force $tmpfile}
    }
    return
}
proc svc {} {return [info exists ::tcl_service]}
# fixme:    -4*$sechour  -3*$secday
proc findSyncTime {} {
    set now      [clock seconds]
    set sechour  [expr 60*60]
    set secday   [expr $sechour*24]
    set secweek  [expr $secday*7]
    set synctime 0
    if {$::shed(type) == 0} {
        set synctime $::shed(savetime)
        while {$synctime < $now} {
            incr synctime [expr $sechour*$::shed(hour)]
        }
    } elseif {$::shed(type) == 1} {
        set days [expr int($::shed(savetime)/$secday)]
        if {$::shed(day) == 1} {set synctime [expr $days*$secday+$::shed(timeh)*$sechour+$::shed(timem)*60-4*$sechour]}
        while {$synctime < $now} {
            incr days $::shed(day)
            set synctime [expr $days*$secday+$::shed(timeh)*$sechour+$::shed(timem)*60-4*$sechour]
        }
    } elseif {$::shed(type) == 2} {
        set weeks [expr int($::shed(savetime)/$secweek)]
        if {$::shed(week) == 1} {
            loop i 0 7 {
                if {$::shed(weekdays,$i)} {
                    set synctime [expr $weeks*$secweek+$i*$secday+$::shed(timeh)*$sechour+$::shed(timem)*60-4*$sechour-3*$secday]
                    if {$synctime >= $now} {return $synctime}
                }
            }
        }
        while {$synctime < $now} {
            incr weeks $::shed(week)
            loop i 0 7 {
                if {$::shed(weekdays,$i)} {
                    set synctime [expr $weeks*$secweek+$i*$secday+$::shed(timeh)*$sechour+$::shed(timem)*60-4*$sechour-3*$secday]
                }
            }
        }
    }
    return $synctime
}
proc svc_readInit {} {
    if {[readInit]} {
        catch {doSource $::blook(svccfgpath)}
        if {[info exists ::shed(sync)] && $::shed(sync)} {
            set ::blook(synctime) [findSyncTime]
            return 1
        }
    }
    return 0
}
proc startEventLoop {} {
    while {1} {
        if {[clock seconds]==$::blook(synctime)} {
            #    ...
            doSynchronize
            after 1000 {set ::next 1}
            vwait ::next
            set ::blook(synctime) [findSyncTime]
            continue
        }
        after $::blook(uto) {set ::next 1}
        vwait ::next
    }
}
proc ftime {} {
    return [clockFormat "%X"]
}
proc ispausedService {} {
    if {$::blook(paused)} {
        sendMsg "paused"
    } else {sendMsg "notpaused"}
}
proc pauseService {} {
    set ::blook(paused) 1
    vwait ::blook(paused)
}
proc resumeService {} {
    set ::blook(paused) 0
}
proc doSynchronize {} {
    if {![array exists ::cfgetab]} {return}
    set ::blook(busy) 1
    set names [array names ::cfgetab vals,*]
    foreach name $names {
        set ::auth(org)      [lindex $::cfgetab($name) 0]
        set ::auth(login)    [lindex $::cfgetab($name) 1]
        set ::auth(password) [decrypt [lindex $::cfgetab($name) 2]]
        if {$::blook(authOK,$name)} {
            doAuth
        }
        if {!$::auth(done)} {
            set ::blook(authOK,$name) 0
            alertError "    $name."
        }
    }
    set ::blook(busy) 0
}
proc decrypt {msg} {
    loadPackages {aes 1.0.0}
    return [string trim [aes::aes -dir decrypt -key $::blook(key) [binary format H* $msg]] \x00]
}
proc syncNow {} {
    if {!$::blook(busy) && [svc_readInit]} {
        doSynchronize
    }
}
# Background synchronization
proc doBGSynchronization {} {
    if {![svc_readInit]} {exit}
    if {![array exists ::cfgetab]} {return}
    set names [array names ::cfgetab vals,*]
    foreach name $names {set ::blook(authOK,$name) 1}
    startEventLoop
    startServer
}
proc startServer {} {
#    comm::comm config -listen 1 -local 1 -port $::blook(svcport) -silent 0
    catch {socket -server newConn -myaddr 127.0.0.1 $::blook(svcport)}
    return
}
proc newConn {channel clientAddress clientPort} {
    if {(($clientAddress ne "127.0.0.1") && ($clientAddress ne "localhost"))} {
        return
    }
    readFromChannel $channel
    return
}
proc readFromChannel {ch} {
    if {[eof $ch]} {
        close $ch
        return
    }
    catch {
        gets $ch msg
        handleMgrMessage $msg
    }
    return
}
proc sendMsg {msg} {
    #comm::comm send -async $::blook(mgrport) handleSvcMessage "{$msg}"
    #-myaddr 127.0.0.1 -myport $::blook(svcport)
    set ch [socket 127.0.0.1 $::blook(mgrport)]
    puts $ch $msg
    flush $ch
    close $ch
    return
}
proc handleMgrMessage {msg} {
    if {[lempty $msg]} {return}
    switch -- $msg {
        "pause"    {pauseService}
        "ispaused" {ispausedService}
        "resume"   {resumeService}
        "syncnow"  {syncNow}
        default    {sendMsg "Unknown_message_to_service:$msg"}
    }
    return
}
proc chooseAction {} {
    if {[svc]} {
        doBGSynchronization
    } else {
        showFirstWindow
        checkVersion
    }
}
# histograms drawing for BotikLook;
# main code written in a month: 10-jan-2007 -- 8-feb-2007;
# only bugfixes and cosmetic improvements followed

# ,     
proc startDisplay {} {
    #     disabled
    set ::chart(buttons,states) {}
    foreach b $::chart(buttons) {
        lappend ::chart(buttons,states) [$b cget -state]
        $b config -state disabled
    }
    update
}
# ,     
proc finishDisplay {} {
    #     
    set i 0
    foreach b $::chart(buttons) {
        $b config -state [lindex $::chart(buttons,states) $i]
        incr i
    }
    changeScrollRegion
    update
}
proc getDateType {date} {
    if {[lempty $date]} {return ""}
    set type "min"
    if [isYear $date] {
        set type year
    } elseif [isQuarter $date] {
        set type quarter
    } elseif [isMonth $date] {
        set type month
    } elseif [isWeek $date] {
        set type week
    } elseif [isDay $date] {
        set type day
    } elseif [isHDay $date] {
        set type hday
    } elseif [isHour $date] {
        set type hour
    }
    return $type
}
proc getDateLabel {date} {
    set type [getDateType $date]
    switch -- $type {
        "year" {
            return "$date "
        }
        "quarter" {
            set spl [split $date "."]
            set rn  [lindex $spl 0]
            set y   [lindex $spl 1]
            return "$rn  $y ."
        }
        "month" {
            set spl [split $date "."]
            set m   [lindex $spl 0]
            set y   [lindex $spl 1]
            return "[mName $m] $y ."
        }
        "week" {
            set spl [split $date "."]
            set rn  [lindex $spl 0]
            set w   $::arab($rn)
            set m   [lindex $spl 1]
            set y   [lindex $spl 2]
            return "$w . [mNameGenitive $m] $y ."
        }
        "day" {
            set spl [split $date "."]
            set d   [lindex $spl 0]
            set m   [lindex $spl 1]
            if {$m < 10} {set m "0$m"}
            set y   [lindex $spl 2]
            return "$d.$m.$y"
        }
        "hday" {
            set spl [split $date "."]
            set hd  [lindex $spl 0]
            set n   $::arab($hd)
            set d   [lindex $spl 1]
            set m   [lindex $spl 2]
            if {$m < 10} {set m "0$m"}
            set y   [lindex $spl 3]
            return "$n- . $d.$m.$y"
        }
        "hour" {
            set spl [split $date "."]
            set h   [lindex $spl 0]
            set d   [lindex $spl 1]
            set m   [lindex $spl 2]
            if {$m < 10} {set m "0$m"}
            set y   [lindex $spl 3]
            return "$h . $d.$m.$y"
        }
        "min" {
            set spl [split $date "."]
            set m   [lindex $spl 0]
            set h   [lindex $spl 1]
            set d   [lindex $spl 2]
            set mn   [lindex $spl 3]
            if {$mn < 10} {set mn "0$mn"}
            if {$m==60} {
                set m "00"
                incr h
                if {$h==24} {set h "00"}
            }
            set y [lindex $spl 4]
            return "$h . $m . $d.$mn.$y"
        }
        default {
            return ""
        }
    }
}
proc getGLabel {date} {
    switch -- $::chart(view) {
        "years" {
            if {![isYear $date]} {return ""}
            return "$date "
        }
        "quarters" {
            if {![isQuarter $date]} {return ""}
            set spl [split $date "."]
            set rn  [lindex $spl 0]
            set y   [lindex $spl 1]
            return "$rn  $y ."
        }
        "months" {
            if {![isMonth $date]} {return ""}
            set spl [split $date "."]
            set m   [lindex $spl 0]
            set y   [lindex $spl 1]
            return "[mName $m] $y ."
        }
        "weeks" {
            if {![isWeek $date]} {return ""}
            set spl [split $date "."]
            set rn  [lindex $spl 0]
            set w   $::arab($rn)
            set m   [lindex $spl 1]
            set y   [lindex $spl 2]
            return "$w . [mNameGenitive $m] $y ."
        }
        "days" {
            if {![isDay $date]} {return ""}
            set spl [split $date "."]
            set d   [lindex $spl 0]
            set m   [lindex $spl 1]
            if {$m < 10} {set m "0$m"}
            set y   [lindex $spl 2]
            return "$d.$m.$y"
        }
        "hdays" {
            if {![isHDay $date]} {return ""}
            set spl [split $date "."]
            set hd  [lindex $spl 0]
            set n   $::arab($hd)
            set d   [lindex $spl 1]
            set m   [lindex $spl 2]
            if {$m < 10} {set m "0$m"}
            set y   [lindex $spl 3]
            return "$n- . $d.$m.$y"
        }
        "hours" {
            if {![isHour $date]} {return ""}
            set spl [split $date "."]
            set h   [lindex $spl 0]
            set d   [lindex $spl 1]
            set m   [lindex $spl 2]
            if {$m < 10} {set m "0$m"}
            set y   [lindex $spl 3]
            return "$h . $d.$m.$y"
        }
        default {
            return ""
        }
    }
}
proc getColLabel {date} {
    if {!$::chart(detailed)} {return ""}
    switch -- $::chart(view) {
        "years" {
            if {![isQuarter $date]} {return ""}
            set spl [split $date "."]
            set rn  [lindex $spl 0]
            return "$rn "
        }
        "quarters" {
            if {![isMonth $date]} {return ""}
            set spl [split $date "."]
            set m   [lindex $spl 0]
            return "[mNameShort $m]"
        }
        "months" {
            if {![isWeek $date]} {return ""}
            set spl [split $date "."]
            set rn  [lindex $spl 0]
            set w   $::arab($rn)
            return "$w "
        }
        "weeks" {
            if {![isDay $date]} {return ""}
            set spl [split $date "."]
            set d   [lindex $spl 0]
            return "$d"
        }
        "days" {
            if {![isHDay $date]} {return ""}
            set spl [split $date "."]
            set hd  [lindex $spl 0]
            return "$hd"
        }
        "hdays" {
            if {![isHour $date]} {return ""}
            set spl [split $date "."]
            set h   [lindex $spl 0]
            return ${h}
        }
        "hours" {
            set spl [split $date "."]
            set m [lindex $spl 0]
            return ${m}
        }
        default {
            return ""
        }
    }
}
proc drawGLabel {txt x} {
    $::chart(c) create text [cconv [list $x $::hist(gy)]] -text $txt -font $::hist(gfont)
}
proc drawColLabel {txt x} {
    $::chart(c) create text [cconv [list $x $::hist(cy)]] -text $txt -font $::hist(cfont)
}
#   
proc analyzeGroup {subds} {
    if {!$::chart(detailed) && [llength $subds] != 1} {return 0}
    set xpos2 $::hist(xpos)
    if {!$::chart(detailed)} {
        return $::hist(cw)
    }
    set dl [llength $subds]
    set di 1
    foreach d $subds {
        set lbl [getColLabel $d]
        set lw  [getTxtWidth $lbl $::hist(cfont)]
        if {$lw < $::hist(cw)} {set lw $::hist(cw)}
        set lg [expr int(ceil(($lw-$::hist(cw))/2.0))]
        incr xpos2 $lg
        if {$di == $dl} {
            #    
            incr xpos2 [expr $::hist(cw)+$lg]
        } else {
            incr xpos2 [expr $::hist(cw)+$lg+2*$::hist(cgap)]
        }
        incr di
    }
    set gwidth [expr $xpos2-$::hist(xpos)]
    return $gwidth
}
proc drawBar {date} {
    set c     $::chart(c)
    set y     0
    set bw    $::hist(bw)
    set trids {}
    foreach trname $::table2(cols) {
        if {$::chart($trname)} {
            lappend trids $::trafid($trname)
        }
    }
    set tmp {}
    foreach trid $trids {
        set tmp "$trid $tmp"
    }
    set trids $tmp
    set ctag ${date}_$::hist(n); # column tag
    lappend ::hist(tags) $ctag
    foreach trid $trids {
        if {![info exists ::histdata($date,$trid)]} {
            set val 0
        } else {
            set val $::histdata($date,$trid)
        }
        set h  [expr int($::hist(pxd)*$val)]
        if {$h < 2} {continue}
        set tag ${date}_${trid}_$::hist(n)
        set x1 $::hist(xpos)
        set y1 [expr $y+$h]
        set x2 [expr $::hist(xpos)+$::hist(cw)-$bw]
        set y2 [expr $y+$bw]
        $c create rect [cconv [list $x1 $y1 $x2 $y2]] -fill $::botiklook(color,$trid) -width $bw -tags $tag
        group barchart $tag
        group $ctag $tag
        incr y $h
    }
    incr ::hist(n)
}
proc drawBars {subds} {
    incr ::hist(xpos) $::hist(gadd)
    if {!$::chart(detailed) && [llength $subds] != 1} {return 0}
    set dl [llength $subds]
    set di 1
    foreach d $subds {
        set lbl [getColLabel $d]
        set lw  [getTxtWidth $lbl $::hist(cfont)]
        if {$lw < $::hist(cw)} {set lw $::hist(cw)}
        if {$::chart(detailed)} {
            set lblx [expr $::hist(xpos)+$lw/2]
            drawColLabel $lbl $lblx
        }
        set lg [expr int(ceil(($lw-$::hist(cw))/2.0))]
        incr ::hist(xpos) $lg
        drawBar $d
        if {$di == $dl} {
            #    
            incr ::hist(xpos) [expr $::hist(cw)+$lg+$::hist(cgap)+$::hist(gadd)]
        } else {
            incr ::hist(xpos) [expr $::hist(cw)+$lg+2*$::hist(cgap)]
        }
        incr di
    }
}
proc drawXaxis {} {
    set c $::chart(c)
    set gi 1
    set gl [llength $::chart(groups,$::chart(view))]
    set ::hist(n) 0
    set ::hist(tags) {}
    foreach date $::chart(groups,$::chart(view)) {
        if {$::chart(detailed)} {
            set subds $::subdates($date)
        } else {set subds $date}
        set w    [analyzeGroup $subds]
        set glbl [getGLabel $date]
        set lw   [getTxtWidth $glbl $::hist(gfont)]
        if {$lw < $w} {set lw $w}
        set ::hist(gadd) [expr int(ceil(($lw-$w)/2))]
        set gx [expr $::hist(xpos)+$lw/2]
        drawGLabel $glbl $gx
        drawBars $subds
        if {$::hist(n) >= $::hist(limit)} {
            alertWarning "     ($::hist(limit)).\n,     ."
            $c lower barchart oy
            initChartBinds
            return
        }
        #    
        if {$gi < $gl} {
            incr ::hist(xpos) [expr 2*$::hist(ggap)+$::hist(cgap)]
        }
        incr gi
    }
    $c lower barchart oy
    initChartBinds
}
proc initChartBinds {} {
    set c $::chart(c)
    $c bind barchart <Enter> "cursor_toHand %x %y"
    $c bind barchart <Motion> [$c bind barchart <Enter>]
    $c bind barchart <Leave> cursor_toNormal
    $c bind barchart <ButtonPress-1> clearBinds
    $c bind barchart <ButtonRelease-1> barSelected
    $c bind barchart <ButtonPress-3> showBarRawStat
}
proc clearBinds {} {
    set c $::chart(c)
    bind $c <ButtonPress-1> {}
    bind $c <ButtonRelease-1> {}
}
proc month {m} {
    set m [string trimleft $m 0]
    return [expr {($m < 10) ? "0$m" : $m}]
}
proc getPeriodByDate {date {ch 1}} {
    switch -- $::chart(view)-$::chart(detailed) {
        years-0 {
            if {![isYear $date]} {return}
            if {$ch} {set ::chart(view) "quarters"}
            set d1 "$date-01-1 00:00:00"
            set d2 "$date-12-[lastDay $date 12] 23:59:59"
            return [list $d1 $d2]
        }
        quarters-0 - years-1 {
            if {![isQuarter $date]} {return}
            if {$ch} {set ::chart(view) "months"}
            set spl [split $date "."]
            set rn  [lindex $spl 0]
            set n   $::arab($rn)
            set y   [lindex $spl 1]
            set m2  [expr $n*3]
            set m1  [expr $m2-2]
            set d1  "$y-[month $m1]-1 00:00:00"
            set d2  "$y-[month $m2]-[lastDay $y $m2] 23:59:59"
            return [list $d1 $d2]
        }
        months-0 - quarters-1 {
            if {![isMonth $date]} {return}
            if {$ch} {set ::chart(view) "weeks"}
            set spl [split $date "."]
            set m   [lindex $spl 0]
            set y   [lindex $spl 1]
            set d1  "$y-[month $m]-1 00:00:00"
            set d2  "$y-[month $m]-[lastDay $y $m] 23:59:59"
            return [list $d1 $d2]
        }
        weeks-0 - months-1 {
            if {![isWeek $date]} {return}
            if {$ch} {set ::chart(view) "days"}
            set spl [split $date "."]
            set rn  [lindex $spl 0]
            set n   $::arab($rn)
            set m   [lindex $spl 1]
            set y   [lindex $spl 2]
            foreach {day1 day2} [getWeekDays $n $m $y] {}
            set d1  "$y-[month $m]-$day1 00:00:00"
            set d2  "$y-[month $m]-$day2 23:59:59"
            return [list $d1 $d2]
        }
        days-0 - weeks-1 {
            if {![isDay $date]} {return}
            if {$ch} {set ::chart(view) "hdays"}
            set spl [split $date "."]
            set d   [lindex $spl 0]
            set m   [lindex $spl 1]
            set y   [lindex $spl 2]
            set d1  "$y-[month $m]-$d 00:00:00"
            set d2  "$y-[month $m]-$d 23:59:59"
            return [list $d1 $d2]
        }
        hdays-0 - days-1 {
            if {![isHDay $date]} {return}
            if {$ch} {set ::chart(view) "hours"}
            set spl [split $date "."]
            set hd  [lindex $spl 0]
            set n   $::arab($hd)
            set d   [lindex $spl 1]
            set m   [lindex $spl 2]
            set y   [lindex $spl 3]
            set d1  "$y-[month $m]-$d"
            set d2  "$y-[month $m]-$d"
            if {$n == 1} {
                append d1 " 00:00:00"
                append d2 " 11:59:59"
            } else {
                append d1 " 12:00:00"
                append d2 " 23:59:59"
            }
            return [list $d1 $d2]
        }
        hdays-1 {
            if {![isHour $date]} {return}
            if {$ch} {set ::chart(view) "hours"}
            set spl [split $date "."]
            set h   [lindex $spl 0]
            set d   [lindex $spl 1]
            set m   [lindex $spl 2]
            set y   [lindex $spl 3]
            if {$h < 10} {set h 0$h}
            set d1  "$y-[month $m]-$d $h:00:00"
            set d2  "$y-[month $m]-$d $h:59:59"
            return [list $d1 $d2]
        }
        hours-0 {
            if {![isHour $date]} {return}
            if {$ch} {
                set ::chart(detailed) 1
                set ::chart(dbutvar) "..."
            }
            set spl [split $date "."]
            set h   [lindex $spl 0]
            set d   [lindex $spl 1]
            set m   [lindex $spl 2]
            set y   [lindex $spl 3]
            if {$h < 10} {set h 0$h}
            set d1  "$y-[month $m]-$d $h:00:00"
            set d2  "$y-[month $m]-$d $h:59:59"
            return [list $d1 $d2]
        }
        hours-1 {
            set spl [split $date "."]
            set min [lindex $spl 0]
            set h   [lindex $spl 1]
            set d   [lindex $spl 2]
            set m   [lindex $spl 3]
            set y   [lindex $spl 4]
            if {$h < 10} {set h 0$h}
            set d1  "$y-[month $m]-$d $h:[expr $min-5]:00"
            set d2  "$y-[month $m]-$d $h:[expr $min-1]:59"
            return [list $d1 $d2]
        }
        default {
            return
        }
    }
}
proc showBarRawStat {} {
    set trafs  {}
    set tnames {}
    set c $::chart(c)
    foreach trname $::table2(cols) {
        if {$::chart($trname)} {
            lappend trafs $trname
        }
    }
    foreach ttype $trafs {
        lappend tnames $::coltitles($ttype)
    }
    if {[llength $trafs] > 1} {
        set cats " [join $tnames {, }]"
    } else {
        set cats " $tnames"
    }
    set bar  [lindex [$c gettags current] 0]
    set date [lindex [split $bar "_"] 0]
    set tag  [lindex [$c gettags $bar] end-1]
    set p    [getPeriodByDate $date 0]
    set d1   [lindex $p 0]
    set d2   [lindex $p 1]
    set fd1  [getNadminDate [clock scan $d1]]
    set fd2  [getNadminDate [clock scan $d2]]
    set cfd1 [getNadminDate [clock scan $::chart(date1)]]
    set cfd2 [getNadminDate [clock scan $::chart(date2)]]
    if {$fd1 < $cfd1} {
        set d1  $::chart(date1)
        set fd1 [getNadminDate [clock scan $d1]]
    }
    if {$fd2 > $cfd2} {
        set d2  $::chart(date2)
        set fd2 [getNadminDate [clock scan $d2]]
    }
    if {$::chart(view) eq "hdays" || $::chart(view) eq "hours"} {
        set ::ufs(ltext) "   $::auth(torg)\n$cats\n $d1  $d2"
    } else {
        set ::ufs(ltext) "   $::auth(torg)\n$cats\n [getPeriod [lindex $d1 0] [lindex $d2 0]]"
    }
    if {"$::chart(view)-$::chart(detailed)" ne "hours-1"} {
           multi_remsel $tag
        multi_select $tag
    }
    initUFS
    findUFS $::table2(rows) $trafs $fd1 $fd2
    if {$::ufs(npages)==0} {
        hideStatusWindow
        return
    }
    sortUFS
    showUFSTable
}
proc barSelected {} {
    if {"$::chart(view)-$::chart(detailed)" eq "hours-1"} {
        return
    }
    cursor_toNormal
    set c   $::chart(c)
    bind $c <ButtonPress-1> {}
    bind $c <ButtonRelease-1> {}
    set bar  [lindex [$c gettags current] 0]
    set date [lindex [split $bar "_"] 0]
    set p    [getPeriodByDate $date]
    if {![lempty $p]} {
        foreach {::chart(date1) ::chart(date2)} $p {}
        displayChart
    }
    cursor_toNormal
}
proc chart_balloon_show {txt x y} {
    set c $::chart(c)
    set x [expr int([$::chart(c) canvasx $x])]
    set y [expr int([$::chart(c) canvasy $y])]
    set y [expr $y-5]
    catch {$c delete balloon}
    catch {destroy $c.txt}
    message $c.txt -aspect 700 -bg lightyellow -text $txt
    $c create window $x $y -window $c.txt -tag balloon -anchor s
    $c raise balloon
    update
}
proc cursor_toHand {x y} {
    set c $::chart(c)
    bind $c <ButtonPress-1>   {}
    bind $c <ButtonRelease-1> {}
    if {"$::chart(view)-$::chart(detailed)" ne "hours-1"} {
        $c config -cursor hand2
    }
    set bar  [lindex [$c gettags current] 0]
    set spl  [split $bar "_"]
    if {[llength $spl] != 3} {return}
    set date [lindex $spl 0]
    set trid [lindex $spl 1]
    if {![info exists ::histdata($date,$trid)]} {
        set val 0
    } else {
        set val [sciToRealFmt2 $::histdata($date,$trid)]
    }
    set unit $::colunits($::trafid($trid),$::stats(mode))
    if {$unit eq "sec"} {set unit "min"}
    set txt "$::coltitles($::trafid($trid)): $val $::colunitstitles($unit)"
    chart_balloon_show $txt $x $y
    catch {
        $c bind $c.txt <Enter> cursor_toNormal
        $c bind $c.txt <Leave> cursor_toNormal
    }
    catch {
        bind $c.txt <Enter> cursor_toNormal
        bind $c.txt <Leave> cursor_toNormal
    }
    update
}
proc cursor_toNormal {} {
    set c $::chart(c)
    catch {$c delete balloon}
    catch {destroy $c.txt}
    $c config -cursor ""
    bind $c <ButtonPress-1> "multi_init %x %y"
    bind $c <ButtonRelease-1> "multi_delMultiBox"
    update
}
proc changeScrollRegion {} {
    set c $::chart(c)
    $c xview moveto 0
    correctYaxis
    if {$::hist(xpos) < $::chart(width)-$::hist(ox)} {
        $c configure -scrollregion [list 0 0 $::chart(width) $::chart(height)]
    } else {
        $c configure -scrollregion [list 0 0 [expr $::hist(xpos)+$::hist(ox)] $::chart(height)]
    }
}
proc getTxtWidth {text font} {
    set c $::chart(c)
    set tag tmptxt
    $c create text -10 -10 -text $text -font $font -tags $tag
    set bb [$c bbox $tag]
    $c delete $tag
    foreach {x1 y1 x2 y2} $bb {}
    set tw [expr int($x2-$x1)]
    return $tw
}
proc getSubdates {} {
    set names [array names ::viewids]
    foreach n $names {
        set ::chart(groups,$n) {}
    }
    catch {array unset ::subdates}
    if {![info exists ::dates(years)]} {return}
    foreach year $::dates(years) {
        lappend ::chart(groups,years) $year
        if {![info exists ::dates($year,quarters)]} {continue}
        foreach q $::dates($year,quarters) {
            set ms [lindex $q 1]
            set qn [lindex $q 0]
            set qid $::roman($qn).$year
            lappend ::chart(groups,quarters) $qid
            lappend ::subdates($year) $qid
            foreach m $ms {
                set mid $m.$year
                lappend ::subdates($qid) $mid
                lappend ::chart(groups,months) $mid
                if {![info exists ::dates($year,$m,weeks)]} {
                    set ::dates($year,$m,weeks) {}
                }
                foreach w $::dates($year,$m,weeks) {
                    set ds [lindex $w 1]
                    set wn [lindex $w 0]
                    set wid  $::roman($wn).$m.$year
                    lappend ::chart(groups,weeks) $wid
                    lappend ::subdates($mid) $wid
                    foreach d $ds {
                        set did $d.$m.$year
                        lappend ::chart(groups,days) $did
                        lappend ::subdates($wid) $did
                        if {![info exists ::dates($year,$m,$d,hdays)]} {
                            lappend ::chart(groups,hdays) I.$did II.$did
                            lappend ::subdates($did) I.$did II.$did
                        } else {
                            foreach hd $::dates($year,$m,$d,hdays) {
                                lappend ::chart(groups,hdays) $hd.$did
                                lappend ::subdates($did) $hd.$did
                            }
                        }
                        if {![info exists ::dates($year,$m,$d,hours)]} {
                            loop h 0 12 {
                                lappend ::chart(groups,hours) $h.$did
                                lappend ::subdates(I.$did) $h.$did
                                set ::subdates($h.$did) [hourMins $h.$did]
                            }
                            loop h 12 24 {
                                lappend ::chart(groups,hours) $h.$did
                                lappend ::subdates(II.$did) $h.$did
                                set ::subdates($h.$did) [hourMins $h.$did]
                            }
                        } else {
                            foreach hd $::subdates($did) {
                                set n [lindex [split $hd "."] 0]
                                if {$n eq "I"} {
                                    foreach h $::dates($year,$m,$d,hours) {
                                        if {$h < 12} {
                                            lappend ::chart(groups,hours) $h.$did
                                            lappend ::subdates($hd) $h.$did
                                            set ::subdates($h.$did) [hourMins $h.$did]
                                        }
                                    }
                                } else {
                                    foreach h $::dates($year,$m,$d,hours) {
                                        if {$h >= 12 && $h < 24} {
                                            lappend ::chart(groups,hours) $h.$did
                                            lappend ::subdates($hd) $h.$did
                                            set ::subdates($h.$did) [hourMins $h.$did]
                                        }
                                    }
                                }
                            }
                        }
                    }
                }
            }
        }
    }
}
proc hourMins {hid} {
    set sh {}
    loop v 5 61 5 {
        lappend sh $v.$hid
    }
    return $sh
}
proc drawDivisions {cmax div} {
    if {$div == 0} {return}
    set c $::chart(c)
    set nareas [expr int($cmax/$div)]
    loop i 0 [expr $nareas+1] {
        set val [expr $i*$div]
        set y [expr int($::hist(pxd)*double($val))]
        $c create line [cconv [list 0 $y $::chart(width) $y]] -tag div$i -fill snow3
        if {$i == 0} {$c itemconfig div$i -fill black}
        $c lower div$i
        group yaxis div$i
    }
}
#        chart(date1) - chart(date2)
proc goodDate {date} {
    global dates
    switch -- $::chart(view) {
        "years" {
            if {![isYear $date]} {return 0}
            return [lcontain $dates(years) $date]
        }
        "quarters" {
            if {![isQuarter $date]} {return 0}
            set spl [split $date "."]
            set rn  [lindex $spl 0]
            set q   $::arab($rn)
            set y   [lindex $spl 1]
            if {![info exists dates($y,quarters)]} {return 0}
            foreach quarter $dates($y,quarters) {
                set qn [lindex $quarter 0]
                set ms [lindex $quarter 1]
                if {$qn == $q} {return 1}
            }
            return 0
        }
        "months" {
            if {![isMonth $date]} {return 0}
            set spl [split $date "."]
            set m   [lindex $spl 0]
            set y   [lindex $spl 1]
            if {![info exists dates($y,months)]} {return 0}
            return [lcontain $dates($y,months) $m]
        }
        "weeks" {
            if {![isWeek $date]} {return 0}
            set spl [split $date "."]
            set rn  [lindex $spl 0]
            set w   $::arab($rn)
            set m   [lindex $spl 1]
            set y   [lindex $spl 2]
            if {![info exists dates($y,$m,weeks)]} {
                set dates($y,$m,weeks) {}
            }
            foreach week $dates($y,$m,weeks) {
                set wn [lindex $week 0]
                set ds [lindex $week 1]
                if {$w == $wn} {return 1}
            }
            return 0
        }
        "days" {
            if {![isDay $date]} {return 0}
            set spl [split $date "."]
            set d   [lindex $spl 0]
            set m   [lindex $spl 1]
            set y   [lindex $spl 2]
            if {![info exists dates($y,$m,days)]} {return 0}
            if {$dates($y,$m,days) eq "all"} {
                if {$d <= [lastDay $y $m]} {return 1} else {return 0}
            }
            return [lcontain $dates($y,$m,days) $d]
        }
        "hdays" {
            if {![isHDay $date]} {return 0}
            set spl [split $date "."]
            set hd  [lindex $spl 0]
            set d   [lindex $spl 1]
            set m   [lindex $spl 2]
            set y   [lindex $spl 3]
            if {![info exists dates($y,$m,days)]} {return 0}
            if {$dates($y,$m,days) eq "all" || [lcontain $dates($y,$m,days) $d]} {
                if {![info exists dates($y,$m,$d,hdays)]} {
                    return 1
                } else {
                    return [lcontain $dates($y,$m,$d,hdays) $hd]
                }
            }
            return 0
        }
        "hours" {
            if {![isHour $date]} {return 0}
            set spl [split $date "."]
            set h   [lindex $spl 0]
            set d   [lindex $spl 1]
            set m   [lindex $spl 2]
            set y   [lindex $spl 3]
            if {![info exists dates($y,$m,days)]} {return 0}
            if {$dates($y,$m,days) eq "all" || [lcontain $dates($y,$m,days) $d]} {
                if {![info exists dates($y,$m,$d,hours)]} {
                    return 1
                } else {
                    return [lcontain $dates($y,$m,$d,hours) $h]
                }
            }
            return 0
        }
        default {
            return 0
        }
    }
}
proc isYear {date} {
    return [expr [string length $date]==4 && [string is integer -strict $date]]
}
proc isQuarter {date} {
    try_eval {
    set spl [split $date "."]
    set rn  [lindex $spl 0]
    set an  $::arab($rn)
    set y   [lindex $spl 1]
    return [expr [string is integer -strict $an] && $an >= 1 && $an <= 4 && [isYear $y]]
    } {
    return 0
    }
}
proc isMonth {date} {
    try_eval {
    set spl [split $date "."]
    set an  [lindex $spl 0]
    set y   [lindex $spl 1]
    return [expr [string is integer -strict $an] && $an >= 1 && $an <= 31 && [isYear $y]]
    } {
    return 0
    }
}
proc isWeek {date} {
    try_eval {
    set spl [split $date "."]
    set rn  [lindex $spl 0]
    set an  $::arab($rn)
    set from [expr [string length $rn]+1]
    set m   [string range $date $from end]
    return [expr [string is integer -strict $an] && $an >= 1 && $an <= 6 && [isMonth $m]]
    } {
    return 0
    }
}
proc isDay {date} {
    try_eval {
    set spl [split $date "."]
    set an  [lindex $spl 0]
    set from [expr [string length $an]+1]
    set m   [string range $date $from end]
    return [expr [string is integer -strict $an] && $an >= 1 && $an <= 31 && [isMonth $m]]
    } {
    return 0
    }
}
proc isHDay {date} {
    try_eval {
    set spl [split $date "."]
    set rn  [lindex $spl 0]
    set an  $::arab($rn)
    set from [expr [string length $rn]+1]
    set d  [string range $date $from end]
    return [expr [string is integer -strict $an] && $an >= 1 && $an <= 2 && [isDay $d]]
    } {
    return 0
    }
}
proc isHour {date} {
    try_eval {
    set spl [split $date "."]
    set an  [lindex $spl 0]
    set from [expr [string length $an]+1]
    set d   [string range $date $from end]
    return [expr [string is integer -strict $an] && $an >= 0 && $an <= 23 && [isDay $d]]
    } {
    return 0
    }
}
proc group {maintag tags} {
    foreach tag $tags {
        $::chart(c) addtag $maintag withtag $tag
    }
}
#   Y
proc drawYaxis {cmax div} {
    if {$div == 0} {return}
    set c $::chart(c)
    #  Y:
    $c create line [cconv [list 0 0 0 $::hist(yl)]] -tags oy
    group yaxis oy
    if {$::stats(mode) eq "nat"} {
        set mtxt ""
    } else {set mtxt "."}
    $c create text $::hist(ox) 7 -text $mtxt -tag modetext -anchor w
    group yaxis modetext
    #    Y:
    set nareas [expr int($cmax/$div)]
    loop i 0 [expr $nareas+1] {
        set val  [expr $i*$div]
        set txtx 0
        set txty [expr int($::hist(pxd)*double($val))]
        #  
        $c create text [cconv [list [expr $txtx-$::hist(dl)] $txty]] -text $val -anchor e -tag ytxt$i
        group yaxis ytxt$i
        # 
        if {$i != 0} {
            $c create line [cconv [list [expr $txtx-$::hist(dl)] $txty [expr $txtx+$::hist(dl)] $txty]] -tag dl$i
            group yaxis dl$i
        }
    }
    correctYaxis
    drawDivisions $cmax $div
}
#     
proc cexists {tag} {
    return [expr ![lempty [$::chart(c) gettags $tag]]]
}
# :     Y    ,
#     bbox'      ,
#           Y    
proc correctYaxis {} {
    set c $::chart(c)
    if {![cexists yaxis]} {return}
    set x1    [expr [lindex [$c bbox yaxis] 0]-5]
    set cx0   [expr int([$c canvasx 0])]
    set shift [expr $cx0 - int($x1)]
    if {$shift != 0} {
        set ::hist(ox) [expr $::hist(ox) + $shift]
        $c move yaxis $shift 0
        update
    }
}
#     Tk-,
# ..    :
# |
# |___
#    :
#  ___
# |
# |
proc cconv {coords} {
    set newcoords {}
    foreach {x y} $coords {
        set newx [expr $x + $::hist(ox)]
        if {$y > $::hist(yl)} {
            set y $::hist(yl)
        } else {
            set y [expr $y + $::hist(oy)]
        }
        set newy [expr $::chart(height) - $y]
        lappend newcoords $newx $newy
    }
    return $newcoords
}
proc sec2min {s} {
    return [expr {$s / 60}]
}
proc findChartMax {} {
    catch {array unset ::histdata}
    catch {array unset ::dates}
    array set ::dates [crumbleDatePeriod $::chart(date1) $::chart(date2)]
    getSubdates
    set trids {}
    foreach trname $::table2(cols) {
        if {$::chart($trname)} {
            lappend trids $::trafid($trname)
        }
    }
    set names ""
    set max   0
    foreach trid $trids {
        set names "$names [array names [subst ::chart_$::stats(mode)] -glob $::viewids($::chart(view)),$::chart(detailed),*,$trid]"
    }
    set udates {}
    foreach name $names {
        set date [lindex [split $name ","] 2]
        lappend udates $date
    }
    set udates [lsort -unique $udates]
    foreach date $udates {
        if {![goodDate $date]} {continue}
        set iname {}
        foreach trid $trids {
            set iname $::viewids($::chart(view)),$::chart(detailed),$date,$trid
            if {[info exists [subst ::chart_$::stats(mode)]($iname)]} {
                break
            } else {set iname {}}
        }
        if {[lempty $iname]} {break}
        set len [llength [set ::chart_$::stats(mode)($iname)]]
        loop i 0 $len {
            set val 0
            if {!$::chart(detailed)} {
                set subdate $date
            } else {
                set subdate [lindex $::subdates($date) $i]
            }
            foreach trid $trids {
                set name $::viewids($::chart(view)),$::chart(detailed),$date,$trid
                if {![info exists [subst ::chart_$::stats(mode)]($name)]} {continue}
                set vals [set ::chart_$::stats(mode)($name)]
                set unit $::colunits($::trafid($trid),$::stats(mode))
                set v    [lindex $vals $i]
                if {$unit eq "mb"} {set v [b2mb $v]}
                if {$unit eq "sec"} {set v [sec2min $v]}
                set val  [wideSum $val $v]
                if {![info exists ::histdata($subdate,$trid)]} {
                    set ::histdata($subdate,$trid) $v
                } else {
                    set ::histdata($subdate,$trid) [wideSum $::histdata($subdate,$trid) $v]
                }
            }
            if {$val > $max} {set max $val}
        }
    }
    if {$max == 0} {return 0}
    if {$max < 0.5} {
        set max 0.5
    } elseif {$max > 0.5 && $max < 1} {
        set max 1
    }
    return $max
}
# bytes to megabytes
proc b2mb {b} {
    return [expr double($b)/double(1024*1024)]
}
proc chartDivisions {max} {
    if {$max == 0} {return [list 1 0]}
    if {$max <= 0.5} {
        return [list 0.5 0.25]
    } elseif {$max > 0.5 && $max <= 1} {
        return [list 1 0.5]
    } elseif {$max <= 1.5} {
        return [list 1.5 0.5]
    }
    set nareas 5; # .    
    set sgn    "+"
    regexp {(.+)e([+-])0*(.+)} [format %e $max] -> mant sign exp
    set exp [expr $sign$exp]
    if {abs($mant) < 1.5} {
        set mant [expr $mant*10]
        incr exp -1
    }
    set t [expr int(round($mant $sgn 0.49)*pow(10,$exp))]
    if {$t < $nareas} {return [list $t 1]}
    return [list $t [expr int(double($t)/double($nareas))]]
}
proc drawHistogram {} {
    global chart hist
    startDisplay
    $chart(c) delete all
    if {[lempty $chart(date1)] || [lempty $chart(date2)]} {
        set chart(name) ""
        finishDisplay
        return
    }
    set ::hist(xpos) $::hist(ocgap)
    changeScrollRegion
    #  .    chart_nat ( chart_cost)
    set max [findChartMax]
    #        Y
    set divs [chartDivisions $max]
    foreach {cmax div} $divs {}
    set hist(pxd) [expr double($hist(yl))/double($cmax)]; #     1 
    drawYaxis $cmax $div
    if {$div==0 || $max==0} {
        finishDisplay
        return
    }
    drawXaxis
    finishDisplay
    return
}
proc showChartWindow {} {
    global chart
    hideStatusWindow
    set w .chart
    catch {destroy $w}
    catch {toplevel $w}
    wm title $w "   \"$::auth(torg)\". $::botiklook(version)"
    wm protocol $w WM_DELETE_WINDOW {
        doExit .chart
    }
    focus -force $w
    label $w.name -textvariable chart(name) -font {Helvetica 12 bold}
    pack $w.name -side top -padx 5 -pady 5

    frame $w.main
    pack $w.main -side top -fill both -expand 1

    frame $w.main.chart
    pack $w.main.chart -side left -fill x

    set chart(buttons) {}
    set chart(c) $w.main.chart.c
    initChartCanvas
    $chart(c) configure -xscrollcommand "correctYaxis; $w.main.chart.hscroll set"
    scrollbar $w.main.chart.hscroll -orient horiz -command "correctYaxis; $chart(c) xview"
    pack $chart(c) -side top -fill x -padx 2 -pady 2
    pack $w.main.chart.hscroll -side top -fill x
    $chart(c) configure -scrollregion "0 0 [expr 2*$chart(width)] $chart(height)"

    if {[windowsPlatform]} {
        autoscroll::autoscroll $w.main.chart.hscroll
    }
    #bind $w.main.chart.hscroll <Motion> correctYaxis

    set ctrl $w.main.ctrl
    frame $ctrl
    pack $ctrl -side left -fill both

    #     :
    frame $ctrl.cbs
    pack $ctrl.cbs -side top

    foreach tr $::table2(cols) {
        set cl $::botiklook(color,$::trafid($tr))
        checkbutton $ctrl.cbs.$tr -text $::coltitles($tr) -variable chart($tr) \
            -command "chartTraf $tr" -justify left -selectcolor $cl -font {Helvetica 10 bold} \
            -bd 3 -indicatoron 0 -activebackground $cl -bg $cl
        pack $ctrl.cbs.$tr -side top -fill x
        lappend chart(buttons) $ctrl.cbs.$tr
    }
    
    #    
    menubutton $ctrl.mb -textvariable chart(vt) -menu $ctrl.mb.menu -indicatoron 1 -relief raised -bd 2 -highlightthickness 2 -anchor c -direction flush -font {Helvetica 10 bold}
    menu $ctrl.mb.menu -tearoff 0
    foreach {v name} $::vtitles {
        $ctrl.mb.menu add radiobutton -label $name -variable chart(view) -value $v -font {Helvetica 10 bold} -command displayChart
    }
    pack $ctrl.mb -side top -padx 5 -pady 5
    lappend chart(buttons) $ctrl.mb

    #  ""
    button $ctrl.d -textvariable chart(dbutvar) -command {detailedChart} -font {Helvetica 10 bold}
    pack $ctrl.d -side top -padx 5 -pady 5
    lappend chart(buttons) $ctrl.d

    #  ""  ""
    frame $ctrl.bs
    pack $ctrl.bs -side top
    button $ctrl.bs.back -text "" -command {chartHistoryBack} -font {Helvetica 10 bold} -state disabled
    if {[imgExists prev2]} {$ctrl.bs.back configure -image prev2 -width 24 -height 24}
    button $ctrl.bs.fwd  -text "" -command {chartHistoryFwd} -font {Helvetica 10 bold} -state disabled
    if {[imgExists next2]} {$ctrl.bs.fwd configure -image next2 -width 24 -height 24}
    pack $ctrl.bs.back $ctrl.bs.fwd -side left -padx 5 -pady 5
    set chart(bback) $ctrl.bs.back
    set chart(bfwd)  $ctrl.bs.fwd
    lappend chart(buttons) $chart(bback)
    lappend chart(buttons) $chart(bfwd)

    frame $w.mode
    pack $w.mode -side top -fill y -expand 1

    label $w.mode.l -text " :" -font {Helvetica 10 bold}

    #  " "
    menubutton $w.mode.om -textvariable ::stats(tmode) -menu $w.mode.om.menu -indicatoron 1 -relief raised -bd 2 -highlightthickness 2 -anchor c -direction flush -font {Helvetica 10 bold}
    menu $w.mode.om.menu -tearoff 0
    foreach {v name} [list cost $::modestitles(cost) nat $::modestitles(nat)] {
        $w.mode.om.menu add radiobutton -label $name -variable ::stats(mode) -value $v -font {Helvetica 10 bold} -command changeChartMode
    }
    pack $w.mode.l $w.mode.om -side left -padx 4 -pady 4
    lappend chart(buttons) $w.mode.om

    showFooter $w; update
    displayChart
    wm resizable $w 0 0
}
proc changeChartMode {} {
    set ::stats(tmode) $::modestitles($::stats(mode))
    displayChart
}
proc chart_check_cursor {} {
    catch {
    set c   $::chart(c)
    set elt [lindex [$c gettags current] 1]
    if {$elt ne "barchart" && [$c cget -cursor] eq "hand2"} {
        $c config -cursor {}
    }
    }
}
proc initChartCanvas {} {
    set c $::chart(c)
    canvas $c -width $::chart(width) -height $::chart(height) -bg snow1 \
        -relief raised -borderwidth 0 -xscrollincrement 20
    bind $c <ButtonPress-1>   "multi_init %x %y"
    bind $c <ButtonRelease-1> "multi_delMultiBox"
    bind $c <Motion>          "chart_check_cursor"
}
proc displayChart {args} {
    set ::chart(name) "   $::auth(torg)\n [getPeriod [lindex $::chart(date1) 0] [lindex $::chart(date2) 0]]"
    set ::chart(vt)   $::viewtitles($::chart(view))
    drawHistogram
    if {$args ne "nadd"} {
        add2History
    }
}
proc chartTraf {tr} {
    #      
    #   displayChart . ,      ?
    displayChart
}
proc detailedChart {} {
    #      ""
    global chart
    if {![lempty $::multi(sel)]} {
        #    
        set first [lindex [split [lindex $::multi(sel) 0] "_"] 0]
        set last  [lindex [split [lindex $::multi(sel) end] "_"] 0]
        set p1    [getPeriodByDate $first 0]
        set p2    [getPeriodByDate $last 1]
        set d1    [lindex $p1 0]
        set d2    [lindex $p2 end]
        set chart(date1) $d1
        set chart(date2) $d2
        set chart(dbutvar) [expr {($chart(detailed)) ? "..." : "..."}]
        set ::multi(sel) {}
        displayChart
        return
    }
    set chart(detailed) [expr abs($chart(detailed)-1)]
    set chart(dbutvar) [expr {($chart(detailed)) ? "..." : "..."}]
    displayChart
}
proc chartBackState {} {
    global chart
    if {$chart(curh) == 0} {
        catch {
            $chart(bback) config -state disabled
        }
    } else {
        catch {
            $chart(bback) config -state normal
        }
    }
}
proc chartFwdState {} {
    global chart
    if {$chart(curh) == [llength $chart(history)]-1} {
        catch {
            $chart(bfwd) config -state disabled
        }
    } else {
        catch {
            $chart(bfwd) config -state normal
        }
    }
}
proc displayHistory {} {
    global chart stats
    set history [lindex $chart(history) $chart(curh)]
    set trvs    [lindex $history 0]
    set i 0
    foreach trv $trvs {
        set trname [lindex $::table2(cols) $i]
        set chart($trname) $trv
        incr i
    }
    set chart(view)     [lindex $history 1]
    set chart(detailed) [lindex $history 2]
    set stats(mode)     [lindex $history 3]
    set stats(tmode)    $::modestitles($stats(mode))
    set chart(date1)    [lindex $history 4 0]
    set chart(date2)    [lindex $history 4 1]
    set chart(name)     "   $::auth(org)\n [getPeriod [lindex $::chart(date1) 0] [lindex $::chart(date2) 0]]"
    set chart(vt)       $::viewtitles($chart(view))
    set chart(dbutvar)  [expr {($chart(detailed)) ? "..." : "..."}]
    displayChart "nadd"
}
proc chartHistoryBack {} {
    global chart
    if {$chart(curh) > 0} {
        incr chart(curh) -1
        displayHistory
    }
    chartBackState
    chartFwdState
}
proc chartHistoryFwd {} {
    global chart
    if {$chart(curh) < [llength $chart(history)]-1} {
        incr chart(curh)
        displayHistory
    }
    chartBackState
    chartFwdState
}
proc getChartParams {} {
    #   ,    :
    # 1.   
    # 2.  : chart(view)
    # 3.   : chart(detailed)
    # 4.  : stats(mode)
    # 5.  : chart(date1) chart(date2)
    set trs [list]
    foreach tr $::table2(cols) {
        lappend trs $::chart($tr)
    }
    return [list $trs $::chart(view) $::chart(detailed) $::stats(mode) [list $::chart(date1) $::chart(date2)]]
}
proc add2History {} {
    global chart
    #  . ,
    if {[chartChanged]} {
        #      
        if {$chart(curh) != [llength $chart(history)]-1} {
            set chart(history) [lrange $chart(history) 0 $chart(curh)]
        }
        set pars [getChartParams]
        lappend chart(history) $pars
        incr chart(curh)
        #      ,  
        chartBackState
        chartFwdState
    }
}
proc chartChanged {} {
    global chart
    if {$chart(curh) < 0} {return 1}
    set params  [getChartParams]
    set curhist [lindex $chart(history) $chart(curh)]
    return [expr {$params ne $curhist}]
}
#      
# :           
#  :   -     
#   1  |  | ...,     :  |  |  ...
proc selectBestView {} {
    if {[llength $::dates(years)] > 1} {return "years"}
    set year $::dates(years)
    if {[llength $::dates($year,quarters)] > 1} {return "quarters"}
    set q $::dates($year,quarters)
    set ms [lindex $q 0 1]
    if {[llength $ms] > 1} {return "months"}
    catch {set w ""; set w $::dates($year,$ms,weeks)}
    if {[llength $w] > 1} {return "weeks"}
    set ds [lindex $w 0 1]
    if {[llength $ds] > 1} {return "days"}
    return "hdays"
}
#     from  to .
proc genInts {from to} {
    set ints {}
    loop i $from [expr $to+1] {
        lappend ints $i
    }
    return $ints
}
proc multi_init {x y} {
    if {"$::chart(view)-$::chart(detailed)" eq "hours-1"} {return}
    multi_createBox $x $y
    bind $::chart(c) <Motion> "multi_changeCoords %x %y; multi_selectObjects"
    multi_selectObjects
}
proc multi_createBox {x y} {
    multi_delMultiBox
    set x [$::chart(c) canvasx $x]
    set y [$::chart(c) canvasy $y]
    $::chart(c) create rectangle [$::chart(c) canvasx $x] [$::chart(c) canvasy $y] [$::chart(c) canvasx $x] [$::chart(c) canvasy $y]\
        -tags multibox -outline blue -width 2 -dash {1 1}
    set ::multi(startX) $x
    set ::multi(startY) $y
}
proc multi_delMultiBox {} {
    $::chart(c) delete multibox
    $::chart(c) dtag multibox
    set ::multi(startX) 0
    set ::multi(startY) 0
    bind $::chart(c) <Motion> {}
}
proc multi_changeCoords {x y} {
    if {abs($::chart(width)-$x) <= 10} {
        $::chart(c) xview scroll 1 pages
    } elseif {$x <= 10} {
        $::chart(c) xview scroll -1 pages
    }
    update
    set x [$::chart(c) canvasx $x]
    set y [$::chart(c) canvasy $y]
    set oldCoords [$::chart(c) coords multibox]
    foreach {oldx1 oldy1 oldx2 oldy2} {0 0 0 0} {}
    foreach {oldx1 oldy1 oldx2 oldy2} $oldCoords {}
    if {$x > $oldx1 && $y < $oldy2} {
        set newCoords [list $::multi(startX) $y $x $::multi(startY)]
    }
    if {$x <= $oldx2 && $y <= $oldy2} {
        set newCoords [list $x $y $::multi(startX) $::multi(startY)]
    }
    if {$x <= $oldx2 && $y >= $oldy1} {
        set newCoords [list $x $::multi(startY) $::multi(startX) $y]
    }
    if {$x >= $oldx1 && $y >= $oldy1} {
        set newCoords [list $::multi(startX) $::multi(startY) $x $y]
    }
    catch {$::chart(c) coords multibox $newCoords}
}
proc multi_getOverlap {} {
    foreach {x1 y1 x2 y2} [$::chart(c) coords multibox] {}
    set elts {}
    catch {set elts [lsort -integer [$::chart(c) find overlapping $x1 $y1 $x2 $y2]]}
    if {![lempty $elts]} {
        set tls {}
        foreach elt $elts {
            set tag [lindex [$::chart(c) gettags $elt] end]
            #     
            set spl [split $tag "_"]
            if {[llength $spl] != 2} {continue}
            lappend tls $tag
        }
        if {![lempty $tls]} {return $tls}
    }
    return
}
proc multi_selectObjects {} {
    #         
    set selection [multi_getOverlap]
    #  
    if {[llength $selection] > 1} {
        set first [lindex $selection 0]
        set last  [lindex $selection end]
        set id1   [lindex [split $first "_"] end]
        set id2   [lindex [split $last "_"] end]
        if {$id2 - $id1 > 1} {
            set selection [lrange $::hist(tags) $id1 $id2]
        }
    }
    #   
       multi_remsel $selection
       #   
    multi_select $selection
    if {![lempty $::multi(sel)]} {
        set ::chart(dbutvar) "..."
    } else {
        set ::chart(dbutvar) [expr {($::chart(detailed)) ? "..." : "..."}]
    }
}
proc multi_remsel {sel} {
    foreach elt $::multi(sel) {
        if {[lsearch $sel $elt] == -1} {
            #  
            $::chart(c) itemconfig $elt -width $::hist(bw)
        }
    }
    set ::multi(sel) $sel
}
proc multi_select {selection} {
    foreach elt $selection {
        if {[$::chart(c) itemcget $elt -width] == $::hist(bw)} {
            # 
            $::chart(c) itemconfig $elt -width 2 -outline blue
        }
    }
}
proc initChartData {} {
    global chart hist dates stats auth vtitles viewtitles multi viewids
    if {$stats(chart)} {return}
    catch {array unset ::dates}
    catch {array unset ::chart}
    catch {array unset ::hist}
    catch {array unset ::histdata}
    catch {array unset ::chart_nat}
    catch {array unset ::chart_cost}
    array set viewids {hours 1 hdays 2 days 3 weeks 4 months 5 quarters 6 years 7}
    set vtitles {years " " quarters " " months " " weeks " " days " " hdays " " hours " "}
    array set viewtitles $vtitles
    getRoman
    set chart(date1) "$stats(cdate1) 00:00:00"
    set chart(date2) "$stats(cdate2) 23:59:59"
    array set dates [crumbleDatePeriod $chart(date1) $chart(date2)]
    set chart(name)     "   $auth(org)\n [getPeriod [lindex $::chart(date1) 0] [lindex $::chart(date2) 0]]"
    set chart(view)     [selectBestView]
    set chart(vt)       $viewtitles($chart(view))
    set chart(dbutvar)  "..."
    set chart(detailed) 0; #   
    set chart(height)   [expr {int(0.6*[winfo screenheight .])}]; #   - 60%   
    set chart(width)    [expr {int(0.7*[winfo screenwidth  .])}]; #   - 70%   
    if {$chart(height) < 400 || $chart(width) < 600} {
        set chart(height) 400; #  
        set chart(width)  600; #  
    }
    set chart(history)  [list]; #    
    set chart(curh)     -1; # current history record
    foreach tr $::table2(cols) {
        set chart($tr) 1
    }
    set chart(buttons) {}
    set chart(buttons,states) {}
    # hist()    
    set hist(ocgap) 2; # .     
    set hist(cgap)  $hist(ocgap); #     
    set hist(ggap)  5;  #    
    set hist(cfont) {Helvetica 8 bold}; #     
    set hist(gfont) {Helvetica 10 bold}; #      
    set hist(cw)   15; #  
    set hist(ox)   20; #     X
    set hist(oy)   40; #     Y
    set hist(gy)   -25; #       X
    set hist(cy)   -7; #       X
    set hist(ygap) 15; #       Y    
    set hist(yl)   [expr $chart(height)-$hist(oy)-$hist(ygap)]; #   Y
    set hist(lh)   5; #    
    set hist(dl)   3; #     Y (  )
    set hist(xpos) $hist(ocgap); #     -     X
    set hist(bw)   0; #   
    set hist(limit) 5000; #    
    set multi(sel) {}
}
proc getWeekDays {n m year} {
    set wdn [clockFormat %u [clock scan "$year-$m-1"]]
    set end [expr 7-$wdn+1]; #   1-  
    set last [lastDay $year $m]
    if {$n==1} {
        return [list 1 $end]
    }
    set days {}
    loop i [expr $end+1] [expr $last+1] {
        set wn [expr int(ceil(double($i-$end)/7.0))+1]
        if {$wn == $n} {
            lappend days $i
        } elseif {$wn > $n} {
            break
        }
    }
    return [list [lindex $days 0] [lindex $days end]]
}
#    
# : [ndays 20090301000000 20090302235959]
proc ndays {lo hi} {
    if {$lo > $hi} {return 0}
    set n    [expr {$hi - $lo + 1}]
    set yhi  [string range $hi 0 3]; #year2
    set mhi  [string range $hi 4 5]; #mon2
    set loym [string range $lo 0 5]; #yearmonth1
    set lod  [string range $lo 6 7]; #day1
    set hiym [string range $hi 0 5]; #yearmonth2
    set hid  [string range $hi 6 7]; #day2
    if {$n <= [lastDay $yhi $mhi]} {return $n}
    set n 0
    while {$loym < $hiym} {
        set ylo [string range $loym 0 3]; #year1
        set mlo [string range $loym 4 5]; #mon1
        incr n [lastDay $ylo $mlo];
        incr loym [expr {([string range $loym 4 5] == 12) ? 89 : 1}]
    }
    set hid [string trimleft $hid "0"]
    if {[lempty $hid] || ![string is integer -strict $hid]} {set hid 1}
    set lod [string trimleft $lod "0"]
    if {[lempty $lod] || ![string is integer -strict $lod]} {set lod 1}
    incr n [expr {$hid + 1 - $lod}]
    if {$n < 0} {set n 0}
    return $n
}
#      
proc crumbleDatePeriod {date1 date2} {
    if {[catch {
    set time1 [clock scan $date1]
    set time2 [clock scan $date2]
    }]} {return}
    if {[lempty $time1] || [lempty $time2]} {return}
    set list1 [clockFormat "%Y %m %e" $time1]
    set list2 [clockFormat "%Y %m %e" $time2]
    foreach {year1 month1 day1} $list1 {}
    foreach {year2 month2 day2} $list2 {}
    set month1 [string trimleft $month1 0]
    set month2 [string trimleft $month2 0]
    set hour1  [string trim [clockFormat %k $time1]]
    set hour2  [string trim [clockFormat %k $time2]]
    if {"$year1-$month1-$day1" eq "$year2-$month2-$day2"} {
        if {$hour1 < 12 && $hour2 < 12} {
            set dates($year1,$month1,$day1,hdays) I
        } elseif {$hour1 < 12 && $hour2 >= 12} {
            set dates($year1,$month1,$day1,hdays) [list I II]
        } elseif {$hour1 >= 12} {
            set dates($year1,$month1,$day1,hdays) II
        }
        loop h $hour1 [expr $hour2+1] {
            lappend dates($year1,$month1,$day1,hours) $h
        }
    } else {
        if {$hour1 < 12} {
            set dates($year1,$month1,$day1,hdays) [list I II]
        } else {
            set dates($year1,$month1,$day1,hdays) II
        }
        loop h $hour1 24 {
            lappend dates($year1,$month1,$day1,hours) $h
        }
        if {$hour2 < 12} {
            set dates($year2,$month2,$day2,hdays) I
        } else {
            set dates($year2,$month2,$day2,hdays) [list I II]
        }
        loop h 0 [expr $hour2+1] {
            lappend dates($year2,$month2,$day2,hours) $h
        }
    }
    #  
    for {set i $year1} {$i <= $year2} {incr i} {
        lappend years $i
        lappend dates(years) $i
    }
    #  
    foreach year $years {
        if {$year1 == $year2} {
            loop m $month1 [expr $month2+1] {
                lappend dates($year1,months) $m
            }
            break
        } elseif {$year == $year1 && $year != $year2} {
            loop m $month1 13 {
                lappend dates($year1,months) $m
            }
        } elseif {$year != $year1 && $year != $year2} {
            loop m 1 13 {
                lappend dates($year,months) $m
            }
        } elseif {$year != $year1 && $year == $year2} {
            loop m 1 [expr $month2+1] {
                lappend dates($year2,months) $m
            }
        }
    }
    #  
    foreach year $years {
        foreach m $dates($year,months) {
            set q [expr int(ceil(double($m)/3.0))]
            lappend qmonths($q) $m
        }
        loop q 1 5 {
            if {[info exists qmonths($q)]} {
                lappend dates($year,quarters) [list $q $qmonths($q)]
            }
        }
        array unset qmonths
    }
    #  
    if {$year1 == $year2} {
        if {$month1 == $month2} {
            if {$day1 == 1 && $day2 == [lastDay $year1 $month1]} {
                set dates($year1,$month1,days) "all"
            } else {
                loop d $day1 [expr $day2+1] {
                    lappend dates($year1,$month1,days) $d
                }
            }
        } else {
            if {$day1 == 1} {
                set dates($year1,$month1,days) "all"
            } else {
                loop d $day1 [expr [lastDay $year1 $month1]+1] {
                    lappend dates($year1,$month1,days) $d
                }
            }
            set otherMonths [lrange $dates($year1,months) 1 end-1]
            foreach m $otherMonths {
                set dates($year1,$m,days) "all"
            }
            if {$day2 == [lastDay $year2 $month2]} {
                set dates($year2,$month2,days) "all"
            } else {
                loop d 1 [expr $day2+1] {
                    lappend dates($year1,$month2,days) $d
                }
            }
        }
    } else {
        if {$day1 == 1} {
            set dates($year1,$month1,days) "all"
        } else {
            loop d $day1 [expr [lastDay $year1 $month1]+1] {
                lappend dates($year1,$month1,days) $d
            }
        }
        if {$day2 == [lastDay $year2 $month2]} {
            set dates($year2,$month2,days) "all"
        } else {
            loop d 1 [expr $day2+1] {
                lappend dates($year2,$month2,days) $d
            }
        }
        foreach year $years {
            if {$year == $year1} {
                loop m [expr $month1+1] 13 {
                    set dates($year,$m,days) "all"
                }
            } elseif {$year == $year2} {
                loop m 1 $month2 {
                    set dates($year,$m,days) "all"
                }
            } else {
                loop m 1 13 {
                    set dates($year,$m,days) "all"
                }
            }
        }
    }
    #  
    foreach year $years {
        foreach m $dates($year,months) {
            set wdn [clockFormat %u [clock scan "$year-$m-1"]]
            set end [expr 7-$wdn+1]
            set last [lastDay $year $m]
            loop i 1 [expr $end+1] {
                set week($i) 1
            }
            loop i [expr $end+1] [expr $last+1] {
                set week($i) [expr int(ceil(double($i-$end)/7.0))+1]
            }
            if {![info exists dates($year,$m,days)]} {set dates($year,$m,days) {}}
            foreach d $dates($year,$m,days) {
                if {$d eq "all"} {
                    set last [lastDay $year $m]
                    loop d_ 1 [expr $last+1] {
                        lappend days($week($d_)) $d_
                    }
                } elseif {[info exists week($d)]} {
                    lappend days($week($d)) $d
                }
            }
            set weeks [lsort -integer [array names days]]
            foreach w $weeks {
                lappend dates($year,$m,weeks) [list $w $days($w)]
            }
            array unset days
            array unset week
        }
    }
    return [array get dates]
}
proc printDates {arrayList} {
    array set dates $arrayList
    set res "Years: $dates(years)\n"
    foreach y $dates(years) {
        append res "Quarters of $y:"
        foreach q $dates($y,quarters) {
            append res " \[$q]"
        }
        append res "\n"
    }
    foreach y $dates(years) {
        append res "Months of $y: $dates($y,months)\n"
    }
    foreach y $dates(years) {
        foreach m $dates($y,months) {
            append res "Weeks of $m.$y: $dates($y,$m,weeks)\n"
        }
    }
    foreach y $dates(years) {
        foreach m $dates($y,months) {
            append res "Days of $m.$y: $dates($y,$m,days)\n"
        }
    }
    return $res
}
proc getRoman {} {
    global roman arab
    set roman(1) I
    set roman(2) II
    set roman(3) III
    set roman(4) IV
    set roman(5) V
    set roman(6) VI
    set roman(7) VII
    set roman(8) VIII
    set roman(9) IX
    set roman(10) X

    set arab(I)    1
    set arab(II)   2
    set arab(III)  3
    set arab(IV)   4
    set arab(V)    5
    set arab(VI)   6
    set arab(VII)  7
    set arab(VIII) 8
    set arab(IX)   9
    set arab(X)    10

    set arab(1)    1
    set arab(2)    2
    set arab(3)    3
    set arab(4)    4
    set arab(5)    5
    set arab(6)    6
    set arab(7)    7
    set arab(8)    8
    set arab(9)    9
    set arab(10)   10
}
proc getDayf {day} {
    if {[string length $day] != 8} {return 0}
    set d     [c_getDay $day]
    set month [getMonthf $day]
    return $d.$month
}
proc c_getDay {day} {
    if {[string length $day] != 8} {return 0}
    set d [string trimleft [string range $day 6 7] 0]
    return $d
}
proc getWeekf {day} {
    if {[string length $day] != 8} {return 0}
    set month [getMonthf $day]
    set week  [getWeek $day]
    return $::roman($week).$month
}
proc getWeek {day} {
    if {[string length $day] != 8} {return 0}
    set month [getMonth $day]
    set year  [getYear $day]
    set day   [c_getDay $day]
    set wdn   [clockFormat %u [clock scan $year-$month-1]]
    set end   [expr 7-$wdn+1]
    if {$day >= 1 && $day <= $end} {
        return 1
    } else {
        return [expr int(ceil(double($day-$end)/7.0))+1]
    }
}
proc getMonthf {day} {
    if {[string length $day] != 8} {return 0}
    set year  [getYear $day]
    set month [getMonth $day]
    return $month.$year
}
proc getMonth {day} {
    if {[string length $day] != 8} {return 0}
    set month [string trimleft [string range $day 4 5] 0]
    return $month
}
proc getQuarter {day} {
    if {[string length $day] != 8} {return 0}
    set month [getMonth $day]
    return [expr int(ceil(double($month)/3.0))]
}
proc getQuarterf {day} {
    if {[string length $day] != 8} {return 0}
    set q    [getQuarter $day]
    set year [getYear $day]
    return $::roman($q).$year
}
proc getYear {day} {
    if {[string length $day] != 8} {return 0}
    return [string range $day 0 3]
}
proc getDayInfo {day} {
    return [list [getDayf $day] [getWeekf $day] [getMonthf $day] [getQuarterf $day] [getYear $day]]
}
proc getRStables {} {
    return [db eval {select name from sqlite_master where type='table' and name like 'rs_%'}]
}
#  ,      int'a
proc wideSum {n1 n2} {
    return [expr {([string is integer -strict $n1] && [string is integer -strict $n2]) ? wide($n1)+wide($n2) : $n1+$n2}]
}
proc getServices {day1 day2} {
    global cservices bytecost
    db eval "select slice_id,service_id,cost,count from slices where date1 between ${day1}000000 and ${day2}235959" {
        set cservices($slice_id) $service_id
        set bytecost($slice_id) [expr {($count==0) ? 0 : [sciToRealFmt [expr {double($cost)/double($count)}]]}]
    }
}
proc getMinuteIdx {min} {
    # min >= 0 & min <= 59
    return [expr {$min / 5}]
}
proc fillChartArrays {sensor_id slice_id dayf time count} {
    global hours_nat hours_cost chart_nat chart_cost
    set sensor_id [getTrafIDBySensorID $sensor_id]
    set indHD1 $::viewids(hdays),0,I.$dayf,$sensor_id
    set indHD2 $::viewids(hdays),0,II.$dayf,$sensor_id
    #             
    if {![info exists ::cservices($slice_id)] || [lempty $time]} {return}
    set srvid $::cservices($slice_id)
    if {[lsearch $::stats(sids) $srvid] == -1} {return}
    set hour  [string trim [clockFormat %k $time]]
    set indH $::viewids(hours),1,$hour.$dayf,$sensor_id
    if {![info exists chart_nat($indH)]} {
        set chart_nat($indH) [string repeat "0 " 12]
    }
    if {![info exists chart_cost($indH)]} {
        set chart_cost($indH) [string repeat "0 " 12]
    }
    set min   [string trimleft [clockFormat %M $time] 0]
    if {$min eq ""} {set min 0}
    set midx  [getMinuteIdx $min]
    set cost  [expr $::bytecost($slice_id)*$count]
    set minvaln [expr $count+[lindex $chart_nat($indH) $midx]]
    set minvalc [expr $cost+[lindex $chart_cost($indH) $midx]]
    lset chart_nat($indH) $midx $minvaln
    lset chart_cost($indH) $midx $minvalc
    if {![info exists hours_nat($sensor_id,$hour)]} {
        set hours_nat($sensor_id,$hour) $count
    } else {
        set hours_nat($sensor_id,$hour) [wideSum $hours_nat($sensor_id,$hour) $count]
    }
    if {![info exists hours_cost($sensor_id,$hour)]} {
        set hours_cost($sensor_id,$hour) $cost
    } else {
        set hours_cost($sensor_id,$hour) [wideSum $hours_cost($sensor_id,$hour) $cost]
    }
    if {$hour < 12} {
        if {![info exists chart_nat($indHD1)]} {
            set chart_nat($indHD1) $count
        } else {
            set chart_nat($indHD1) [wideSum $chart_nat($indHD1) $count]
        }
        if {![info exists chart_cost($indHD1)]} {
            set chart_cost($indHD1) $cost
        } else {
            set chart_cost($indHD1) [wideSum $chart_cost($indHD1) $cost]
        }
    } else {
        if {![info exists chart_nat($indHD2)]} {
            set chart_nat($indHD2) $count
        } else {
            set chart_nat($indHD2) [wideSum $chart_nat($indHD2) $count]
        }
        if {![info exists chart_cost($indHD2)]} {
            set chart_cost($indHD2) $cost
        } else {
            set chart_cost($indHD2) [wideSum $chart_cost($indHD2) $cost]
        }
    }
}
proc fillHoursArrays {trids dayf} {
    global chart_nat chart_cost hours_nat hours_cost
    foreach sensor_id $trids {
        set sensor_id [getTrafIDBySensorID $sensor_id]
        #       :
        set indH1 $::viewids(hdays),1,I.$dayf,$sensor_id
        loop h 0 12 {
            set indH01 $::viewids(hours),0,$h.$dayf,$sensor_id
            if {![info exists chart_nat($indH01)]} {
                set chart_nat($indH01) 0
            }
            if {![info exists chart_cost($indH01)]} {
                set chart_cost($indH01) 0
            }
            if {![info exists hours_nat($sensor_id,$h)]} {
                lappend hnvlist 0
            } else {
                lappend hnvlist $hours_nat($sensor_id,$h)
                set chart_nat($indH01) [expr $chart_nat($indH01)+$hours_nat($sensor_id,$h)]
            }
            if {![info exists hours_cost($sensor_id,$h)]} {
                lappend hcvlist 0
            } else {
                lappend hcvlist $hours_cost($sensor_id,$h)
                set chart_cost($indH01) [expr $chart_cost($indH01)+$hours_cost($sensor_id,$h)]
            }
        }
        set chart_nat($indH1)  $hnvlist
        set chart_cost($indH1) $hcvlist
        unset -nocomplain hnvlist
        unset -nocomplain hcvlist
        set indH2 $::viewids(hdays),1,II.$dayf,$sensor_id
        loop h 12 24 {
            set indH02 $::viewids(hours),0,$h.$dayf,$sensor_id
            if {![info exists chart_nat($indH02)]} {
                set chart_nat($indH02) 0
            }
            if {![info exists chart_cost($indH02)]} {
                set chart_cost($indH02) 0
            }
            if {![info exists hours_nat($sensor_id,$h)]} {
                lappend hnvlist 0
            } else {
                lappend hnvlist $hours_nat($sensor_id,$h)
                set chart_nat($indH02) [expr $chart_nat($indH02)+$hours_nat($sensor_id,$h)]
            }
            if {![info exists hours_cost($sensor_id,$h)]} {
                lappend hcvlist 0
            } else {
                lappend hcvlist $hours_cost($sensor_id,$h)
                set chart_cost($indH02) [expr $chart_cost($indH02)+$hours_cost($sensor_id,$h)]
            }
        }
        set chart_nat($indH2)  $hnvlist
        set chart_cost($indH2) $hcvlist
        unset -nocomplain hnvlist
        unset -nocomplain hcvlist
    }
}
#          
# (  )
proc processRStables {} {
    global chart_nat chart_cost hours_nat hours_cost
    set day1 [string map {- ""} [lindex $::chart(date1) 0]]
    set day2 [string map {- ""} [lindex $::chart(date2) 0]]
    set rstabs [getRStables]
    getServices $day1 $day2
    shiftStatus
    set trafids {}
    foreach ttype $::table2(cols) {
        foreach sns $::colsensors($ttype) {
            lappend trafids $::sensorids($sns)
        }
    }
    set trids   $trafids
    set trafids [join $trafids ","]
    set sids {}
    foreach tab $rstabs {
        set day [string range $tab 3 end]
        if {!($day >= $day1 && $day <= $day2)} {continue}
        set dayf [getDayf $day]
        db eval "select slice_id,count_in,count_out,call_duration,time,sensor_id from $tab where sensor_id in ($trafids)" {
            set count [expr $count_in+$count_out+$call_duration]
            fillChartArrays $sensor_id $slice_id $dayf $time $count
            lappend sids $sensor_id
        }
        set sids [lsort -unique $sids]
        fillHoursArrays $sids $dayf
        set sids {}
        array unset hours_nat
        array unset hours_cost
        shiftStatus
    }
    set int [intersect $::table2(cols) $::botiklook(rubcols)]
    if {![lempty $int]} {
        foreach col $::botiklook(rubcols) {
            if {[lsearch $::table2(cols) $col] >= 0} {
                lappend criteria $::sensorids($col)
            }
        }
        set criteria [join $criteria ","]
        set svccrit  [join $::stats(sids) ","]
        db eval "select * from slices where sensor_id in ($criteria) and service_id in ($svccrit) and date1 between ${day1}000000 and ${day2}236969" {
            set day  [string range $date1 0 7]
            set dayf [getDayf $day]
            set time [clock scan [ftime3 $date1]]
            fillChartArrays $sensor_id $slice_id $dayf $time $count
            fillHoursArrays $sensor_id $dayf
            array unset hours_nat
            array unset hours_cost
        }
        shiftStatus
    }
    array unset ::cservices
    array unset ::bytecost
}
proc nonDetailedNat {} {
    global chart_nat
    set day1  [string map {- ""} [lindex $::chart(date1) 0]]
    set day2  [string map {- ""} [lindex $::chart(date2) 0]]
    set ids   [join $::stats(sids) ","]
    set trafs [join $::table2(cols) ","]
    db eval "select $trafs,day from traffic_nat where service_id in ($ids) and day between '$day1' and '$day2'" {
        foreach {dayf week month quarter year} [getDayInfo $day] {}
        foreach col $::table2(cols) {
        set indY $::viewids(years),0,$year,$::trafid($col)
        set indQ $::viewids(quarters),0,$quarter,$::trafid($col)
        set indM $::viewids(months),0,$month,$::trafid($col)
        set indW $::viewids(weeks),0,$week,$::trafid($col)
        set indD $::viewids(days),0,$dayf,$::trafid($col)
        set val  [set $col]
        if {![info exists chart_nat($indY)]} {
            set chart_nat($indY) $val
        } else {
            set chart_nat($indY) [wideSum $chart_nat($indY) $val]
        }
        if {![info exists chart_nat($indQ)]} {
            set chart_nat($indQ) $val
        } else {
            set chart_nat($indQ) [wideSum $chart_nat($indQ) $val]
        }
        if {![info exists chart_nat($indM)]} {
            set chart_nat($indM) $val
        } else {
            set chart_nat($indM) [wideSum $chart_nat($indM) $val]
        }
        if {![info exists chart_nat($indW)]} {
            set chart_nat($indW) $val
        } else {
            set chart_nat($indW) [wideSum $chart_nat($indW) $val]
        }
        if {![info exists chart_nat($indD)]} {
            set chart_nat($indD) $val
        } else {
            set chart_nat($indD) [wideSum $chart_nat($indD) $val]
        }
        }
    }
    shiftStatus
}
proc nonDetailedCost {} {
    global chart_cost
    set day1  [string map {- ""} [lindex $::chart(date1) 0]]
    set day2  [string map {- ""} [lindex $::chart(date2) 0]]
    set ids   [join $::stats(sids) ","]
    set trafs [join $::table2(cols) ","]
    db eval "select $trafs,day from traffic_cost where service_id in ($ids) and day between '$day1' and '$day2'" {
        foreach {dayf week month quarter year} [getDayInfo $day] {}
        foreach col $::table2(cols) {
        set indY $::viewids(years),0,$year,$::trafid($col)
        set indQ $::viewids(quarters),0,$quarter,$::trafid($col)
        set indM $::viewids(months),0,$month,$::trafid($col)
        set indW $::viewids(weeks),0,$week,$::trafid($col)
        set indD $::viewids(days),0,$dayf,$::trafid($col)
        set val  [set $col]
        if {![info exists chart_cost($indY)]} {
            set chart_cost($indY) $val
        } else {
            set chart_cost($indY) [wideSum $chart_cost($indY) $val]
        }
        if {![info exists chart_cost($indQ)]} {
            set chart_cost($indQ) $val
        } else {
            set chart_cost($indQ) [wideSum $chart_cost($indQ) $val]
        }
        if {![info exists chart_cost($indM)]} {
            set chart_cost($indM) $val
        } else {
            set chart_cost($indM) [wideSum $chart_cost($indM) $val]
        }
        if {![info exists chart_cost($indW)]} {
            set chart_cost($indW) $val
        } else {
            set chart_cost($indW) [wideSum $chart_cost($indW) $val]
        }
        if {![info exists chart_cost($indD)]} {
            set chart_cost($indD) $val
        } else {
            set chart_cost($indD) [wideSum $chart_cost($indD) $val]
        }
        }
    }
    shiftStatus
}
#        :
proc detailedNat {} {
    global chart_nat
    foreach col $::table2(cols) {
    set dvlist {}
    set mvlist {}
    set qvlist {}
    set wvlist {}
    foreach year $::dates(years) {
        set indY $::viewids(years),0,$year,$::trafid($col)
        if {![info exists chart_nat($indY)]} {
            set chart_nat($indY) 0
        }
        foreach q $::dates($year,quarters) {
            set ms [lindex $q 1]
            set qn [lindex $q 0]
            set qid $::roman($qn).$year
            set qind $::viewids(quarters),0,$qid,$::trafid($col)
            try_eval {
                lappend qvlist $chart_nat($qind)
            } {
                set chart_nat($qind) 0
                lappend qvlist 0
            }
            foreach m $ms {
                set mid $m.$year
                set mind $::viewids(months),0,$mid,$::trafid($col)
                try_eval {
                    lappend mvlist $chart_nat($mind)
                } {
                    set chart_nat($mind) 0
                    lappend mvlist 0
                }
                if {![info exists ::dates($year,$m,weeks)]} {
                    set ::dates($year,$m,weeks) {}
                }
                foreach w $::dates($year,$m,weeks) {
                    set ds   [lindex $w 1]
                    set wn   [lindex $w 0]
                    set wid  $::roman($wn).$m.$year
                    set wind $::viewids(weeks),0,$wid,$::trafid($col)
                    try_eval {
                        lappend wvlist $chart_nat($wind)
                    } {
                        set chart_nat($wind) 0
                        lappend wvlist 0
                    }
                    foreach d $ds {
                        set did $d.$m.$year
                        set dind $::viewids(days),0,$did,$::trafid($col)
                        try_eval {
                            lappend dvlist $chart_nat($dind)
                        } {
                            set chart_nat($dind) 0
                            lappend dvlist 0
                        }
                        set ddind  $::viewids(days),1,$did,$::trafid($col)
                        set indHD1 $::viewids(hdays),0,I.$did,$::trafid($col)
                        set indHD2 $::viewids(hdays),0,II.$did,$::trafid($col)
                        if {![info exists chart_nat($indHD1)]} {
                            set chart_nat($indHD1) 0
                        }
                        if {![info exists chart_nat($indHD2)]} {
                            set chart_nat($indHD2) 0
                        }
                        set chart_nat($ddind) [list $chart_nat($indHD1) $chart_nat($indHD2)]
                    }
                    set chart_nat($::viewids(weeks),1,$wid,$::trafid($col)) $dvlist
                    set dvlist {}
                }
                set chart_nat($::viewids(months),1,$mid,$::trafid($col)) $wvlist
                set wvlist {}
            }
            set chart_nat($::viewids(quarters),1,$qid,$::trafid($col)) $mvlist
            set mvlist {}
        }
        set chart_nat($::viewids(years),1,$year,$::trafid($col)) $qvlist
        set qvlist {}
    }
    }
}
#        :
proc detailedCost {} {
    global chart_cost
    foreach col $::table2(cols) {
    set dvlist {}
    set mvlist {}
    set qvlist {}
    set wvlist {}
    foreach year $::dates(years) {
        set indY $::viewids(years),0,$year,$::trafid($col)
        if {![info exists chart_cost($indY)]} {
            set chart_cost($indY) 0
        }
        foreach q $::dates($year,quarters) {
            set ms [lindex $q 1]
            set qn [lindex $q 0]
            set qid $::roman($qn).$year
            set qind $::viewids(quarters),0,$qid,$::trafid($col)
            try_eval {
                lappend qvlist $chart_cost($qind)
            } {
                set chart_cost($qind) 0
                lappend qvlist 0
            }
            foreach m $ms {
                set mid $m.$year
                set mind $::viewids(months),0,$mid,$::trafid($col)
                try_eval {
                    lappend mvlist $chart_cost($mind)
                } {
                    set chart_cost($mind) 0
                    lappend mvlist 0
                }
                foreach w $::dates($year,$m,weeks) {
                    set ds   [lindex $w 1]
                    set wn   [lindex $w 0]
                    set wid  $::roman($wn).$m.$year
                    set wind $::viewids(weeks),0,$wid,$::trafid($col)
                    try_eval {
                        lappend wvlist $chart_cost($wind)
                    } {
                        set chart_cost($wind) 0
                        lappend wvlist 0
                    }
                    foreach d $ds {
                        set did $d.$m.$year
                        set dind $::viewids(days),0,$did,$::trafid($col)
                        try_eval {
                            lappend dvlist $chart_cost($dind)
                        } {
                            set chart_cost($dind) 0
                            lappend dvlist 0
                        }
                        set ddind  $::viewids(days),1,$did,$::trafid($col)
                        set indHD1 $::viewids(hdays),0,I.$did,$::trafid($col)
                        set indHD2 $::viewids(hdays),0,II.$did,$::trafid($col)
                        if {![info exists chart_cost($indHD1)]} {
                            set chart_cost($indHD1) 0
                        }
                        if {![info exists chart_cost($indHD2)]} {
                            set chart_cost($indHD2) 0
                        }
                        set chart_cost($ddind) [list $chart_cost($indHD1) $chart_cost($indHD2)]
                    }
                    set chart_cost($::viewids(weeks),1,$wid,$::trafid($col)) $dvlist
                    set dvlist {}
                }
                set chart_cost($::viewids(months),1,$mid,$::trafid($col)) $wvlist
                set wvlist {}
            }
            set chart_cost($::viewids(quarters),1,$qid,$::trafid($col)) $mvlist
            set mvlist {}
        }
        set chart_cost($::viewids(years),1,$year,$::trafid($col)) $qvlist
        set qvlist {}
    }
    }
}
#          ,
#       
proc findChartData {} {
    #          
    if {$::stats(chart)} {return}
    set stepscnt 3
    set day1 [string map {- ""} [lindex $::chart(date1) 0]]
    set day2 [string map {- ""} [lindex $::chart(date2) 0]]
    set rstabs [getRStables]
    foreach tab $rstabs {
        set day [string range $tab 3 end]
        if {!($day >= $day1 && $day <= $day2)} {continue}
        incr stepscnt
    }
    set int [intersect $::table2(cols) $::botiklook(rubcols)]
    if {![lempty $int]} {
        incr stepscnt
    }
    initStatus $stepscnt " . "
    processRStables
    #      :
    nonDetailedNat
    #        :
    nonDetailedCost
    #       :
    detailedNat
    detailedCost
    finishStatus
    set ::stats(chart) 1
}
proc freeMemory {} {
    catch {array unset ::dates}
    catch {array unset ::chart}
    catch {array unset ::hist}
    catch {array unset ::histdata}
    catch {array unset ::chart_nat}
    catch {array unset ::chart_cost}
    catch {array unset ::table3units}
    catch {array unset ::table3srv}
    catch {array unset ::table3tps}
    catch {array unset ::ufstab}
}
proc hls2rgb {h l s} {
    # h, l and s are floats between 0.0 and 1.0, ditto for r, g and b
    # h = 0   => red
    # h = 1/3 => green
    # h = 2/3 => blue

    set h6 [expr {($h-floor($h))*6}]
    set r [expr {  $h6 <= 3 ? 2-$h6
                            : $h6-4}]
    set g [expr {  $h6 <= 2 ? $h6
                            : $h6 <= 5 ? 4-$h6
                                       : $h6-6}]
    set b [expr {  $h6 <= 1 ? -$h6
                            : $h6 <= 4 ? $h6-2
                                       : 6-$h6}]
    set r [expr {$r < 0.0 ? 0.0 : $r > 1.0 ? 1.0 : double($r)}]
    set g [expr {$g < 0.0 ? 0.0 : $g > 1.0 ? 1.0 : double($g)}]
    set b [expr {$b < 0.0 ? 0.0 : $b > 1.0 ? 1.0 : double($b)}]

    set r [expr {(($r-1)*$s+1)*$l}]
    set g [expr {(($g-1)*$s+1)*$l}]
    set b [expr {(($b-1)*$s+1)*$l}]
    return [list $r $g $b]
}
proc hls2tk {h l s} {
     set rgb [hls2rgb $h $l $s]
     foreach c $rgb {
        set intc [expr {int($c * 256)}]
        if {$intc == 256} { set intc 255 }
        set c1 [format %1X $intc]
        if {[string length $c1] == 1} {set c1 "0$c1"}
        append init $c1
     }
     return #$init
}
# returns a list
# of colors rather than drawing buttons
proc distinctColors {n} {
     set nn 1
     set hue_increment .15
     set s 1.0 ;# non-variable saturation

     set lum_steps [expr $n * $hue_increment]
     set int_lum_steps [expr int($lum_steps)]
     if {$lum_steps > $int_lum_steps} { ;# round up
         set lum_steps [expr $int_lum_steps + 1]
     }
     set lum_increment [expr .7 / $lum_steps]

     for {set l 1.0} {$l > 0.3} {set l [expr {$l - $lum_increment}]} {
         for {set h 0.0} {$h < 1.0} {set h [expr {$h + $hue_increment}]} {
             lappend rc [hls2tk $h $l $s]
             incr nn
             if {$nn > $n} { return $rc }
         }
     }
     return $rc
}
proc exportChartToCSV {} {
    set date1 [string map {: -} [lindex $::chart(date1) 0]]
    set date2 [string map {: -} [lindex $::chart(date2) 0]]
    if {$date1 eq $date2} {
        set datestr $date1
    } else {
        set datestr ${date1}_$date2
    }
    set ifile  "$::auth(torg)_histogram_$::chart(view)_$::stats(mode)_$datestr"
    set total {}
    set xls   0
    set ncols 0
    set filename {}
    set file_info [getSaveFile $ifile ""]
    foreach {filename xls} $file_info {}
    if {[lempty $filename]} {return}
    set caption {}; #    
    set trids {};   # -   
    set labels {};  #
    set info [string map {\n " "} $::chart(name)]
    lappend total {}
    # 1.    :
    foreach tr $::table2(cols) {
        set text $::coltitles($tr)
        set val  $::chart($tr)
        set unit $::colunits($tr,$::stats(mode))
        if {$unit eq "sec"} {set unit "min"}
        append text " ($::colunitstitles($unit))"
        if {$val} {
            #lappend total "$text"
            set trtext($::trafid($tr)) "$text"
            lappend trids $::trafid($tr)
        }
    }
    # 2.  :
    foreach date $::chart(groups,$::chart(view)) {
        if {$::chart(detailed)} {
            set subds $::subdates($date)
        } else {
            set subds $date
        }
        foreach d $subds {
            set lbl  [getDateLabel $d]
            set val_ {}
            lappend labels "$lbl"
            #lappend total "$lbl"
            foreach trid $trids {
                if {![info exists ::histdata($d,$trid)]} {
                    set val 0
                } else {
                    set val [sciToRealFmt2 $::histdata($d,$trid)]
                }
                set val [string map ". $::stats(decpoint)" $val]
                #lappend total $val
                set trtable($trid,$lbl) $val
            }
        }
    }
    set ncols [expr [llength $labels]+1]
    set total [concat $total $labels]
    foreach trid $trids {
        lappend total "$trtext($trid)"
        foreach label $labels {
            lappend total $trtable($trid,$label)
        }
    }
    set success $::exportsuccess

    # .xls export
    if {$xls} {
        set res [table2excel $::auth(torg) $ncols $total $filename $info]
        if {!$res} {
            #alert $success
        }
        return
    }

    # .csv export
    set f [open $filename w]
    puts $f $info
    set tlen  [llength $total]
    set niter [expr int(ceil($tlen/$ncols))]
    loop i 0 $niter {
        set line [lrange $total [expr {$i*$ncols}] [expr {($i+1)*$ncols - 1}]]
        puts $f [join $line $::stats(csvsep)]
    }
    close $f
    unset total
    #alert $success
    return
}
proc rgb_to_excel_scheme {rgb} {
    set least_distance 1000
    set best_clr       #000000
    set allcolors      [array get ::xlcolors]
    scan $rgb "\#%2x%2x%2x" r0 g0 b0
    foreach clr $allcolors {
        scan $clr "\#%2x%2x%2x" r g b
        set d [expr abs($r - $r0) + abs($g - $g0) + abs($b - $b0)]
        if {$d == 0} {
            return $::xlcolors($clr)
        }
        if {$d < $least_distance} {
            set least_distance $d
            set best_clr $clr
        }
    }
    return $::xlcolors($best_clr)
}
proc traceCmd {a b c d} {
    puts $::tracechan "$d:[string repeat { } $d]$b"
}
#    TCL-   
proc traceon {} {
    set ::tracechan [open $::botiklook(tracelog) w]
    fconfigure $::tracechan -encoding cp1251
    cmdtrace on notruncate procs command traceCmd
}
proc traceoff {} {
    catch {cmdtrace off; close $::tracechan}
}
proc versionHandler {token} {
    set data {}
    catch {
        upvar #0 $token state
        set data [split $state(body) "\n"]
    }
    set btver 0
    set newver 0
    foreach line $data {
        set spl [split $line ":"]
        set app [lindex $spl 1]
        set ver [lindex $spl 2]
        if {$app eq "BotikTools"} {set btver $ver}
        if {$app eq $::botiklook(pname)} {set newver $ver}
    }
    if {$::botiklook(pversion) < $newver} {
        add2Version "-" ::botiklook(version)
        set answer [selfUpdate $::botiklook(pname) $::botiklook(pversion) $newver $btver]
        if {$answer eq "yes"} {showURL $::botiklook(downloadpage)}
    }
    # else add2Version "*" ::botiklook(version)
    return [string length $state(body)]
}
proc checkVersion {} {
    catch {http::geturl $::botiklook(versionurl) -command versionHandler -timeout 10000}
}

loadPackages {Tcl 8.4 Tk 8.4 Tclx 8.4 sqlite3 3.0 dns 1.0 http 2.4 Tktable 2.8 mime 1.4 smtp 1.3.5 tls 1.4}
http::register https 443 ::tls::socket
if {[windowsPlatform]} {
    loadPackages {autoscroll 1.0 registry 1.1.3 tile 0.7.3 tcom 3.9}
    namespace import -force ttk::*
}
if {[unixPlatform]} {
    catch {source bgerror.tcl}
}
configure
chooseAction
