#!/usr/bin/wish

# Copyright (c) 2003-2014, Botik Technologies, Ltd.
# All rights reserved.

#    BotikMap (http://www.botik.ru/~botik/map/),
#     C "".
#   : 24  2003 .

set ::plot(pname) "BotikMap"
set ::plot(version) 1.77
set ::plot(ver) "$::plot(pname) v.$::plot(version)"

proc initVars {c w} {
    global layers plot lines ids search but \
        clipboard lastBtn myImages tmpID ID \
        conn complex nodes pi layers2 objects types \
        states zooms classes images move \
        grid canvas parameters pi agr srvids \
        edges multi tags divs TOPs binds keys tmpchoice \
        mmap delobjstr inlayer zhidden man_edit man_vis \
        cancel delobjs zoom toplayer \
        every updateBusy localID satmap

    set ::whoamiurl        "https://nadmin.$::net(domain)/~nadmin/whoami.cgi"
    set ::versionurl       "http://www.$::net(domain)/~botik/download/versions.txt"
    set ::dlurl            "http://www.$::net(domain)/~botik/tools/download.ru.html#sWin"
    # map width&height (in px); can be increased indefinitely;
    # you must also scale up minimap.gif image if you increase map size:
    set canvas(maxSize_px) 128000.0
    set canvas(maxSize_m)  44000.0; # map width&height (in meters); can be increased
    set canvas(sizes)      [canvas_sizes $canvas(maxSize_px)]
    set canvas(px_in_m)    [expr {double($canvas(maxSize_px)/$canvas(maxSize_m))}]
    set canvas(m_in_px)    [expr {double($canvas(maxSize_m)/$canvas(maxSize_px))}]
    set canvas(busy)       0
    set canvas(cX)         0
    set canvas(cY)         0
    set canvas(panX)       0
    set canvas(panY)       0
    set canvas(propx)      500
    set canvas(propy)      300
    set canvas(cursor)     [$c configure -cursor]
    set bridges(tag)       ""
    set delobjs            {}
    set updateBusy         0
    set but                ""
    set cancel             0
    set clipboard(obj)     ""
    set complex(0)         ""
    set complex(activeTOP) ""
    set complex(activeTOPLine) ""
    set ::botiktools(progname) $plot(pname)
    set conn(auth)    0
    set conn(org)     ""
    set conn(login)   ""
    set conn(pass)    ""
    set conn(mainpage) "https://map.$::net(domain)/~botikmap/xbotikmap.cgi"
    set conn(sid) ""
    set conn(timeout) 5000
    set conn(authtime) 0
    set conn(orglogin) ""
    set drawComplete 0
    set every 50
    set pi 3.1415926535897932384626433832795
    set plot(scheme)     "botikmap:"
    set plot(cache_file)  [appFile "botikmap.cache"]
    set plot(cachetime_file)  [appFile "timestamp.cache"]
    # this can be altered to add new maps:
    set satmap(maptypes) {yn yh y kh osm mq cm ovi}
    set satmap(maptitles) {". ( )" ". ()" ". (.)" " Google" "OpenStreetMap" "MapQuest" "CloudMade" "Ovi Maps"}
    set satmap(mtype,yn)  "pmap"; #  
    set satmap(mtype,yh)  "sat,pskl"; # 
    set satmap(mtype,y)   "sat"; #  
    set satmap(mtype,g)   "satellite"; #  
    set satmap(mtype,kh)  ""; #  
    set satmap(mtype,osm) ""
    set satmap(mtype,mq)  ""
    set satmap(mtype,cm)  ""
    set satmap(mtype,ovi) ""
    set satmap(format,yn)  "png"
    set satmap(format,yh)  "jpg"
    set satmap(format,y)   "jpg"
    set satmap(format,g)   "jpg"
    set satmap(format,kh)  "jpg"
    set satmap(format,osm) "png"
    set satmap(format,mq)  "jpg"
    set satmap(format,cm)  "png"
    set satmap(format,ovi) "jpg"
    set satmap(khver) 113; # may change (fixme)
    # ---------------------------
    # sat. map coordinates (x&y) of center point in 18-th zoom level:
    set satmap(centerX) 159285
    set satmap(centerY) 80580
    set satmap(type)    [lindex $satmap(maptypes) 0]
    set satmap(dir)     [appFile "."]
    set satmap(tile)    256; # Maps tile size: 256*256
    set satmap(shiftx)  330; # in px, zoom=7
    set satmap(shifty)  200
    if {[llength $satmap(maptitles)] != [llength $satmap(maptypes)]} {
        alert "Error in satmaps specification."
    }
    set myImages(pkg_loaded) 0
    set grid(csize) 500.0
    set grid(shown) ""
    set ID 0; # local ID; less than zero
    set lastBtn(btn)  "" 
    set layers(N) 0
    set layers(buts)  {}
    set layers(butnames) {}
    set layers(cur)   ""
    set layers(tButs) {}
    set layers(top) 2
    set layers(zoomLevel) 7
    set lines(N) 0
    set mmap(shown) 0
    set mmap(mode) "town"
    set mmap(var) "\n"
    set mmap(lastx) 0
    set mmap(lasty) 0
    set multi(startX) 0
    set multi(startY) 0
    set myImages(0) ""
    set myImages(N) 0
    set myImages(all) "null"
    set myImages(showsublayer) 0
    set myImages(subPicts) {}
    set nodes(lastNode) 0
    set nodes(lastX) 0
    set nodes(lastY) 0
    set objects(nFields) 10
    set ::updates(new) {}; # new objects recvd from server
    set ::updates(prohibit) {}
    set ::updates(recv) {}
    set plot(tmpobjs) {}
    set plot(tmpmax)  30
    set plot(lastX) 0
    set plot(lastY) 0
    set plot(selected) ""
    set plot(shift) 3
    set plot(ovalRad) 3
    set plot(butpress1)   [bind $c <ButtonPress-1>]
    set plot(butpress3)   [bind $c <ButtonPress-3>]
    set plot(butrelease1) [bind $c <ButtonRelease-1>]
    set plot(butrelease3) [bind $c <ButtonRelease-3>]
    set plot(cbutpress1)  [bind $c <Control-ButtonPress-1>]
    set plot(motion)      [bind $c <Motion>]
    set plot(icon)        [file join . img botikmap.ico]
    set plot(hlpwin) .hlp
    set plot(size) 0
    set plot(rem)  0
    set plot(tmp) ""
    set plot(mto) 3; #  ( .)        .
    set plot(timeout)    [expr {$plot(mto)*60}]
    set plot(ts)         [string repeat "0" 14]; # timestamp,  .
    set plot(configfile) [appFile $plot(pname).config]
    set plot(mindate)    $plot(ts)
    set plot(date)       $plot(mindate)
    set plot(binds)      {}
    set plot(sendobjects) 0
    set plot(usegraph) 0
    set plot(admin) 0
    set plot(errobjs) {}
    set plot(dbgfile) [appFile bmdebug.txt]
    set plot(numq)    500; # max number of queries to hold in memory before processing
    set plot(dbfpath) [appFile sensornodes.bmb]
    set plot(sysorgs)   {system MultiProc Admin}
    set plot(nonstd)  {-k -m -x -t -minarea -diff -textfill -style -linewidth -polywidth -linefill -polyfill -polyoutline -radius -file -name}; # non-standard options
    set ::hist(dbinit) 0
    set ::hist(current_node) ""
    set ::hist(sensstat) ""
    set ::channels {}
    set ::dotbinds {}
    set search(limit) 5000
    set search(res) ""
    set toplayer $layers(top)
    set tmpID 0
    set ::bmap(len) 0
    set ::bmap(recv) ""
    set zoom $layers(zoomLevel)
    for {set i 1} {$i <= 7} {incr i} {
        set zhidden($i) {}
    }
    set ::fonts(txt)   {Sans-Serif 11}; # text
    set ::fonts(txtb)  {Sans-Serif 11 bold}; # bold text
    set ::fonts(buts)  {Arial 11}; # buttons
    set ::fonts(butsb) {Arial 11 bold}; # bold button
    set ::fonts(heads) {Arial 12 bold}; # headings
    set ::refresh 0
    set ::status(coords) ""
    trace add variable ::refresh write "newRefresh"
    trace add variable but write "rb_write"
    set plot(rbuts) 0
    set ::TOPtxt ""
    #        windows-1251
    set rusalpha ""
    set charlist [split $rusalpha ""]
    for {set i 0} {$i < [llength $charlist]} {incr i} {
        set char [lindex $charlist $i]
        set code [expr {$i + 192}]
        set ::ruscode($char) $code
    }
    set ::ruscode() 168
    set ::ruscode() 184
    updateStatus coords  ""
    updateStatus hint    ""
    updateStatus objInfo ""
}
# return list of canvas sizes in different zoom levels, e.g.:
# 0 2000 4000 8000 16000 32000 64000 128000
# 'max' is the canvas size (in pixels) in 7-th zoom level
proc canvas_sizes {max} {
    if {$::tcl_version < 8.5} {
    proc lreverse {l} {
        set end [llength $l]
        foreach tmp $l {
            lset l [incr end -1] $tmp
        }
        return $l
    }}
    set res {}
    for {set i 0} {$i < 7} {incr i} {
        lappend res [expr {int($max/pow(2,$i))}]
    }
    lappend res 0
    return [lreverse $res]
}
proc windowsPlatform {} {
   return [expr {$::tcl_platform(platform) eq "windows"}]
}
proc WinNT6 {} {
    return [expr {[windowsPlatform] && $::tcl_platform(osVersion) >= 6.0}]
}
proc unixPlatform {} {
   return [expr {$::tcl_platform(platform) eq "unix" && $::tcl_platform(os) ne "Darwin"}]
}
proc macPlatform {} {
   return [expr {$::tcl_platform(os) eq "Darwin"}]
}
proc appFile {fname} {
    set d "~"
    catch {set d $::env(APPDATA)}
    set appfile $fname
    if {[string length $d] != 0} {
        #catch {file mkdir [file join $d $::plot(pname)]}
        #set appfile [file join $d $::plot(pname) $fname]
        catch {file mkdir [file join $d BotikTools]}
        set appfile [file join $d BotikTools $fname]
    }
    return $appfile
}
proc bindDotObjs {c} {
    global plot binds objects chbinds houseboxes
    progress ""
    if {[lempty $plot(selected)]} {return}
    #        2- 
    if {[llength $plot(selected)] == 3} {
        set chan  {}
        set boxes {}
        foreach otag $plot(selected) {
            set objID  [takeID $otag]
            set ostr   $objects($objID)
            set oname  [getStr [lindex $ostr 2]]
            if {$oname eq ""} {
                set chan $otag
            } elseif {$oname eq ""} {
                lappend boxes $otag
            }
        }
        if {![lempty $chan] && [llength $boxes]==2} {
            set chanID [takeID $chan]
            set ostr   $objects($chanID)
            set opar   [lindex $ostr 3]
            set box1   [lindex $boxes 0]
            set box2   [lindex $boxes 1]
            set box1ID [takeID $box1]
            set box2ID [takeID $box2]
            if {![info exists ::srvids($chanID)] || ![info exists ::srvids($box1ID)] || ![info exists ::srvids($box2ID)]} {
                alert "        ."
                return
            }
            lappend opar "$::srvids($box1ID)" "$::srvids($box2ID)"
            set objects($chanID) [lreplace $objects($chanID) 3 3 $opar]
            setChangeState $c $chan 1
            set chbinds($chanID) [list $box1ID $box2ID]
            g_modArcBinds $chanID
            progress "   ."
            return
        }
    }
    #  
    if {[llength $plot(selected)] == 1} {
        set objID [takeID $plot(selected)]
        set ostr  $objects($objID)
        set oname [getStr [lindex $ostr 2]]
        if {$oname eq "" && [info exists chbinds($objID)]} {
            set params [lindex $objects($objID) 3]
            set newParams [lrange $params 0 2]
            set objects($objID) [lreplace $objects($objID) 3 3 $newParams]
            unset chbinds($objID)
            setChangeState $c $plot(selected) 1
            g_modArcBinds $objID
            progress "   ."
            return
        }
    }
    #    -       ,  
    set hasdot  0
    set haschan 0
    set chanid  0
    set local   0
    set eltids  {}
    set boxid   {}
    set dottag  {}
    foreach tag $plot(selected) {
        set id    [takeID $tag]
        set class [getClassByTag $tag]
        set ostr  $objects($id)
        set oname [getStr [lindex $ostr 2]]
        if {$oname eq ""} {
            incr haschan
            set chanid $id
        } elseif {$oname eq ""} {
            incr hasdot
            set boxid  $id
            set dottag $tag
        } else {
            if {![info exists ::srvids($id)]} {
                set local 1
            } else {
                lappend eltids $id
            }
        }
    }
    if {!$hasdot || $hasdot > 1} {
        alertError "    \n       ."
        return
    }
    if {$hasdot && $haschan} {
        alertError "       .\n : 2   1 ."
        return
    }
    if {![info exists ::srvids($boxid)] || $local} {
        alert "        ."
        return
    }
    if {[info exists binds($boxid)]} {
        set oldbs $binds($boxid)
        set unbind [diff $oldbs $eltids]
        if {[llength $unbind]} {
            # unbind houses
            foreach id $unbind {
                if {[info exists houseboxes($id)]} {
                    set houseboxes($id) [delFromList $houseboxes($id) $boxid]
                    if {[lempty $houseboxes($id)]} {
                        setObjectState $id " *"
                        set tag [getTagBySrvID $id]
                        set layerID [getLayer $tag]
                        applyParams $c $tag $id $layerID
                        setChangeState $c $tag 1
                    }
                }
            }
        }
    }
    set binds($boxid) $eltids
    setChangeState $c $dottag 1
    handleBinds $c [list $boxid $eltids]
    showDotBinds $c $boxid
    g_modNodeBinds $boxid
    progress "   ."
}
#         
proc getClosestPoint {p p1 p2} {
    lassign $p  px py
    lassign $p1 p1x p1y
    lassign $p2 p2x p2y
    set dist1 [dist $px $py $p1x $p1y]
    set dist2 [dist $px $py $p2x $p2y]
    if {$dist2 < $dist1} {
        return 2
    }
    return 1
}
proc getID {} {
    return [incr ::ID -1]
}
proc startRadSearch {w ids x y} {
    global search layers
    set x [$w canvasx $x]
    set y [$w canvasy $y]
    set res {}
    foreach {x y} [countCoords2 "$x $y" $layers(zoomLevel) 7] {break}
    foreach id $ids {
        foreach {mx my} [getMidCoords $id] {break}
        set dist [expr {hypot($x-$mx,$y-$my)}]
        set dists($dist) $id
    }
    set ldists [lsort -real [array names dists]]
    foreach dist $ldists {
        if {[llength $res]==$search(limit)} {
            #alert " $search(limit) .\n,   ."
            break
        }
        lappend res $dists($dist)
    }
    set search(res) $res
}
proc drawBridge {w x y obj layer num} {
    global plot layers complex bridges
    set x [$w canvasx $x]
    set y [$w canvasy $y]
    if {[regexp nodeOval [$w gettags current]]} {
        initNodeMove $w $x $y "bridge2_nodeMoveStop $w $obj"
        return
    }
    if {[lempty [getStr $layer]]} {set layer $layers(top)}
    if {$num > 0} {
        set id    [takeID $bridges(tag)]
        set line0 "line${id}_0"
        set line1 "line${id}_1"
    }
    if {$num==0} {
        removeSelection $w
        lockAllButtons $w 0
        hideActiveTOPLine $w
        set id [getID]
        set tag "line${id}_0"
        $w create line $x $y $x $y -tags $tag -width 2
        set bridges(tag) "bridge${layer}_${obj}_$id"
        group $w $bridges(tag) $tag
        set complex($bridges(tag)) $tag
        set complex($tag) $bridges(tag)
        bind $w <Motion> "draw_changePlotCoords $w %x %y $tag"
        bind $w <ButtonPress-3> ""
    } elseif {$num < 3} {
        set coords [$w coords $line0]
        set newCoords "$coords $x $y"
        $w coords $line0 $newCoords
    } elseif {$num==3} {
        bind $w <Motion> ""
    } elseif {$num == 4} {
        $w create line $x $y $x $y -tags $line1 -width 2
        group $w $bridges(tag) $line1
        set complex($bridges(tag)) "$complex($bridges(tag)) $line1"
        set complex($line1) $bridges(tag)
        bind $w <Motion> "+draw_changePlotCoords $w %x %y $line1"
    } elseif {$num < 7} {
        set coords [$w coords $line1]
        set newCoords "$coords $x $y"
        $w coords $line1 $newCoords
    } elseif {$num==7} {
        set lineCoords "[$w coords $line0] [$w coords $line1]"
        set pcoords [getBridgePolyCoords $lineCoords]
        set poly "polygon${id}_2"
        $w create polygon $pcoords -tags $poly -fill white
        $w raise $line0 $poly
        $w raise $line1 $poly
        set complex($bridges(tag),elts) "$complex($bridges(tag)) $poly"
        set complex($poly) $bridges(tag)
        group $w $bridges(tag) $poly
        put $w $bridges(tag)
        applyParams $w $bridges(tag) $obj $layer
        setSelect $w $bridges(tag) 1
        setChangeState $w $bridges(tag) 1
        positionElt $w $id
        unlockAllButtons $w 0
        set num -1
        bind $w <Motion> ""
        showProps $w $bridges(tag)
    }
    bind $w <ButtonPress-1> "drawBridge $w %x %y $obj $layer [incr num]"
}
proc getBridgePolyCoords {coords} {
    set pcoords "[lrange $coords 2 5] [lrange $coords 10 13]"
    set edge1 [lrange $pcoords 0 3]
    set edge2 [lrange $pcoords 4 end]
    set int1  [getIntersctn $edge1 $edge2]
    set s  [lindex $int1 0]
    set t1 [lindex $int1 end-1]
    set t2 [lindex $int1 end]
    if {$s && $t1 > 0 && $t1 < 1 && $t2 > 0 && $t2 < 1} {
        set newCoords "[lrange $pcoords 0 1] [lrange $pcoords 4 5] [lrange $pcoords 2 3] [lrange $pcoords 6 7]"
        return $newCoords
    }
    set edge1 "[lrange $pcoords 0 1] [lrange $pcoords 6 7]"
    set edge2 [lrange $pcoords 2 5]
    set int1  [getIntersctn $edge1 $edge2]
    set s  [lindex $int1 0]
    set t1 [lindex $int1 end-1]
    set t2 [lindex $int1 end]
    if {$s && $t1 > 0 && $t1 < 1 && $t2 > 0 && $t2 < 1} {
        set newCoords "[lrange $pcoords 0 3] [lrange $pcoords 6 7] [lrange $pcoords 4 5]"
        return $newCoords
    }
    return $pcoords
}
proc bridge2_nodeMoveStop {w obj} {
    global plot
    setParams $w $plot(selected)
    setChangeState $w $plot(selected) 1
    bind $w <Motion> ""
    bind $w <ButtonPress-1> "drawBridge $w %x %y $obj {} 0"
}
proc reposSelected {w pos} {
    global plot layers divs objects
    if {[lempty $plot(selected)] || [llength $plot(selected)] > 1} {return}
    set plot(selected) [getStr $plot(selected)]
    set l [getLayer $plot(selected)]
    set layer [getLayer $plot(selected)]
    set lname $layers($layer)
    set num   [llength $objects($lname)]
    for {set i 0} {$i < $num} {incr i} {
        set div "div${layer}_$i"
        set divs($div) [delFromList $divs($div) $plot(selected)]
    }
    if {$pos eq "raise"} {
        setCursor $w to_front    
        set upperdiv "div${layer}_0"
        set last [lindex $divs($upperdiv) end]
        catch {$w raise $plot(selected) $last}
        set divs($upperdiv) [concat $divs($upperdiv) $plot(selected)]
    } else {
        setCursor $w to_back    
        set lowerdiv "div${layer}_[expr $num-1]"
        catch {$w raise $plot(selected) $lowerdiv}
        set divs($lowerdiv) [linsert $divs($lowerdiv) 1 $plot(selected)]
    }
    $w raise nodeOvals
}
proc positionElt {w id} {
    global divs
    set tag [getTagBySrvID $id]
    if {[lempty $tag]} {return}
    set spl [split [getStr $tag] "_"]
    set layer [string index [lindex $spl 0] end]
    set objID [lindex $spl 1]
    set div   "div${layer}_$objID"
    if {![info exists divs($div)]} {return}
    set divs($div) [delFromList $divs($div) $tag]
    set last [lindex $divs($div) end]
    lappend divs($div) $tag
    if {$layer == 0} {
        $w raise $tag
    } else {
        if {[catch {$w raise $tag $last} ed]} {
            #dbg "\[positionElt $w $id]: couldn't raise $tag above $last: $ed"
            set first [lindex $divs($div) 0]
            if {[catch {$w raise $tag $first} ed2]} {
                #dbg "\[positionElt $w $id]: couldn't raise $tag above $first (the first one): $ed2"
            }
        }
    }
}
proc correctObjBrackets {obj} {
    if {[lempty $obj]} {return}
    set pars [lindex $obj 3]
    set newobj {}
    set i 0
    foreach elt $obj {
        set elt [getStr $elt]
        if {$i != 3} {
            set elt "{$elt}"
            set newobj "$newobj$elt "
        }
        incr i
    }
    return "$newobj$pars"
}
proc convToNew {obj} {
    if {[lempty $obj]} {return}
    set pars [lindex $obj 3]
    set specpars [lrange $pars 2 end]
    set specpars [mkpar $specpars]
    set coords [lindex $pars 1]
    set newobj {}
    set i 0
    foreach elt $obj {
        set elt [getStr $elt]
        if {$i != 3} {
            set elt "$elt"
            lappend newobj $elt
        }
        incr i
    }
    if {[lindex $pars 0] eq "7"} {
        set pars [lrange $pars 1 end]
    }
    lappend newobj $coords $specpars
    return $newobj
}
proc convToOld {obj} {
    if {[lempty $obj]} {return}
    set specpars [lindex $obj 10]
    if {[lempty $specpars]} {
        set pars [lrange $obj 9 end]
        return [lrange [linsert $obj 3 $pars] 0 9]
    }
    set coords [lindex $obj 9]
    lappend pars $coords
    foreach par $specpars {
        lappend pars $par
    }
    return [lrange [linsert $obj 3 $pars] 0 9]
}
proc makeObject {w obj} {
    global objects grid ID ids binds localID srvids
    set obj [convToOld $obj]
    if {[lempty [getStr $obj]]} {return}
    set srvid [lindex $obj 0]
    if {[llength $obj] < $objects(nFields)} {return}
    if {![info exists localID($srvid)]} {
        #   ,   -
        set localID($srvid) [getID]
    }
    set locid     $localID($srvid); # local ID
    set obj       [lreplace $obj 0 0 $locid]
    set objstr    "[lrange $obj 0 end-1] 0"
    set params    [lindex $objstr 3]
    set newParams "7 $params"
    set objstr    [lreplace $objstr 3 3 $newParams]
    set objname   [getStr [lindex $objstr 2]]
    set objects($locid) $objstr
    set newbs {}
    if {$objname eq ""} {
        if {[llength $newParams] == 5} {
            set chb [lrange $newParams 3 end]
            foreach id $chb {
                if {[info exists localID($id)]} {
                    lappend newbs $localID($id)
                } else {
                    lappend ::channels $locid $id
                }
            }
            set ::chbinds($locid) $newbs
            #if {[llength $newbs]==2} {g_addArc $locid}
        }
    }
    if {$objname eq ""} {
        set bs    [lindex $params end]
        set newbs {}
        foreach id $bs {
            if {![string is integer -strict $id]} {continue}
            if {$id > 0 && [info exists localID($id)]} {
                lappend newbs $localID($id)
            } elseif {$id < 0 && [info exists srvids($id)]} {
                lappend newbs $id
            } else {
                lappend ::dotbinds $locid $id
            }
        }
        set binds($locid) $newbs
        set ::plot(admin) 1
        #g_addNode $locid
    }
    set grid(shown,$locid) 0
    setGrid $locid [lindex $obj end]
    addToLayer $w $locid
    set lname [getStr [lindex $objects($locid) 1]]
    set oname $objname
    if {![info exists ids($lname,$oname)]} {
        set ids($lname,$oname) {}
    }
    if {![lcontain $ids($lname,$oname) $locid]} {
        lappend ids($lname,$oname) $locid
    }
    return $locid
}
proc setGrid {id boxes} {
    global grid
    foreach box $boxes {
        if {![info exists grid($box)]} {continue}
        lappend grid($box) $id
    }
    set grid($id) $boxes
}
proc addToLayer {w id} {
    global objects inlayer layers zhidden types zooms
    set lname [getStr [lindex $objects($id) 1]]
    set oname [getStr [lindex $objects($id) 2]]
    set otype [getStr [lindex $objects($id) 4]]
    if {![info exists layers($lname)]} {return}
    set lnum $layers($lname)
    lappend inlayer($lnum) $id
    if {![info exists zooms($oname)]} {return}
    foreach {z p} $zooms($oname) {
        if {[regexp -all {state hidden} $p]} {
            foreach zoom $z {
                lappend zhidden($zoom) $id
            }
            continue
        }
        if {[regexp -all {state .*pars.+} $p]} {
            if {![lempty  $otype]} {
                array set typepars $types($oname)
                if {![info exists typepars($otype)]} {
                    set otype ${otype}*
                }
                if {![info exists typepars($otype)]} {
                    continue
                }
                array set pars $typepars($otype)
            }
            catch {set p [subst $p]}
            if {[regexp -all {state hidden} $p]} {
                foreach zoom $z {
                    lappend zhidden($zoom) $id
                }
                continue
            }
        }
        if {[regexp -all {minarea} $p]} {
            array set pars $p
            set crds7 [getCoords $id]
            foreach zoom $z {
                set coords [countCoords2 $crds7 7 $zoom]
                set area   [getBboxArea $w $coords]
                if {$area < $pars(-minarea)} {
                    lappend zhidden($zoom) $id
                }
            }
        }
    }
}
proc delFromLayer {id} {
    global inlayer zhidden layers
    for {set i 0} {$i < $layers(N)} {incr i} {
        set inlayer($i) [delFromList $inlayer($i) $id]
    }
    for {set i 1} {$i <= 7 } {incr i} {
        set zhidden($i) [delFromList $zhidden($i) $id]
    }
}
proc hidePointer {w} {
    $w delete pointer
    $w dtag pointer
}
proc showPointer {w x y} {
    global pi
    hidePointer $w
    set color1 "red";          #1-  :
    set color2 "blue";         #2-  :
    set time   200;            #     ( ).
    set num    2;              #  .
    set width  15;             # .
    set length 105;            #  ( ).
    set shape  {21 34 15};     # .
    set angle  [expr $pi/4.0]; #   ( ).
    set tag "pointer"
    set crds [getPointerCoords $x $y $length $angle]
    $w create line $crds -width $width -fill $color1 -tags $tag \
        -arrow first -arrowshape $shape
    catch {$w raise $tag nodeOvals}
    set cmd ""
    set end "after $time \"hidePointer $w\""
    set done 0
    for {set i 0} {$i < $num} {incr i} {
        set cmd "$cmd after $time \[subst \{\n\
                $w itemconfig $tag -fill $color2;\n\
                update;\n\
                after $time \[subst \{\n\
                    $w itemconfig $tag -fill $color1;\n\
                    update;"
        set end "$end \}\] \}\]"
    }
    eval "$cmd $end"
}
proc getPointerCoords {x y plen pang} {
    global layers
    set x1 $x
    set y1 $y
    set x2 [expr {$x1+$plen*cos($pang)}]
    set y2 [expr {$y1-$plen*sin($pang)}]
    return "$x1 $y1 $x2 $y2"
}
proc degrees_to_radians {d} {
    return [expr {$d * $::pi / 180.0}]
}
proc radians_to_degrees {r} {
    return [expr {$r * 180. / $::pi}]
}
#.5 ln( (1 + sin t) / (1 - sin t) )
proc mercator {d} {
    set s [expr {sin([degrees_to_radians $d])}]
    set r [expr {0.5 * log((1. + $s) / (1. - $s))}]
    return [radians_to_degrees $r]
}
# arcsin((e^2x - 1)/(e^2x + 1))
proc inverse_mercator {d} {
    set e [expr {exp(2.0 * [degrees_to_radians $d])}]
    set e [expr {($e - 1.)/($e + 1.)}]
    set r [expr {atan2($e, sqrt(1. - $e * $e))}]
    return [radians_to_degrees $r]
}
proc get_satmap_coords {zoom box} {
    # 159285,80580: Pereslavl upper-left tile coord. in bmap_zoom=7
    set start_x [expr {double($::satmap(centerX)) / ($::satmap(tile)/256.0)}]
    set start_y [expr {double($::satmap(centerY)) / ($::satmap(tile)/256.0)}]
    set x0 [expr {$start_x / pow(2.0,18 - $zoom)}]
    set y0 [expr {$start_y / pow(2.0,18 - $zoom)}]
    foreach {y x} [split $box ","] {break}
    set y [expr {$y + $y0}]
    set x [expr {$x + $x0}]
    switch -glob -- $::satmap(type) {
        y* - g - ovi {
            set d [expr {pow(2.0,$zoom)}]
            set lon_extent [expr {360./$d}]
            set merclat_extent [expr {360./$d}]
            set l [expr {180.0 - $y * $merclat_extent}]
            set lat1 [inverse_mercator $l]
            set lon0 [expr {$x * $lon_extent - 180.0}]
            set lat0 [expr {$lat1 - $merclat_extent}]
            set lon1 [expr {$lon0 + $lon_extent}]
            set latt [format "%.6f" [expr {($lat0 + $lat1)/2.0}]]
            set long [format "%.6f" [expr {($lon0 + $lon1)/2.0}]]
            return [list $latt $long]; # tile center
        }
        default {
            set x [expr {int($x)}]
            set y [expr {int($y)}]
            return [list $x $y]; # tile coordinate
        }
    }
}
#     ,   :
proc getSubImageFromWeb {c zl box basetag} {
    if {!$::myImages(showsublayer)} {return}
    set res {}
    set tok ""
    set fmt [string tolower $::satmap(format,$::satmap(type))]
    set mzl [expr {$zl+11}]
    set coords [get_satmap_coords $mzl $box]
    set tag [file join $basetag $box]
    set fname $tag.$fmt
    set fpath [file join $::satmap(dir) $fname]
    set old 0
    set hdr ""
    if {[lcontain $::myImages(subPicts) $tag]} {return $tag};# already displayed
    if {[file exists $fpath]} {
        set mt [file mtime $fpath]
        set imgday [clockFormat %Y%m%d $mt]
        set nowday [clockFormat %Y%m%d [clock seconds]]
        set nd [ndays $imgday $nowday]
        if {$nd < 31} {return [display_image $c $tag $fname]}
        file rename -force $fpath $fpath.old
        set old 1
    }
    if {[info exists ::satmap(override,$fname)]} {
        return [display_image $c $tag $::satmap(override,$fname)]
    }
    foreach {x y} $coords {break}
    set type $::satmap(mtype,$::satmap(type))
    switch -glob -- $::satmap(type) {
        y* {
            set link "http://static-maps.yandex.ru/1.x/?ll=$y,$x&l=$type&z=$mzl&size=$::satmap(tile),$::satmap(tile)"
        }
        g {
            set link "http://maps.googleapis.com/maps/api/staticmap?center=$x,$y&zoom=$mzl&size=$::satmap(tile)x$::satmap(tile)&scale=1&maptype=$type&sensor=false&format=$fmt"
        }
        kh {
            set link "http://khm0.google.com/kh/v=$::satmap(khver)&src=app&x=$x&y=$y&z=$mzl&s=Galileo"
        }
        cm {
            set link "http://a.tile.cloudmade.com/287BE18000EA4CBA9646637E21520743/1/$::satmap(tile)/$mzl/$x/$y.$fmt"
        }
        osm {
            set link "http://a.tile.openstreetmap.org/$mzl/$x/$y.$fmt"
        }
        mq {
            set link "http://otile1.mqcdn.com/tiles/1.0.0/osm/$mzl/$x/$y.$fmt"
        }
        ovi {
            set link "http://m.ovi.me/?c=$x,$y&t=1&z=$mzl&w=$::satmap(tile)&h=$::satmap(tile)&nord&nodot"
        }
        default {return}
    }
    set ::links($link) [list $c $fname $fpath $tag $old $box 0]
    return $tag
}
proc process_request {tok} {
    upvar #0 $tok state
    set link $state(url)
    if {![array exists ::links] || ![info exists ::links($link)]} {return}
    set fmt [string tolower $::satmap(format,$::satmap(type))]
    foreach {c fname fpath tag old box num} $::links($link) {break}
    catch {unset ::links($link)}
    if {[http::ncode $tok] == 200} {
        set f [open $fpath w+]
        fconfigure $f -translation binary
        puts -nonewline $f $state(body)
        seek $f 0
        set hdr [read $f 4]
        close $f
        set realfmt [get_image_format $hdr]
        if {$old} {file delete -force $fpath.old}
        if {[llength $realfmt] && $realfmt ne $fmt} {
            set newfname $tag.$realfmt
            set newfpath [file join $::satmap(dir) $newfname]
            file rename -force $fpath $newfpath
            #debug "file rename: $fpath --> $newfpath; link=$link"
            set ::satmap(override,$fname) $newfname
            set fname $newfname
        }
        catch {http::cleanup $tok}
        display_image $c $tag $fname
    } else {
        catch {file delete -force $fpath}
        catch {http::cleanup $tok}
        if {$old && ![lcontain {kh osm} $::satmap(type)]} {
            file rename -force $fpath.old $fpath
            display_image $c $tag $fname
        } elseif {[lcontain {kh osm} $::satmap(type)]} {
            if {[incr num] > 3} {
                if {$old} {
                    file rename -force $fpath.old $fpath
                    display_image $c $tag $fname}
                return}
            # use alternate servers of Google Maps, from 0-th to 3-rd
            set mzl [expr {$::layers(zoomLevel) + 11}]
            set coords [get_satmap_coords $mzl $box]
            foreach {x y} $coords {break}
            set letter [lindex {a b c a} $num]
            switch -glob -- $::satmap(type) {
                kh {
                    set link "http://khm$num.google.com/kh/v=$::satmap(khver)&src=app&x=$x&y=$y&z=$mzl&s=Galileo"
                }
                cm {
                    set link "http://$letter.tile.cloudmade.com/287BE18000EA4CBA9646637E21520743/1/$::satmap(tile)/$mzl/$x/$y.$fmt"
                }
                osm {
                    set link "http://$letter.tile.openstreetmap.org/$mzl/$x/$y.$fmt"
                }
                default {return}
            }
            set ::links($link) [list $c $fname $fpath $tag $old $box $num]
        }
    }
}
# download map tiles in parallel
proc download_images {} {
    if {![array exists ::links]} {return}
    set alllinks [array names ::links]
    foreach link $alllinks {
        if {!$::myImages(showsublayer)} {return}
        if {![info exists ::links($link)]} {continue}; # sanity check
        foreach {c fname fpath tag old box num} $::links($link) {break}
        if {[catch {
            set tok [http::geturl $link -command process_request -timeout 5000]
        } err]} {
            #debug $err
            catch {unset ::links($link)}
            catch {http::cleanup $tok}
            if {$old} {
                file rename -force $fpath.old $fpath
                display_image $c $tag $fname
            }
        }
    }
}
proc display_image {c tag fname} {
    set fpath [file join $::satmap(dir) $fname]
    if {![file exists $fpath]} {return}
    if {[file size $fpath] < 100} {
        file delete -force $fpath; # it is likely a response in XML format
        return
    }
    set parts [file split $tag]
    set type [string range [lindex $parts 2] 0 end-1]
    # in case if user changes map type before dload finishes:
    if {[lcontain $::satmap(maptypes) $type] && $type ne $::satmap(type)} {return}
    catch {
    image create photo $tag -file $fpath
    lappend ::myImages(subPicts) $tag
    set ::myImages(subPicts) [lsort -unique $::myImages(subPicts)]
    set coords [getSubPictCoords $tag]
    $c create image $coords -image $tag -anchor nw -tags $tag -state disabled
    $c raise $tag mapSquare
    }
    update idletasks
    return $tag
}
proc showSublayer {c} {
    global layers myImages images
    if {!$myImages(showsublayer)} {return}
    if {!$myImages(pkg_loaded)} {
        set myImages(pkg_loaded) 1
        catch {package require Img}
    }
    setQuarters 0; #  
    updateStatus zoomLevel ": $layers(zoomLevel)"
    set ::maptype $::satmap(type)
    set zl       $layers(zoomLevel)
    set cellsize [expr {double($::satmap(tile))}]
    set bbox [getScreenBbox $c]
    foreach {x1 y1 x2 y2} $bbox {break}
    set sx [countCoords2 $::satmap(shiftx) 7 $zl]
    set sy [countCoords2 $::satmap(shifty) 7 $zl]
    set x1 [expr {$x1 - abs($sx)}]
    set y1 [expr {$y1 - abs($sy)}]
    set x2 [expr {$x2 + abs($sx)}]
    set y2 [expr {$y2 + abs($sy)}]
    set bbox [list $x1 $y1 $x2 $y2]
    set boxes [getBoxes $bbox $cellsize]
    set X {}; # images that will now be downloaded
    set basetag [file join . $images(imagedir) $::satmap(type)$zl]
    file mkdir [appFile $basetag]
    foreach box $boxes {
        lappend X [file join $basetag $box]
    }
    set d [diff $myImages(subPicts) $X]
    foreach pic $d {delete_image $c $pic}
    foreach box $boxes {
        getSubImageFromWeb $c $zl $box $basetag
    }
    download_images; # parallel (async.) download
}
proc delete_image {c pic} {
    catch {
        image delete $pic
        $c delete $pic
        $c dtag $pic
        set ::myImages(subPicts) [lsort -unique [delFromList $::myImages(subPicts) $pic]]
    }
}
proc setQuarters {v} {
    set ql [expr {$::layers(N) - 1}]
    set ::man_edit($ql) $v
    set ::man_vis($ql) $v
    set ::layers($ql,visible) $v
    set ::layers($ql,editable) $v
}
#substrate layer
proc toggleSublayer {c} {
    global myImages
    if {$myImages(showsublayer)} {
        set myImages(showsublayer) 0
        hideSublayer $c
    } else {
        set myImages(showsublayer) 1
        showSublayer $c
    }
}
proc sublayer_shift {c dx dy} {
    set idx [countCoords2 $dx 7 $::layers(zoomLevel)]
    set idy [countCoords2 $dy 7 $::layers(zoomLevel)]
    if {$::myImages(showsublayer)} {
        set ::satmap(shiftx) [expr {$::satmap(shiftx) + $dx}]
        set ::satmap(shifty) [expr {$::satmap(shifty) + $dy}]
        foreach pic $::myImages(subPicts) {
            $c move $pic $idx $idy
        }
    }
}
proc hideSublayer {c} {
    global myImages layers
    updateStatus zoomLevel ": $layers(zoomLevel)"
    foreach img $myImages(subPicts) {
        image delete $img
        $c delete $img
        $c dtag $img
    }
    set myImages(subPicts) {}
    set ::maptype ""
    setQuarters 1
}
proc getSubPictCoords {pict} {
    set YX [lindex [file split $pict] end]
    foreach {Y X} [split $YX ","] {break}
    set shiftx [countCoords2 $::satmap(shiftx) 7 $::layers(zoomLevel)]
    set shifty [countCoords2 $::satmap(shifty) 7 $::layers(zoomLevel)]
    set x [expr {$X * $::satmap(tile) + $shiftx}]
    set y [expr {$Y * $::satmap(tile) + $shifty}]
    return [list $x $y]
}
proc img_jpg {hdr4bytes} {
    set hdr "\xff\xd8"
    set bytes [string range $hdr4bytes 0 1]
    return [expr {$bytes eq $hdr}]
}
proc img_png {hdr4bytes} {
    set hdr "PNG"
    set bytes [string range $hdr4bytes 1 3]
    return [expr {$bytes eq $hdr}]
}
proc img_gif {hdr4bytes} {
    set hdr "GIF"
    set bytes [string range $hdr4bytes 0 2]
    return [expr {$bytes eq $hdr}]
}
proc img_tif {hdr4bytes} {
    set hdr1 "II"
    set hdr2 "MM"
    set bytes2 [string range $hdr4bytes 0 1]
    set bytes3 [string index $hdr4bytes 2]
    return [expr {$bytes3 eq "*" && ($bytes2 eq $hdr1 || $bytes2 eq $hdr2)}]
}
proc get_image_format {hdr4bytes} {
    if {[img_jpg $hdr4bytes]} {
        return "jpg"
    } elseif {[img_png $hdr4bytes]} {
        return "png"
    } elseif {[img_gif $hdr4bytes]} {
        return "gif"
    } elseif {[img_tif $hdr4bytes]} {
        return "tif"
    }
    return
}
proc debug {str} {
    catch {
        if {![info exists ::dbgfd]} {
            set ::dbgfd [open $::plot(dbgfile) w]
        }
        puts $::dbgfd $str
        flush $::dbgfd
    }
}
# usage: debugcaller
# debug caller's name
proc debugcaller {} {
    uplevel {
        array set _inform [info frame -3]
        if {![info exists _inform(proc)]} {return}
        if {[string match ::* $_inform(proc)]} {
           set _inform(proc) [string range $_inform(proc) 2 end]
        }
        debug "caller: $_inform(proc)"
    }
}
# usage: debugvars
# debug currently visible local&global vars
proc debugvars {} {
    uplevel {
        array set _inform [info frame -2]
        if {![info exists _inform(proc)]} {return}
        if {[string match ::* $_inform(proc)]} {
           set _inform(proc) [string range $_inform(proc) 2 end]
        }
        set _info ""
        set _args [info args $_inform(proc)]
        foreach varname [info vars] {
            if {![lcontain {_info _inform _args} $varname] && ![array exists $varname]} {
                if {[lcontain $_args $varname]} {set ast "*"} else {set ast ""}
                append _info "in proc $_inform(proc): $ast$varname={[set $varname]}\n"
            }
        }
        debug $_info
    }
}
# usage: debugvar varname
# debug proc name and value of specified variable
proc debugvar {varname} {
    uplevel "array set _inform \[info frame [info level]]
             if {!\[info exists _inform(proc)] || \[array exists $varname]} {return}
             set _info \"in proc \$_inform(proc): $varname={\$$varname}\n\"
             debug \$_info
             "
}
proc lastDay {year month} {
    return [clockFormat %d [clock scan "+1 month -1 day" -base [clock scan "$month/01/$year"]]]
}
# number of days;
# set n [ndays 20120425 20120427]
proc ndays {lo hi} {
    if {$lo > $hi} {return 0}
    set n    [expr {$hi - $lo + 1}]
    set yhi  [string range $hi 0 3]; #year2
    set mhi  [string range $hi 4 5]; #mon2
    set loym [string range $lo 0 5]; #yearmonth1
    set lod  [string range $lo 6 7]; #day1
    set hiym [string range $hi 0 5]; #yearmonth2
    set hid  [string range $hi 6 7]; #day2
    if {$n <= [lastDay $yhi $mhi]} {return $n}
    set n 0
    while {$loym < $hiym} {
        set ylo [string range $loym 0 3]; #year1
        set mlo [string range $loym 4 5]; #mon1
        incr n [lastDay $ylo $mlo];
        incr loym [expr {([string range $loym 4 5] == 12) ? 89 : 1}]
    }
    set hid [string trimleft $hid "0"]
    if {[lempty $hid] || ![string is integer -strict $hid]} {set hid 1}
    set lod [string trimleft $lod "0"]
    if {[lempty $lod] || ![string is integer -strict $lod]} {set lod 1}
    incr n [expr {$hid + 1 - $lod}]
    if {$n < 0} {set n 0}
    return $n
}
proc initZoomMenu {w c} {
    global layers hints myImages zoom
    menubutton $w.zmb -text " " -underline 0 \
        -direction below -menu $w.zmb.m -relief raised -image $myImages(zoommenu)
    menu $w.zmb.m -tearoff 0 -font $::fonts(txt)
    set zoom $layers(zoomLevel)
    for {set i 1} {$i <= 7} {incr i} {
        $w.zmb.m add radio -label $i -variable zoom -value $i -command "setZL $c $i"
    }
    pack $w.zmb -side left -padx 3 -pady 3
    set layers(tButs) [lsort -unique "$layers(tButs) $w.zmb "]
    if {[info exists hints(choosezoom)]} {
        bind $w.zmb <Any-Enter> "showHint {$hints(choosezoom)} {$w.zmb} %W %X %Y"
        bind $w.zmb <Motion>    "showHelp %X %Y %W {$hints(choosezoom)}"
        bind $w.zmb <Any-Leave> "hideHint"
    }
}
proc initLayerMenu {w c} {
    global layers hints myImages toplayer
    menubutton $w.lmb -text " " -underline 0\
        -direction below -menu $w.lmb.m -relief raised -image $myImages(layermenu)
    menu $w.lmb.m -tearoff 0 -font $::fonts(txt)
    for {set i 0} {$i < $layers(N)} {incr i} {
        $w.lmb.m add radio -label $layers($i) -variable toplayer -value $i -command "setTopLayer $c $i"
    }
    pack $w.lmb -side left -padx 3 -pady 3
    set layers(tButs) [lsort -unique "$layers(tButs) $w.lmb "]
    if {[info exists hints(chooselayer)]} {
        bind $w.lmb <Any-Enter> "showHint {$hints(chooselayer)} {$w.lmb} %W %X %Y"
        bind $w.lmb <Motion>    "showHelp %X %Y %W {$hints(chooselayer)}"
        bind $w.lmb <Any-Leave> "hideHint"
    }
}
proc initMapsMenu {w c} {
    global hints satmap layers
    menubutton $w.mmb -text " " -underline 0 \
        -direction below -menu $w.mmb.m -relief raised
    menu $w.mmb.m -tearoff 0 -font $::fonts(txt)
    set ::maptype ""
    if {$::myImages(showsublayer)} {set ::maptype $satmap(type)}
    foreach title $satmap(maptitles) type $satmap(maptypes) {
        $w.mmb.m add radio -label $title -variable ::maptype -value $type -command "setMapType $c $type"
    }
    pack $w.mmb -side left -padx 3 -pady 3
    set layers(tButs) [lsort -unique "$layers(tButs) $w.mmb "]
    if {[info exists hints(choosemaptype)]} {
        bind $w.mmb <Any-Enter> "showHint {$hints(choosemaptype)} {$w.mmb} %W %X %Y"
        bind $w.mmb <Motion>    "showHelp %X %Y %W {$hints(choosemaptype)}"
        bind $w.mmb <Any-Leave> "hideHint"
    }
    if {$::myImages(showsublayer)} {setMapType $c $satmap(type)}
}
proc setMapType {c type} {
    if {$type ne $::satmap(type)} {
        hideSublayer $c
    }
    set ::satmap(type) $type
    set ::myImages(showsublayer) 1
    showSublayer $c
}
proc multi_getOverlap {w} {
    set mcoords [$w coords multibox]
    foreach {x1 y1 x2 y2} $mcoords {}
    set elts ""
    catch {set elts [$w find overlapping $x1 $y1 $x2 $y2]}
    if {![lempty $elts]} {
        set str ""
        foreach elt $elts {
            set tag [getComplexTag $w $elt]
            set state ""
            catch {set state [lindex [$w itemconfig $tag -state] end]}
            set class [getClass $w $tag]
            if {$state ne "disabled" && $tag ne "multibox" && $tag ne "pointer" && $tag ne "mapSquare" && ![lempty $class] && ![regexp {nodeOval} $tag]} {
                lappend str $tag
            }
        }
        if {![lempty $str]} {
            return [lsort -unique $str]
        }
    }
}
proc multi_changeCoords {w x y} {
    global multi
    set x [$w canvasx $x]
    set y [$w canvasy $y]
    set oldCoords [$w coords multibox]
    foreach {oldx1 oldy1 oldx2 oldy2} {0 0 0 0} {break}
    foreach {oldx1 oldy1 oldx2 oldy2} $oldCoords {break}
    if {$x > $oldx1 && $y < $oldy2} {
        set newCoords "$multi(startX) $y $x $multi(startY)"
    }
    if {$x <= $oldx2 && $y <= $oldy2} {
        set newCoords "$x $y $multi(startX) $multi(startY)"
    }
    if {$x <= $oldx2 && $y >= $oldy1} {
        set newCoords "$x $multi(startY) $multi(startX) $y"
    }
    if {$x >= $oldx1 && $y >= $oldy1} {
        set newCoords "$multi(startX) $multi(startY) $x $y"
    }
    catch {$w coords multibox $newCoords}
}
proc multi_createBox {w x1 y1 x2 y2} {
    global multi
    multi_delMultiBox $w
    $w create rectangle $x1 $y1 $x2 $y2 -tags multibox\
        -outline grey2 -dash {1 1}
    set multi(startX) $x1
    set multi(startY) $y1
}
proc multi_selectScreenElts {w} {
    set bbox [getScreenBbox $w]
    foreach {x1 y1 x2 y2} $bbox {}
    multi_createBox $w $x1 $y1 $x2 $y2
    set selection [multi_getOverlap $w]
    multi_delMultiBox $w
    if {[lempty $selection]} {return}
    setSelect $w $selection 1
}
proc multi_delMultiBox {w} {
    global multi
    $w delete multibox
    $w dtag multibox
    set multi(startX) 0
    set multi(startY) 0
    bind $w <Motion> ""
}
proc multi_selectObjects {w} {
    global plot
    set selection [multi_getOverlap $w]
    if {[lempty $selection]} {removeSelection $w; return}
    set toadd [diff $selection $plot(selected)]; # to add to selection
    set torem [diff $plot(selected) $selection]; # to remove from selection
    foreach el $torem {
        unSelect $w $el
    }
    foreach el $toadd {
        setSelect $w $el 0
    }
    update idletasks
}
proc delFromList {list elt} {
    if {![lcontain $list $elt]} {return $list}
    return [lsearch -all -inline -not $list $elt]
}
proc getObjNameByID {id} {
    global objects
    set objName ""
    catch {set objName [getStr [lindex $objects($id) 2]]}
    return "$objName"
}
proc unSelect {w obj} {
    global nodes plot complex
    set obj [getComplexTag $w $obj]
    if {[lempty $obj] || ![info exists nodes($obj,N)]} {return}
    for {set i 0} {$i < $nodes($obj,N)} {incr i} {
        set class   [getClass $w $obj]
        set selElts [expr {($class eq "TOP") ? "TOPLine+$obj" : [getAllTags $w $obj]}]
        foreach elt $selElts {
            set ovalTag "$elt+nodeOval_$i"
            $w delete $ovalTag
            $w dtag $ovalTag
        }
    }
    if {$complex(activeTOPLine) eq "TOPLine+$obj"} {
        hideActiveTOPLine $w
    }
    set plot(selected) [getStr [delFromList $plot(selected) $obj]]
    if {[lempty $plot(selected)]} {hideDotBinds $w}
}
proc isSelected {elt} {
    return [lcontain $::plot(selected) $elt]
}
proc getBboxArea {w coords} {
    set a 0
    set b 0
    catch {
        set bbox [getBbox $w $coords]
        foreach {x1 y1 x2 y2} $bbox {}
        set a  [expr {abs($x1-$x2)}]
        set b  [expr {abs($y1-$y2)}]
    }
    return [expr {$a*$b}]
}
proc getCoords {id} {
    global objects
    if {![info exists objects($id)] || [lempty $objects($id)]} {return}
    set obj    $objects($id)
    set params [lindex $obj 3]
    set coords [lindex $params 1]    
    return $coords
}
proc moveMapView {w dx dy} {
    set xact 0
    set yact 0
    set widget $w
    if {$widget ne ""} {
        if {[catch "$widget cget -xscrollcommand" xcmd]} {return}
        if {[catch "$widget cget -yscrollcommand" ycmd]} {return}
        if {$xcmd ne ""} {
            set xscroller [lindex $xcmd 0]
            set xact 1
        }
        if {$ycmd ne ""} {
            set yscroller [lindex $ycmd 0]
            set yact 1
        }
    }
    set cmd ""
    if {$dx != 0 && $xact} {
        set cmd "[$xscroller cget -command] scroll [expr 10*$dx] units"
    } elseif {$dy != 0 && $yact} {
        set cmd "[$yscroller cget -command] scroll [expr 10*$dy] units"
    }
    eval $cmd
    catch {updateCanvas $widget 1.0}
    changeMCRectCoords $widget
}
proc moveSelection {w dx dy} {
    global plot
    if {![llength $plot(selected)]} {
        moveMapView $w $dx $dy
        return
    }
    foreach elt $plot(selected) {
        $w move $elt $dx $dy
        setParams $w $elt
        setChangeState $w $elt 1
    }
    foreach tag $plot(selected) {
        set id [takeID $tag]
        set class [getClassByTag $tag]
        if {$class eq "dot"} {showDotBinds $w $id}
    }
}
proc setZL {w newZL} {
    set width   [winfo width  $w]
    set height  [winfo height $w]
    set centerX [expr {$width  / 2}]
    set centerY [expr {$height / 2}]
    setZoomLevel $w $newZL $centerX $centerY
}
proc toMeters {pixels} {
    set crd [countCoords2 $pixels $::layers(zoomLevel) 7]
    return [expr {double($::canvas(m_in_px)*$crd)}]
}
proc toPixels {meters} {
    return [countCoords [expr {double($::canvas(px_in_m)*$meters)}] 7]
}
proc showObject {w srvid} {
    global objects layers grid srvids
    set obj $objects($srvid)
    if {![llength $obj] || [llength $obj] < $objects(nFields)} {return}
    if {[isShown $srvid]} {return}
    addToShown $srvid
    set tag     [getTagBySrvID $srvid]
    set lname   [getStr [lindex $obj 1]]
    if {![info exists layers($lname)]} { return }
    set layerID $layers($lname)
    set objID   [getObject $tag]
    set class   [getClassByTag $tag]
    set params  [lindex $obj 3]
    set zl      [lindex $params 0]
    set oldCrds [lindex $params 1]
    set addPars [lindex $params 2]
    set newCrds [countCoords $oldCrds $zl]
    switch $class {
        polygon {
            eval [subst "$w create $class $newCrds -tags $tag $addPars"]
            applyParams $w $tag $objID $layerID
        }
        line {
            eval [subst "$w create $class $newCrds -tags $tag $addPars"]
            applyParams $w $tag $objID $layerID
        }
        text {
            eval [subst "$w create text $newCrds -tags $tag -text {[lindex $params 2]} [lindex $params 3]"]
            applyParams $w $tag $objID $layerID
        }
        bridge {
            createBridge $w $newCrds $objID $layerID $srvid
        }
        dot {
            drawDot $w [lindex $newCrds 0] [lindex $newCrds 1] {} {} $srvid
        }
        TOP {
            $w create line $newCrds -tags "TOPLine+$tag" -state hidden
            arrangeTOP $w "$addPars" $objID $tag $layerID $newCrds "default"
        }
        default {return}
    }
    positionElt $w $srvid
    updateBalloon $w $tag
}
proc updateBalloon {w tag} {
    set type  [getParam $tag 4]
    set state [getParam $tag 5]
    set name  [getParam $tag 6]
    set addr  [getParam $tag 7]
    set comm  [getParam $tag 8]
    set class [getClassByTag $tag]
    set res   ""
    if {![lempty $name]} {
        append res ": $name\n"
    }
    if {![lempty $addr]} {
        append res ": $addr\n"
    }
    if {$class eq "line"} {
        set len [getLength $w $tag]
        append res ": $len .\n"
    }
    if {$class eq "line" || $class eq "dot"} {
        if {[llength $type]} {append res ": $type\n"}
        if {[llength $state]} {append res ": $state\n"}
    }
    if {![lempty $comm]} {
        append res ":\n$comm\n"
    }
    if {[info exists ::sensor_data($name)]} {
        append res "\n:\n$::sensor_data($name)\n"
    }
    set res [string trimright $res \n]
    setBalloon $w $tag "$res"
}
proc getLength {w tag} {
    set coords [$w coords $tag]
    set pix 0
    set x0 [lindex $coords 0]
    set y0 [lindex $coords 1]
    set coords [lrange $coords 2 end]
    foreach {x y} $coords {
        set dx [expr {$x-$x0}]
        set dy [expr {$y-$y0}]
        set hyp [expr {hypot($dx,$dy)}]
        set pix [expr {$pix+$hyp}]
        set x0 $x
        set y0 $y
    }
    return [expr {round([toMeters $pix])}]
}
proc setSelect {w selected delSelected} {
    global nodes plot layers complex
    if {$delSelected} {removeSelection $w}
    hideActiveTOPLine $w
    set tops ""
    set rad $plot(ovalRad)
    foreach sel $selected {
        set nodes($sel,N) 0
        set class [getClass $w $sel]
        set selElts [expr {($class eq "TOP") ? "TOPLine+$sel" : [getAllTags $w $sel]}]
        if {$class eq "image"} {
            updateStatus objInfo {}
            continue
        }
        if {$class eq "TOP"} {
            set tops [concat $tops $selElts]
        }
        foreach elt $selElts {
            set coords [$w coords $elt]
            if {[llength $coords]==0} {
                updateStatus objInfo {}
                continue
            }
            set i 0
            if {[smoothedObject $elt]} {
                set npnts [expr [llength $coords]/2]
                for {set i 0} {$i < $npnts} {incr i} {
                    set ovalTag "$elt+nodeOval_$i"
                    foreach {x y} [bezierCoords $coords $i] {break}
                    $w create oval [nodeOvalCoords $x $y $rad] -fill white -tags $ovalTag
                    group $w nodeOvals $ovalTag
                    group $w $sel $ovalTag
                }
            } else {
                foreach {x y} $coords { 
                    set ovalTag "$elt+nodeOval_$i"
                    $w create oval [nodeOvalCoords $x $y $rad] -fill white -tags $ovalTag
                    group $w nodeOvals $ovalTag
                    group $w $sel $ovalTag
                    incr i
                }
            }
            incr nodes($sel,N) $i
            update idletasks
        }
        $w bind nodeOvals <Any-Enter> "$w itemconfig current -fill red"
        $w bind nodeOvals <Any-Leave> "$w itemconfig current -fill white"
        if {![lcontain $plot(selected) $sel]} {
            lappend plot(selected) $sel
        }
        if {[llength $tops]==1} {
            set complex(activeTOPLine) "[getStr $tops]"
            showActiveTOPLine $w
        }
        #group $w selected nodeOvals
        $w raise nodeOvals
        if {[llength $plot(selected)]==1} {
            displayProps $w $plot(selected)
        } else {
            updateStatus objInfo " "
            hideDotBinds $w
        }
    }
    #       ,     ,
    #       
    if {0} {; # disabled 8.04.2014
        set binds {}
        if {[llength $plot(selected)]==1} {
            set sel $plot(selected)
            set class [getClass $w $sel]
            set id [takeID $sel]
            if {$class eq "dot" && [info exists ::binds($id)]} {
                set binds [concat $binds $::binds($id)]
                showDotBinds $w $id
                foreach id $binds {
                    set tag [getTagBySrvID $id]
                    setSelect $w $tag 0; # add to selection
                }
            }
        }
    }

    #   ,      ,
    #    
    if {0} {
        if {[llength $plot(selected)]==1} {
            set dots {}
            set id [takeID $plot(selected)]
            if {[info exists ::chbinds($id)]} {
                foreach did $::chbinds($id) {
                    set tag [getTagBySrvID $did]
                    lappend dots $tag
                }
                if {![lempty $dots]} {
                    setSelect $w $dots 0
                }
            }
        }
    }
}
proc nodeOvalCoords {x y rad} {
    return [list [expr {$x - $rad}] [expr {$y - $rad}] \
                 [expr {$x + $rad}] [expr {$y + $rad}]]
}
proc displayProps {w tag} {
    set info    ""
    set general ""
    set len     ""
    catch {
        set general ": [getObjectName $tag]"
    }
    set class [getClassByTag $tag]
    if {$class eq "line"} {
        set len [getLength $w $tag]
    }
    set type  [getParam $tag 4]
    set state [getParam $tag 5]
    set name  [getParam $tag 6]
    set addr  [getParam $tag 7]
    set comm  [getParam $tag 8]
    if {![lempty $general]} {
        set info "$info$general. "
    }
    if {![lempty $len]} {
        set info "$info : $len . "
    }
    if {![lempty $type]} {
        set info "$info : $type. "
    }
    if {![lempty $state]} {
        set info "$info : $state. "
    }
    if {![lempty $name]} {
        set info "$info : $name. "
    }
    if {![lempty $addr]} {
        set info "$info : $addr. "
    }
    if {![lempty $comm]} {
        set info "$info : $comm."
    }
    updateStatus objInfo $info
}
proc removeSelection {w} {
    global plot
    $w dtag selected
    $w delete nodeOvals
    set plot(selected) ""
    hideDotBinds $w
    updateStatus objInfo {}
}
proc addToSelection {w x y} {
    global plot complex
    set class [getClass $w current]
    if {[lempty $class] || $class eq "nodeOvals"} {return}
    set tag [getComplexTag $w current]
    if {[lcontain $plot(selected) $tag]} {
        unSelect $w $tag
        if {[llength $plot(selected)]==1} {
            displayProps $w $plot(selected)
        }
        return
    }
    group $w selected current
    set plot(lastX) [$w canvasx $x]
    set plot(lastY) [$w canvasy $y]
    bind $w <Motion> ""
    bind $w <ButtonRelease-1> "plotMoveStop $w $tag"
    if {$class eq "TOP" && ![regexp {^TOPLine} [getTag $w current]]} {
        hideActiveTOPLine $w
        set complex(activeTOPLine) "TOPLine+$tag"
        showActiveTOPLine $w
        group $w $complex(activeTOP) $complex(activeTOPLine)
        setSelect $w $tag 0
    } elseif {$class ne "image"} {
        setSelect $w $tag 0
    }
}
proc initNodeMove {w x y cmd} {
    global nodes
    set nodes(lastNode) [getTag $w current]
    set nodes(lastX) $x
    set nodes(lastY) $y
    $w dtag selected
    group $w selected current
    bind $w <Motion> "nodeMove $w %x %y"
    bind $w <ButtonRelease-1> "$cmd"
}
proc plotEdit {w x y} {
    global plot nodes complex
    set class [getClass $w current]
    if {$class eq "balloon"} {return}
    if {[lempty $class]} {
        removeSelection $w
        hideActiveTOPLine $w
        multi_createBox $w [$w canvasx $x] [$w canvasy $y] [$w canvasx $x] [$w canvasy $y]
        bind $w <Motion> "multi_changeCoords $w %x %y"
        bind $w <Motion> "+multi_selectObjects $w"
        bind $w <ButtonRelease-1> "multi_delMultiBox $w"
        return
    }
    if {$class eq "nodeOvals"} {
        initNodeMove $w [$w canvasx $x] [$w canvasy $y] "nodeMoveStop $w"
        return
    }
    set tag [getComplexTag $w current]
    set sel $plot(selected)
    removeSelection $w
    $w dtag selected
    group $w selected current
    set plot(lastX) [$w canvasx $x]
    set plot(lastY) [$w canvasy $y]
    bind $w <Motion> "plotMove $w %x %y"
    bind $w <ButtonRelease-1> "plotMoveStop $w $tag"
    if {$class eq "TOP" && ![regexp {^TOPLine} [getTag $w current]]} {
        selectTOP $w $tag
    } elseif {$class ne "image"} {
        if {$class eq "text" && [lsearch $sel $tag] != -1} {
            catch {setText $w $x $y "[getObject $tag]" 0}
            bind $w <Motion> ""
            bind $w <ButtonRelease-1> ""
        }
        setSelect $w $tag 1
    }
}
proc dot_nodeMoveStop {w l obj} {
    global plot
    setParams $w $plot(selected)
    setChangeState $w $plot(selected) 1
    bind $w <Motion> ""
    bind $w <ButtonPress-1> "drawDot $w %x %y $obj $l {}"
}
proc getClassByTag {tag} {
    set class ""
    regexp {^([a-zA-Z]+)} $tag class
    return $class
}
proc getAllTags {w tag} {
    global complex
    set tag [getComplexTag $w $tag]
    set class [getClass $w $tag]
    if {[info exists complex($tag)]} {        
        if {$class eq "dot"} {
            return [lindex $complex($tag) end]
        } else {return $complex($tag)}
    }
    return $tag
}
proc updateStatus {args} {
    global status layers canvas
    set keyWord [lindex $args 0]
    if {$keyWord eq "coords"} {
        # no need in this anymore:
        #set w [lindex $args 1]
        #if {[lempty $w]} {set status(coords) "X: ?; Y: ?"; return}
        #set x [$w canvasx [lindex $args 2]]
        #set y [$w canvasy [lindex $args 3]]
        #set val "X: $x; Y: $y"
        set val ""
    } else {
        set val [lindex $args 1]
    }
    if {$keyWord eq "zoomLevel"} {
        if {$::myImages(showsublayer)} {append val " (.)"}
    }
    set status($keyWord) $val
    update idletasks
}
proc deselAllLayers {} {
    global layers man_vis man_edit
    for {set i 0} {$i < $layers(N)} {incr i} {
        set man_vis($i) 0
        set man_edit($i) 0
    }
}
proc selAllLayers {} {
    global layers man_vis man_edit
    for {set i 0} {$i < $layers(N)} {incr i} {
        set man_vis($i) 1
        set man_edit($i) 1
    }
}
proc getScreenBoxes {w} {
    set screenBbox [getScreenBbox $w]
    return [getBoxes $screenBbox $::grid(csize) $::layers(zoomLevel)]
}
proc getScreenBbox {w} {
    set width  [winfo width $w]
    set height [winfo height $w]
    set x [$w canvasx 0]
    set y [$w canvasy 0]
    set X [expr {$x+$width}]
    set Y [expr {$y+$height}]
    return [list $x $y $X $Y]
}
proc countBox {x y cellSize} {
    return [list [expr {int(floor($y/$cellSize))}] [expr {int(floor($x/$cellSize))}]]
}
proc getBoxes {bbox cellSize {zl {}}} {
    if {[llength $zl]} {set bbox [countCoords2 $bbox $zl 7]}
    foreach {x1 y1 x2 y2} $bbox {break}
    set box1 [countBox $x1 $y1 $cellSize]
    set box3 [countBox $x2 $y2 $cellSize]
    foreach {I1 J1} $box1 {break}
    foreach {I3 J3} $box3 {break}
    set minI [min2 $I1 $I3]
    set maxI [max2 $I1 $I3]
    set minJ [min2 $J1 $J3]
    set maxJ [max2 $J1 $J3]
    set boxes {}
    for {set i $minI} {$i <= $maxI} {incr i} {
        for {set j $minJ} {$j <= $maxJ} {incr j} {
            lappend boxes $i,$j
        }
    }
    return [lsort -unique $boxes]
}
proc getAllParams {w args} {
    global layers objects parameters classes
    set elt ""
    if {[llength $args]==1} {
        set elt    $args
        set layer  [getLayer  $elt]
        set objNum [getObject $elt]
    } elseif {[llength $args]==2} {
        set layer  [lindex $args 0]
        set objNum [lindex $args 1]
    } else {return}
    if {![string is integer -strict $layer] || $layer >= $layers(N)} {return}
    set srvid  [takeID $elt]
    set type   ""
    set state  ""
    catch {set type  [getStr [lindex $objects($srvid) 4]]}
    catch {set state [getStr [lindex $objects($srvid) 5]]}
    if {$layers($layer,editable)} {
        set st "normal"
    } else {set st "disabled"}
    set layerState [expr {($layers($layer,visible)) ? \
            $st : "hidden"}]
    if {[info exists parameters($layer,$objNum,$layers(zoomLevel),$type,$state)]} {
        array set pars $parameters($layer,$objNum,$layers(zoomLevel),$type,$state)
        if {[info exists objects($srvid)] && ![lempty $elt] && [info exists pars(-minarea)]} {
            set coords [countCoords [getCoords $srvid] 7]
            set area   [getBboxArea $w $coords]
            if {$area < $pars(-minarea)} {
                return "-state hidden"
            }
        }
        if {$layerState eq "hidden"} {
            return "-state hidden"
        }
        set ret "$parameters($layer,$objNum,$layers(zoomLevel),$type,$state)"
        if {$ret ne "-state hidden"} {
            return "$ret -state $layerState"
        }
        return $ret
    }
    set typepars  ""
    set statepars ""
    set typepars  [expr {(![lempty $type]) ?\
            [getTypeParams "$type" $objNum $layer] :\
            [getDefaultTypeParams $objNum $layer]}]
    set statepars [expr {(![lempty $state]) ?\
            [getStateParams "$state" $objNum $layer] :\
            [getDefaultStateParams $objNum $layer]}]
    set zoompars  [getParsByZoom $layers(zoomLevel) $objNum $layer]
    if {[lempty [getStr $statepars]]} {
        set statepars ""
    }
    if {[lempty [getStr $typepars]]} {
        set typepars ""
    }
    if {[lempty [getStr $zoompars]]} {
        set zoompars ""
    }
    set params "$zoompars $typepars $statepars"
    if {[llength $params] % 2} {return}
    array set pars $params
    if {![lempty $elt] && [info exists pars(-minarea)]} {
        set coords [countCoords [getCoords $srvid] 7]
        set area   [getBboxArea $w $coords]
        if {$area < $pars(-minarea)} {
            return "-state hidden"
        }
    }
    set parameters($layer,$objNum,$layers(zoomLevel),$type,$state) $params
    set ret $params
    if {[info exists pars(-state)]} {
        if {[subst $pars(-state)] eq "hidden"} {
            set ret "-state hidden"
            set parameters($layer,$objNum,$layers(zoomLevel),$type,$state) $ret
        } elseif {$layerState eq "hidden"} {
            set ret "-state hidden"
        } else {
            set ret "$ret -state $layerState"
        }
    } else {
        if {$layerState eq "hidden"} {
            set ret "-state hidden"
        } else {
            set ret "$ret -state $layerState"
        }
    }
    return $ret
}
proc zoomActivate {w} {
    unbindAll $w
    setCursor $w zoom
    bind $w <ButtonPress-1> "doZoom $w %x %y 2 1"
    bind $w <ButtonPress-3> "doZoom $w %x %y 0.5 1"
}
proc setZoomLevel {w lvl x y} {
    global layers
    if {$lvl == $layers(zoomLevel)} {return}
    if {$lvl eq "last"}  {set lvl 7}
    if {$lvl eq "first"} {set lvl 1}
    set lvl [expr int($lvl)]
    set diff [expr $lvl - $layers(zoomLevel)]
    doZoom $w $x $y [expr {pow(2,$diff)}] 1
}
proc doZoom {w x y val change} {
    global plot layers canvas cancel zoom
    set cancel 1
    set zl [expr {int($layers(zoomLevel) + log10($val)/log10(2))}]
    if {$zl < 1 || $zl > 7 || $canvas(busy)} {return}
    set layers(zoomLevel) $zl
    set zoom $zl
    set canvas(size) [getCanvasSize $zl]
    if {$change} {
        set x [$w canvasx $x]
        set y [$w canvasy $y]
    }
    hideSublayer $w
    update
    $w delete nodeOvals
    $w dtag nodeOvals
    $w dtag selected
    updateStatus zoomLevel ""
    $w scale all 0 0 $val $val
    $w configure -scrollregion [canvasBbox]
    doMove $w $x $y $val
    update idletasks
    if {![lempty $plot(selected)]} {
        setSelect $w $plot(selected) 1
    }
    updateStatus zoomLevel ": $layers(zoomLevel)"
}
proc canvasBbox {} {
    set csize [getCanvasSize $::layers(zoomLevel)]
    return [list [expr {-$csize/2.0}] [expr {-$csize/2.0}] [expr {$csize/2.0}] [expr {$csize/2.0}]]
}
proc doMove {w x y val} {
    if {$val==1.0} {
        set x [$w canvasx $x]
        set y [$w canvasy $y]
    } 
    set x [expr {$val*$x}]
    set y [expr {$val*$y}]
    moveCenter $w $x $y $val
}
# diff:     list1,    list2.
proc diff {list1 list2} {
    foreach v $list1 {set la1($v) {}}
    foreach v $list2 {
        if {[info exists la1($v)]} {
            unset la1($v)
        }
    }
    return [lsort [array names la1]]
}
proc moveCenter {w x y val} {
    global cancel updateBusy
    centerScreen $w $x $y
    update
    if {$updateBusy} {
        set cancel 1
    } else {set cancel 0}
    updateCanvas $w $val
}
# just a handy proc;
# draws map rectangles 500x500px
proc draw_test_grid {w boxes} {
    global grid
    if {[info exists ::allbx]} {
        foreach box $::allbx {
            catch { $w delete _r$box
                $w dtag _r$box }
            catch { $w delete _t$box
                $w dtag _t$box }
        }
    }
    foreach box $boxes {
        foreach {I J} [split $box ,] {break}
        set x1 [expr {$J*$grid(csize)}]
        set y1 [expr {$I*$grid(csize)}]
        set x2 [expr {($J+1)*$grid(csize)}]
        set y2 [expr {($I+1)*$grid(csize)}]
        set tx [expr {($x1 + $x2) / 2.0}]
        set ty [expr {($y1 + $y2) / 2.0}]
        $w create rect [list $x1 $y1 $x2 $y2] -tags _r$box
        $w create text [list $tx $ty] -text $box -tags _t$box
        lappend ::allbx $box
    }
}
#   : , ,  ;
#  ( )  ,       ;
#     ,      ;
#      
proc updateCanvas {w val} {
    global grid classes objects inlayer zhidden layers \
        cancel srvids every updateBusy
    set boxes [getScreenBoxes $w]
    #draw_test_grid $w $boxes
    set X {}
    foreach box $boxes {
        if {![info exists grid($box)]} {
            set grid($box) {}
            continue
        }
        set X [concat $X $grid($box)]
    }
    set X1 $zhidden($layers(zoomLevel))
    loop i 0 $layers(N) {
        if {!$layers($i,visible)} {
            set X1 [concat $X1 $inlayer($i)]
        }
    }
    set X [diff $X $X1]; # ,    .
    set Y $grid(shown);  # ,  .
    #eltsToAdd - O,   .
    #delElts - O,   .
    #chStylesElts - O,     .
    set needLock [expr {![lempty $X] || ![lempty $Y]}]
    if {$needLock} {
        lockAllButtons $w 1
    }
    lassign [intersect3 $X $Y] eltsToAdd chStylesElts delElts
    if {$val == 1.0} {set chStylesElts {}}
    set count 0
    foreach obj $chStylesElts {
        set tag [getTagBySrvID $obj]
        set lname   [getStr "[lindex $objects($obj) 1]"]
        if {![info exists layers($lname)]} {continue}
        set layerID $layers($lname)
        if {$val=="edit"} {
            if {[isSelected $tag]} {unSelect $w $tag}
            set st [expr {($layers($layerID,editable)) ? "normal":"disabled"}]
            catch {$w itemconfigure $tag -state $st}
            continue
        }
        set objID [getObject $tag]
        applyParams $w $tag $objID $layerID
        if {[incr count] % $every == 0} {update idletasks}
    }
    addDelElts $w $eltsToAdd $delElts
    if {$needLock} {
        progress ""
        unlockAllButtons $w 1
    }
    showSublayer $w
}
proc addDelElts {w eltsToAdd delElts} {
    global cancel every updateBusy
    set updateBusy 1
    set count 0
    foreach obj $delElts {
        if {$cancel} {
            set cancel 0
            set updateBusy 0
            return
        }
        delObject $w $obj
        if {[incr count] % $every == 0} {update idletasks}
    }
    set count 0
    foreach elt $eltsToAdd {
        if {$cancel} {
            set cancel 0
            set updateBusy 0
            return
        }
        showObject $w $elt
        if {[incr count] % $every == 0} {update idletasks}
    }
    set updateBusy 0
}
proc centerScreen {w x y} {
    global canvas
    set cnt [getCenterCoords $w]
    foreach {cX cY} $cnt {}
    set dx [expr {int($x-$cX)}]
    set dy [expr {int($y-$cY)}]
    $w xview scroll $dx units
    $w yview scroll $dy units
    set canvas(cX) $x
    set canvas(cY) $y
    changeMCRectCoords $w
}
proc lockAllButtons {w cur} {
    set ::canvas(busy) 1
    return
    global layers canvas
    setTbButsState "disabled"
    updateStatus coords ""
    clearBinds $w
    #if {$cur} {cursor_toWatches $w}
    update
}
proc unlockAllButtons {w cur} {
    global layers canvas
    set canvas(busy) 0
    return
    setTbButsState "normal"
    if {$layers($layers(top),visible)} {
        if {$layers($layers(top),editable)} {
            set st "normal"
        } else {set st "disabled"}
        setLayerButsState $layers(top) $st
    } else {
        setLayerButsState $layers(top) "disabled"
    }    
    set canvas(busy) 0
    initBinds $w
    #if {$cur} {cursor_toNormal $w}
    update idletasks
}
proc cursor_toWatches {w} {
    global layers
    set cur [lindex [$w config -cursor] end]
    $w config -cursor watch    
    set layers(cur) $cur
    update idletasks
}
proc cursor_toNormal {w} {
    global layers
    $w config -cursor $layers(cur)
    update idletasks
}
proc delFromShown {id} {
    global grid
    set grid(shown,$id) 0
    set grid(shown) [delFromList $grid(shown) $id]
}
proc isShown {id} {
    if {![info exists ::grid(shown,$id)]} {return 0}
    return $::grid(shown,$id)
}
proc addToShown {id} {
    global grid
    set grid(shown,$id) 1
    lappend grid(shown) $id
    set grid(shown) [lsort -unique -integer $grid(shown)]
}
proc getNewCoords {id} {
    global objects
    set params  [lindex $objects($id) 3]
    set zlOld   [lindex $params 0]
    set oldCrds [lindex $params 1]
    return [countCoords $oldCrds $zlOld]
}
proc getBbox {w coords} {
    set minX [lindex $coords 0]
    set maxX $minX
    set minY [lindex $coords 1]
    set maxY $minY
    foreach {x y} $coords {
        if {$x < $minX} {set minX $x}
        if {$x > $maxX} {set maxX $x}
        if {$y < $minY} {set minY $y}
        if {$y > $maxY} {set maxY $y}
    }
    return [list $minX $minY $maxX $maxY]
}
proc boxesintersect {box1 box2} {
    foreach {x1 y1 x2 y2} $box1 {break}
    foreach {x3 y3 x4 y4} $box2 {break}
    return [expr {[box $x1 $x2 $x3 $x4] * [box $y1 $y2 $y3 $y4]}]
}
proc box {c1 c2 c3 c4} {
    return [expr {[max2 $c1 $c2] - [min2 $c1 $c2] + [max2 $c3 $c4] - [min2 $c3 $c4] >= [max4 $c1 $c2 $c3 $c4] - [min4 $c1 $c2 $c3 $c4]}]
}
proc max2 {a b} {
    return [expr {($a > $b) ? $a : $b}]
}
proc min2 {a b} {
    return [expr {($a < $b) ? $a : $b}]
}
proc max4 {a b c d} {
    return [max2 [max2 $a $b] [max2 $c $d]]
}
proc min4 {a b c d} {
    return [min2 [min2 $a $b] [min2 $c $d]]
}
proc initGridBoxes {} {
    global grid
    set cellSize $::grid(csize)
    set canvSize [getCanvasSize 7]
    set max      [expr {int(ceil($canvSize/$cellSize))}]
    set from [expr {-int(ceil($max/2.0))}]
    set to [expr {-$from}]
    for {set i $from} {$i < $to} {incr i} {
        for {set j $from} {$j < $to} {incr j} {
            set grid($i,$j) [list]
        }
    }
}
proc countGrid {w id} {
    global grid
    if {[info exists grid($id)]} {
        set oldBoxes $grid($id)
        foreach box $oldBoxes {
            set grid($box) [delFromList $grid($box) $id]
        }
    }
    set coords [getCoords $id]
    set bbox   [getBbox $w $coords]
    set boxes  [getBoxes $bbox $grid(csize)]
    foreach box $boxes {
        lappend grid($box) $id
    }
    set grid($id) $boxes
}
proc getDotCoords {w x y style r} {
    if {![dotStyle $style]} {return}
    switch $style {
        trUp    {return "$x [expr {$y-$r}] [expr {$x+$r*sqrt(3)/2}] [expr {$y+$r/2}] [expr {$x-$r*sqrt(3)/2}] [expr {$y+$r/2}]"}
        trDn    {return "$x [expr {$y+$r}] [expr {$x+$r*sqrt(3)/2}] [expr {$y-$r/2}] [expr {$x-$r*sqrt(3)/2}] [expr {$y-$r/2}]"}
        diamond {return "$x [expr {$y-$r}] [expr {$x+$r}] $y $x [expr {$y+$r}] [expr {$x-$r}] $y"}
        circle  {return "[expr {$x-$r}] [expr {$y-$r}] [expr {$x+$r}] [expr {$y+$r}]"}
        box     {return "[expr {$x-$r}] [expr {$y-$r}] [expr {$x+$r}] [expr {$y-$r}] [expr {$x+$r}] [expr {$y+$r}] [expr {$x-$r}] [expr {$y+$r}]"}
        icon    {return "$x $y"}
        default {return}
    }
}
proc dotStyle {style} {
    return [lcontain {trUp trDn diamond circle box icon} $style]
}
proc getDotType {style} {
    switch $style {
        trUp    {return "polygon"}
        trDn    {return "polygon"}
        diamond {return "polygon"}
        box     {return "polygon"}
        circle  {return "oval"}
        icon    {return "image"}
        default {return}
    }
}
proc getTagBySrvID {srvid} {
    global objects classes tags
    if {[lempty $srvid] || ![info exists objects($srvid)]} {return}
    if {[info exists tags($srvid)]} {return $tags($srvid)}
    set lName   [getStr "[lindex $objects($srvid) 1]"]
    set oName   [getStr "[lindex $objects($srvid) 2]"]    
    set layerID [getLayerIDByName $lName]    
    if {$layerID eq ""} {return}
    set objID   [getObjectID $layerID $oName]
    set class   $classes($oName)
    set tag "$class${layerID}_${objID}_$srvid"
    set tags($srvid) $tag
    return $tag
}
proc search {w} {
    global s_name s_addr s_comm plot
    set s $w.srch
    if {[winfo exists $s]} {
        set x [winfo x $s]
        set y [winfo y $s]
    } else {
        set x [expr {[winfo width $w] / 2 - 100}]
        set y [expr {[winfo height $w] / 2 - 100}]
    }
    catch {destroy $s}
    catch {toplevel $s}
    wm title $s " ."
    if {[unixPlatform]} {wm iconbitmap $s @[file join . img botikmap.xbm]}
    catch {wm deiconify $s; raise $s;}
    focus -force $s
    frame $s.top
    frame $s.mid1
    frame $s.mid2
    pack $s.top $s.mid1 $s.mid2 -side top
    set tfont  $::fonts(txt)
    set bfont  $::fonts(buts)
    set bfontb $::fonts(butsb)
    set hfont  $::fonts(heads)
    label $s.top.l -text " \n" -font $hfont
    pack $s.top.l -side top -pady 3
    initSearchVars $w
    button $s.mid1.selectLayers -text " " -command "selectLayers $s" \
        -activebackground [activeClr] -highlightbackground [activeClr] -width 14 -font $bfont
    button $s.mid1.selectObjects -text " " -command "selectObjects $s" \
        -activebackground [activeClr] -highlightbackground [activeClr] -width 16 -font $bfont
    pack $s.mid1.selectLayers $s.mid1.selectObjects -side left -expand yes -fill x -padx 3 -pady 3
    button $s.mid2.selectTypes -text " " -command "selectTypes $s" \
        -activebackground [activeClr] -highlightbackground [activeClr] -width 14 -font $bfont
    button $s.mid2.selectStates -text " " -command "selectStates $s" \
        -activebackground [activeClr] -highlightbackground [activeClr] -width 18 -font $bfont
    pack $s.mid2.selectTypes $s.mid2.selectStates -side left -expand yes -fill x -padx 3 -pady 3
    frame $s.mid3
    pack $s.mid3 -side top
    set s_name ""
    set s_addr ""
    set s_comm ""
    label $s.mid3.lname -text ":" -font $tfont
    label $s.mid3.laddr -text ":" -font $tfont
    label $s.mid3.lcomm -text ":" -font $tfont
    entry $s.mid3.name -textvar s_name -takefocus 1 -width 25 -font $tfont
    entry $s.mid3.addr -textvar s_addr -takefocus 1 -width 25 -font $tfont
    entry $s.mid3.comm -textvar s_comm -takefocus 1 -width 25 -font $tfont
    setRussianKeys $s.mid3.name $s.mid3.addr $s.mid3.comm
    focus -force $s.mid3.name
    pack $s.mid3.lname $s.mid3.name $s.mid3.laddr $s.mid3.addr $s.mid3.lcomm $s.mid3.comm -side top -pady 3 -padx 2
    frame $s.but
    pack $s.but -side top
    button $s.but.bNormal -text "" -command "startSearch $w normal"\
        -width 7 -padx 5 -relief raised\
        -activebackground [activeClr] -highlightbackground [activeClr] -font $bfontb
    button $s.but.bRad -text " " -command "startSearch $w rad"\
        -width 23 -padx 5 -relief raised \
        -activebackground [activeClr] -highlightbackground [activeClr] -font $bfont
    pack $s.but.bNormal $s.but.bRad -expand yes -side left -pady 5 -padx 5
    frame $s.bot
    pack $s.bot -side bottom
#    button $s.bot.bCanc -text "  " -command "destroy $s" -width 7 -padx 5 -relief raised \
            -activebackground [activeClr] -highlightbackground [activeClr] -font $tfont
#    pack $s.bot.bCanc -expand no -side top
    bind $s <KeyPress-Return> "$s.but.bNormal invoke"
    bind $s <KeyPress-Escape> "destroy $s"
    update
}
proc s_getResults {mode} {
    global s_name s_addr s_comm objects ids search
    set objs        [getSelectedObjects]
    set sel_types   [getSelectedTypes]
    set sel_states  [getSelectedStates]
    set all_types   [getSrchTypes]
    set all_states  [getSrchStates]
    set nsel_types  [diff "$all_types"  "$sel_types"]
    set nsel_states [diff "$all_states" "$sel_states"]
    set types       {}
    set states      {}
    set res         {}
    set prim        {}
    foreach obj $objs {
        set oName "[s_getObjName $obj]"
        set lName $objects(layer,$oName)
        set prim [concat $prim $ids($lName,$oName)]
    }
    foreach type $nsel_types {
        set typeName "[s_getTypeName $type]"
        set types    "$types {$typeName}"
    }        
    foreach state $nsel_states {
        set stateName "[s_getStateName $state]"
        set states    "$states {$stateName}"
    }
    foreach id $prim {
        set type  [getStr [lindex $objects($id) 4]]
        set state [getStr [lindex $objects($id) 5]]
        set name  [string trimleft [getStr [lindex $objects($id) 6]] "-"]
        set addr  [string trimleft [getStr [lindex $objects($id) 7]] "-"]
        set comm  [string trimleft [getStr [lindex $objects($id) 8]] "-"]
        set found 0
        catch {
            set found [expr {[lsearch $types $type]==-1 && \
                [lsearch $states $state]==-1 && \
                [regexp -nocase $s_name $name] && \
                [regexp -nocase $s_addr $addr] && \
                [regexp -nocase $s_comm $comm]}]
        }
        if {$found} {
            if {$mode ne "rad" && [llength $res]==$search(limit)} {
                #alert " $search(limit) .\n,   ."
                break
            }
            lappend res $id
        }
    }
    return $res
}
proc startSearch {c mode} {
    global search
    lockAllButtons $c 1
    set search(res) [s_getResults $mode]
    set num [llength $search(res)]
    if {$mode eq "rad" && $num != 0} {
        progress "   ."
        focus -force .
        $c config -cursor crosshair
        bind $c <ButtonPress-1> "$c config -cursor watch; startRadSearch $c {$search(res)} %x %y"
        vwait search(res)
        unbindAll $c
        set num [llength $search(res)]
    }
    if {$num==0} {
        alert "  ."
    } else {
        printSrchResults $c $search(res)
    }
    unlockAllButtons $c 1
}
# sort id_list by objects addresses
proc sort_by_addr {id1 id2} {
    set a1 [getStr [lindex $::objects($id1) 7]]
    set a2 [getStr [lindex $::objects($id2) 7]]
    return [string compare -nocase $a1 $a2]
}
proc printSrchResults {w res} {
    global objects search num plot
    set r $w.sr
    catch {destroy $r}
    catch {toplevel $r}
    wm title $r " ."
    if {[unixPlatform]} {wm iconbitmap $r @[file join . img botikmap.xbm]}
    set x [expr {[winfo width  $w]/2+150}]
    set y [expr {[winfo height $w]/2-100}]
    #wm geometry $r +${x}+${y}
    set tfont $::fonts(txt)
    set bfont $::fonts(buts)
    #focus -force $r
    frame $r.buttons
    pack $r.buttons -side bottom -fill x -pady 2m
    button $r.buttons.bOK -text "" -command "destroy $r" -width 15\
        -activebackground [activeClr] -highlightbackground [activeClr] -font $bfont
    pack $r.buttons.bOK -side left -expand 1
    set num ": 0"
    frame $r.label
    pack $r.label -side bottom -fill x -pady 2m
    label $r.label.lbl -textvar num -font $tfont
    pack $r.label.lbl -side left
    set f [frame $r.frame]
    pack $f -expand yes -fill both -padx 1 -pady 1
    text $f.text -xscrollcommand "$f.xscr set" -yscrollcommand "$f.yscr set" \
        -width 60 -wrap none -font $tfont
    scrollbar $f.xscr -orient horizontal -command "$f.text xview"
    scrollbar $f.yscr -orient vertical -command "$f.text yview"
    grid $f.text $f.yscr -sticky nsew
    grid $f.xscr         -sticky nsew
    grid columnconfigure $f 0 -weight 1
    grid rowconfigure    $f 0 -weight 1
    set i 1    
    set style1 "-background DeepSkyBlue1 -relief flat -borderwidth 1"
    set style2 "-background {} -relief flat"
    $f.text delete 1.0 end
    $f.text insert end "      ()    (*)    ()\n"
    set res [lsort -command sort_by_addr $res]; # sort objects by address
    foreach id $res {
        if {[lempty $objects($id)]} {continue}
        set txt ""
        foreach pos {6 7 8} {
            set t [getStr [lindex $objects($id) $pos]]
            set t [string trimright $t *]
            if {[string length $t] > 50} {
                set t [string range $t 0 49]...
            }
            append txt "     ($t)"
        }
        $f.text insert end "$i.$txt\n" r$i
        $f.text tag bind r$i <Any-Enter> "$f.text tag configure r$i $style1; $f.text configure -cursor hand2"
        $f.text tag bind r$i <Any-Leave> "$f.text tag configure r$i $style2; $f.text configure -cursor top_left_arrow"
        $f.text tag bind r$i <ButtonRelease-1> "findObject $w $id $r"
        set num ": $i"
        if {[incr i] % 100 == 0} {update idletasks}
    }
    $f.text configure -state disabled
    bind $r <KeyPress-Return> "$r.buttons.bOK invoke"
    bind $r <KeyPress-Escape> "$r.buttons.bOK invoke"
    focus -force $f.text
    update
}
proc placeWindow {parent child} {
    set mainx [winfo x .]
    set mainy [winfo y .]
    set mainwidth [winfo width .]
    set mainheight [winfo height .]
    set centerx [expr {$mainwidth/2 + $mainx}]
    set centery [expr {$mainheight/2 + $mainy}]
    set winx [winfo x $child]
    set winy [winfo y $child]
    set winwidth [winfo width $child]
    set winheight [winfo height $child]
    set olapx [expr {$winx < $centerx && $winx + $winwidth > $centerx}]
    set olapy [expr {$winy < $centery && $winy + $winheight > $centery}]
    if {$olapx && $olapy} {
        #  ,      
        set newx [expr {$centerx - $winwidth - 10}]
        set newy [expr {$centery - $winheight - 10}]
        if {$newx < 0} {set newx 0}
        if {$newy < 0} {set newy 0}
        wm geometry $child +${newx}+${newy}
    }
}
proc findObject {w id cwin} {
    global objects
    if {[lempty $objects($id)]} {return}
    foreach {x y} [getMidCoords $id] {break}
    if {![info exists x]} {return}
    foreach {X Y} [countCoords2 [list $x $y] 7 $::layers(zoomLevel)] {break}
    if {![info exists X]} {return}
    moveCenter $w $X $Y 1.0
    #placeWindow $w $cwin
    catch {wm iconify $cwin}
    showPointer $w $X $Y
    set tag [getTagBySrvID $id]
    if {[getAllParams $w $tag] ne "-state hidden"} {
        setSelect $w $tag 1
    }
    focus -force .
}
proc getMidCoords {id} {
    global classes objects
    set coords  [getCoords $id]
    set mid     [expr {int([llength $coords]/4)}]
    set X       [lindex $coords [expr {2*$mid}]]
    set Y       [lindex $coords [expr {2*$mid+1}]]
    set objName [getObjNameByID $id]
    set class   ""
    catch {set class $classes($objName)}
    if {$class eq "polygon"} {
        set params [lindex $objects($id) 3]
        set smooth [lindex [lindex $params 2] 1]
        if {[smoothOn $smooth]} {
            foreach {X Y} [bezierCoords $coords $mid] {break}
        }
    }
    return [list $X $Y]
}
proc getScrBboxByCenter {w x y} {
    set halfWidth  [expr {[winfo width  $w]/2}]
    set halfHeight [expr {[winfo height $w]/2}]
    set x1 [expr {$x-$halfWidth}]
    set y1 [expr {$y-$halfHeight}]
    set x2 [expr {$x+$halfWidth}]
    set y2 [expr {$y+$halfHeight}]
    return "$x1 $y1 $x2 $y2"
}
proc scrollToElt {w id} {
    foreach {x y} [getMidCoords $id] {break}
    moveCenter  $w $x $y 1.0
    showPointer $w $x $y
}
proc selectLayers {w} {
    global layers2 layers plot
    set l $w.sl
    if {[winfo exists $l]} {
        set x [winfo x $l]
        set y [winfo y $l]
    } else {
        set x [expr {[winfo width $w] / 2 + 100}]
        set y [expr {[winfo height $w] / 2 + 100}]
    }
    set hfont $::fonts(heads)
    set tfont $::fonts(txt)
    set bfont $::fonts(buts)
    catch {destroy $l}
    catch {toplevel $l}
    wm title $l " ."
    if {[unixPlatform]} {wm iconbitmap $l @[file join . img botikmap.xbm]}    
    wm geometry $l +${x}+${y}
    catch {wm deiconify $l; raise $l}
    focus -force $l
    frame $l.main
    pack $l.main -side top
    set ls [getAllSrchLayers]
    frame $l.main.lf
    pack $l.main.lf -side top
    label $l.main.lf.l -pady 2 -text " :" -padx 2 \
        -font $hfont
    pack $l.main.lf.l -side top
    set lnum [llength $ls]
    set fnum [expr {int(ceil(double($lnum)/10.0))}]
    for {set i 1} {$i <= $fnum} {incr i} {
        frame $l.main.lf.f$i
        pack  $l.main.lf.f$i -side left -fill y
    }
    set i 1
    foreach num $ls {
        global sl$num
        set fr [expr {int(ceil(double($i)/10.0))}]
        checkbutton $l.main.lf.f$fr.l$layers2($num) -text "$layers2($num)" -variable sl$num -anchor w\
            -command "selAllButChange $l.selAll Layers" -font $tfont
        pack $l.main.lf.f$fr.l$layers2($num) -side top -pady 2 -fill x -ipadx 25
        if {[set sl$num]} {
            #$l.main.lf.f$fr.$layers2($num) select
        } else {
            #$l.main.lf.f$fr.$layers2($num) deselect
        }
        incr i
    }
    button $l.selAll -text " " -command "selectAllSearchLayers $w $l.selAll $l.main.lf"\
        -activebackground [activeClr] -highlightbackground [activeClr] -font $bfont
    pack $l.selAll -side top -padx 3 -pady 3
    button $l.bOK -text "  " -command "updateObjects $w; destroy $l"  -width 7 -padx 5 -relief raised \
            -activebackground [activeClr] -highlightbackground [activeClr] -font $bfont
    button $l.bCancel -text "  " -command "initSrchTypeVars Layers l;destroy $l" -width 7 -padx 5 -relief raised \
            -activebackground [activeClr] -highlightbackground [activeClr] -font $bfont
    pack $l.bOK $l.bCancel -expand yes -side left -padx 3 -pady 3
    bind $l <KeyPress-Return> "$l.bOK invoke"
    bind $l <KeyPress-Escape> "$l.bCancel invoke"
    update idletasks
    selAllButChange $l.selAll Layers
}
proc selectObjects {w} {
    global objects plot
    set o $w.obj
    if {[winfo exists $o]} {
        set x [winfo x $o]
        set y [winfo y $o]
    } else {
        set x [expr {[winfo width $w] / 2 + 100}]
        set y [expr {[winfo height $w] / 2 + 100}]
    }
    catch {destroy $o}
    catch {toplevel $o}
    wm title $o " ."
    if {[unixPlatform]} {wm iconbitmap $o @[file join . img botikmap.xbm]}    
    wm geometry $o +${x}+${y}
    catch {wm deiconify $o; raise $o;}
    focus -force $o
    set objs [getSrchObjects]
    set hfont $::fonts(heads)
    set tfont $::fonts(txt)
    set bfont $::fonts(buts)
    frame $o.main
    pack $o.main -side top
    frame $o.main.lf
    pack $o.main.lf -side top
    label $o.main.lf.l -pady 2 -text " :" -padx 2 \
        -font $hfont
    pack $o.main.lf.l -side top
    set onum [llength $objs]
    set fnum [expr {int(ceil(double($onum)/10.0))}]
    for {set i 1} {$i <= $fnum} {incr i} {
        frame $o.main.lf.f$i
        pack  $o.main.lf.f$i -side left -fill y
    }
    set i 1
    foreach obj $objs {
        global so$obj
        set fr [expr {int(ceil(double($i)/10.0))}]
        set oName "[s_getObjName $obj]"
        checkbutton $o.main.lf.f$fr.$obj -text "$oName" -variable so$obj -anchor w\
            -command "selAllButChange $o.selAll Objects" -font $tfont
        pack $o.main.lf.f$fr.$obj -side top -pady 2 -fill x -ipadx 20
        if {[set so$obj]} {
            #$o.main.lf.f$fr.$obj select
        } else {
            #$o.main.lf.f$fr.$obj deselect
        }
        incr i
    }
    button $o.selAll -text " " -command "selectAllSearchObjects $w $o.selAll $o.main.lf"\
        -activebackground [activeClr] -highlightbackground [activeClr] -font $bfont
    pack $o.selAll -side top -padx 3 -pady 3
    button $o.bOK -text "  " -command "updateTypesAndStates $w; destroy $o"  -width 7 -padx 5 -relief raised \
            -activebackground [activeClr] -highlightbackground [activeClr] -font $bfont
    button $o.bCancel -text "  " -command "initSrchTypeVars Objects o;destroy $o" -width 7 -padx 5 -relief raised \
            -activebackground [activeClr] -highlightbackground [activeClr] -font $bfont
    pack $o.bOK $o.bCancel -expand yes -side left -padx 3 -pady 3
    bind $o <KeyPress-Return> "$o.bOK invoke"
    bind $o <KeyPress-Escape> "$o.bCancel invoke"
    update idletasks
    selAllButChange $o.selAll Objects
}
proc selectTypes {w} {
    global types plot
    set t $w.types
    if {[winfo exists $t]} {
        set x [winfo x $t]
        set y [winfo y $t]
    } else {
        set x [expr {[winfo width $w] / 2 + 100}]
        set y [expr {[winfo height $w] / 2 + 100}]
    }
    catch {destroy $t}
    catch {toplevel $t}
    wm title $t " ."
    if {[unixPlatform]} {wm iconbitmap $t @[file join . img botikmap.xbm]}    
    wm geometry $t +${x}+${y}
    catch {wm deiconify $t; raise $t;}
    focus -force $t
    set stypes [getSrchTypes]
    set hfont $::fonts(heads)
    set tfont $::fonts(txt)
    set bfont $::fonts(buts)
    frame $t.main
    pack $t.main -side top
    frame $t.main.lf
    pack $t.main.lf -side top
    label $t.main.lf.l -pady 2 -text " :" -padx 2 \
        -font $hfont
    pack $t.main.lf.l -side top
    set num  [llength $stypes]
    set fnum [expr {int(ceil(double($num)/10.0))}]
    for {set i 1} {$i <= $fnum} {incr i} {
        frame $t.main.lf.f$i
        pack  $t.main.lf.f$i -side left -fill y
    }
    set i 1
    foreach type $stypes {
        global st$type
        set fr [expr {int(ceil(double($i)/10.0))}]
        set tName [s_getTypeName $type]
        regsub {\*$} $tName {} tp
        checkbutton $t.main.lf.f$fr.$type -text "$tp" -variable st$type -anchor w\
            -command "selAllButChange $t.selAll Types" -font $tfont
        pack $t.main.lf.f$fr.$type -side top -pady 2 -fill x -ipadx 20
        if {[set st$type]} {
            #$t.main.lf.f$fr.$type select
        } else {
            #$t.main.lf.f$fr.$type deselect
        }
        incr i
    }
    button $t.selAll -text " " -command "selectAllSearchTypes $w $t.selAll $t.main.lf"\
        -activebackground [activeClr] -highlightbackground [activeClr] -font $bfont
    pack $t.selAll -side top -padx 3 -pady 3
    button $t.bOK -text "  " -command "destroy $t"  -width 7 -padx 5 -relief raised \
            -activebackground [activeClr] -highlightbackground [activeClr] -font $bfont
    button $t.bCancel -text "  " -command "initSrchTypeVars Types t;destroy $t" -width 7 -padx 5 -relief raised \
            -activebackground [activeClr] -highlightbackground [activeClr] -font $bfont
    pack $t.bOK $t.bCancel -expand yes -side left -padx 3 -pady 3
    bind $t <KeyPress-Return> "$t.bOK invoke"
    bind $t <KeyPress-Escape> "$t.bCancel invoke"
    update idletasks
    selAllButChange $t.selAll Types
}
proc selectStates {w} {
    global plot
    set s $w.states
    if {[winfo exists $s]} {
        set x [winfo x $s]
        set y [winfo y $s]
    } else {
        set x [expr {[winfo width $w] / 2 + 100}]
        set y [expr {[winfo height $w] / 2 + 100}]
    }
    catch {destroy $s}
    catch {toplevel $s}
    wm title $s " ."
    if {[unixPlatform]} {wm iconbitmap $s @[file join . img botikmap.xbm]}    
    wm geometry $s +${x}+${y}
    catch { wm deiconify $s; raise $s;}
    focus -force $s
    set sstates [getSrchStates]
    set hfont $::fonts(heads)
    set tfont $::fonts(txt)
    set bfont $::fonts(buts)
    frame $s.main
    pack $s.main -side top
    frame $s.main.lf
    pack $s.main.lf -side top
    label $s.main.lf.l -pady 2 -text " :" -padx 2 \
        -font $hfont
    pack $s.main.lf.l -side top
    set num  [llength $sstates]
    set fnum [expr {int(ceil(double($num)/10.0))}]
    for {set i 1} {$i <= $fnum} {incr i} {
        frame $s.main.lf.f$i
        pack  $s.main.lf.f$i -side left -fill y
    }
    set i 1
    foreach state $sstates {
        global ss$state
        set fr [expr {int(ceil(double($i)/10.0))}]
        set sName [s_getStateName $state]
        regsub {\*$} $sName {} t
        checkbutton $s.main.lf.f$fr.$state -text "$t" -variable ss$state -anchor w\
            -command "selAllButChange $s.selAll States" -font $tfont
        pack $s.main.lf.f$fr.$state -side top -pady 2 -fill x -ipadx 50
        if {[set ss$state]} {
            #$s.main.lf.f$fr.$state select
        } else {
            #$s.main.lf.f$fr.$state deselect
        }
        incr i
    }
    button $s.selAll -text " " -command "selectAllSearchStates $w $s.selAll $s.main.lf"\
        -activebackground [activeClr] -highlightbackground [activeClr] -font $bfont
    pack $s.selAll -side top -padx 3 -pady 3
    button $s.bOK -text "  " -command "destroy $s"  -width 7 -padx 5 -relief raised \
            -activebackground [activeClr] -highlightbackground [activeClr] -font $bfont
    button $s.bCancel -text "  " -command "initSrchTypeVars States s;destroy $s" -width 7 -padx 5 -relief raised \
            -activebackground [activeClr] -highlightbackground [activeClr] -font $bfont
    pack $s.bOK $s.bCancel -expand yes -side left -padx 3 -pady 3
    bind $s <KeyPress-Return> "$s.bOK invoke"
    bind $s <KeyPress-Escape> "$s.bCancel invoke"
    update idletasks
    selAllButChange $s.selAll States
}
proc s_getObjName {obj} {
    set lNum ""
    set oNum ""
    regexp {(\d+)} $obj lNum
    regexp {(\d+)$} $obj oNum
    return "[getObjNameByLayer $lNum $oNum]"
}
proc s_getTypeName {type} {
    global types
    set spl  [split $type "_"]
    set lNum [string index [lindex $spl 0] end]
    set oNum [lindex $spl 1]
    set tNum [lindex $spl 2]
    set objName "[getObjNameByLayer $lNum $oNum]"
    if {[lempty $tNum] || [lempty "$objName"]} return
    set allTypes $types($objName)
    return "[lindex $allTypes [expr 2*$tNum]]"
}
proc s_getStateName {state} {
    global states
    set spl  [split $state "_"]
    set lNum [string index [lindex $spl 0] end]
    set oNum [lindex $spl 1]
    set sNum [lindex $spl 2]
    set objName "[getObjNameByLayer $lNum $oNum]"
    if {[lempty $sNum] || [lempty "$objName"]} return
    set allStates $states($objName)
    return "[lindex $allStates [expr 2*$sNum]]"
}
proc initSrchTypeVars {type par} {
    set objs [getSrch$type]
    foreach obj $objs {
        global s$par$obj
        set s$par$obj 1
    }
}
proc initSearchVars {w} {
    set ls [getAllSrchLayers]
    foreach num $ls {
        global sl$num
        set sl$num 1
    }
    set objs [getAllSrchObjects]
    foreach obj $objs {
        global so$obj
        set so$obj 1
    }
    set types [getAllSrchTypes]
    foreach type $types {
        global st$type
        set st$type 1
    }
    set states [getAllSrchStates]
    foreach state $states {
        global ss$state
        set ss$state 1
    }
}
proc selAllButChange {but type} {
    if {[llength [getSelected$type]] == [llength [getSrch$type]]} {
        $but configure -text " "
    } else {
        $but configure -text " "
    }
}
proc selectAllSearchTypes {w but frame} {
    set txt [lindex [$but configure -text] end]
    if {$txt==" "} {
        set opt "1"
        $but configure -text " "
    } else {
        set opt "0"
        $but configure -text " "
    }
    set types [getSrchTypes]
    set i 1
    foreach type $types {
        set num [expr {int(ceil(double($i)/10.0))}]
           global st$type
           set st$type $opt
        #$frame.f$num.$type configure -state $opt
        incr i
    }
}
proc selectAllSearchStates {w but frame} {
    set txt [lindex [$but configure -text] end]
    if {$txt eq " "} {
        set opt "1"
        $but configure -text " "
    } else {
        set opt "0"
        $but configure -text " "
    }
    set states [getSrchStates]
    set i 1
    foreach state $states {
        set fr [expr {int(ceil(double($i)/10.0))}]
           global ss$state
           set ss$state $opt
        #$frame.f$fr.$state $opt
        incr i
    }
}
proc selectAllSearchObjects {w but frame} {
    set txt [lindex [$but configure -text] end]
    if {$txt==" "} {
        set opt "1"
        $but configure -text " "
    } else {
        set opt "0"
        $but configure -text " "
    }
    set objs [getSrchObjects]
    set i 1
    foreach obj $objs {
        set fr [expr {int(ceil(double($i)/10.0))}]
        global so$obj
        set so$obj $opt
        #$frame.f$fr.$obj $opt
        incr i
    }
}
proc selectAllSearchLayers {w but frame} {
    global layers2
    set txt [lindex [$but configure -text] end]
    if {$txt==" "} {
        set opt "1"
        $but configure -text " "
    } else {
        set opt "0"
        $but configure -text " "
    }
    set nums [lsort [array names layers2]]
    set i 1
    foreach num $nums {
        set fr [expr {int(ceil(double($i)/10.0))}]
        global sl$num
        set sl$num $opt
        #$frame.f$fr.$layers2($num) $opt
        incr i
    }
}
proc updateTypesAndStates {w} {
    set states [getSrchStates]
    foreach state $states {
        global ss$state
        set ss$state 1
    }
    set types [getSrchTypes]
    foreach type $types {
        global st$type
        set st$type 1
    }
    if {[winfo exists $w.states]} {
        selectStates $w
    }
    if {[winfo exists $w.types]} {
        selectTypes $w
    }
}
proc updateObjects {w} {
    set objs [getSrchObjects]
    foreach obj $objs {
        global so$obj
        set so$obj 1
    }
    if {[winfo exists $w.obj]} {
        selectObjects $w
    }
    updateTypesAndStates $w
}
proc getAllSrchLayers {} {
    global layers2
    return [lsort [array names layers2]]
}
proc getAllSrchObjects {} {
    global layers2 objects
    set nums [getAllSrchLayers]
    set objs {}
    foreach num $nums {
        set i 0
        foreach obj $objects($layers2($num)) {
            lappend objs ${num}_$i
            incr i
        }
    }
    return $objs
}
proc getAllSrchTypes {} {
    global types
    set objs [getAllSrchObjects]
    set tps {}
    foreach obj $objs {
        set i 0
        set objName "[s_getObjName $obj]"
        foreach {tName tPars} $types($objName) {
            if {![lempty "$tName"]} {
                lappend tps t${obj}_$i
            }
            incr i
        }
    }
    return $tps
}
proc getAllSrchStates {} {
    global states
    set objs [getAllSrchObjects]
    set sts {}
    foreach obj $objs {
        set i 0
        set objName "[s_getObjName $obj]"
        foreach {sName sPars} $states($objName) {
            if {![lempty "$sName"]} {
                lappend sts s${obj}_$i
            }
            incr i
        }
    }
    return $sts
}
proc getSelectedLayers {} {
    set nums [getAllSrchLayers]
    set ls {}
    foreach num $nums {
        global sl$num
        if {[set sl$num]} {
            lappend ls $num
        }
    }
    return $ls
}
proc getSelectedObjects {} {
    set sObjs [getSrchObjects]
    set objs {}
    foreach obj $sObjs {
        global so$obj
        if {[set so$obj]} {
            lappend objs $obj
        }
    }
    return $objs
}
proc getSelectedTypes {} {
    set types [getSrchTypes]
    set tps {}
    foreach type $types {
        global st$type
        if {[set st$type]} {
            lappend tps $type
        }
    }
    return $tps
}
proc getSelectedStates {} {
    set states [getSrchStates]
    set sts {}
    foreach state $states {
        global ss$state
        if {[set ss$state]} {
            lappend sts $state
        }
    }
    return $sts
}
proc getSrchLayers {} {
    global layers2
    return [lsort [array names layers2]]
}
proc getSrchObjects {} {
    global layers2 objects
    set nums [getSelectedLayers]
    set objs {}
    foreach num $nums {
        set i 0
        foreach obj $objects($layers2($num)) {
            lappend objs ${num}_$i
            incr i
        }
    }
    return $objs
}
proc getSrchTypes {} {
    global types
    set objs [getSelectedObjects]
    set tps {}
    set uniq {}
    foreach obj $objs {
        set i 0
        set objName "[s_getObjName $obj]"
        foreach {tName tPars} $types($objName) {
            if {![lempty "$tName"] && [lsearch $uniq "$tName"]==-1} {
                lappend tps t${obj}_$i
                set uniq "$uniq{$tName} "
            }
            incr i
        }
    }
    return $tps
}
proc getSrchStates {} {
    global states
    set objs [getSelectedObjects]
    set sts {}
    set uniq {}
    foreach obj $objs {
        set i 0
        set objName "[s_getObjName $obj]"
        foreach {sName sPars} $states($objName) {
            if {![lempty $sName] && [lsearch $uniq "$sName"]==-1} {
                lappend sts s${obj}_$i
                set uniq "$uniq{$sName} "
            }
            incr i
        }
    }
    return $sts
}
proc hideActiveTOPLine {w} {
    global complex
    catch {$w itemconfig $complex(activeTOPLine) -state hidden}
    set complex(activeTOPLine) ""
    set complex(activeTOP) ""
}
proc showActiveTOPLine {w} {
    global complex
    $w itemconfig $complex(activeTOPLine) -state normal
    set complex(activeTOP) [getActiveTOPtag]
}
proc delTOPLine {w} {
    global complex layers
    $w delete $complex(activeTOPLine)
    $w dtag $complex(activeTOPLine)
    set complex(activeTOPLine) ""
    set complex(activeTOP) ""
}
proc getActiveTOPtag {} {
    global complex
    return [lindex [split $complex(activeTOPLine) "+"] 1]
}
proc changeTOPTxt {w text tag} {
    global complex
    if {[lempty $tag]} return
    set obj   [getObject $tag]
    set layer [getLayer $tag]
    arrangeTOP $w $text $obj $tag $layer {} "default"
}
proc setTOPTxt {w obj} {
    global TOPtxt complex drawComplete fsize dsize
    if {[lempty $TOPtxt]} {
        delTOPLine $w
        return
    }
    set tag $complex(activeTOP)
    set layer {}
    if {![lempty $tag]} {
        set layer [getLayer $tag]
    }
    set coords [$w coords $complex(activeTOPLine)]
    arrangeTOP $w $TOPtxt $obj $tag $layer $coords "$fsize $dsize"
    set tag [getActiveTOPtag]
    selectTOP $w $tag
    set drawComplete 1
    if {![lempty $tag]} {showProps $w $tag}
}
proc selectTOP {w tag} {
    global complex
    if {$complex(activeTOP) == $tag} {
        getTOPtext $w $complex($complex(activeTOP),text) [getObject $tag] $tag
    }
    hideActiveTOPLine $w
    set complex(activeTOPLine) "TOPLine+$tag"
    showActiveTOPLine $w
    group $w $complex(activeTOP) $complex(activeTOPLine)
    setSelect $w $tag 1
}
proc getTOPtext {w text obj tag} {
    global layers TOPs plot
    set t $w.txtTOP
    set tfont $::fonts(txt)
    set bfont $::fonts(buts)
    catch {destroy $t}
    catch {toplevel $t}
    wm title $t " ."
    if {[unixPlatform]} {wm iconbitmap $t @[file join . img botikmap.xbm]}    
    catch {wm deiconify $t; raise $t;}
    focus -force $t
    frame $t.main
    pack $t.main
    label $t.main.l -text " :" -font $tfont
    entry $t.main.e -width 30 -textvar TOPtxt -takefocus 1 -font $tfont
    pack $t.main.l $t.main.e -side top -padx 5 -pady 5
        focus -force $t.main.e
    $t.main.e delete 0 end
    $t.main.e insert 0 $text
    setRussianKeys $t.main.e
    set fontsize 10
    set chardiff 10
    if {![lempty $tag]} {
        catch {
            set id [takeID $tag]
            set fontsize $TOPs($id,fsize)
            set chardiff $TOPs($id,dsize)
        }
    } else {
        array set pars [getAllParams $w $layers(top) $obj]
        if {[info exists pars(-font)]} {
            set fontsize [lindex [subst $pars(-font)] 1]
        } else {set fontsize 1}
        if {[info exists pars(-diff)]} {
            set chardiff [subst $pars(-diff)]; #  .
        } else {set chardiff 1}
    }
    label $t.main.lf -text " :" -font $tfont
    spinbox $t.main.spinf -textvar fsize -from 1 -to 40\
        -width 7 -wrap on -font $tfont
    label $t.main.ld -text "   ( .):" -font $tfont
    spinbox $t.main.spind -textvar dsize -from 1 -to 100 \
        -width 7 -wrap on -font $tfont
    pack $t.main.lf $t.main.spinf $t.main.ld $t.main.spind -side top
    $t.main.spinf delete 0 end
    $t.main.spinf insert 0 $fontsize
    $t.main.spind delete 0 end
    $t.main.spind insert 0 $chardiff
    frame $t.main.buts
    pack $t.main.buts -side top
    button $t.main.buts.ok -text "" -width 10 -padx 5 -relief raised \
            -activebackground [activeClr] -highlightbackground [activeClr] \
            -command "setTOPTxt $w $obj; destroyTOPdialog $w $t" -default active -font $bfont
    button $t.main.buts.cancel -text "" -width 10 -padx 5 -relief raised\
            -activebackground [activeClr] -highlightbackground [activeClr] \
            -command "destroyTOPdialog $w $t" -font $tfont
    pack $t.main.buts.ok $t.main.buts.cancel -side left -padx 3 -pady 3
    bind $t <KeyPress-Return> "$t.main.buts.ok invoke"
    bind $t <KeyPress-Escape> "$t.main.buts.cancel invoke"
    bind $t <Destroy> "destroyTOPdialog $w $t"
    update idletasks
}
proc destroyTOPdialog {w t} {
    global TOPtxt drawComplete
    destroy $t
    if {[info exists TOPtxt] && [lempty $TOPtxt]} {
        delTOPLine $w
    }
    set drawComplete 1
}
proc getDefaultStateParams {obj l} {
    set states [getStatesByObj $obj $l]
    foreach {s par} $states {
        if {[regexp {\*$} "$s"]} {
            return "$par"
        }
    }
    return "{}"
}
proc getDefaultTypeParams {obj l} {
    set types [getTypesByObj $obj $l]
    foreach {t par} $types {
        if {[regexp {\*$} "$t"]} {
            return "$par"
        }
    }
    return "{}"
}
proc getParam {tag pos} {
    set val ""
    catch {
        set id  [takeID $tag]
        set val [lindex $::objects($id) $pos]
    }
    #set p ""
    #regsub {\*$} [getStr $val] "" p
    set p [string trimright [getStr $val] "*"]
    return $p
}

proc getTypeParams {type obj l} {
    set types [getTypesByObj $obj $l]
    set type  [string trimright $type "*"]
    foreach {t par} $types {
        set t [string trimright $t "*"]
        if {$type eq "$t"} {
            return "$par"
        }
    }
    return
}
proc getStateParams {state obj l} {
    set states [getStatesByObj $obj $l]
    set state  [string trimright $state "*"]
    foreach {s par} $states {
        set s [string trimright $s "*"]
        if {$state eq "$s"} {
            return "$par"
        }
    }
    return
}
proc drawDot {w x y obj l id} {
    global layers complex states types myImages nodes
    set class [getClass $w current]
    if {[lempty $id]} {
        set emptyid 1
        set id [getID]
        set x  [$w canvasx $x]
        set y  [$w canvasy $y]
    } else {    
        set emptyid 0    
        set tag [getTagBySrvID $id]
        set obj [getObject $tag]
        set l   [getLayer $tag]
    }
    if {[lempty $l]} {
        set l $layers(top)
    }
    if {[lempty $obj]} {return}
    if {$class eq "nodeOvals"} {
        initNodeMove $w $x $y "dot_nodeMoveStop $w $l $obj"
        return
    }
    set params [getAllParams $w $l $obj]
    if {$params eq "-state hidden" || [lempty $params] || [expr [llength $params] % 2] != 0} {return}
    array set pars $params
    if {![info exists pars(-style)]} {
        set pars(-style) box
    }
    if {![info exists pars(-radius)] || [lempty $pars(-radius)]} {
        set pars(-radius) 12
    }
    if {![info exists pars(-text)]} {
        set pars(-text) " "
    }
    set coords [getDotCoords $w $x $y $pars(-style) $pars(-radius)]
    set dtype  [getDotType $pars(-style)]
    if {[lempty $coords] || [lempty $dtype]} {return}
    set baseTag "$dtype${id}_0"
    if {$dtype eq "image"} {
        if {![info exists pars(-file)] || [lempty $pars(-file)]} return
        global images        
        set img [file join . $images(imagedir) $pars(-file)]
        loadImage $baseTag $img
        $w create $dtype $coords -tags $baseTag -image $myImages($baseTag)
    } else {
        $w create $dtype $coords -tags $baseTag
    }
    set mainTag "dot${l}_${obj}_$id"
    set textTag "text${id}_1"
    $w create text $x $y -text $pars(-text) -tags $textTag -anchor center
    set complex($mainTag,text) $pars(-text)
    set complex($mainTag) "$baseTag $textTag"
    set complex($baseTag) $mainTag
    set complex($textTag) $mainTag
    set complex($mainTag,elts) $complex($mainTag)
    group $w $mainTag $complex($mainTag)
    $w raise $textTag $baseTag
    put $w $mainTag
    applyParams $w $mainTag $obj $l
    #g_addNode $id
    if {$emptyid} {setSelect $w $mainTag 1}
    return $mainTag
}
proc autoBindBox {w id} {
    global grid binds complex objects srvids
    if {[info exists binds($id)] && ![lempty $binds($id)]} {return}
    if {![info exists srvids($id)]} {return}
    if {![isNetObj $id]} {return}
    set tag  [getTagBySrvID $id]
    if {![info exists complex($tag)]} {return}
    set text [lindex $complex($tag) 1]
    set crds [$w coords $text]
    set x    [lindex $crds 0]
    set y    [lindex $crds 1]
    set box  [join [countBox $x $y $grid(csize)] ,]
    if {![info exists grid($box)]} {return}
    set hobj {}
    catch {
    foreach obj $grid($box) {
        set oName [getStr "[lindex $objects($obj) 2]"]    
        if {$oName eq ""} {
            set crds [getCoords $obj]
            set box1 [getBbox $w $crds]
            set box2 [list $x $y [expr $x+1] [expr $y+1]]
            if {[boxesintersect $box1 $box2]} {
                set hobj $obj
                break
            }
        }
    }}
    if {![lempty $hobj]} {
        set binds($id) $hobj
        setChangeState $w $tag 1
    }
}
proc changeStyle {w elt newStyle r} {
    global complex myImages images
    if {[getClass $w $elt] ne "dot"} {
        return
    }
    set elt  [getComplexTag $w $elt]
    set poly [lindex $complex($elt) 0]
    set text [lindex $complex($elt) 1]
    set newType [getDotType $newStyle]
    set oldType [$w type $poly]
    set tcoords [$w coords $text]
    foreach {x y} $tcoords {}
    set newCoords [getDotCoords $w $x $y $newStyle $r]    
    set l     [getLayer $elt]
    set obj   [getObject $elt]
    set srvid [lindex [split $elt "_"] 2]
    set tag   $newType${srvid}_0
    $w delete $poly
    $w dtag $poly
    if {$newType eq "image"} {
        array set pars [getAllParams $w $elt]
        set img [file join . $images(imagedir) $pars(-file)]
        loadImage $tag $img
        $w create $newType $newCoords -tags $tag -image $myImages($tag)
    } else {
        $w create $newType $newCoords -tags $tag
    }
    set complex($poly) ""
    set complex($elt) [getStr "$tag $text"]
    set complex($tag) $elt
    set complex($elt,elts) $complex($elt)
    group $w $elt $complex($elt)
    catch {$w raise $text $tag}
    positionElt $w $srvid
    return $tag
}
proc arrangeTOP {w text obj elem layer coords other} {
    global complex layers TOPs
    if {[lempty [getStr $layer]]} {
        set layer $layers(top)
    }
    set txtlen [string length $text]
    if {[lempty [getStr $coords]]} {
        set coords [$w coords $complex(activeTOPLine)]
    }
    if {$txtlen == 0 || [lempty [getStr $coords]]} {
        delTOPLine $w
        return
    }
    set linelen 0
    set segs(0) 0
    set nsegs 0
    set ang(0) 0
    set i 0
    set h 0
    set first 1
    foreach {x2 y2} $coords {
        if {!$first} {
            set j [expr {$i-1}]
            set x1 [lindex $coords [expr {2*$j}]]
            set y1 [lindex $coords [expr {2*$j+1}]]
            set dx [expr {$x2-$x1}]
            set dy [expr {$y2-$y1}]
            set ang($j) [expr {atan2($dy,$dx)}]
            set h [expr {hypot($dx,$dy)}]
            set linelen [expr {$linelen+$h}]
            set segs($j) $h
            incr nsegs
        } else {
            set first 0
        }
        incr i
    }
    set ilast [expr {$nsegs-1}]
    set l 0
    set t 0
    set s 0
    set i 0
    set diff  0
    set lastx 0
    set lasty 0
    if {[lempty $elem]} {
        set TOPtag [getActiveTOPtag]
    } else {
        set TOPtag $elem
        set elems ""
        catch { set elems $complex($elem) }
        foreach el $elems {
            set complex($el) ""
            $w delete $el
            $w dtag $el
        }
    }
    set id [takeID $TOPtag]
    array set pars [getAllParams $w $TOPtag]
    if {![info exists pars(-diff)]} {
        set pars(-diff) 10
    }
    if {$other ne "default"} {
        set k [lindex $other 1]
        set size [lindex $other 0]
        if {[info exists pars(-font)]} {
            set pars(-font) [lreplace $pars(-font) 1 2 $size]
        }
        set TOPs($id,dsize) $k
        set TOPs($id,fsize) $size
        set TOPs($id,zoom)  $layers(zoomLevel)
    } else {
        if {![info exists TOPs($id,zoom)]} {
            set TOPs($id,zoom) 7
        }
        set diff [expr {$layers(zoomLevel)-$TOPs($id,zoom)}]
        if {[info exists TOPs($id,dsize)]} {
            set k [expr {int($TOPs($id,dsize)*pow(2,$diff))}]
        } else {
            set k [subst $pars(-diff)]
        }
        if {[info exists TOPs($id,fsize)] && [info exists pars(-font)]} {
            set fsize [expr {int($TOPs($id,fsize)*pow(2,$diff))}]
            set pars(-font) [lreplace $pars(-font) 1 2 $fsize]
        }
    }
    set complex($TOPtag) ""
    set complex($TOPtag,text) $text
    while {$i < $nsegs} {
        set s $segs($i)
        set X [lindex $coords [expr {2*$i}]]
        set Y [lindex $coords [expr {2*$i+1}]]
        while {$l <= $s} {
            set x [expr {$l*cos($ang($i)) + $X}]
            set y [expr {$l*sin($ang($i)) + $Y}]
            set tag "text${id}_$t"
            $w create text $x $y -text [string index $text $t] -tags $tag
            lappend complex($TOPtag) $tag
            set complex($tag) $TOPtag
            set l [expr {$l + $k}]
            incr t
        }
        set l [expr {$l - $s}]
        incr i
    }
    set complex($TOPtag,elts) $complex($TOPtag)
    group $w $TOPtag "$complex($TOPtag) TOPLine+$TOPtag"
    $w raise nodeOvals
    put $w $TOPtag
    set names [array names pars]
    foreach par $names {
        set val [subst $pars($par)]
        if {![commonParam $par]} {continue}
        foreach text $complex($TOPtag,elts) {
            catch {$w itemconfig $text $par $val}
        }
    }
    positionElt $w $id
    update idletasks
}
proc applyParams {w el obj l} {
    global layers complex myImages objects images
    set elt [getComplexTag $w [lindex $el 0]]
    if {[lempty $elt]} {return}
    if {[lempty $l]} {set l $layers(top)}
    set class  [getClassByTag $elt]
    set srvid  [takeID $elt]
    set params [getAllParams $w $elt]
    if {$params eq "-state hidden"} {
        catch {delObject $w $srvid}
        return
    }
    if {[lempty $params] || [expr {[llength $params] % 2}] != 0} {return}
    array set pars $params
    set names [array names pars]
    if {$class eq "bridge"} {
        set line1 [lindex $complex($elt,elts) 0]
        set line2 [lindex $complex($elt,elts) 1]
        set poly  [lindex $complex($elt,elts) 2]
        if {![info exists pars(-linewidth)]}   {set pars(-linewidth) 1}
        if {![info exists pars(-polywidth)]}   {set pars(-polywidth) 1}
        if {![info exists pars(-linefill)]}    {set pars(-linefill) black}
        if {![info exists pars(-polyfill)]}    {set pars(-polyfill) white}
        if {![info exists pars(-polyoutline)]} {set pars(-polyoutline) black}
        $w itemconfig $line1 -width $pars(-linewidth) -fill $pars(-linefill)
        $w itemconfig $line2 -width $pars(-linewidth) -fill $pars(-linefill)
        $w itemconfig $poly  -width $pars(-polywidth) -fill $pars(-polyfill) -outline $pars(-polyoutline)
        foreach n $names {
            if {![commonParam $n]} {continue}
            set val [subst $pars($n)]
            catch { $w itemconfig $elt $n $val }
        }
    } elseif {$class eq "TOP"} {
        catch {
        set text  $complex($elt,text)
        set obj   [getObject $elt]
        set layer [getLayer $elt]
        set coords [$w coords TOPLine+$elt]
        arrangeTOP $w $text $obj $elt $layer $coords "default"
        }
    } elseif {$class eq "dot"} {
        if {![info exists pars(-style)]} {
            set pars(-style) box
        }
        if {![info exists pars(-radius)] || [lempty $pars(-radius)]} {
            set pars(-radius) 12
        }
        set oldPoly [lindex $complex($elt,elts) 0]
        set text    [lindex $complex($elt,elts) 1]
        set newType [getDotType $pars(-style)]
        set oldType [$w type $oldPoly]
        set poly    [changeStyle $w $elt $pars(-style) $pars(-radius)]
        if {$newType eq "image" && $oldType eq "image"} {
            set oldFile [lindex [$myImages($oldPoly) configure -file] end]
            set newFile [file join . $images(imagedir) $pars(-file)]
            $myImages($poly) configure -file $newFile
            set myImages($oldFile) ""
            set myImages($newFile) $myImages($poly)
            catch {set objects($srvid) [lreplace $objects($srvid) 6 6 $pars(-name)]}
        }
        foreach n $names {
            if {![commonParam $n]} {continue}
            set val [subst $pars($n)]
            if {[lsearch -exact {-font -text -anchor} $n] == -1} {
                catch {$w itemconfig $poly $n $val}
            }
            if {[lsearch -exact {-width -outline} $n] == -1} {
                catch {$w itemconfig $text $n $val}
            }
        }
        if {![info exists pars(-text)]} {
            if {[info exists pars(-name)]} {
                set txt [getStr $pars(-name)]
            } else {
                set name [getStr [lindex $objects($srvid) 6]]
                if {[lempty $name]} {
                    set txt " "
                } else {
                    set txt [getStr $name]
                }
            }
            if {$newType eq "image"} {set txt " "}
        } else {
            if {[catch {
                set txt [getStr [expr {$pars(-text)}]]
            }]} {
                set txt [getStr $pars(-text)]
            }
        }
        if {![info exists pars(-textfill)]} {set pars(-textfill) "black"}
        if {![info exists pars(-font)]}     {set pars(-font) "$::fonts(txt)"}
        catch {$w itemconfig $text -text $txt; set complex($elt,text) $txt}
        catch {$w itemconfig $text -fill $pars(-textfill)}
        catch {$w itemconfig $text -font $pars(-font)}
    } else {
        set justCreated [lindex $el 1]
        if {[lempty $justCreated]} {
            set justCreated 0
        }
        foreach n $names {
            if {![commonParam $n]} {continue}
            set val [subst $pars($n)]
            if {$n eq "-smooth"} {
                if {$justCreated} {
                    catch {$w itemconfig $elt $n $val}
                }
            } else {
                catch {$w itemconfig $elt $n $val}
            }
        }
    }
    catch {setParams $w $elt}
}
proc readFromFile {w fileName cache} {
    global every
    if {![file exists $fileName]} {return}
    if {[catch {set file [open $fileName r]}]} {
        alertError "   ."
        return
    }
    set fsize [file size $fileName]
    if {$fsize == 0} {close $file; return}
    set count 0
    if {$cache} {set what " "} else {set what ""}
    while {![eof $file]} {
        catch {
            gets $file line
            if {[lempty $line]} {continue}
            if {$cache} {processObject $w $line} else {makeObject $w $line}
            set pos [tell $file]
            set ::progress " $what... : [getPercent $pos $fsize]%"
            if {[incr count] % $every == 0} {update idletasks}
        }
    }
    close $file
    handleBinds $w
    updateCanvas $w 1.0
}
proc fileDialog {w operation} {
    global plot objects
    set types {
        {"GIS files"  {.gis} TEXT}
        {"Text files" {.txt} TEXT}
    }
    if {$operation eq "open"} {
        set fileName [tk_getOpenFile -filetypes $types -parent $w \
            -initialfile Untitled -defaultextension .gis -initialdir ~]
        if {[lempty $fileName]} {return}
        readFromFile $w $fileName 0
    } elseif {$operation eq "save"} {
        set fileName [tk_getSaveFile -filetypes $types -parent $w \
            -initialfile Untitled -defaultextension .gis -initialdir ~]
        if {[lempty $fileName]} {return}
        update idletasks
        set file [open $fileName w]
        savePlotToFile $w $file 0
        close $file
    }
}
proc isPolyType {type} {
    return [expr {$type eq "polygon" || $type eq "line"}]
}
proc isComplexClass {class} {
    return [expr {$class eq "bridge" || $class eq "dot" || $class eq "TOP"}]
}
proc commonParam {par} {
    return [expr {[lsearch -exact $::plot(nonstd) $par] == -1}]
}
proc getDefaultState {obj l} {
    set states [getStatesByObj $obj $l]
    foreach {s par} $states {
        if {[regexp {\*$} "$s"]} {return "$s"}
    }
    return "{}"
}
proc getDefaultType {obj l} {
    set types [getTypesByObj $obj $l]
    foreach {t par} $types {
        if {[regexp {\*$} "$t"]} {return "$t"}
    }
    return "{}"
}
proc countCoords {coords zlOld} {
    global layers
    if {![string is integer -strict $zlOld]} {return}
    if {$layers(zoomLevel)==$zlOld} {return $coords}
    set newCoords {}
    set k [expr {pow(2,$layers(zoomLevel) - $zlOld)}]
    foreach coord $coords {
        lappend newCoords [expr {$k * $coord}]
    }
    return $newCoords
}
proc countCoords2 {coords zlOld zlNew} {
    if {$zlOld==$zlNew} {return $coords}
    set k [expr {pow(2,$zlNew - $zlOld)}]
    set newCoords {}
    foreach coord $coords {
        lappend newCoords [expr {$k * $coord}]
    }
    return $newCoords
}
proc loadModule {fname} {
    global errorCode myModules
    if {[info exists myModules($fname)]} {
        alert " \"$fname\"  "
        return
    }
    if {[catch {
        source $fname
        set myModules($fname) 1
    }]} {
        set str "    \"$fname\"."
        set str "$str\n    ."
        set str "$str\n   ."
        alertError $str
        exit
    }
}
proc getComplexTag {w elt} {
    if {[string match "TOPLine*" $elt]} {
        return [lindex [split $elt "+"] 1]
    }
    if {[string match "TOP*" $elt]} {
        return $elt
    }
    set elt  [getStr $elt]
    set tags $elt
    catch {set tags [$w gettags $elt]}
    set tag [lindex $tags 1]
    if {![regexp {current|selected} $tag] && [llength $tag] == 1} {
        return $tag
    }
    return [lindex $tags 0]
}
proc getClass {w elt} {
    set tag [getComplexTag $w $elt]
    return  [getClassByTag $tag]
}
proc notEmpty {str} {
    return [expr {![lempty $str]}]
}
proc loadStyles {w num} {
    global layers objects lastBtn images
    if {[regexp $layers(toolbar) $lastBtn(btn)]} {set lastBtn(btn) ""}
    destroy $layers(toolbar)
    frame $layers(toolbar)
    pack $layers(toolbar) -side top
    set layers(buts) {}
    set layers(butnames) {}
    set i 0
    foreach obj $objects($layers($num)) {
        set img [file join . $images(imagedir) $images($obj)]
        loadImage "$obj" $img
        set cmds "[getClassByObj $obj {}] $i"
        if {$layers($layers(top),editable)} {
            set st "normal"
        } else {set st "disabled"}
        setImgButtons $w $layers(toolbar) 1 1 top 31 31 1 1 $st [subst { 
            "$obj" " : $obj" "bindObjectButton $w {$cmds}"
        }]
        incr i
    }
    #invokeFirstButton $w
}
proc bindObjectButton {w cmds} {
    global layers objects
    unbindAll $w
    set class [lindex $cmds 0]
    set obj   [lindex $cmds 1]
    delDotTmp $w
    if {$class eq "dot"} {
        set l $layers(top)
        if {[lempty $obj]} {return}
        set params [getAllParams $w $l $obj]
        if {$params eq "-state hidden" || [lempty $params] || [expr [llength $params] % 2] != 0} {return}
        array set pars $params
        if {![info exists pars(-style)] || [lempty $pars(-style)]} {
            set pars(-style) "box"
        }
        if {![info exists pars(-radius)] || [lempty $pars(-radius)]} {
            set pars(-radius) 12
        }
        set coords [getDotCoords $w 0 0 $pars(-style) $pars(-radius)]
        set dtype  [getDotType $pars(-style)]
        if {[lempty $coords] || [lempty $dtype]} {return}
        set baseTag "dottmp"
        if {$dtype eq "image"} {
            if {![info exists pars(-file)] || [lempty $pars(-file)]} {return}
            global images myImages
            set img [file join . $images(imagedir) $pars(-file)]
            loadImage $baseTag $img
            $w create $dtype $coords -tags $baseTag -image $myImages($baseTag) -state hidden
        } else {
            $w create $dtype $coords -tags $baseTag -fill white -outline red -dash {4 4} -state normal
        }
        bind $w <Motion> "+draw_changeDotTmpCoords $w %x %y $baseTag $pars(-style) $pars(-radius)"
        bind $w <Leave>  "hideDotTmp $w"
        bind $w <Enter>  "showDotTmp $w %x %y $baseTag $pars(-style) $pars(-radius)"
    }
    bind $w <ButtonPress-1> "drawPlot $w %x %y {$cmds}"
    set lname $layers($layers(top))
    set oname [lindex $objects($lname) $obj]
    catch {setCursor $w "$oname"}
}
proc showDotTmp {w x y tag style radius} {
    catch {
        draw_changeDotTmpCoords $w $x $y $tag $style $radius
        $w itemconfig dottmp -state normal
    }
}
proc hideDotTmp {w} {
    catch {
        $w itemconfig dottmp -state hidden
    }
}
proc draw_changeDotTmpCoords {w x y tag style radius} {
    global canvas layers
    set x [$w canvasx $x]
    set y [$w canvasy $y]
    $w itemconfig $tag -state normal
    set coords [getDotCoords $w $x $y $style $radius]
    $w coords $tag $coords
}
proc setCursor {w name} {
    global cursors
    if {[macPlatform]} {return 0}
    set p [string index $::tcl_platform(platform) 0]
    if {![info exists cursors($name)] && ![info exists cursors(${name}_$p)]} {return 0}
    if {[info exists cursors(${name}_$p)] && $p eq "w" && [regexp {\.cur\M} $cursors(${name}_$p)]} {
        if {[bm_exe]} {
            $w configure -cursor [file rootname $cursors(${name}_$p)]
        } else {
            $w configure -cursor "@[file join . $cursors(cursordir) $cursors(${name}_$p)]"
        }
    } elseif {[info exists cursors(${name}_$p)] && $p eq "u" && [regexp {\.xbm\M} $cursors(${name}_$p)]} {
        $w configure -cursor "@[file join . $cursors(cursordir) $cursors(${name}_$p)] black"
    } elseif {![info exists cursors(${name}_$p)]} {
        if {[info exists cursors($name)]} {
            if {[catch {$w configure -cursor $cur}]} {alertError ":   ."; return 0}
        } else {alertError ":   ."; return 0}
    } else {alertError ":   ."; return 0}
    return 1
}
proc invokeFirstButton {c} {
    global layers
    set firstButton [getStr [lindex $layers(butnames) 0]]
    leftTB "$firstButton" $c
}
proc drawPlot {w x y pars} {
    global layers canvas
    if {$canvas(busy)} {return}
    if {!$layers($layers(top),editable)} {
        alertError "  .   \n   ."
        return
    }
    if {!$layers($layers(top),visible)} {
        alertError " .   \n   ."
        return
    }
    set class  [lindex $pars 0]
    set objnum [lindex $pars 1]
    set params [getAllParams $w $layers(top) $objnum]
    if {$params eq "-state hidden"} {
        alert " ."
        return
    }
    switch -- $class {
        bridge  {drawBridge $w $x $y $objnum {} 0}
        dot     {set tag [drawDot $w $x $y $objnum {} {}]; showProps $w $tag}
        text    {set tag [setText $w $x $y $objnum 1]; showProps $w $tag}
        default {draw_plotInit $w $x $y $objnum}
    }
}
proc createBridge {w coords obj l id} {
    global bridges layers complex
    if {[lempty $id]} {return}
    if {[lempty [getStr $l]]} {set l $layers(top)}    
    set lineCoords1 [lrange $coords 0 7]
    set lineCoords2 [lrange $coords 8 end]
    set polyCoords  [getBridgePolyCoords $coords]
    set bridges(tag) "bridge${l}_${obj}_$id"
    set tag0 "line${id}_0"
    set tag1 "line${id}_1"
    set tag2 "poly${id}_2"
    set complex($tag0) $bridges(tag)
    set complex($tag1) $bridges(tag)
        set complex($tag2) $bridges(tag)
    set complex($bridges(tag)) "$tag0 $tag1"
    set complex($bridges(tag),elts) "$tag0 $tag1 $tag2"
    $w create line $lineCoords1 -tags $tag0 -width 2
    $w create line $lineCoords2 -tags $tag1 -width 2
    $w create polygon $polyCoords -outline black -fill white -tags $tag2
    $w raise $tag0 $tag2
    $w raise $tag1 $tag2
    group $w $bridges(tag) "$tag0 $tag1 $tag2"
    applyParams $w $bridges(tag) $obj $l
    positionElt $w $id
}
proc getBridgeCoords {w elt} {
    global complex bridges
    set class [getClass $w $elt]
    if {$class ne "bridge"} {return}
    set coords {}
    if {[regexp bridge $elt]} {
        set elts $complex($elt)
    } else {set elts $complex($complex($elt))}
    foreach elem $elts {
        set coords [concat $coords [$w coords $elem]]
    }
    return $coords
}
proc nodeMove {w x y} {
    global nodes plot complex
    set elt ""
    set nodes(lastNode) [getTag $w current]
    regsub -all {\+nodeOval_\d+$} $nodes(lastNode) "" elt
    set tag [getComplexTag $w $elt]
    set nodeNum ""
    regexp {(\d+)$} $nodes(lastNode) nodeNum
    if {[lempty $nodeNum] || ![string is integer $nodeNum] || $nodeNum < 0} {return}
    set plotCoords [$w coords $elt]
    set x [$w canvasx $x]
    set y [$w canvasy $y]
    set xpos [expr {2*$nodeNum}]
    set ypos [expr {$xpos+1}]
    set type [$w type $elt]
    set rad $plot(ovalRad)
    if {[isPolyType $type] || $type eq "text"} {
        set dx [expr {$x - $nodes(lastX)}]
        set dy [expr {$y - $nodes(lastY)}]
        set xval [lindex $plotCoords $xpos]
        set yval [lindex $plotCoords $ypos]
        if {[lempty $xval] || [lempty $yval]} {return}
        set plotX [expr {$dx + $xval}]
        set plotY [expr {$dy + $yval}]
        set newCoords [lreplace $plotCoords $xpos $ypos $plotX $plotY]
        $w coords $elt $newCoords
        if {[smoothedObject $elt]} {
            changeOvalsCoords $w $elt $newCoords
        } else {
            $w move $nodes(lastNode) $dx $dy
        }
        if {[getClass $w $tag] eq "dot"} {
            set poly [lindex $complex($tag) 0]
            $w move $poly $dx $dy
            changeDotArrows $w [takeID $tag]
        }
        set nodes(lastX) $x
        set nodes(lastY) $y
    }
    set class [getClass $w $elt]
    if {$class eq "bridge" && ($nodeNum==1 || $nodeNum==2)} {
        changeBridgePoly $w $tag
    } elseif {$class eq "TOP"} {
        hideActiveTOPLine $w
        set complex(activeTOPLine) "TOPLine+$tag"
        set complex(activeTOP) [getActiveTOPtag]
        showActiveTOPLine $w
        changeTOPTxt $w $complex($complex(activeTOP),text) $complex(activeTOP)
    }
}
proc changeOvalsCoords {w elt coords} {
    set npnts [expr {[llength $coords]/2}]
    for {set i 0} {$i < $npnts} {incr i} {
        set ovalTag "$elt+nodeOval_$i"
        foreach {x y} [bezierCoords $coords $i] {break}
        $w coords $ovalTag [nodeOvalCoords $x $y $::plot(ovalRad)]
    }
}
proc bezierCoords {coords node} {
    set npnts [expr {[llength $coords]/2}]
    if {$node==0} {
        set x0 [lindex $coords end-1]
        set y0 [lindex $coords end]
        set x1 [lindex $coords 0]
        set y1 [lindex $coords 1]
        set x2 [lindex $coords 2]
        set y2 [lindex $coords 3]
    } elseif {$node==$npnts-1} {
        set x0 [lindex $coords [expr {2*$node-2}]]
        set y0 [lindex $coords [expr {2*$node-1}]]
        set x1 [lindex $coords [expr {2*$node}]]
        set y1 [lindex $coords [expr {2*$node+1}]]
        set x2 [lindex $coords 0]
        set y2 [lindex $coords 1]
    } else {
        set x0 [lindex $coords [expr {2*$node-2}]]
        set y0 [lindex $coords [expr {2*$node-1}]]
        set x1 [lindex $coords [expr {2*$node}]]
        set y1 [lindex $coords [expr {2*$node+1}]]
        set x2 [lindex $coords [expr {2*$node+2}]]
        set y2 [lindex $coords [expr {2*$node+3}]]
    }
    set t 0.5
    set x [expr {($x2-$x0)*pow($t,3)-3*($x1-$x0)*pow($t,2)+3*($x1-$x0)*$t+$x0}]
    set y [expr {($y2-$y0)*pow($t,3)-3*($y1-$y0)*pow($t,2)+3*($y1-$y0)*$t+$y0}]
    return [list $x $y]
}
proc nodeMoveStop {w} {
    global plot
    foreach elt $plot(selected) {
        setParams $w $elt
        setChangeState $w $elt 1
    }
    setSelect $w $plot(selected) 1
    bind $w <Motion> ""
    bind $w <ButtonPress-1> "plotEdit $w %x %y"
}
proc changeBridgePoly {w ctag} {
    global complex
    if {![info exists complex($ctag,elts)] || [lempty $complex($ctag,elts)]} return
    set poly [lindex $complex($ctag,elts) end]
    $w coords $poly [getBridgePolyCoords "[$w coords [lindex $complex($ctag,elts) 0]] [$w coords [lindex $complex($ctag,elts) 1]]"]
}
proc plotMove {w x y} {
    global plot complex
    set x [$w canvasx $x]
    set y [$w canvasy $y]
    set tag [lindex [$w gettags current] end-1]
    if {[lempty $tag]} {return}
    if {![regexp {current|selected} $tag]} {
        set class [getClass $w $tag]
        if {$class eq "TOP"} {
            group $w selected "$complex(activeTOP) $complex(activeTOPLine)"
        } else { group $w selected $tag }
    }
    #group $w selected nodeOvals
    $w move selected [expr $x-$plot(lastX)] [expr $y-$plot(lastY)]
    catch {$w raise nodeOvals selected}
    set plot(lastX) $x
    set plot(lastY) $y
    if {$tag eq "current"} {set tag [lindex [$w gettags current] end-2]}
    set class [getClass $w $tag]
    if {$class eq "dot"} {
        changeDotArrows $w [takeID $tag]
    }
    setChangeState $w $tag 1
}
proc plotMoveStop {w tag} {
    global complex
    $w dtag selected
    setParams $w $tag
    bind $w <Motion> ""
    bind $w <ButtonPress-1> "plotEdit $w %x %y"
}
proc savePlotToFile {w fd cache} {
    global objects grid binds layers2 srvids
    set objs [array names objects]
    set res ""
    if {$cache} {set what ""} else {set what ""}
    progress "  $what..."
    foreach obj $objs {
        if {![string is integer -strict $obj]} {continue}
        if {$cache && [info exists srvids($obj)]} {
            #    ,    
            lappend res $obj
        } elseif {!$cache && ![info exists srvids($obj)]} {
            #  ()   ,    
            lappend res $obj
        }
    }
    set res [lsort -integer -decreasing $res]
    foreach obj $res {
        if {[lempty $objects($obj)]} {continue}
        set objstr "[lrange $objects($obj) 0 end-1] {[lsort $grid($obj)]}"
        set objstr "[convToNew $objstr]"
        if {$cache && [info exists srvids($obj)]} {
            set id     $srvids($obj)
            set objstr [lreplace $objstr 0 0 $id]
        }
        if {[isNetObj $obj] && [getClass $w [getTagBySrvID $obj]] eq "dot" && ![info exists binds($obj)]} {
            set binds($obj) {}
        }
        set specPars "[lindex $objstr 10]"
        set objstr   [lreplace $objstr end end $specPars]
        if {[info exists binds($obj)]} {
            set objstr "$objstr {$binds($obj)}"
        }
        if {[catch {
            puts $fd [mkpar $objstr]
            flush $fd
        }]} {
            alertError ":    ."
            return
        }
    }
    progress ""
}
proc getOneParam {w elt par} {
    if {![catch {
        set val [lindex [$w itemconfig $elt $par] end]
    }]} {
        return $val
    }
    return 0
}
#      Z-
proc delFromDiv {w tag} {
    global divs layers
    if {[lempty $tag]} {return}
    set spl [split [getStr $tag] "_"]
    set layer [string index [lindex $spl 0] end]
    set objID [lindex $spl 1]
    #fixme? layers(N) must be less than 11
    if {![string is integer -strict $layer] || \
        $layers(N) > 10 || [lempty $objID]} {
            debug "err0:$layers(N):$objID:$tag"
            return
    }
    set div "div${layer}_$objID"
    if {[info exists divs($div)]} {
        set divs($div) [delFromList $divs($div) $tag]
    }
}
proc getTmpID {} {
    global tmpID
    return [incr tmpID -1]
}
proc alertQuestion {msg {def "yes"}} {
    return [tk_messageBox -icon question -type yesno -default $def -title "" -parent . -message $msg]
}
proc alertWarning {msg} {
    tk_messageBox -icon warning -type ok -title "" -message $msg
}
proc alertError {msg} {
    tk_messageBox -icon error -type ok -title "" -message "$msg"
}
proc alert {msg} {
    tk_messageBox -icon info -type ok -title "" -message "$msg"
}
proc passiveClr {} { return [expr {([windowsPlatform]) ? "SystemButtonFace" : "\#d9d9d9"}]}
proc activeClr  {} { return "gray85" }
proc getTag {w elt} {
    return [lindex [$w gettags $elt] 0]
}
#  : "1 ", "2 ", "12 "...
proc getTermination {n} {
    if {![string is integer $n] || $n < 0} {return}
    set word "$n "
    set rem10 [expr $n % 10]
    set rem100 [expr $n % 100]
    if {$rem100 >= 11 && $rem100 <= 14 || $rem10 == 0 || $rem10 >= 5 && $rem10 <= 9} {
        append word ""
    } elseif {[lcontain {2 3 4} $rem10]} {
        append word ""
    }
    return $word
}
proc multiDel {w ever ask} {
    global plot srvids delobjs delobjstr objects
    if {[llength $plot(selected)]==0} {return}
    if {$ask} {
        set window $w.deldialog
        set title  " "
        set numo [llength $plot(selected)]
        if {$numo == 1} {
            set text "  ?"
        } else {
            set text " [getTermination $numo]?"
        }
        set bitmapname "question"
        set defaultbut 0
        set msg [tk_messageBox -icon $bitmapname -type yesno \
            -title "" -parent $w -default yes    -message $text]
        if {$msg eq "no"} {
            return
        }
    }
    if {$ever} {
        foreach tag $plot(selected) {
            set srvid [takeID $tag]
            if {[info exists srvids($srvid)] && ![lempty $srvids($srvid)]} {
                lappend delobjs $srvids($srvid)
                set delobjstr($srvids($srvid)) $objects($srvid)
                set srvids($srvid) ""
            }
        }
    }
    foreach elt $plot(selected) {
        del $w $elt $ever 0 0
    }
    removeSelection $w
}
proc del {w elt ever ask fromsrv} {
    global objects plot grid ids srvids delobjs delobjstr
    set elt [getComplexTag $w $elt]
    set srvid [takeID $elt]
    if {$ever} {
        if {$ask} {
            set window     $w.deldialog
            set title      " "
            set text       "  ?"
            set bitmapname "question"
            set defaultbut 0
            set msg [tk_messageBox -icon $bitmapname -type yesno \
                -title "" -parent $w -default yes    -message $text]
            if {$msg eq "no"} {
                return
            }
        }
        set oName [getObjectName $elt]
        if {[lempty $oName]} {return}
        set lName $objects(layer,$oName)
        set ids($lName,$oName) [delFromList $ids($lName,$oName) $srvid]
        delFromLayer $srvid
        #g_delObject $srvid
    }
    set class [getClass $w $elt]
    if {$ever && $fromsrv && [info exists srvids($srvid)] && ![lempty $srvids($srvid)]} {
        lappend delobjs $srvids($srvid)
        set delobjstr($srvids($srvid)) $objects($srvid)
        set srvids($srvid) ""
    }
    if {$ever} {set objects($srvid) {}}
    if {$class eq "TOP"} {
        delTOP $w $elt
    } elseif {$class eq "bridge"} {
        delBridge $w $elt
    }
    if {[isSelected $elt]} {
        unSelect $w $elt
    }
    catch {
        $w delete $elt
        $w dtag $elt
    }
    delFromShown $srvid
    delFromDiv $w $elt
}
proc delTOP {w TOPtag} {
    global complex plot
    if {$complex(activeTOP) == $TOPtag} {
        delTOPLine $w
    }
    $w delete $TOPtag
    $w dtag $TOPtag
    if {[lsearch $plot(selected) "TOPLine+$TOPtag"] > -1} {
        unSelect $w "TOPLine+$TOPtag"
    }
    set complex($TOPtag) ""
    set complex($TOPtag,text) ""
    set complex($TOPtag,elts) ""
}
proc delBridge {w tag} {
    global complex
    $w delete $tag
    $w dtag $tag
    set complex($tag,elts) ""
}
proc setChangeState {w tag state} {
    global objects changed
    set locid [takeID $tag]
    #        (  ),
    #      ,
    #      :
    set changed($locid) $state
    catch {
        set changed([expr -$locid]) $state
    }
    set srvid [getSrvID $w $tag]
    if {[lempty $srvid]} {return}
    catch {set objects($srvid) [lreplace $objects($srvid) end end $state]}
}
proc getDefType {objName} {
    global types
    foreach {t par} $types($objName) {
        if {[regexp {\*$} "$t"]} {return "$t"}
    }
    return "{}"
}
proc getDefState {objName} {
    global states
    foreach {s par} $states($objName) {
        if {[regexp {\*$} "$s"]} {return "$s"}
    }
    return "{}"
}
proc put {w el} {
    global objects layers canvas ids
    set srvid [takeID $el]
    set layer [getLayer $el]
    if {![info exists objects($srvid)] || [lempty $objects($srvid)]} {
        set obj     [getObject $el]
        set lName   $layers($layer)
        set oName   [lindex $objects($lName) $obj]
        if {[lempty "$oName"]} {return}
        set type   "{[getDefType  $oName]}"
        set state  "{[getDefState $oName]}"
        set objects($srvid) "$srvid {{$lName}} {{$oName}} {{}} {$type} {$state} {{}} {{}} {{}} 1"
        addToShown $srvid
        positionElt $w $srvid
        catch {lappend ids($lName,$oName) $srvid}
    }
    setParams $w $el
}
proc setParams {w el} {
    global layers complex objects
    if {[lempty $el]} {return}
    set class [getClassByTag $el]
    set srvid [takeID $el]
    if {![info exists objects($srvid)]} {return}
    switch $class {
        polygon {
            set coords "[$w coords $el]"
            if {[lempty $coords]} {return}
            set coords [countCoords2 $coords $layers(zoomLevel) 7]
            set params "7 {$coords} {-smooth [lindex [$w itemconfig $el -smooth] end]}"
        }
        line {
            set coords "[$w coords $el]"
            if {[lempty $coords]} {return}
            set coords [countCoords2 $coords $layers(zoomLevel) 7]
            set params "7 {$coords} {-smooth [lindex [$w itemconfig $el -smooth] end]}"
            if {[info exists ::chbinds($srvid)]} {
                foreach id $::chbinds($srvid) {
                    if {[info exists ::srvids($id)]} {
                        lappend params $::srvids($id)
                    }
                }
            }
        }
        bridge {
            set coords "[getBridgeCoords $w $el]"
            if {[lempty $coords]} {return}
            set coords [countCoords2 $coords $layers(zoomLevel) 7]
            set params "7 {$coords}"
        }
        TOP {
            set coords "[$w coords TOPLine+$el]"
            if {[lempty $coords]} {return}
            set coords [countCoords2 $coords $layers(zoomLevel) 7]
            set params "7 {$coords} {$complex($el,text)}"
        }
        dot {
            if {![info exists complex($el)]} {return}
            set coords "[$w coords [lindex $complex($el) 1]]"
            if {[lempty $coords]} {return}
            set coords [countCoords2 $coords $layers(zoomLevel) 7]
            set params "7 {$coords}"
        }
        text {
            set coords "[$w coords $el]"
            if {[lempty $coords]} {return}
            set coords [countCoords2 $coords $layers(zoomLevel) 7]
            set txt    "[getOneParam $w $el -text]"
            set anch   "-anchor [getOneParam $w $el -anchor]"
            set params "7 {$coords} {$txt} {$anch}"
        }
        default {return}
    }
    set objects($srvid) [lreplace $objects($srvid) 3 3 "$params"]
    countGrid $w $srvid
    #if {$class eq "dot"} {autoBindBox $w $srvid}; # fixme: use it from time to time
    updateBalloon $w $el
}
proc unbindAll {w} {
    bind $w <ButtonPress-1> ""
    bind $w <ButtonPress-3> ""
    bind $w <ButtonRelease-1> ""
    bind $w <ButtonRelease-3> ""
    bind $w <Motion> ""
    bind . <Control-ButtonPress-1> ""
    $w configure -cursor ""
}
proc getCanvasSize {zl} {
    return [lindex $::canvas(sizes) $zl]
}
proc getCenterCoords {w} {
    set scr [getScreenBbox $w]
    set centerX [expr {([lindex $scr 0]+[lindex $scr 2])/2}]
    set centerY [expr {([lindex $scr 1]+[lindex $scr 3])/2}]
    return "$centerX $centerY"
}
proc getLayer {tag} {
    set spl [split [getStr $tag] "_"]
    return [string index [lindex $spl 0] end]
}
proc getLayerByID {id} {
    global layers objects
    if {[info exists objects($id)] && ![lempty $objects($id)]} {
        set lname [getStr [lindex $objects($id) 1]]
        return "$layers($lname)"
    }
    return
}
proc getLayerIDByName {layerName} {
    global layers
    if {![lempty $layerName] && [info exists layers($layerName)]} {
        return $layers($layerName)
    }
    return
}
proc getObject {el} {
    return [lindex [split [getStr $el] "_"] 1]
}       
proc getObjectName {el} {
    return [getObjNameByLayer "[getLayer $el]" "[getObject $el]"]
}
proc getObjectID {layerNum objName} {
    return [lsearch $::objects($::layers($layerNum)) $objName]
}
proc changeSmooth {w} {
    global plot multi
    if {[lempty $plot(selected)]} {return}
    setCursor $w chSmooth    
    foreach elt $plot(selected) {
        if {![isPolyType [getClass $w $elt]]} {continue}
        if {[smoothedObject $elt]} {
            catch {$w itemconfigure $elt -smooth 0}
        } else {catch {$w itemconfigure $elt -smooth 1 -splinesteps 100}}
        setParams $w $elt
        setChangeState $w $elt 1
    }
    setSelect $w $plot(selected) 1
}
proc copySelected {w} {
    if {[lempty $::plot(selected)]} {return}
    set ::clipboard(obj) $::plot(selected)
}
proc copyTag {tag} {
    set last [string last "_" $tag]
    set newtag [string range $tag 0 [expr {$last - 1}]]_[getID]
    return $newtag
}
proc shiftCoords {coords shift} {
    set newcoords [list]
    foreach {x y} $coords {
        lappend newcoords [expr {$x + $shift}] [expr {$y + $shift}]
    }
    return $newcoords
}
proc insertObjects {w} {
    global clipboard layers plot objects complex
    if {[lempty $clipboard(obj)]} {return}
    removeSelection $w
    set shift 15
    foreach tag $clipboard(obj) {
        set id    [takeID $tag]
        set class [getClassByTag $tag]
        set objnum [getObject $tag]
        set l [getLayer $tag]
        if {$class eq "dot"} {
            set coords [getCoords $id]
            set newid [getID]
            set objects($newid) [concat $newid [lrange $objects($id) 1 end]]
            set newcoords [shiftCoords $coords $shift]
            foreach {x y} $newcoords {break}
            set newtag [drawDot $w $x $y $objnum $l $newid]
            setChangeState $w $newtag 1
            setSelect $w $newtag 1
            continue
        }
        if {$class eq "TOP"} {
            set newtag [copyTag $tag]
            set coords [getCoords $id]
            set newcoords [shiftCoords $coords $shift]
            set complex(activeTOPLine) "TOPLine+$newtag"
            $w create line $newcoords -tags $complex(activeTOPLine)
            set complex(activeTOP) $newtag
            set TOPtxt [lindex $objects($id) 3 end]
            arrangeTOP $w $TOPtxt $objnum $newtag $l $newcoords "default"
            set newid [takeID $newtag]
            continue
        }
        if {$class eq "text"} {
            set coords [getCoords $id]
            set newtag [copyTag $tag]
            set newid  $::ID
            set objects($newid) [concat $newid [lrange $objects($id) 1 end]]
            set newcoords [shiftCoords $coords $shift]
            set params [lindex $objects($id) 3]
            eval [subst "$w create text $newcoords -tags $newtag -text {[lindex $params 2]} [lindex $params 3]"]
            applyParams $w $newtag $objnum $l
            setChangeState $w $newtag 1
            continue
        }
        if {$class eq "bridge"} {
            set coords [getCoords $id]
            set newtag [copyTag $tag]
            set newid  $::ID
            set objects($newid) [concat $newid [lrange $objects($id) 1 end]]
            set newcoords [shiftCoords $coords $shift]
            createBridge $w $newcoords $objnum $l $newid
            setChangeState $w $newtag 1
            continue
        }
        set newtag [copyTag $tag]
        set coords [shiftCoords [$w coords $tag] $shift]
        $w create $class $coords -tags $newtag
        put $w $newtag
        set newid [takeID $newtag]
        set type  [lindex $objects($id) 4]
        set state [lindex $objects($id) 5]
        set name  [lindex $objects($id) 6]
        set addr  [lindex $objects($id) 7]
        set comm  [lindex $objects($id) 8]
        lset objects($newid) 4 $type
        lset objects($newid) 5 $state
        lset objects($newid) 6 $name
        lset objects($newid) 7 $addr
        lset objects($newid) 8 $comm
        setChangeState $w $newtag 1
        applyParams $w "$newtag 1" $objnum {}
        setSelect $w $newtag 1
        updateBalloon $w $newtag
    }
    reposSelected $w raise
}
proc addRemNode {w} {
    unbindAll $w
    setCursor $w addremnode
    bind $w <ButtonPress-1> "addNode $w"
    bind $w <ButtonPress-3> "rmNode $w"
}
proc addNode {w} {
    global plot nodes complex
    set nodes(lastNode) [getTag $w current]
    set spl [split $nodes(lastNode) "+"]
    set elt [lindex $spl 0]
    if {$elt eq "TOPLine"} {
        set elt "TOPLine+[lindex $spl 1]"
    } else {
        set elt [getComplexTag $w $elt]
    }
    set class [getClass $w $elt]
    if {$class eq "bridge" || $class eq "dot" || $class eq "text"} {return}
    bind $w <ButtonRelease-1> ""
    bind $w <ButtonRelease-3> ""
    bind $w <Motion> ""
    if {[isPolyType [$w type $elt]] && [regexp "nodeOval" $nodes(lastNode)]} {
        set oldCoords [$w coords $elt]
        regexp {(\d+)$} $nodes(lastNode) nodeNum
        if {![string is integer $nodeNum]} return
        set numPoints [expr {([llength $oldCoords]/2)-1}]
        set oldXpos [expr 2*$nodeNum]
        set x1 [lindex $oldCoords $oldXpos]
        set y1 [lindex $oldCoords [expr $oldXpos+1]]
        if {$nodeNum < $numPoints} {
            set x2 [lindex $oldCoords [expr $oldXpos+2]]
            set y2 [lindex $oldCoords [expr $oldXpos+3]]
        } else {
            set x2 [lindex $oldCoords 0]
            set y2 [lindex $oldCoords 1]            
        }
        set x [expr {($x1+$x2)/2}]
        set y [expr {($y1+$y2)/2}]
        set newCoords [linsert $oldCoords [expr $oldXpos+2] $x $y]
        $w coords $elt $newCoords
        if {$elt == $complex(activeTOPLine)} {
            changeTOPTxt $w $complex($complex(activeTOP),text) $complex(activeTOP)
        }
        unSelect $w $elt
        setSelect $w $elt 0
        setParams $w $elt
        setChangeState $w $elt 1
    }
    bind $w <ButtonPress-1> "addNode $w"
}
proc rmNode {w} {
    global plot nodes complex
    set nodes(lastNode) [getTag $w current]
    set spl [split $nodes(lastNode) "+"]
    set elt [lindex $spl 0]
    if {$elt eq "TOPLine"} {
        set elt "TOPLine+[lindex $spl 1]"
    } else {
        set elt [getComplexTag $w $elt]
    }
    set class [getClass $w $elt]
    if {$class eq "bridge" || $class eq "dot" || $class eq "text"} {return}
    if {$elt eq "TOPLine"} {
        set tag [lindex $spl 1]
        set elt "TOPLine+$tag"
    } else {set tag $elt}
    bind $w <ButtonRelease-1> ""
    bind $w <ButtonRelease-3> ""
    bind $w <Motion> ""
    if {[isPolyType [$w type $elt]] && [regexp "nodeOval" $nodes(lastNode)]} {
        set oldCoords [$w coords $elt]
        regexp {(\d+)$} $nodes(lastNode) nodeNum
        if {[llength $oldCoords] > 4 && [string is integer $nodeNum]} {
            $w dchars $elt [expr 2*$nodeNum]
            if {$elt == $complex(activeTOPLine)} {
                changeTOPTxt $w $complex($complex(activeTOP),text) $complex(activeTOP)
            }
            unSelect $w $elt
            setSelect $w $tag 0
            setParams $w $tag
            setChangeState $w $tag 1
        } else {
            unSelect $w $tag
            del $w $tag 1 0 1
            set nodes(lastNode) ""
        }
    }
    bind $w <ButtonPress-3> "rmNode $w"
}
proc draw_plotInit {w x y objnum} {
    set x [$w canvasx $x]
    set y [$w canvasy $y]
    if {[regexp nodeOval [$w gettags current]]} {
        initNodeMove $w $x $y "draw_nodeMoveStop $w $objnum"
        return
    }
    draw_drawPlot $w $x $y $objnum
}
proc draw_nodeMoveStop {w objnum} {
    global plot
    setChangeState $w $plot(selected) 1
    setParams $w $plot(selected)
    bind $w <ButtonRelease-1> ""
    bind $w <Motion> ""
    bind $w <ButtonPress-1> "draw_plotInit $w %x %y $objnum"
    if {![lempty $plot(selected)]} {
        setSelect $w $plot(selected) 1
    }
}
proc draw_drawPlot {w x y objnum} {
    global plot layers complex
    removeSelection $w
    lockAllButtons $w 0
    hideActiveTOPLine $w
    set plotType [getClassByObj $objnum $layers(top)]
    if {$plotType eq "" || [lempty $plotType]} {unlockAllButtons $w 0; return}
    if {$plotType eq "TOP"} {
        set tag "TOPLine+TOP${layers(top)}_${objnum}_[getID]"
        $w create line $x $y $x $y -tags $tag
        set complex(activeTOPLine) $tag
    } else {
        set tag $plotType${layers(top)}_${objnum}_[getID]
        $w create $plotType $x $y $x $y -tags $tag
        applyParams $w "$tag 1" $objnum {}
    }
    catch {setChangeState $w $tag 1}
    bind $w <Motion> "draw_changePlotCoords $w %x %y $tag"
    bind $w <ButtonPress-1> "draw_addNodeToPlot $w %x %y $tag $objnum"
    bind $w <ButtonPress-3> "draw_drawPlotStop $w $tag $objnum"
}
proc draw_addNodeToPlot {w x y plot objnum} {
    global layers
    set x [$w canvasx $x]
    set y [$w canvasy $y]
    set coords [$w coords $plot]
    lappend coords $x $y
    $w coords $plot $coords
    set plotType [getClassByObj $objnum $layers(top)]
    if {$plotType eq "TOP"} {set plotType "line"}
    if {![isPolyType $plotType]} {
        draw_drawPlotStop $w $plot $objnum
    }
}
proc draw_changePlotCoords {w x y plot} {
    set x [$w canvasx $x]
    set y [$w canvasy $y]
    set coords [$w coords $plot]
    $w coords $plot [lreplace $coords end-1 end $x $y]
}
proc draw_drawPlotStop {w tag objnum} {
    global layers drawComplete
    bind $w <Motion> ""
    set plotType [getClassByObj $objnum $layers(top)]
    if {$plotType eq "TOP"} {
        getTOPtext $w {} $objnum {}
        vwait drawComplete
    } else {
        put $w $tag
        setSelect $w $tag 1
    }
    unlockAllButtons $w 0
    bind $w <ButtonPress-1> "draw_plotInit $w %x %y $objnum"
    if {![lempty $tag]} {
        showProps $w $tag
    }
}
proc setText {w x y objnum ins} {
    global nodes plot
    set x [$w canvasx $x]
    set y [$w canvasy $y]
    if {[regexp nodeOval [$w gettags current]]} {
        initNodeMove $w $x $y "text_nodeMoveStop $w $objnum"
        return
    }
    lockAllButtons $w 0
    set tfont $::fonts(txt)
    set bfont $::fonts(buts)
    set t $w.text
    catch {destroy $t}
    catch {toplevel $t}
    wm title $t " ."
    if {[unixPlatform]} {wm iconbitmap $t @[file join . img botikmap.xbm]}    
    catch { wm deiconify $t; raise $t;}
    focus -force $t
    frame $t.f
    pack $t.f
    frame $t.f.ft
    pack $t.f.ft -side top
    set ftxt $t.f.ft
    set i 1
    set tag [getTag $w current]
    set class [getClass $w $tag]
    set txt  ""
    set anch ""
    if {$class eq "text"} {
        catch { set txt  [lindex [$w itemconfig $tag -text] end] }
        catch { set anch [lindex [$w itemconfig $tag -anchor] end] }
    } else {set tag ""}
    label $ftxt.tl -text " :" -font $tfont
    set ::tv ""
    entry $ftxt.e -width 30 -textvar tv -takefocus 1 -font $tfont
    pack $ftxt.tl $ftxt.e -side top -pady 5 -padx 10        
        focus -force $ftxt.e
    $ftxt.e delete 0 end
    $ftxt.e insert 0 $txt
    setRussianKeys $ftxt.e
    frame $t.f.fa
    pack $t.f.fa -side top
    set a $t.f.fa
    label $a.la -text "    :" -font $tfont
    pack $a.la -side top
    foreach {f anchs} "$a.f1 {- se  s - sw} $a.f2 { e { } center  w} $a.f3 {- ne  n - nw}" {
        frame $f
        pack $f -side top
        foreach {a1 a2} $anchs {
            $::widget(radiobutton) $f.r$a2 -variable pos -text $a1 -relief flat \
            -value $a2 -indicatoron 0 -width 13 -font $tfont
            pack $f.r$a2 -side left
            if {$a2 == $anch} {
                #$f.r$a2 select
                set pos $a2
            }
        }
    }
    if {[lempty $anch]} {
        #$a.f2.rcenter select
    }
    frame $t.f.b
    pack $t.f.b -side top
    set tg ""
    button $t.f.b.ok -text "" -width 10 -padx 5 -relief raised -default active \
            -activebackground [activeClr] -highlightbackground [activeClr] \
            -command "putText $w $x $y {$tag} $objnum; destroy $t" -font $bfont
    button $t.f.b.cancel -text "" -width 10 -padx 5 -relief raised\
            -activebackground [activeClr] -highlightbackground [activeClr] \
            -command "destroyTextDialog $t" -font $bfont
    pack $t.f.b.ok $t.f.b.cancel -side left -padx 3 -pady 3
    bind $ftxt.e <KeyPress-Return> "$t.f.b.ok invoke"
    bind $t <KeyPress-Escape> "$t.f.b.cancel invoke"
    bind $t <Destroy> "destroyTextDialog $t"
    update idletasks
    vwait drawComplete
    unlockAllButtons $w 0
    if {![lempty $tg]} {showProps $w $tg}
}
proc destroyTextDialog {t} {
    global drawComplete
    destroy $t
    set drawComplete 1
}
proc putText {w x y tag objnum} {
    global pos tv layers plot drawComplete
    if {[lempty $tv]} return
    set class [getClass $w $tag]
    if {![info exists pos] || $pos eq ""} {set pos "center"}
    if {$class eq "text"} {
        catch {$w itemconfig $tag -text $tv -anchor $pos}
        setSelect $w $tag 1
        setChangeState $w $tag 1
    } else {
        set tag "text${layers(top)}_${objnum}_[getID]"
        $w create text $x $y -text "$tv" -anchor $pos -tags $tag
        put $w $tag
        applyParams $w $tag $objnum {}
        setSelect $w $tag 1
    }
    set drawComplete 1
    if {![lempty $tag]} {showProps $w $tag}
}
proc text_nodeMoveStop {w objnum} {
    bind $w <ButtonRelease-1> ""
    bind $w <Motion> ""
    bind $w <ButtonPress-1> "setText $w %x %y $objnum 1"
}
proc getSrvID {w tag} {
    return [takeID [getComplexTag $w $tag]]
}
proc takeID {el} {
    set id ""
    regexp {(\d+)$} $el id
    return -$id
}
proc setLayerButsState {l st} {
    global layers
    if {$layers($l,top)} {
        foreach b $layers(buts) {
            catch {"$b" configure -state $st}
        }
    }
}
proc setTbButsState {state} {
    global layers
    foreach b $layers(tButs) {
        catch {"$b" configure -state $state}
    }
}
proc layerManager {w} {
    global layers man_edit man_vis top plot
    set l $w.lm
    catch {destroy $l}
    if {[winfo exists $l]} {
        catch { wm deiconify $l; raise $l; }
        focus -force $l
        update idletasks
        return
    }
    catch {toplevel $l}
    set tfont $::fonts(txt)
    set tfontb $::fonts(txtb)
    set bfont $::fonts(buts)
    wm title $l " ."
    if {[unixPlatform]} {wm iconbitmap $l @[file join . img botikmap.xbm]}    
    focus -force $l
    bind $l <KeyPress-Escape> "destroy $l"
    bind $l <KeyPress-Return> "destroy $l"
    frame $l.main -relief ridge -bd 3
    pack $l.main -side left
    frame $l.buts
    pack $l.buts -side top -fill y
    set rl $l
    set l $l.main
    frame $l.f1 -height 20 -width 50
    pack $l.f1 -side left -fill y -expand yes
    $::widget(label) $l.f1.layers -text "" -relief ridge -bd 3 -width 20 -font $tfontb -anchor center
    pack $l.f1.layers -side top
    if {[unixPlatform]} {
        set pady 2
    } else {
        if {[WinNT6]} {set pady 3} else {set pady 1}
    }
    for {set i 0} {$i < $layers(N)} {incr i} {
        $::widget(label) $l.f1.layer$i -text "$layers($i)" -justify left -pady $pady -font $tfont
        pack $l.f1.layer$i -side top
    }
    frame $l.s1 -relief ridge -bd 4 -width 3
    pack $l.s1 -side left -fill y
    frame $l.f2 -height 20 -width 50
    pack $l.f2 -side left -fill y -expand yes
    $::widget(label) $l.f2.editable -text "" -relief ridge -bd 3 -width 15 -font $tfontb -anchor center
    pack $l.f2.editable -side top
    for {set i 0} {$i < $layers(N)} {incr i} {
        checkbutton $l.f2.editable$i -variable man_edit($i) -font $tfont
        pack $l.f2.editable$i -side top
    }
    frame $l.s2 -relief ridge -bd 4 -width 3
    pack $l.s2 -side left -fill y
    frame $l.f3 -height 20 -width 50
    pack $l.f3 -side left -fill y -expand yes
    $::widget(label) $l.f3.visible -text "" -relief ridge -bd 3 -width 15 -font $tfontb -anchor center
    pack $l.f3.visible -side top
    for {set i 0} {$i < $layers(N)} {incr i} {
        checkbutton $l.f3.visible$i -variable man_vis($i) -font $tfont
        pack $l.f3.visible$i -side top
    }
    frame $l.s3 -relief ridge -bd 4 -width 3
    pack $l.s3 -side left -fill y
    frame $l.f4 -height 20 -width 50
    pack $l.f4 -side left -fill y -expand yes
    $::widget(label) $l.f4.top -text "" -relief ridge -bd 3 -width 10 -font $tfontb -anchor center
    pack $l.f4.top -side top
    for {set i 0} {$i < $layers(N)} {incr i} {
        radiobutton $l.f4.top$i -variable top -value $i -font $tfont
        pack $l.f4.top$i -side top
        if {$layers($i,top)} {
            #$l.f4.top$i select
        } else {
            set top 0
            #$l.f4.top$i deselect
        }
    }
    for {set i 0} {$i < $layers(N)} {incr i} {
        if {$layers($i,top)} {
            set top $i
        }
    }
    button $rl.buts.apply -text ""  -command "man_applyChanges $w; destroy $rl" \
        -activebackground [activeClr] -highlightbackground [activeClr] -font $bfont
#    button $rl.buts.cancel -text "" -command "destroy $rl" \
        -activebackground [activeClr] -highlightbackground [activeClr] -font $bfont
    button $rl.buts.selAll -text " " -command "selAllLayers" \
        -activebackground [activeClr] -highlightbackground [activeClr] -font $bfont
    button $rl.buts.unselAll -text " " -command "deselAllLayers" \
        -activebackground [activeClr] -highlightbackground [activeClr] -font $bfont
#$rl.buts.ok $rl.buts.cancel
    pack $rl.buts.apply $rl.buts.selAll $rl.buts.unselAll \
        -side top -padx 10 -pady 5 -fill x -expand yes
}
proc man_applyChanges {w} {
    global man_edit man_vis layers top
    set changed 0
    for {set i 0} {$i < $layers(N)} {incr i} {
        if {$layers($i,visible) !=$man_vis($i) || \
            $layers($i,editable)!=$man_edit($i)} {
            set changed 1
            break
        }
    }
    if {$layers(top) != $top} {set changed 1}
    if {!$changed} {return}
    #     - :
    # 1)  :
    for {set i 0} {$i < $layers(N)} {incr i} {
        set layers($i,visible)  $man_vis($i)
        set layers($i,editable) $man_edit($i)
    }
    setTopLayer $w $top
    # 2)   :
    updateCanvas $w "edit"
}
proc setTopLayer {w num} {
    global layers toplayer
    set last [expr $layers(N)-1]
    if {$num eq "first"} {set num 0}
    if {$num eq "last"}  {set num $last}
    if {$num < 0 || $num > $last} {return}
    set layers($layers(top),top) 0
    set layers(top) $num
    set layers($num,top) 1
    set toplayer $num
    loadStyles $w $num
    setTbButsState "normal"
    if {$layers($num,visible)} {
        if {$layers($num,editable)} {
            set st "normal"
        } else {set st "disabled"}
        setLayerButsState $num $st
    } else {
        setLayerButsState $num "disabled"
    }    
}
proc getTypesByObj {obj l} {
    global types
    set obj [getObjNameByLayer $l "$obj"]
    if {![info exists types($obj)]} return
    return $types($obj)
}
proc getStatesByObj {obj l} {
    global states
    set obj [getObjNameByLayer  $l "$obj"]
    if {![info exists states($obj)] || [lempty $states($obj)]} return
    return $states($obj)
}
proc getClassByObj {obj l} {
    global classes
    set obj [getObjNameByLayer "$l" "$obj"]
    if {![info exists classes($obj)]} return
    return $classes($obj)
}
proc getObjNameByLayer {l obj} {
    global objects layers2
    if {[string is integer $obj]} {
        if {[lempty $l]} {return}
        if {[string is integer $l]} {
            set l "$layers2($l)"
        }
        if {![info exists objects($l)]} {return}
        set obj [getStr [lindex $objects($l) $obj]]
    }
    return $obj
}
proc getParsByZoom {zoom obj l} {
    global zooms
    set obj "[getObjNameByLayer $l $obj]"
    if {![info exists zooms($obj)]} return
    foreach {z par} $zooms($obj) {
        if {[lsearch $z $zoom] != -1} {
            return $par
        }
    }
    return
}
proc loadLayers {} {
    global layers layers2 objects types states zooms ids
    loadModule "styles.txt"
    array set states {
         {
            *     {-outline green -width 3}
            { } {-outline red   -width 3}
                {-width 0}
        }
         {
            *     {-dash {}}
            { } {-dash {4 4}}
                    {-dash {6 6 6 6}}
                {-fill white}
        }
         {
            *     {-outline green -width 1}
            { } {-outline red   -width 2}
                {-outline white -width 1}
        }
         {
            { *}         {-outline black}
            { (On)}       {-outline RoyalBlue}
            { ()} {-outline sienna}
            { (Off)}      {-outline red}
                      {-outline RoyalBlue}
        }
    }
    set i 0
    set ls [array get layers2]
    foreach {num lname} $ls {
        set layers($num)      "$lname"
        set layers($lname)     $num
        foreach obj $objects($lname) {
            if {[lempty [getStr $obj]]}   {continue}
            if {![info exists types($obj)]}  {set types($obj)  ""}
            if {![info exists states($obj)]} {set states($obj) ""}
            if {![info exists zooms($obj)]}  {set zooms($obj)  "{1 2 3 4 5 6 7} {}"}
            set ids($lname,$obj) ""
            set objects(layer,[getStr $obj]) $lname
        }
        incr i
    }
    set layers(N) $i
}
proc rb_fun {b num} {
    if {!$::tbbut($num)} {
        set ::tbbut($num) 1
        return
    }
    for {set i 0} {$i < $::plot(rbuts)} {incr i} {
        if {$i != $num} {
            set ::tbbut($i) 0
        }
    }
}
proc rb_write {w args} {
    if {$::but eq ""} {return}
    set name ""
    regsub -all {[ ]} "$::but" _ name
    catch {$w.but$name invoke}
}
proc setImgButtons {c w padx pady side width height radio style state bs} {
    global layers myImages hints but
    #if {!$style} {set layers(buts) {}}
    set bcmd button
#       if {$width == 24} {
#           set bcmd button
#       } else {set bcmd tk::button}
    foreach {n h cmd} $bs {
        regsub -all {[ ]} "$n" _ name
        set bname $w.but$name
           if {![info exists myImages($n)]} {
               set myImages($n) ""
               set width [expr $width/6]
               set height [expr $height/8]
           }
        if {$radio} {
            if {[windowsPlatform]} {
                checkbutton $bname -style Toolbutton -indicatoron 0 -image "$myImages($n)" \
                    -variable ::tbbut($::plot(rbuts)) -command "rb_fun $bname $::plot(rbuts); $cmd" \
                    -width $width -height $height -state $state -takefocus 1 -relief solid -text $h
            } else {
                radiobutton $bname -image $myImages($n) -command "$cmd" \
                    -width $width -height $height -state $state -takefocus 1 \
                    -indicatoron 0 -variable but -value "$n" -relief flat -text $h \
                    -activebackground [activeClr] -highlightbackground [activeClr] -selectcolor [activeClr]
            }
            incr ::plot(rbuts)
        } else {
            $bcmd $bname -image $myImages($n) -command "$cmd" -takefocus 1 \
                -width $width -height $height -state $state -text $h \
                -activebackground [activeClr] -highlightbackground [activeClr]
        }
        if {$style} {
            lappend layers(buts) $bname
            lappend layers(butnames) $n
        }
        set layers(tButs) [lsort -unique [concat $layers(tButs) $bname]]
        set hint [expr {([lempty $h] && [info exists hints($n)]) ? $hints($n) : $h}]
        bind $bname <Any-Enter> "showHint {$hint} $bname %W %X %Y"
        bind $bname <Motion>    "showHelp %X %Y %W {$hint}"
        bind $bname <Any-Leave> "hideHint"
        pack $bname -padx $padx -pady $pady -side $side
    }
}
proc showHint {text but w x y} {
    global top
    set state [lindex [$but configure -state] end]
    if {$state eq "disabled"} {
        updateStatus hint ""
        return
    }
    updateStatus hint "$text"
    initHelp $w $x $y "$text"
}
proc hideHint {} {
    updateStatus hint ""
    killHelp
}
proc loadImage {name fname} {
    global errorCode myImages
    if {![file exists $fname]} {return}
    if {[catch {
        regsub -all {[ ]} "$name" _ newname
        set myImages($name)  [image create photo $newname -file $fname]
        set myImages($fname) $newname
    } rc]} {
        set str "      : \"$fname\"\nError: $errorCode, $rc"
        set str "$str\n\n    ."
        set str "$str\n\n  ."
        tk_messageBox -icon error -type ok -message $str
        exit
    }
    return
}
proc group {w maintag tags} {
    foreach tag $tags {
        $w addtag $maintag withtag $tag
    }
}
proc isKey {objname num} {
    global keys
    if {![info exists keys($objname)]} {return 0}
    return [expr {[lsearch -integer $keys($objname) $num] > -1}]
}
proc showProps {w tag} {
    global objects complex bridges oType$tag name$tag addr$tag comm$tag donothing$tag plot canvas srvids
    set hfont $::fonts(heads)
    set tfont $::fonts(txt)
    set bfont $::fonts(buts)
    set ::donothing$tag 0
    set tag [getComplexTag $w $tag]
    if {$tag eq "mapSquare"} {return}
    set srvid [getSrvID $w $tag]
    if {![info exists objects($srvid)]} {return}
    set oname [getStr [lindex $objects($srvid) 2]]
    set p $w.props$tag
    if {[winfo exists $p]} {
        catch {wm deiconify $p; raise $p}
        focus -force $p
        update idletasks
        return
    }
    #catch {destroy $p}
    catch {toplevel $p}
    wm title $p " \"$oname\""
    if {[unixPlatform]} {wm iconbitmap $p @[file join . img botikmap.xbm]}    
    wm geometry $p +${canvas(propx)}+${canvas(propy)}
    focus -force $p
    frame $p.top
    pack $p.top -side top
    frame $p.left
    pack $p.left -side left
    frame $p.right
    pack $p.right -side top -padx 5 -fill both -expand 1
    label $p.top.l -text "  \"$oname\"" -font $hfont
    pack $p.top.l -side top
    set fcount 0
    set txt ",   ,\n  ."
    label $p.top.r -text $txt -font $tfont
    pack $p.top.r -side top
    set l [getLayer $tag]
    set obj [getObject $tag]
    set types [getTypesByObj $obj $l]
    foreach var "::oType$tag ::name$tag ::addr$tag ::comm$tag" {set $var ""}
    if {![lempty [getStr $types]]} {
        pack configure $p.right -side left
        frame $p.left.tlf
        pack $p.left.tlf -side top
        label $p.left.tlf.lt -text " :" -font $tfont -bg [passiveClr]
        pack $p.left.tlf.lt -side top
        set curtype [getStr [lindex $objects($srvid) 4]]
        foreach {type par} $types {
            set t ""
            regsub {\*$} $type "" t
            regsub {\*$} $curtype "" ct
            radiobutton $p.left.tlf.rb$type -text $t -variable ::oType$tag \
                -relief flat -value $t -anchor w \
                -command "applyProps $w $tag 0" -font $tfont
            if {$t eq $ct} {
                #$p.left.tlf.rb$type select
                set ::oType$tag $t
            }
            pack $p.left.tlf.rb$type -side top -pady 2 -fill x
        }
        if {[isKey "$oname" 3] && [lempty $curtype]} {
            $p.left.tlf.lt configure -bg red
            incr fcount
        }
    }
    frame $p.right.info
    pack $p.right.info -side top -fill both -expand 1
    label $p.right.info.lname -text ":" -font $tfont
    label $p.right.info.laddr -text ":" -font $tfont
    label $p.right.info.lcomm -text ":" -font $tfont
    set tw 75; # text width in props window
    entry $p.right.info.name -textvar ::name$tag -takefocus 1 -font $tfont -width $tw
    entry $p.right.info.addr -textvar ::addr$tag -takefocus 1 -font $tfont -width $tw
    set fr $p.right.info.cf
    frame $fr
    set te $fr.comm
    text $te -relief sunken -bd 2 -yscrollcommand "$fr.scroll set" -width $tw \
        -height 10 -undo 1 -autosep 1 -wrap word -takefocus 1 -font $tfont
    if {[windowsPlatform]} {$te configure -setgrid 1}
    scrollbar $fr.scroll -command "$te yview"
    focus -force $p.right.info.name
    $p.right.info.name delete 0 end
    $p.right.info.addr delete 0 end
    set cname [getStr [lindex $objects($srvid) 6]]
    set caddr [getStr [lindex $objects($srvid) 7]]
    set ccomm [getStr [lindex $objects($srvid) 8]]
    $p.right.info.name insert 0 $cname
    $p.right.info.addr insert 0 $caddr
    pack $p.right.info.lname $p.right.info.name $p.right.info.laddr $p.right.info.addr $p.right.info.lcomm -side top -pady 2 -padx 2 -fill x -expand 1
    pack $fr -side top -fill both -expand 1
    pack $te -fill both -expand 1 -side left
    pack $fr.scroll -side right -fill y
    $te delete 0.0 end
    regsub -all {\\n} $ccomm \n ins
    set scheme_id "$plot(scheme)//id="
    catch {
    if {[info exists srvids($srvid)] && ![lempty $srvids($srvid)] && ![string match "*$scheme_id*" $ins]} {
        append ins "\n  : $scheme_id$srvids($srvid)\n"
    } elseif {[info exists srvids($srvid)] && ![lempty $srvids($srvid)] && [string match "*$scheme_id*" $ins]} {
        set lb [string first $scheme_id $ins]
        set le [string first "\n" $ins $lb]
        set len [string length $scheme_id]
        set _id [string trim [string range $ins [expr {$lb+$len}] [expr {$le-1}]]]
        if {$_id ne $srvids($srvid)} {
            set ins [string replace $ins $lb $le "$scheme_id$srvids($srvid)\n"]
        }
    }}
    $te insert 0.0 $ins
    findURLs $te
    global fin
    set fin 0
    bind $te <FocusIn>  "set ::fin 1"
    bind $te <FocusOut> "set ::fin 0"
    if {[isKey "$oname" 5] && [lempty $cname]} {
        incr fcount
        $p.right.info.lname configure -bg red
    }
    $p.right.info.name configure -validate key \
        -validatecommand "checkField %P $p.right.info.lname {$oname} 5"
    if {[isKey "$oname" 6] && [lempty $caddr]} {
        incr fcount
        $p.right.info.laddr configure -bg red
    }
    $p.right.info.addr configure -validate key \
        -validatecommand "checkField %P $p.right.info.laddr {$oname} 6"
    if {[isKey "$oname" 7] && [lempty $ccomm]} {
        incr fcount
        $p.right.info.lcomm configure -bg red
    }
    set edit [expr {$fcount == 0}]
    if {$edit} {$p.top.r config -text ""}
    if {[info exists ::sensor_data($cname)]} {
        package require Tktable
        set spl [split $::sensor_data($cname) \n]
        set n [llength $spl]
        updateSTable $cname $tag
        set fr $p.right.info.df
        frame $fr
        set t $fr.st
        table $t \
            -variable ::stabvar$cname \
            -cols 2 \
            -rows $n \
            -width 20 \
            -height 30 \
            -titlerows 1 \
            -titlecols 0 \
            -roworigin -1 \
            -colorigin 0 \
            -rowstretchmode all \
            -colstretchmode all \
            -yscrollcommand "$fr.sy set" \
            -sparsearray 0 \
            -state disabled \
            -rowheight 2 \
            -colwidth 20 \
            -justify left \
            -ipadx 2 \
            -cursor top_left_arrow \
            -selecttitles 0 \
            -rowtagcommand st_rowTagCmd \
            -selectmode browse \
            -wrap 1 \
            -borderwidth 2
        $t tag config ht -font {Times 14 bold}
        $t tag config vt -font {Times 12}
        scrollbar $fr.sy -command "$t yview"
        pack $fr -side top -fill both -expand 1
        pack $fr.sy -side right -fill y
        pack $t -side top -fill both -expand 1
        bind $p <Alt-v> "analyze_node $cname"
    }
    if {![lempty $cname]} {
        button $p.right.info.bGraph -text "" -command "sens_chart_window $::plot(w) $cname" \
            -width 8 -padx 5 -relief raised -activebackground [activeClr] \
            -highlightbackground [activeClr] -font $bfont
        button $p.right.info.bReboot -text "" -command "sens_reboot $w $cname" \
            -width 8 -padx 5 -relief raised -activebackground [activeClr] \
            -highlightbackground [activeClr] -font $bfont
        pack $p.right.info.bGraph $p.right.info.bReboot -expand yes -side left -pady 5
    }
    button $p.right.info.bOK -text "" -command "doDump $te $tag; checkFields $w $p {$oname} $tag ok $edit"\
        -width 10 -padx 5 -relief raised -activebackground [activeClr]\
        -highlightbackground [activeClr] -font $bfont
    button $p.right.info.bFind -text "" -command "findObject $w $srvid $p"\
        -width 7 -padx 5 -relief raised -activebackground [activeClr]\
        -highlightbackground [activeClr] -font $bfont
    button $p.right.info.bCanc -text "" -command "doDump $te $tag; checkFields $w $p {$oname} $tag cancel $edit"\
        -width 7 -padx 5 -relief raised -activebackground [activeClr]\
        -highlightbackground [activeClr] -font $bfont
    pack $p.right.info.bOK $p.right.info.bFind $p.right.info.bCanc -expand yes -side left -pady 5
    bind $p.right.info.name <KeyPress-Return> "doReturn $p.right.info.bOK"
    bind $p.right.info.addr <KeyPress-Return> "doReturn $p.right.info.bOK"
    bind $p <KeyPress-Escape> "$p.right.info.bCanc invoke"
    bind $p <Destroy> "doDestroy $edit %W $w $tag"
    bind $te <Control-w> "selectText %W"
    bind $te <KeyPress> "findURLs %W"
    setRussianKeys $p.right.info.name $p.right.info.addr $te
    update idletasks
}
# workaround for ctrl+c in Russian layout;
# used both for 'entries' and 'texts'
proc setRussianKeys {args} {
    foreach w $args {
        bind $w <Control-ntilde> "copySelection %W"; # Russian ""
        bind $w <Control-division> "textCut %W"; # Russian ""
        bind $w <Control-igrave> "textPaste %W"; # Russian ""
    }
}
proc textCut {w} {
    catch {
    set text [selection get -displayof $w -type STRING]
    clipboard clear -displayof $w
    clipboard append -displayof $w $text
    $w delete sel.first sel.last
    }
}
proc textPaste {w} {
    if { [catch {::tk::GetSelection $w CLIPBOARD} sel] } {return}
    catch { $w insert insert $sel }
}
proc centerWin {w} {
    set x [expr {[winfo screenwidth $w]/2 - [winfo reqwidth $w]/2 \
        - [winfo vrootx [winfo parent $w]]}]
    set y [expr {[winfo screenheight $w]/2 - [winfo reqheight $w]/2 \
        - [winfo vrooty [winfo parent $w]]}]
    if {$x < 0} {set x 0}
    if {$y < 0} {set y 0}
    wm geometry $w +$x+$y
}
proc sens_reboot {w name} {
    set p $w.rconfirm[mask_sensnode $name]
    catch {destroy $p}
    catch {toplevel $p}
    wm transient $p
    wm title $p " "
    if {[unixPlatform]} {wm iconbitmap $p @[file join . img botikmap.xbm]}    
    set font {Arial 13}
    frame $p.top
    pack $p.top -side top
    label $p.top.l -text "  , , :\n 777-77,   " -font $font
    pack $p.top.l -padx 5 -pady 5
    entry $p.top.re -width 30 -font $font
    pack $p.top.re
    setRussianKeys $p.top.re
    focus -force $p.top.re
    bind $p.top.re <KeyPress-Return> "$p.bottom.c invoke"
    frame $p.bottom
    pack $p.bottom -side top -expand 1 -fill x
    button $p.bottom.c -text "" -command "sens_reboot_action $w $name $p $p.top.re" -font "$font bold"
    pack $p.bottom.c -side left -expand 1 -padx 3 -pady 5
    button $p.bottom.cancel -text "" -command "destroy $p" -font $font
    pack $p.bottom.cancel -side left -expand 1 -padx 3 -pady 5
    centerWin $p
    update idletasks
    bind $p <KeyPress-Escape> "$p.bottom.cancel invoke"
}
proc sens_reboot_action {w name p re} {
    set r [$re get]
    set len [string length [string trim $r]]
    if {$len==0} {
        alert "    ."
        return
    }
    set max 1000
    if {$len > $max} {
        alert "      $max  ."
        return
    }
    destroy $p
    sendit $w do_reboot 1 box $name reason $r
}
proc copySelection {t} {
    catch {
    set text [selection get -displayof $t -type STRING]
    copyToCB $text
    }
}
proc selectText {te} {
    $te tag remove sel 1.0 end
    $te tag add sel 1.0 end
}
proc configURLtag {t tag link} {
    $t tag configure $tag -underline 1 -foreground blue -font {Arial 12}
    $t tag bind $tag <Any-Enter> "$t configure -cursor hand2"
    $t tag bind $tag <Any-Leave> "$t configure -cursor xterm"
    $t tag bind $tag <ButtonPress-1> "showURL $link"
    $t tag bind $tag <ButtonPress-3> "copyToCB $link"
}
proc copyToCB {text} {
    clipboard clear
    clipboard append $text
    progress "   ."
}
#      
proc findURLs {t} {
    catch {
    $t tag delete [$t tag names]
    set re {[a-zA-Z]+://\S+|www.\S+}
    set info [$t get 1.0 end]
    set lines [split $info \n]
    set i 0
    foreach line $lines {
        incr i
        set all [regexp -all -inline -nocase -- $re $line]
        foreach url $all {
            set fs   [string first $url $line]
            set len  [string length $url]
            set fidx $i.$fs
            set lidx $i.[expr $fs+$len]
            $t tag add URL$fidx $fidx $lidx
            configURLtag $t URL$fidx $url
        }
    }}
}
proc st_rowTagCmd {row} {
    if {$row==-1} {return ht}
    return vt
}
#     
proc updateSTable {name tag} {
    set var ::stabvar$name
    set [set var](-1,0) ""
    set [set var](-1,1) ""
    if {![info exists ::sensor_data($name)]} {return}
    set spl [split $::sensor_data($name) \n]
    set n [llength $spl]
    if {$n == 0} {return}
    set t $::plot(c).props$tag.right.info.df.st
    if {[winfo exists $t]} {
        $t configure -rows $n
    }
    for {set col 0} {$col < 2} {incr col} {
        for {set row 0} {$row < $n} {incr row} {
            set par_val [lindex $spl $row]
            if {$col} {
                set [set var]($row,$col) [lindex $par_val end]
            } else {
                set [set var]($row,$col) [lrange $par_val 0 end-1]
            }
        }
    }
    update
}
proc doDump {te tag} {
    set txt [string trim [$te get 0.0 end]]
    regsub -all {\n} $txt "\\n" txt
    set ::comm$tag $txt
}
proc doReturn {but} {
    global fin
    if {!$fin} {$but invoke}
}
proc doDestroy {edit p w tag} {
    global canvas
    set canvas(propx) [winfo x $p]
    set canvas(propy) [winfo y $p]
    if {![info exists ::donothing$tag]} {return}
    if {![set ::donothing$tag]} {
        set ::donothing$tag 1
        destroy $p
        if {!$edit} {
            multiDel $w 1 0
        }
    }
}
proc checkField {val l objname num} {
    if {[isKey $objname $num] && [lempty [getStr $val]]} {
        $l configure -bg red
    } else {
        $l configure -bg [passiveClr]
    }
    return 1
}
proc checkFields {w p oname tag but edit} {
    if {$but eq "cancel"} {
        set ::donothing$tag 0
        doDestroy $edit $p $w $tag
        if {$edit} {addToLayer $w [takeID $tag]}
        return
    }
    set all 1
    if {[isKey "$oname" 3] && [lempty [getStr [set ::oType$tag]]]} {
        set all 0
    }
    if {[isKey "$oname" 5] && [lempty [getStr [set ::name$tag]]]} {
        set all 0
    }
    if {[isKey "$oname" 6] && [lempty [getStr [set ::addr$tag]]]} {
        set all 0
    }
    if {[isKey "$oname" 7] && [lempty [getStr [set ::comm$tag]]]} {
        set all 0
    }
    if {!$all} {
        alertError "   ."
        catch {wm deiconify $p; raise $p;}
    } else {
        set ::donothing$tag 1
        applyProps $w $tag
        addToLayer $w [takeID $tag]
        destroy $p
    }
}
proc applyProps {w tag {fsave 1}} {
    global objects
    set srvid [getSrvID $w $tag]
    set c 0
    if {$fsave} {
        set vlist "::oType$tag 4 ::name$tag 6 ::addr$tag 7 ::comm$tag 8"
    } else {
        set vlist "::oType$tag 4"
    }
    foreach {var n} $vlist {
        if {[info exists $var]} {
            catch {
                set objects($srvid) [lreplace $objects($srvid) $n $n "{[set $var]}"]
            }
            incr c
        }
        #set $var ""
    }
    setChangeState $w $tag 1
    setParams $w $tag
    applyParams $w $tag [getObject $tag] {}
    setSelect $w $tag 1
    updateBalloon $w $tag
}
#make parentheses around list elements
proc mkpar {list} {
    set res {}
    foreach elt $list {
        set res [concat $res "{$elt}"]
    }
    return $res
}
proc getStr {str} {
    return [string trim [string map {\{ "" \} "" | ""} $str]]
}
proc toGrad {a} {
    return [expr {double($a)*180.0/$::pi}]
}
proc sgn {val} {
    return [expr {($val > 0) ? "+" : "-"}]
}
proc loadAllImages {} {
    foreach imgname {cutline saveimg spinimg start tbsensnode tbminimap \
        imgsystem imgupdate imgcancel imgopen saveas help layerman srch \
        select zoom center pantool addremnode chSmooth to_front to_back \
        zoommenu layermenu showsub gotopoint authb send mod binddot} {
            loadImage $imgname [file join . $::images(imagedir) $::images($imgname)]
    }
}
proc initBinds {c} {
    global plot
    set shift $plot(shift)
    bind $c <ButtonPress-1>   $plot(butpress1)
    bind $c <ButtonPress-3>   $plot(butpress3)
    bind $c <ButtonRelease-1> $plot(butrelease1)
    bind $c <ButtonRelease-3> $plot(butrelease3)
    bind $c <Motion>          $plot(motion)
    bind .  <Control-ButtonPress-1> $plot(cbutpress1)
    bind . <Control-r>       "rotateObject $c 1"; # clockwise
    bind . <Control-Alt-r>   "rotateObject $c 0"; # counterclockwise
    bind . <Control-a>       "multi_selectScreenElts $c"
    bind . <Control-o>       "fileDialog $c open"
    bind . <Control-s>       "fileDialog $c save"
    bind . <Control-f>       "search $c"
    bind . <Control-x>       "doZoom $c 0 0 2 1"
    bind . <Control-z>       "doZoom $c 0 0 0.5 1"
    bind . <Control-q>       "Exit $c"
    bind . <Control-m>       "changeSmooth $c"
    bind . <Control-w>       "bindDotObjs $c"
    bind . <Control-Right>   "moveSelection $c [expr $shift*10] 0"
    bind . <Control-Left>    "moveSelection $c [expr -$shift*10] 0"
    bind . <Control-Up>      "moveSelection $c 0 [expr -$shift*10]"
    bind . <Control-Down>    "moveSelection $c 0 [expr $shift*10]"
    bind . <KeyPress-Right>  "moveSelection $c $shift 0"
    bind . <KeyPress-Left>   "moveSelection $c [expr -$shift] 0"
    bind . <KeyPress-Up>     "moveSelection $c 0 [expr -$shift]"
    bind . <KeyPress-Down>   "moveSelection $c 0 $shift"
    bind . <KeyPress-Delete> "multiDel $c 1 1"
    bind . <KeyPress-F5>     "updateCanvas $c 1.0"
    bind . <Control-c>       "copySelected $c"
    bind . <Control-v>       "insertObjects $c"
    bind . <Control-Insert>  [bind . <Control-c>]
    bind . <Shift-Insert>    [bind . <Control-v>]
    bind . <Control-n>       "checkNetObjs $c"
    # moves gmap sublayer right,left,up,down 10 pixels
    bind . <Control-Shift-Right> "sublayer_shift $c 10 0"
    bind . <Control-Shift-Left>  "sublayer_shift $c -10 0"
    bind . <Control-Shift-Up>    "sublayer_shift $c 0 -10"
    bind . <Control-Shift-Down>  "sublayer_shift $c 0 10"
    #bind . <KeyPress> "alert %K"
}
proc clearBinds {c} {
    global plot
    set plot(butpress1)       [bind $c <ButtonPress-1>]
    set plot(butpress3)       [bind $c <ButtonPress-3>]
    set plot(butrelease1)     [bind $c <ButtonRelease-1>]
    set plot(butrelease3)     [bind $c <ButtonRelease-3>]
    set plot(motion)          [bind $c <Motion>]
    set plot(cbutpress1)      [bind .  <Control-ButtonPress-1>]
    #bind $c <ButtonPress-1>  ""
    bind $c <ButtonPress-3>   ""
    #bind $c <ButtonRelease-1> ""
    bind $c <ButtonRelease-3> ""
    bind $c <Motion>          ""
    bind . <Control-ButtonPress-1> ""
    bind . <Control-a>       ""
    bind . <Control-o>       ""
    bind . <Control-s>       ""
    bind . <Control-f>       ""
    bind . <Control-x>       ""
    bind . <Control-z>       ""
    bind . <Control-q>       ""
    bind . <Control-t>       ""
    bind . <Control-m>       ""
    bind . <Control-w>       ""
    bind . <Control-Right>   ""
    bind . <Control-Left>    ""
    bind . <Control-Up>      ""
    bind . <Control-Down>    ""
    bind . <KeyPress-Right>  ""
    bind . <KeyPress-Left>   ""
    bind . <KeyPress-Up>     ""
    bind . <KeyPress-Down>   ""
    bind . <KeyPress-Delete> ""
    bind . <KeyPress-F5>     ""
    bind $c <Configure>      ""
    bind . <Control-n>       ""
    bind . <Control-c>       ""
    bind . <Control-v>       ""
    bind . <Control-Insert>  ""
    bind . <Shift-Insert>    ""
}
#  Z- 
proc initMainRects {c} {
    global layers objects divs
    set coords [$c coords mapSquare]
    if {![lempty $coords]} {
        $c delete mapSquare
        $c dtag mapSquare
    }
    $c create rectangle [canvasBbox] \
        -fill white -outline black -tags mapSquare -state disabled
    for {set i 0} {$i < $layers(N)} {incr i} {
        set num [llength $objects($layers($i))]
        for {set j 0} {$j < $num} {incr j} {
            set tag "div${i}_$j"
            $c create rectangle [canvasBbox] -tags $tag -state hidden
            $c lower $tag
            set divs($tag) "$tag"
        }
    }
    $c lower mapSquare
}
proc recountObjects {f1 f2} {
    set file1 [open $f1 r]
    set file2 [open $f2 a]
    while {![eof $file1]} {
        gets $file1 line
        if {[lempty $line]} {continue}
        set params  [lindex $line 3]
        set zl      [lindex $params 0]
        set oldCrds [lindex $params 1]
        set addPars [lindex $params 2]
        set newCrds [countCoords2 $oldCrds $zl 7]
        set line [lreplace $line 3 3 "7 {$newCrds} {$addPars}"]
        puts $file2 $line
    }
    close $file1
    close $file2
}
proc initMove {w} {
    unbindAll $w
    if {![setCursor $w center]} {
        $w configure -cursor crosshair
    }    
    bind $w <ButtonPress-1> "doMove $w %x %y 1.0"
    bind $w <ButtonPress-3> "showProps $w current"
}
proc initSelect {w} {
    unbindAll $w
    if {![setCursor $w select]} {
        $w configure -cursor top_left_arrow
    }    
    bind $w <Control-ButtonPress-1> "addToSelection $w %x %y"
    bind $w <ButtonPress-1> "plotEdit $w %x %y"
    bind $w <ButtonPress-3> "showProps $w current"
    bind $w <Double-Button-1> "showHouseBinds $w current"
}
proc showHouseBinds {w cur} {
    global houseboxes
    set tag [getComplexTag $w $cur]
    set id [getSrvID $w $tag]
    if {![info exists houseboxes($id)]} {return}
    set did [lindex $houseboxes($id) 0]
    set dtag [getTagBySrvID $did]
    setSelect $w $dtag 1
}
proc chooseCenter {w c} {
    global layers canvas plot
    set cnt $w.chcenter
    catch {destroy $cnt}
    catch {toplevel $cnt}
    wm title $cnt "  ."
    if {[unixPlatform]} {wm iconbitmap $cnt @[file join . img botikmap.xbm]}    
    catch {wm deiconify $cnt; raise $cnt}
    focus -force $cnt
    frame $cnt.coords
    pack $cnt.coords -side top
    set max [expr int($canvas(maxSize_m))]
    label $cnt.coords.label -text\
        "   ( ),\n  -   0  $max"\
        -font $::fonts(txt)
    pack  $cnt.coords.label -side top
    frame   $cnt.coords.x
    pack    $cnt.coords.x -side top
    label   $cnt.coords.x.l -text "X:" -font $::fonts(txt)
    spinbox $cnt.coords.x.spinX -textvar centX -from 0 -to $max\
        -width 7 -wrap on -font $::fonts(txt)
    pack    $cnt.coords.x.l $cnt.coords.x.spinX -side left
    focus -force $cnt.coords.x.spinX
    $cnt.coords.x.spinX icursor 1
    frame   $cnt.coords.y
    pack    $cnt.coords.y -side top
    label   $cnt.coords.y.l -text "Y:" -font $::fonts(txt)
    spinbox $cnt.coords.y.spinY -textvar centY -from 0 -to $max\
        -width 7 -wrap on -font $::fonts(txt)
    pack    $cnt.coords.y.l $cnt.coords.y.spinY -side left
    frame $cnt.buts
    pack  $cnt.buts -side top
    button $cnt.buts.bOK -text "  " -command "validateSpins $c $cnt"  -width 7 -relief raised \
            -activebackground [activeClr] -highlightbackground [activeClr] -font $::fonts(buts)
    button $cnt.buts.bCanc -text "  " -command "destroy $cnt" -width 7 -relief raised \
            -activebackground [activeClr] -highlightbackground [activeClr] -font $::fonts(buts)
    pack $cnt.buts.bOK $cnt.buts.bCanc -expand yes -side left -pady 4 -fill both
    bind $cnt <KeyPress-Return> "$cnt.buts.bOK invoke"
    bind $cnt <KeyPress-Escape> "$cnt.buts.bCanc invoke"    
    update idletasks
}
proc validateSpins {c cnt} {
    global centX centY layers canvas
    set xok 0
    set yok 0
    set max $canvas(maxSize_m)
    catch {
        if {[string is integer -strict $centX] && $centX >= 0 && $centX <= $max} {
            set xok 1
        }
    }
    catch {
        if {[string is integer -strict $centY] && $centY >= 0 && $centY <= $max} {
            set yok 1
        }
    }
    if {!($xok*$yok)} {
        if {!$yok} {
            if {!$xok} {
                alertError "   X  Y."
                return
            }
            alertError "   Y."
            return
        }
        alertError "   X."
    } else {
        destroy $cnt
        moveCenter $c [toPixels $centX] [toPixels $centY] 1.0
    }
    return
}
proc getIntersctn {edge1 edge2} {
    foreach {x11 y11 x12 y12} $edge1 {}
    foreach {x21 y21 x22 y22} $edge2 {}
    return  [findIntersection $x11 $x12 $x21 $x22 $y11 $y12 $y21 $y22]
}
proc findIntersection {x11 x12 x21 x22 y11 y12 y21 y22} {
    set s  0
    set x  0.0
    set y  0.0
    set t  0.0
    set t1 0.0
    set t2 0.0
    set a [expr {$x21 - $x11}]
    set b [expr {$x21 - $x22}]
    set c [expr {$x12 - $x11}]
    set d [expr {$y21 - $y11}]
    set e [expr {$y21 - $y22}]
    set f [expr {$y12 - $y11}]
    set D  [expr {double($f * $b - $e * $c)}]
    set D1 [expr {double($f * $a - $d * $c)}]
    set D2 [expr {double($d * $b - $e * $a)}]
    if {$D != 0} {
        set s 1
        set t1 [expr {$D1 / $D}]
        set t2 [expr {$D2 / $D}]
        set x  [expr {$x11 + $t2 * $c}]
        set y  [expr {$y11 + $t2 * $f}]
    }
    return "$s $x $y $t1 $t2"
}
proc doResize {w} {
    set coords [getCenterCoords $w]
    foreach {x y} $coords {}
    moveCenter $w $x $y 1.0
}
proc setInitZoomLevel {w zl} {
    global canvas layers
    if {$zl < 1 || $zl > 7} {return}
    set csize [getCanvasSize $zl]
    $w configure -width $csize -height $csize -scrollregion [canvasBbox]
    set canvas(size) $csize
    set layers(zoomLevel) $zl
    updateStatus zoomLevel ": $zl"
    update
}
proc calcCenter {coords} {
    set x0 [set y0 0]
    set n [expr {[llength $coords]/2}]
    if {$n == 0} {return}
    foreach {x y} $coords {
        set x0 [expr {$x0 + $x}]
        set y0 [expr {$y0 + $y}]
    }
    set x0 [expr {$x0/$n}]
    set y0 [expr {$y0/$n}]
    return [list $x0 $y0]
}
proc rotateObject {c cw} {
    global plot complex
    set ang [expr {$::pi/32.0}]
    if {!$cw} {set ang [expr {-$ang}]}
    foreach tag $plot(selected) {
        set class [getClassByTag $tag]
        if {$class eq "dot" || $class eq "text"} {continue}
        if {$class eq "bridge"} {
            set btag $tag
            if {![info exists complex($btag,elts)]} {continue}
            set otags $complex($btag,elts)
            set coords [list]
            foreach objtag $otags {
                if {![string match "line*" $objtag]} {continue}
                set coords [concat $coords [$c coords $objtag]]
            }
            foreach {x0 y0} [calcCenter $coords] {break}
            if {[lempty $x0] || [lempty $y0]} {continue}
            foreach objtag $otags {
                set coords [$c coords $objtag]
                set newcoords [rotate $coords $ang $x0 $y0]
                $c coords $objtag $newcoords
            }
            setParams $c $btag
            setChangeState $c $btag 1
            continue
        }
        set coords [$c coords $tag]
        foreach {x0 y0} [calcCenter $coords] {break}
        if {[lempty $x0] || [lempty $y0]} {continue}
        set newcoords [rotate $coords $ang $x0 $y0]
        $c coords $tag $newcoords
        setParams $c $tag
        setChangeState $c $tag 1
        if {$class eq "TOP"} {
            hideActiveTOPLine $c
            set complex(activeTOPLine) "TOPLine+$tag"
            set complex(activeTOP) [getActiveTOPtag]
            showActiveTOPLine $c
            changeTOPTxt $c $complex($complex(activeTOP),text) $complex(activeTOP)
       }
   }
   setSelect $c $plot(selected) 1
}
proc rotate {coords a x0 y0} {
    set newcoords [list]
    set sin_a [expr {sin($a)}]
    set cos_a [expr {cos($a)}]
    foreach {x y} $coords {
        set newX [expr {$x0+($x-$x0)*$cos_a-($y-$y0)*$sin_a}]
        set newY [expr {$y0+($x-$x0)*$sin_a+($y-$y0)*$cos_a}]
        lappend newcoords $newX $newY
    }
    return $newcoords
}
proc getAngle {x0 y0 x1 y1 x2 y2} {
    global pi
    set a [expr {hypot(double($x2 - $x0),double($y2 - $y0))}]
    set b [expr {hypot(double($x1 - $x0),double($y1 - $y0))}]
    set c [expr {hypot(double($x2 - $x1),double($y2 - $y1))}]
    if {$b==0.0 || $c==0.0} {return 0}
    set angle [expr {acos(double(($b*$b+$c*$c-$a*$a)/(2*$b*$c)))}]
    if {$angle > $pi} {set angle [expr {$angle-$pi}]}
    return $angle
}
proc setButton {w frame bname text cmd state side textvar image} {
    global layers hints myImages
    button $frame.$bname -text $text -command $cmd \
        -activebackground [activeClr] -highlightbackground [activeClr] \
        -state $state -textvar $textvar
    if {![lempty $image]} {$frame.$bname configure -image $myImages($image)}
    pack $frame.$bname -side $side -padx 3 -pady 3
    set layers(tButs) "$layers(tButs) $frame.$bname"
    if {[info exists hints($bname)]} {
        bind "$frame.$bname" <Any-Enter> "showHint {$hints($bname)} {$frame.$bname} %W %X %Y"
        bind "$frame.$bname" <Motion>    "showHelp %X %Y %W {$hints($bname)}"
        bind "$frame.$bname" <Any-Leave> "hideHint"
    }
}
proc showHelp {x y w text} {
    global plot configVars
    if {!$configVars(showButtonHints)} {return}
    catch {
        wm geometry $plot(hlpwin) "+$x+[expr $y+30]"
        update
    }
}
proc killHelp {} {
    global plot configVars
    if {!$configVars(showButtonHints)} {return}
    catch {
        destroy $plot(hlpwin)
        update
    }
}
proc initHelp {w x y text} {
    global plot configVars
    if {!$configVars(showButtonHints)} {return}
    catch {
        toplevel $plot(hlpwin) -relief flat \
            -bg white \
            -screen [winfo screen $w]
        wm overrideredirect $plot(hlpwin) 1
        wm transient $plot(hlpwin)
        wm geometry $plot(hlpwin) "+[expr $x+30]+$y"
        label $plot(hlpwin).label -text $text -relief flat -bd 0 -highlightthickness 0 \
                -padx 1 -pady 1 -foreground black -background "#FFFFC0" \
                -font $::fonts(txt) -justify left
        pack $plot(hlpwin).label -side left
        update
    }
}
proc doScroll {args} {
    eval $args
}
proc initScrolls {c w} {
    global configVars
    if {![info exists configVars(showScrolls)] || !$configVars(showScrolls)} {return}
    $c configure -xscrollcommand "$w.hscroll set" -yscrollcommand "$w.vscroll set"
    scrollbar $w.hscroll -orient horiz -command "doScroll $c xview"
    scrollbar $w.vscroll -command "doScroll $c yview"
    grid $w.vscroll -in $w.grid -padx 1 -pady 1 \
        -row 0 -column 1 -rowspan 1 -columnspan 1 -sticky news
    grid $w.hscroll -in $w.grid -padx 1 -pady 1 \
        -row 1 -column 0 -rowspan 1 -columnspan 1 -sticky news
    bind $w.hscroll <ButtonRelease-1> "updateCanvas $c 1.0"
    bind $w.vscroll <ButtonRelease-1> "updateCanvas $c 1.0"
    bind $w.hscroll <Motion> "changeMCRectCoords $c"
    bind $w.vscroll <Motion> "changeMCRectCoords $c"
}
proc bm_exe {} {
    return [expr {[info exists ::bt_exe] && $::bt_exe}]
}
proc callHelp {} {
    if {[bm_exe]} {
        showURL http://www.$::net(domain)/~botik/map/general.html
        return
    }
    if {[windowsPlatform]} {
        set helpfile [file join . doc $::plot(pname).chm]
    } else {
        set helpfile [file join . doc $::plot(pname).html]
    }
    if {![file exists $helpfile]} {
        #alertError "   ."
        return
    }
    if {[windowsPlatform] && [catch {
        exec $::env(COMSPEC) /c start $helpfile
    } rc]} {
        alertError "     \"$helpfile\".\n$rc"
    } elseif {![windowsPlatform] && [catch {
        exec [findBrowser] $helpfile
    } rc]} {
        alertError "     \"$helpfile\".\n$rc"
    }
}
proc delDotTmp {c} {
    catch {
        $c delete dottmp
        $c dtag dottmp
    }
}
proc leftTB {bname c} {
    global objects layers but
    if {[lempty $bname]} {return}
    delDotTmp $c
    switch $bname {
        select     {initSelect    $c}
        zoom       {zoomActivate  $c}
        center     {initMove      $c}
        pantool    {initPan       $c}
        addremnode {addRemNode    $c}
        chSmooth   {changeSmooth  $c}
        to_front   {reposSelected $c raise}
        to_back    {reposSelected $c lower}
        cutline    {initCutline   $c}
        default    {
            set i [lsearch $objects($layers($layers(top))) $bname]
            set cmds "[getClassByObj $bname {}] $i"
            bindObjectButton $c "$cmds"
        }
    }
    set but $bname
}
proc auth {c} {
    global conn plot
    set a $c.seca
    #catch {destroy $a}
    if {[winfo exists $a]} {
        catch {wm deiconify $a; raise $a;}
        focus -force $a
        update idletasks
        return
    }
    catch {toplevel $a}
    wm title $a "."
    if {[unixPlatform]} {wm iconbitmap $a @[file join . img botikmap.xbm]}    
    set hfont $::fonts(heads)
    set tfont $::fonts(txt)
    set bfont $::fonts(buts)
    focus -force $a
    frame $a.f
    frame $a.f.f1
    frame $a.f.f2
    frame $a.f.fol
    frame $a.f.f3
    pack $a.f $a.f.f1 $a.f.f2 $a.f.fol $a.f.f3 -fill both
    label $a.f.f1.label -text ",   \n    \"\""\
         -font $hfont
    pack $a.f.f1.label -expand 1 -padx 5 -pady 10
    frame $a.f.f2.labels
    frame $a.f.f2.entries
    pack $a.f.f2.labels $a.f.f2.entries -side left -expand 1
    set l $a.f.f2.labels
    set e $a.f.f2.entries
    label $l.org   -text "  :" -anchor w -font $tfont
    label $l.login -text " :"     -anchor w -font $tfont
    label $l.pswd  -text " :"           -anchor w -font $tfont
    pack $l.org $l.login $l.pswd -pady 4 -padx 3 -fill x
    entry $e.org   -width 20 -takefocus 1 -textvar conn(org)   -font $tfont
    entry $e.login -width 20 -takefocus 1 -textvar conn(login) -font $tfont
    entry $e.pswd  -width 20 -takefocus 1 -textvar conn(pass)  -font $tfont -show "*"
    pack $e.org $e.login $e.pswd -pady 4
    setRussianKeys $e.org $e.login $e.pswd
    set conn(pass) ""
    if {[lempty $conn(org)]} {
        focus -force $e.org
    } elseif {[lempty $conn(login)]} {
        focus -force $e.login
    } elseif {[lempty $conn(pass)]} {
        focus -force $e.pswd
    }
    frame $a.f.b
    button $a.f.b.ok -text "" -width 10 -command "destroy $a; beginAuth $c"\
        -background [passiveClr] -activebackground [activeClr] -highlightbackground [activeClr] -font $bfont
    button $a.f.b.cancel -text "" -width 10 -command "destroy $a"\
        -background [passiveClr] -activebackground [activeClr] -highlightbackground [activeClr] -font $bfont
    pack $a.f.b -side top -pady 5 -padx 10 -fill both
    pack $a.f.b.ok $a.f.b.cancel -side left -padx 10 -expand 1
    bind $a <KeyPress-Return> "$a.f.b.ok invoke"
    bind $a <KeyPress-Escape> "$a.f.b.cancel invoke"
}
proc beginAuth {c} {
    global conn plot
    update idletasks
    if {[regexp {[&?]} $conn(pass)]} {
        alertError "     \"&\"  \"?\""
        auth $c
        return
    }
    testCacheAuthdata
    #      :
    progress "..."
    set conn(auth) [secureAuth $c]
    if {$conn(auth)==0} {
        alertError "  ."
        progress ""
        return
    }
    if {$conn(auth)==1} {
        doStart $c
        updateCache
        progress " ."
    } else {
        progress ""
    }
}
proc secureAuth {c} {
    global conn errorInfo plot
    if {![lempty $conn(orglogin)]} {
        foreach {o l} [split $conn(orglogin) ":"] {break}
        if {$o ne $conn(org) && $l ne $conn(login)} {
            set plot(ts) [string repeat "0" 14]
        }
    }
    set query [http::formatQuery org [encode $conn(org)] login [encode $conn(login)] pswd [encode $conn(pass)]]
    if {[catch {
        set token [http::geturl $conn(mainpage) -query $query -handler "httpHandler $c"]
    } desc]} {
        catch {http::cleanup $token}
        progress ""
        setWindowTitle ""
        if {[string match "*unreachable*" $desc]} {
            displayDialog " .    .\n$desc"
        } else {
            displayDialog "    .\n$desc"
        }
        return -1
    }
    catch {
        set ncode 0
        set ncode [http::ncode $token]
    }
    parseServerInput $c
    if {$ncode != 200} {
        catch {http::cleanup $token}
        return 0
    }
    catch {http::cleanup $token}
    set conn(authtime) [clock seconds]
    set conn(orglogin) $conn(org):$conn(login)
    return 1
}
proc displayDialog {msg} {
    set date [clockFormat "%d.%m.%Y %X"]
    append msg "\n: $date"
    if {![winfo exists .dlg]} {
        if {[catch {
            my_tk_dialog .dlg "" $msg "" 0 "OK"; # no wait for user reaction
        }]} {
            alert $msg
        }
    }
}
proc my_tk_dialog {w title text bitmap default args} {
    global tcl_platform
    if {[string is integer -strict $default]} {
        if {$default >= [llength $args]} {
            return -code error "default button index greater than number of\
                buttons specified for tk_dialog"
        }
    } elseif {"" eq $default} {
        set default -1
    } else {
        set default [lsearch -exact $args $default]
    }
    set windowingsystem [tk windowingsystem]
    if {$windowingsystem eq "aqua"} {
        option add *Dialog*background systemDialogBackgroundActive widgetDefault
        option add *Dialog*Button.highlightBackground \
            systemDialogBackgroundActive widgetDefault
    }
    destroy $w
    toplevel $w -class Dialog
    wm title $w $title
    wm iconname $w Dialog
    if {[winfo viewable [winfo toplevel [winfo parent $w]]] } {
        wm transient $w [winfo toplevel [winfo parent $w]]
    }
    if {$windowingsystem eq "aqua"} {
        ::tk::unsupported::MacWindowStyle style $w moveableModal {}
    }
    frame $w.bot
    frame $w.top
    if {$windowingsystem eq "x11"} {
        $w.bot configure -relief raised -bd 1
        $w.top configure -relief raised -bd 1
    }
    pack $w.bot -side bottom -fill both
    pack $w.top -side top -fill both -expand 1
    grid anchor $w.bot center
    option add *Dialog.msg.wrapLength 7i widgetDefault
    #option add *Dialog.msg.font TkCaptionFont widgetDefault
    label $w.msg -justify left -text $text -font {Arial 12}
    pack $w.msg -in $w.top -side right -expand 1 -fill both -padx 3m -pady 3m
    if {$bitmap ne ""} {
        if {$windowingsystem eq "aqua" && $bitmap eq "error"} {
            set bitmap "stop"
        }
        label $w.bitmap -bitmap $bitmap
        pack $w.bitmap -in $w.top -side left -padx 3m -pady 3m
    }
    set i 0
    foreach but $args {
        button $w.button$i -text $but -command "destroy $w" -font {Times 10}
        if {$i == $default} {
            $w.button$i configure -default active
        } else {
            $w.button$i configure -default normal
        }
        grid $w.button$i -in $w.bot -column $i -row 0 -sticky ew \
            -padx 10 -pady 4
        grid columnconfigure $w.bot $i
        # We boost the size of some Mac buttons for l&f
        if {$windowingsystem eq "aqua"} {
            set tmp [string tolower $but]
            if {$tmp eq "ok" || $tmp eq "cancel"} {
                grid columnconfigure $w.bot $i -minsize 90
            }
            grid configure $w.button$i -pady 7
        }
        incr i
    }
    if {$default >= 0} {
        bind $w <Return> "destroy $w"
    }
    wm withdraw $w
    update idletasks
    set x [expr {[winfo screenwidth $w]/2 - [winfo reqwidth $w]/2 \
        - [winfo vrootx [winfo parent $w]]}]
    set y [expr {[winfo screenheight $w]/2 - [winfo reqheight $w]/2 \
        - [winfo vrooty [winfo parent $w]]}]
    if {$x < 0} {
       set x 0
    }
    if {$y < 0} {
       set y 0
    }
    wm maxsize $w [winfo screenwidth $w] [winfo screenheight $w]
    wm geometry $w +$x+$y
    wm deiconify $w
    bind $w <KeyPress-Escape> "destroy $w"
}
proc enumFields {objstr} {
    set txt ""
    #1 {if {![lempty $t]} {append txt ": $t\n"}}
    #5 {if {![lempty $t]} {append txt ": $t\n"}}
    loop pos 1 9 {
        set t ""
        regsub {\*$} [getStr [lindex $objstr $pos]] {} t
        switch -- $pos {
            2 {if {![lempty $t]} {append txt ": $t\n"}}
            4 {if {![lempty $t]} {append txt ": $t\n"}}
            6 {if {![lempty $t]} {append txt ": $t\n"}}
            7 {if {![lempty $t]} {append txt ": $t\n"}}
            8 {
                if {![lempty $t]} {
                    regsub -all {\\n} $t \n t
                    append txt ":\n$t\n"
                }
            }
            default {}
        }
    }
    return $txt
}
proc nextUpdatesPage {w page pbut nbut} {
    if {$page eq "next"} {
        if {$::updates(curpage) + 1 < $::updates(npages)} {
            #      
            incr ::updates(curpage)
        } else {return}
    } else {
        if {$::updates(curpage) - 1 >= 0} {
            #      
            incr ::updates(curpage) -1
        } else {return}
    }
    if {$::updates(curpage) == 0} {
        $pbut configure -state disabled
    } else {
        $pbut configure -state normal
    }
    if {$::updates(curpage) == $::updates(npages) - 1} {
        $nbut configure -state disabled
    } else {
        $nbut configure -state normal
    }
    showUpdatesPage $w
}
proc updateObjectSelected {srvid left right} {
    set myfr $left.objs.$srvid
    set forfr $right.objs.$srvid
    if {[set ::selobj$srvid] eq "local"} {
        $myfr.text configure -font {Arial 11 bold}
        $forfr.text configure -font {Arial 11}
    } else {
        $myfr.text configure -font {Arial 11}
        $forfr.text configure -font {Arial 11 bold}
    }
}
proc showUpdatesPage {w} {
    catch {destroy $w.main.parts}
    frame $w.main.parts
    pack $w.main.parts -side top
    set left $w.main.parts.left
    set mid $w.main.parts.mid
    set right $w.main.parts.right
    frame $left
    pack $left -side left
    frame $mid -width 4 -relief ridge
    pack $mid -side left -fill y -padx 8
    frame $right
    pack $right -side left
    label $left.l -text " :" -font {Arial 14 bold}
    label $right.l -text " :" -font {Arial 14 bold}
    pack $left.l $right.l -side top -pady 8
    frame $left.objs
    pack $left.objs -side top
    frame $right.objs
    pack $right.objs -side top
    set opp $::updates(opp)
    set subset [lrange $::updates(new) [expr {$::updates(curpage)*$opp}] [expr {($::updates(curpage)+1) * $opp - 1}]]
    if {$::updates(npages) > 0} {
        $w.main.control.n configure -text " [expr $::updates(curpage) + 1]  $::updates(npages)"
    }
    set winwidth 40
    set winheight 10
    # 'my objects' pane
    foreach srvid $subset {
        set f $left.objs.$srvid
        frame $f
        pack $f -side top
        set locid $::localID($srvid)
        set loctext [enumFields $::objects($locid)]
        #set ::selobj$srvid "local"; # default choice
        set ltext ""
        set lw $f.lf$locid
        label $lw -text $ltext -fg blue -cursor hand2 -font linkfont
        bind $lw <ButtonRelease-1> "findObject $::plot(c) $locid $w"
        radiobutton $f.r -variable ::selobj$srvid -command "updateObjectSelected $srvid $left $right" -relief flat -value "local" -anchor w
        pack $f.r -side left
        set_simple_tooltip $f.r "  "
        pack $lw -side left -padx 3
        text $f.text -yscrollcommand [list $f.scroll set] -height $winheight -width $winwidth -wrap word -font {Arial 11} -cursor arrow
        if {[windowsPlatform]} {$f.text configure -setgrid 1}
        scrollbar $f.scroll -command [list $f.text yview]
        pack $f.scroll -side right -fill y
        pack $f.text -side left -expand yes -fill both -pady 4
        $f.text insert 0.0 $loctext
        $f.text configure -state disabled
        if {[info exists ::selobj$srvid] && [set ::selobj$srvid] eq "local"} {
            $f.text configure -font {Arial 11 bold}
        }
        bind $f.text <ButtonRelease-1> "$f.r invoke"
    }
    # 'foreign objects' pane
    foreach srvid $subset {
        set f $right.objs.$srvid
        frame $f
        pack $f -side top
        set srvtext [enumFields [convToOld $::updates($srvid)]]
        radiobutton $f.r -variable ::selobj$srvid -command "updateObjectSelected $srvid $left $right" -relief flat -value "remote" -anchor e
        text $f.text -yscrollcommand [list $f.scroll set] -height $winheight -width $winwidth -wrap word -font {Arial 11} -cursor arrow
        if {[windowsPlatform]} {$f.text configure -setgrid 1}
        scrollbar $f.scroll -command [list $f.text yview]
        pack $f.text -side left -expand yes -fill both -pady 4
        pack $f.scroll -side left -fill y
        pack $f.r -side left
        set_simple_tooltip $f.r "  "
        $f.text insert 0.0 $srvtext
        $f.text configure -state disabled
        if {[info exists ::selobj$srvid] && [set ::selobj$srvid] eq "remote"} {
            $f.text configure -font {Arial 11 bold}
        }
        bind $f.text <ButtonRelease-1> "$f.r invoke"
    }
    update idletasks
}
proc showAcceptDialog {c} {
    set ::updates(new) [lsort -unique $::updates(new)]
    set w $c.updates
    if {[winfo exists $w]} {return}
    catch {destroy $w}
    catch {toplevel $w}
    wm title $w " ."
    if {[unixPlatform]} {wm iconbitmap $w @[file join . img botikmap.xbm]}
    catch {wm deiconify $w; raise $w;}
    focus -force $w
    frame $w.main
    pack $w.main -side top -fill x -expand 1
    label $w.main.l -text " " -font {Arial 20 bold}
    pack $w.main.l -side top
    label $w.main.l2 -text "   .\n  ,     ." -font {Arial 10}
    pack $w.main.l2 -side top -pady 5
    set ::updates(curpage) 0
    set num [llength $::updates(new)]; # number of objects
    set ::updates(opp) 2; # num. of objects per page
    set ::updates(npages) [expr {int(ceil(double($num)/double($::updates(opp))))}]
    frame $w.main.control
    pack $w.main.control -side top -expand 1 -fill x
    set but1 $w.main.control.bwd
    set but2 $w.main.control.fwd
    button $but1 -text " << " -command "nextUpdatesPage $w prev $but1 $but2" -font {Arial 11}
    button $but2 -text " >> " -command "nextUpdatesPage $w next $but1 $but2" -font {Arial 11}
    label $w.main.control.n -font {Arial 10}
    pack $but1 $w.main.control.n $but2 -side left -pady 6 -padx 5 -expand 1
    set_simple_tooltip $but1 " "
    set_simple_tooltip $but2 " "
    catch {font create linkfont -family Arial -size 10 -underline 1}
    showUpdatesPage $w
    if {$::updates(curpage) == 0} {
        $but1 configure -state disabled
    }
    if {$::updates(npages) == 0 || $::updates(curpage) == $::updates(npages) - 1} {
        $but2 configure -state disabled
    }
    frame $w.buts
    pack $w.buts -side top -expand 1 -fill x
    button $w.buts.apply -text "" -command "apply_updates $c" -font {Arial 13}
    button $w.buts.help  -text "" -command "showUpdatesHelp" -font {Arial 13}
    button $w.buts.close -text "" -command "destroy $w" -font {Arial 13}
    pack $w.buts.apply $w.buts.help $w.buts.close -expand 1 -pady 10 -side left
    bind $w <KeyPress-Return> "$w.buts.apply invoke"
    bind $w <KeyPress-Escape> "$w.buts.close invoke"
    update idletasks
}
proc showUpdatesHelp {} {
    set msg {
     BotikMap  
  ,     , 
   ,     
,  .     
-   " ".

 BotikMap  (  )  Map-
      .   
,   .     
        .
            
,       .
 " "   
       :   .

 " "    
  .    
( " ")     , 
   .    
( " ")     , 
       .
  (   )  , 
      .  
,   "".

  "" ,      
 ,   .    
     .
  "" ,  (  ) 
        ,   .

,       ,    
    ,       
  ,   ,     
( ,   ).
    }
    displayDialog $msg
}
proc delIntFromList {list elt} {
    if {![lcontain $list $elt]} {return $list}
    return [lsearch -exact -integer -all -inline -not $list $elt]
}
proc apply_updates {c} {
    set ids {}
    foreach srvid $::updates(new) {
        if {![info exists ::selobj$srvid]} {continue}
        if {[set ::selobj$srvid] eq "local"} {
            lappend ::updates(prohibit) $srvid,$::plot(ts); # prohibit asking about this version of the object
            lappend ids $srvid
            unset ::selobj$srvid
        } elseif {[set ::selobj$srvid] eq "remote"} {
            set locid $::localID($srvid)
            set ::changed($locid) 0
            set ::objects($locid) [lreplace $::objects($locid) end end 0]
            processObject $c $::updates($srvid); # recreate object
            lappend ids $srvid
            unset ::selobj$srvid
            lappend ::updates(prohibit) $srvid,$::plot(ts); # prohibit asking about this version of the object
        }
    }
    set ::updates(new) [diff $::updates(new) $ids]
    destroy $c.updates
}
proc newRefresh {args} {
    doRefresh $::plot(c)
}
proc setupRefresh {c} {
    after [expr {$::plot(timeout)*1000}] {set ::refresh 1}
}
proc touch {file} {
    if {[file exists $file]} {return}
    catch {close [open $file w]}
}
proc doStart {c} {
    global plot conn
    progress " ..."
    sendit $c start $plot(ts)
    doRefresh $c
}
proc check_obj_errors {} {
    global plot
    if {![lempty $plot(errobjs)]} {
        set msg "    .\nIDs:$plot(errobjs)"
        if {[file exists $plot(dbgfile)]} {
            set dbg [read_file $plot(dbgfile)]
            append msg "\n$dbg"
        }
        asksendmail $msg
        set plot(errobjs) {}
        touch $plot(dbgfile)
    }
}
proc sensor_data_allowed {} {
    set corg [lsearch -exact $::plot(sysorgs) $::conn(org)]
    return [expr {[windowsPlatform] && $corg > -1}]
}
proc doRefresh {c} {
    global plot conn
    update idletasks
    if {$conn(authtime) > 0 && [clock seconds] - $conn(authtime) >= 3600} {
        progress " ..."
        set conn(auth) [secureAuth $c]
        if {$conn(auth) != 1} {
            set conn(authtime) [clock seconds]
        }
        if {$conn(auth) == 0} {
            setWindowTitle ""
            progress ""
            displayDialog "    (, -     ).   ."
        }
    }
    if {[sensor_data_allowed]} {
        set args  [list refresh $plot(ts) NADMIN_AUTH $conn(sid)]
        set query [formQuery $args]
        set url1 "$conn(mainpage)?$query"
        informer_fetch3 $url1
        set res1 [informer_data 1]
        set res2 [encoding convertfrom cp1251 [informer_data 2]]
        set res3 [encoding convertfrom cp1251 [informer_data 3]]
        foreach line [split $res1 \n] {
            set line [encoding convertfrom cp1251 [decode $line]]
            set notstate 1
            catch {set notstate [expr {[lindex $line 0] ne "STATE" && [llength $line] > 1}]}
            if {$notstate} {
                catch {handleMessage $c $line}
            }
        }
        initSensorDB
        get_sensor_data $res2\n$res3
        handleUpdates $c
    } else {
        sendit $c refresh $plot(ts)
    }
    handleBinds $c
    setupRefresh $c
    progress ""
}
proc handleUpdates {c} {
    global plot updates
    foreach srvid $updates(recv) {
        if {[lsearch -exact $updates(prohibit) $srvid,$plot(ts)] < 0} {
            lappend updates(new) $srvid
        }
    }
    set updates(recv) {}
    if {![lempty $updates(new)]} {
        showAcceptDialog $c
    }
}
proc get_sensor_data {data} {
    checkInitSensorDB
    unset -nocomplain ::sensor_time
    unset -nocomplain ::sensor_time2
    array unset ::sensor_hbeat; # heartbeat
    set ::plot(sensors) {}
    set allnodes {}
    set lines [split $data \n]
    set headers {HTTP/1.1 Date: Server: Content-Length: Connection: Content-Type: Vary:}
    catch {
    foreach line $lines {
        if {[llength $line] < 3} {continue}
        set node [lindex $line 0]
        if {[lsearch $headers $node] > -1} {continue}
        lappend allnodes $node
    }
    set allnodes [lsort -unique $allnodes]
    foreach node $allnodes {
        set ::sensor_data($node) ""
        set ::sensor_hbeat($node) 0
    }
    foreach line $lines {
        set node [lindex $line 0]
        if {[lsearch $headers $node] > -1} {continue}
        process_sline $line
    }
    }
    if {![info exists ::sensor_time]} {
        set ::sensor_time [clock seconds]
    }
    if {![info exists ::sensor_time2]} {
        set ::sensor_time2 [clock seconds]
    }
    set query ""
    set cnt 0
    set value 0
    if {[llength [array names ::lasttime]] >= 15000} {array unset ::lasttime}
    foreach node $allnodes {
        if {[string match "node*" $node]} {
            set stime $::sensor_time2
        } else {set stime $::sensor_time}
        set time [expr {int($stime - $::sensor_hbeat($node))}]
        set day [dayFormat $time]
        sensor_daytable $day
        set nodeid [getSensNodeID $node]
        set lines [split $::sensor_data($node) \n]
        foreach line $lines {
            if {![llength $line]} {continue}
            set sens [lrange $line 0 end-1]
            catch {set value [expr {[lindex $line end]}]}
            if {![string is double -strict $value]} {set value 0}
            set sensid [getSensID $sens]
            if {![llength $day] || ![llength $nodeid] || ![llength $sensid]} {continue}
            if {$sens eq [hbsensor]} {
                set time_ $stime
                set day_ [dayFormat $time_]
                sensor_daytable $day_
            } else {
                set time_ $time
                set day_ $day
            }
            #        
            if {![info exists ::lasttime($day_,$nodeid,$sensid)]} {
                set ::lasttime($day_,$nodeid,$sensid) $time_
            } else {
                if {$time_ - $::lasttime($day_,$nodeid,$sensid) < 30} {
                    continue
                }
                set ::lasttime($day_,$nodeid,$sensid) $time_
            }
            set redraw($node,$sens) 1
            if {$sens eq [statesensor]} {
                set ::node_state($node) $value
            }
            append query "insert into indicators$day_ values ($nodeid,$sensid,$time_,$value);"
            if {[incr cnt] % $::plot(numq) == 0} {
                asyncQueryEval "begin;${query}commit"
                set query ""
            }
        }
    }
    if {[llength $query]} {
        asyncQueryEval "begin;${query}commit"
        set query ""
    }
    sensors_ui_update
    foreach node $allnodes {
        if {[info exists ::hist($node,current_sensor)] && \
            [info exists redraw($::hist(current_node),$::hist($node,current_sensor))]} {
            graph_update $node
        }
    }
}
proc hbsensor {} {return "HEARTBEAT"}
proc statesensor {} {return "STATE"}
proc process_sline {line} {
    set node [lindex $line 0]
    if {$node eq "_currenttime_"} {
        set time [lindex $line 1]
        if {[string is integer -strict $time]} {
            if {[info exists ::sensor_time]} {
                set ::sensor_time2 $time
            } else {
                set ::sensor_time $time
            }
        }
        return
    }
    if {[llength $line] < 3} {return}
    set sens [lindex $line 1]
    set values [lrange $line 1 end]
    set measure [lindex $values end]
    if {![string is double -strict $measure]} {return}
    if {$sens eq [hbsensor]} {
        set ::sensor_hbeat($node) $measure
    }
    append ::sensor_data($node) $values\n
}
#  -    .
proc sensors_ui_update {} {
    if {![info exists ::layers()] || ![info exists ::layers()]} {return}
    set lnum $::layers()
    set lnum2 $::layers()
    set netobjs [concat $::inlayer($lnum) $::inlayer($lnum2)]
    set slist [list]
    set w $::plot(c)
    foreach srvid $netobjs {
        set tag [getTagBySrvID $srvid]
        set name [getParam $tag 6]
        if {[info exists ::sensor_data($name)]} {
            updateBalloon $w $tag
            lappend slist $srvid
            if {[info exists ::node_state($name)]} {
                set val [expr {int($::node_state($name))}]
                if {$srvid < 0 && [info exists ::srvids($srvid)]} {
                    set srvid $::srvids($srvid); # to serverID
                }
                catch {handleMessage $w [list STATE $srvid $val]}
            }
        }
        if {[winfo exists $w.props$tag.right.info.df.st]} {
            updateSTable $name $tag
        }
    }
    set ::sensor_list2 [lsort -unique $slist]
    if {$::mmap(shown) && [info exists ::mmap(mc)]} {
        mmap_drawdots $::mmap(mc)
    }
    set t $w.sensobjs.f1.tt
    if {[winfo exists $t]} {
        # realtime sensor table update
        getSensorIDs
        set n [llength $::sensor_list]
        if {$n == 0} {return}
        $t configure -rows [expr $n + 1]
        loop i 0 $n {
            loop j 0 6 {
                catch {nodesTabCmd $t $w $i,$j}
            }
        }
    }
}
# sensors statistics (# up, # down, # unknown)
# not needed anymore
proc get_sensors_stat {} {
    set ok 0
    set down 0
    set unknown 0
    foreach id $::sensor_list {
        set state [get_sensnode_state $id]
        incr $state
    }
    return [list $ok $down $unknown]
}
proc housesdown {} {
    global objects
    set res {}
    if {![array exists objects]} {return {}}
    set sid [array startsearch objects]
    while {[array anymore objects $sid]} {
        set id [array nextelement objects $sid]
        set val $objects($id)
        set oname [getStr [lindex $val 2]]
        if {$oname eq ""} {
            set state [getStr [lindex $val 5]]
            if {[string match -nocase "* (Off)*" $state] ||
                [string match -nocase "* ()*" $state]} {
                lappend res $id
            }
        }
    }
    array donesearch objects $sid
    return $res
}
proc nodesdown {} {
    global objects srvids plot
    set res {}
    set all [getSensorIDs]
    set down [lindex $all 0]
    foreach el $down {
        set id [lindex $el 0]
        if {[string is integer -strict $id]} {
            lappend res $id
        }
    }
    return $res

    if {![array exists objects]} {return {}}
    set sid [array startsearch objects]
    while {[array anymore objects $sid]} {
        set id [array nextelement objects $sid]
        if {[isBoxObj $id] &&
            [getClass $plot(c) [getTagBySrvID $id]] eq "dot"} {
            set state [getStr [lindex $objects($id) 5]]
            if {[string match -nocase "* *" $state]} {
                lappend res $id
            }
        }
    }
    array donesearch objects $sid
    return $res
}
proc get_sensnode_state {id} {
    if {![string is integer -strict $id]} {
        set name $id
        set state ""
    } else {
        set name [getStr [lindex $::objects($id) 6]]
        set state [getStr [lindex $::objects($id) 5]]
    }
    if {[info exists ::node_state($name)]} {
        set val [expr {int($::node_state($name))}]
        if {$val} {return ok}
        return down
    } else {
        if {[string match -nocase "* *" $state]} {
            return down
        } elseif {[string match -nocase "**" $state]} {
            return ok
        }
    }
    return unknown
}
proc setSensButton {w} {
    if {![winfo exists $::plot(w).top.tbsensnode]} {
        setButton $w $::plot(w).top tbsensnode " " "findSensors $w" normal left {} tbsensnode
    }
}
# graph realtime update
proc graph_update {node} {
    set xcanvas 0
    if {[info exists ::chart($node,name)] && [info exists ::chart($node,c)] && \
        ![string match -nocase "* *" $::chart($node,name)] && \
        [winfo exists $::chart($node,c)]} {
            set xcanvas 1
    }
    if {!$xcanvas || ![info exists ::sensor_data($node)]} {return}
    if {![info exists ::hist($node,current_sensor)]} {
        set ::hist($node,current_sensor) ""
    }
    set lines [split $::sensor_data($node) \n]
    set cursens $::hist($node,current_sensor)
    foreach line $lines {
        set sens [lrange $line 0 end-1]
        if {$xcanvas && $cursens ne "" && $cursens eq $sens} {
            append_sensor_data $node
            return
        }
    }
}
#    
proc getSensList {day node} {
    set nodeid  [getSensNodeID $node]
    if {![llength $day] || ![llength $nodeid]} {return}
    sensor_daytable $day
    set sensids [db eval "select distinct sensorid from indicators$day where nodeid=$nodeid"]
    set sqlids  ([join $sensids ,])
    return [db eval "select name from sensors where sensorid in $sqlids"]
}
proc getSensData {day node {sens {}}} {
    if {![llength $sens]} {
        set sens $::chart($node,selected)
    }
    set sensid [getSensID $sens]
    set nodeid [getSensNodeID $node]
    if {![llength $day] || ![llength $nodeid] || ![llength $sensid]} {return}
    sensor_daytable $day
    set tmp [db eval "select time,value from indicators$day where nodeid=$nodeid and sensorid=$sensid"]
    set res {}
    foreach {time value} $tmp {
        lappend res [list $time $value]
    }
    return $res
}
proc getSensNodeID {node {db "db"}} {
    global nodeids
    if {![llength $node]} {return}
    if {![info exists nodeids($node)]} {
        $db eval "begin;insert into nodes values (NULL,'$node');commit"
        set nodeids($node) [$db eval "select nodeid from nodes where name='$node'"]
    }
    return $nodeids($node)
}
proc getSensID {sens {db "db"}} {
    global sensids
    if {![llength $sens]} {return}
    if {![info exists sensids($sens)]} {
        $db eval "begin;insert into sensors values (NULL,'$sens');commit"
        set sensids($sens) [$db eval "select sensorid from sensors where name='$sens'"]
    }
    return $sensids($sens)
}
proc get_sensor_dbinfo {} {
    global sensids nodeids
    db eval "select sensorid,name from sensors" {
        set sensids($name) $sensorid
    }
    db eval "select nodeid,name from nodes" {
        set nodeids($name) $nodeid
    }
}
# "" :    ,
#        
#mend DB: v0&1 -> v3
proc mendSensDB {} {
    global nodeids sensids
    set progr $::progress
    progress "$progr 0%"
    set numrows [db eval "select count(*) from sensornodes"]
    set pc 0
    set cnt 0
    set query ""
    set dbfpath  $::plot(dbfpath)
    set ndbfpath $::plot(dbfpath).new
    sqlite3 ndb $ndbfpath
    initSensTables ndb
    db eval "select day,node,time,data from sensornodes" {
        set nodeid [getSensNodeID $node ndb]
        set lines [split $data \n]
        sensor_daytable $day "ndb"
        foreach line $lines {
            if {![llength $line]} {continue}
            set sens [lrange $line 0 end-1]
            set value 0
            catch {set value [expr [lindex $line end]]}
            set sensid [getSensID $sens ndb]
            if {![string is integer -strict $time]} {continue}
            if {![llength $day] || ![llength $nodeid] || ![llength $sensid]} {continue}
            append query "insert into indicators$day values ($nodeid,$sensid,$time,$value);"
        }
        incr cnt
        set newpc [getPercent $cnt $numrows]
        if {$newpc - $pc > 0 || $cnt % $::plot(numq) == 0} {
            ndb eval "begin;${query}commit"
            progress "$progr $newpc%"
            set query ""
        }
        set pc $newpc
    }
    if {[llength $query]} {ndb eval "begin;${query}commit"}
    #db eval "drop table sensornodes"
    db close; ndb close
    file delete -force $dbfpath
    file rename -force $ndbfpath $dbfpath
    sqlite3 db $dbfpath
    initSensTables
    progress $progr
}
# mend DB: v2 -> v3
proc mendSensDB2 {} {
    global nodeids sensids
    set progr $::progress
    progress "$progr 0%"
    set numrows [db eval "select count(*) from indicators"]
    set pc 0
    set cnt 0
    set query ""
    set dbfpath  $::plot(dbfpath)
    set ndbfpath $::plot(dbfpath).new
    sqlite3 ndb $ndbfpath
    initSensTables ndb
    db eval "select day,nodeid,sensorid,time,value from indicators" {
        sensor_daytable $day "ndb"
        append query "insert into indicators$day values ($nodeid,$sensorid,$time,$value);"
        incr cnt
        set newpc [getPercent $cnt $numrows]
        if {$newpc - $pc > 0 || $cnt % $::plot(numq) == 0} {
            ndb eval "begin;${query}commit"
            progress "$progr $newpc%"
            set query ""
        }
        set pc $newpc
    }
    if {[llength $query]} {ndb eval "begin;${query}commit"}
    #db eval "drop table indicators"
    db close; ndb close
    file delete -force $dbfpath
    file rename -force $ndbfpath $dbfpath
    sqlite3 db $dbfpath
    initSensTables
    progress $progr
}
# mend DB: v3 -> v4
proc mendSensDB3 {} {
    db close
    set dbfpath $::plot(dbfpath)
    file rename -force $dbfpath $dbfpath.old
    sqlite3 db $dbfpath
    initSensTables
}
#    %;
#         Alt-v
proc analyze_node {node} {
    set sid [getSensID [statesensor]]
    set nid [getSensNodeID $node]
    set total   0
    set notwork 0
    set tmp $::progress
    progress "  ..."
    foreach day $::hist(days) {
        set name "indicators$day"
        set all [db eval "select count(*) from $name where nodeid=$nid and sensorid=$sid"]
        set state0 [db eval "select count(*) from $name where nodeid=$nid and sensorid=$sid and value=0"]
        if {[string is integer -strict $all] && [string is integer -strict $state0]} {
            incr total $all
            incr notwork $state0
        }
    }
    if {$total > 0} {
        set pc [expr {100 - [getPercent $notwork $total]}]
        alert " : $pc% ($notwork   $total)"
    }
    progress $tmp
}
proc sensor_daytable {day {db "db"}} {
    set name "indicators$day"
    if {[info exists ::chart_tabs($name)] || ![llength $day]} {return}
    if {[catch {
        $db eval "create table if not exists $name (nodeid integer,\
                                          sensorid integer,\
                                          time integer,\
                                          value real)"
        set ::chart_tabs($name) 1
        lappend ::hist(days) $day
    }]} {
        set fsize [file size $::plot(dbfpath)]
        if {$db eq "db" && $fsize > 2*1024*1024*1024} {
            mendSensDB4; # mend those DBs where PRAGMA synchronous=OFF
        }
    }
}
proc chooseFileName {path} {
    for {set i 0} {$i >= 0} {incr i} {
        if {![file exists $path$i]} {
            return $path$i
        }
    }
}
# v4(synchr=OFF) -> v4(synchr=NORMAL)
proc mendSensDB4 {} {
    db close
    set dbfpath $::plot(dbfpath)
    catch {thread::send $::dbthread "thdb close"}
    catch {thread::release $::dbthread}
    set newname [chooseFileName $dbfpath.old]
    file rename -force $dbfpath $newname
    set ::hist(dbinit) 0
    initSensorDB
}
proc initSensTables {{db "db"}} {
    $db eval {PRAGMA cache_size=10240}
    $db eval {PRAGMA synchronous=NORMAL}
    $db eval "create table if not exists nodes (nodeid integer primary key autoincrement,\
                                               name text unique on conflict ignore)"
    $db eval "create table if not exists sensors (sensorid integer primary key autoincrement,\
                                                 name text unique on conflict ignore)"
}
proc initSensorDB {} {
    set fexists [file exists $::plot(dbfpath)]
    if {$::hist(dbinit) && $fexists} {return}
    progress "    ..."
    sqlite3 db $::plot(dbfpath)
    set ::hist(days) {}
    set dbver 4; # current DB version
    initSensTables
    if {$fexists} {
        try_eval {set v [db eval {PRAGMA user_version}]} {set v 0}
        #    ,   
        if {![llength $v] || $v == 0 || $v == 1} {mendSensDB}
        if {$v == 2} {mendSensDB2}
        if {$v == 3} {mendSensDB3}
    }
    db eval "PRAGMA user_version=$dbver"; #  
    set alltabs [db eval "select name from sqlite_master where type='table'"]
    foreach tab $alltabs {
        set tab [string trim $tab ']
        if {[string match "indicators*" $tab]} {
            lappend ::hist(days) [string range $tab 10 end]
            set ::chart_tabs($tab) 1
        }
    }
    get_sensor_dbinfo
    set ::hist(dbinit) 1
    progress " ..."
    if {[info exists ::dbthread] || [bm_exe]} {return}
    package require Thread
    set ::dbthread [thread::create -preserved {
        proc threadEval {query} {thdb eval $query}
        thread::wait
    }]
    set ::save_done 0
    thread::send $::dbthread "\
        package require sqlite3;\
        sqlite3 thdb {$::plot(dbfpath)};\
        thdb eval {PRAGMA cache_size=10240};\
        thdb eval {PRAGMA synchronous=NORMAL}"
}
#pseudo-asynchronous DB insert
proc asyncQueryEval {query} {
    if {[bm_exe]} {
        db eval $query
    } else {
        catch {
            thread::send -async $::dbthread [list threadEval $query] ::save_done
            vwait ::save_done
        }
    }
}
proc getSensorIDs {} {
    if {![info exists ::layers()]} {return}
    set lnum $::layers()
    set netobjs $::inlayer($lnum)
    set slist [list]
    if {[info exists ::sensor_list2]} {
        set slist $::sensor_list2
    }
    foreach srvid $netobjs {
        lappend slist $srvid
    }
    set slist [lsort -unique $slist]
    # sort by name
    set res {}
    set names {}
    foreach id $slist {
        set name [getStr [lindex $::objects($id) 6]]
        set st [get_sensnode_state $id]
        lappend res [list $id $name $st]
        lappend names $name
    }
    set allnames [array names ::sensor_data]
    set noid [diff $allnames $names]
    foreach el $noid {
        set st [get_sensnode_state $el]
        lappend res [list $el $el $st]
    }
    # sort by state
    set res [lsort -index 2 $res]; # down, ok, unknown
    set resok {}
    set resdown {}
    set resunknown {}
    set ok 0
    set down 0
    set unknown 0
    foreach el $res {
        set st [lindex $el end]
        incr $st
        lappend res$st [list [lindex $el 0] [lindex $el 1]]
    }
    # sort by name
    set resok [lsort -index 1 $resok]
    set resdown [lsort -index 1 $resdown]
    set resunknown [lsort -index 1 $resunknown]
    set ::sensor_list {}
    foreach el [concat $resdown $resok $resunknown] {
        lappend ::sensor_list [lindex $el 0]
    }
    set ::hist(sensstat) "(:$ok,  :$down, :$unknown)"
    return [list $resdown $resok $resunknown]
}
proc findSensors {c} {
    set w $c.sensobjs
    catch {destroy $w}
    catch {toplevel $w}
    wm title $w " "
    set hfont $::fonts(heads)
    set tfont $::fonts(txt)
    set tfontb $::fonts(txtb)
    set bfont $::fonts(buts)
    focus -force $w
    frame $w.f1
    pack $w.f1 -fill both -expand 1 -side top
    label $w.f1.l -text " " -font $hfont -anchor n
    label $w.f1.s -textvariable ::hist(sensstat) -font {Sans-Serif 10} -anchor n
    pack $w.f1.l $w.f1.s -fill x -expand 1 -padx 5 -pady 5 -side top
    set t $w.f1.tt
    getSensorIDs
    set n [llength $::sensor_list]
    if {$n == 0} {destroy $w; return}
    if {[winfo screenheight .] >= 1024} {
        set h 30
    } else {
        set h 20
    }
    table $t \
        -command [list nodesTabCmd $t $c %C] \
        -cols 6 \
        -rows [expr $n + 1] \
        -width 40 \
        -height $h \
        -titlerows 1 \
        -titlecols 0 \
        -roworigin -1 \
        -colorigin 0 \
        -yscrollcommand "$w.f1.sny set" \
        -colstretchmode all \
        -rowstretchmode all \
        -sparsearray 0 \
        -state disabled \
        -borderwidth 1 \
        -wrap 0 \
        -rowheight 2 \
        -justify left \
        -ipadx 3 \
        -cursor top_left_arrow \
        -selecttitles 1 \
        -rowtagcommand rowTagCmd \
        -selectmode browse
    $t tag config title -font {Helvetica 11 bold} -fg black
    catch {font create linkfont -family Arial -size 12 -underline 1}
    scrollbar $w.f1.sny -command "$t yview"
    pack $w.f1.sny -side right -fill y
    pack $t -fill both -expand 1 -side left
    set len 6
    foreach sn $::sensor_list {
        if {![string is integer -strict $sn]} {
            set name $sn
        } else {
            set name [getStr [lindex $::objects($sn) 6]]
        }
        set nlen [string length $name]
        if {$nlen > $len} {
            set len $nlen
        }
    }
    incr len 10
    if {$len > 40} {set len 40}
    $t width 0 7; #   
    $t width 1 $len; #  
    $t width 2 18; # 
    $t width 3 18; # 
    $t width 4 18; # 
    $t width 5 22; # state
    bind $w <KeyPress-Escape> "destroy $w"
    bind $w <MouseWheel> "catch {wheelEvent %X %Y %D}"
}
proc wheelEvent {x y delta} {
    set act 0
    set widget [winfo containing $x $y]
    if {$widget ne ""} {
        if {[catch "$widget cget -yscrollcommand" cmd]} {return}
        if {$cmd ne ""} {
            set scroller [lindex $cmd 0]
            set act 1
        }
    }
    if {$act == 1} {
        set xy [$widget yview]
        set factor [expr [lindex $xy 1]-[lindex $xy 0]]
        set cmd "[$scroller cget -command] scroll [expr {-int($delta/(480*$factor))}] units"
        eval $cmd
    }
}
proc nodesTabCmd {t c cell} {
    set spl [split $cell ","]
    set row [lindex $spl 0]
    set col [lindex $spl 1]
    set id  [lindex $::sensor_list $row]
    if {![string is integer -strict $id]} {
        set name $id
    } else {
        set name [getStr [lindex $::objects($id) 6]]
    }
    set txtfont {Arial 12}
    if {$row == -1} {
        switch $col {
            0 {return "#"}
            1 {return ""}
            2 {return ""}
            3 {return ""}
            4 {return ""}
            5 {return ""}
            default {return}
        }
    }
    if {$col==0} {
        set num [expr {$row + 1}]
        set lw $t.ln$cell
        catch {destroy $lw}
        label $lw -text $num. \
            -fg black -font $txtfont
        $t window config $cell -window $lw
    }
    if {$col==1} {
        set lw $t.l$cell
        catch {destroy $lw}
        label $lw -text $name \
            -fg black -font $txtfont
        $t window config $cell -window $lw
    }
    if {$col==2} {
        if {![string is integer -strict $id]} {return}
        set tag [getTagBySrvID $id]
        set ltext ""
        set lw $t.lp$cell
        catch {destroy $lw}
        label $lw -text $ltext \
            -fg blue -cursor hand2 -font linkfont
        $t window config $cell -window $lw
        set pw [winfo parent [winfo parent $t]]
        bind $lw <ButtonRelease-1> "findObject $c $id $pw; showProps $c $tag"
    }
    if {$col==3} {
        set ltext ""
        set lw $t.lg$cell
        catch {destroy $lw}
        label $lw -text $ltext \
            -fg blue -cursor hand2 -font linkfont
        $t window config $cell -window $lw
        bind $lw <ButtonRelease-1> "sens_chart_window $::plot(w) $name"
    }
    if {$col==4} {
        if {![string is integer -strict $id]} {return}
        set ltext ""
        set lw $t.lf$cell
        catch {destroy $lw}
        label $lw -text $ltext \
            -fg blue -cursor hand2 -font linkfont
        $t window config $cell -window $lw
        set pw [winfo parent [winfo parent $t]]
        bind $lw <ButtonRelease-1> "findObject $c $id $pw"
    }
    if {$col==5} {
        set stateid [get_sensnode_state $id]
        if {$stateid eq "ok"} {
            set state ""
            set color green
        } elseif {$stateid eq "down"} {
            set state " "
            set color red
        } else {
            set state ""
            set color black
        }
        set lw $t.ls$cell
        catch {destroy $lw}
        label $lw -text $state \
            -fg $color -font $txtfont
        $t window config $cell -window $lw
    }
    return
}
proc setBalloonHelp {w node msg args} {
    array set opt [concat {-tag ""} $args]
    set delay 130; # ms
    set bw .balloonHelp[mask_sensnode $node]
    if {$msg ne ""} {
        set toolTipScript [list showBalloonHelp %W $node $opt(-tag) "$msg"]
        set enterScript [list after $delay $toolTipScript]
        set leaveScript [list after cancel $toolTipScript]
        append leaveScript \n [list destroy $bw]
    } else {
        set enterScript {}
        set leaveScript {}
    }
    if {$opt(-tag) ne ""} {
        switch -- [winfo class $w] {
            Text {
                $w tag bind $opt(-tag) <Enter> $enterScript
                $w tag bind $opt(-tag) <Leave> $leaveScript
            }
            Canvas {
                $w bind $opt(-tag) <Enter> $enterScript
                $w bind $opt(-tag) <Leave> $leaveScript
            }
            default {
                bind $w <Enter> $enterScript
                bind $w <Leave> $leaveScript
            }
        }
    } else {
        bind $w <Enter> $enterScript
        bind $w <Leave> $leaveScript
    }
}
proc mask_sensnode {node} {
    return [string map {. |} $node]
}
# shows hint window and positions it on screen correctly
# so that most part of it is visible
proc showBalloonHelp {w node tag msg} {
    if {![winfo exists $w]} {return}
    set t .balloonHelp[mask_sensnode $node]
    set msg [subst -nocommands -novariables [subst -nocommands $msg]]
    catch {destroy $t}
    catch {destroy $::balloon_window}
    toplevel $t -bg black
    wm overrideredirect $t 1
    if {$::tcl_platform(platform) eq "macintosh"} {
        unsupported1 style $t floating sideTitlebar
    }
    label $t.l -text $msg -bg lightyellow -font {Helvetica 11}
    pack $t.l -padx 1 -pady 1
    set width [winfo reqwidth $t.l]
    set height [winfo reqheight $t.l]
    set sw 0
    catch {set sw [winfo screenwidth $w]}
    if {$sw==0} {return}
    set sh [winfo screenheight $w]
    set x [winfo pointerx $w]
    set y [winfo pointery $w]
    set minX [set minY 15]; # minimal coords
    set hx [set hy $minY]; # hint default coords
    # whether hint will be on left side of the screen:
    set left [expr {$x > $sw/2}]
    set gap 20; # distance between mouse pointer and hint window
    if {$left} {
        set spacex $x; # horiz. space for hint window
    } else {
        set spacex [expr {$sw - $x}]
    }
    if {$spacex < $width} {
        set left -1; # hint is very wide
    }
    # whether hint will be on upper side of the screen:
    set up [expr {$y > $sh/2}]
    if {$up} {
        set spacey $y; # vert. space for hint window
    } else {
        set spacey [expr {$sh - $y}]
    }
    if {$spacey < $height} {
        set up -1; # hint is very tall
    }
    # various $left:$up combinations:
      # 1:-1 hint takes left-half of the screen
      # 1:0 hint is at left-down part of the screen
      # 1:1 hint is at left-up part of the screen
      # 0:-1 hint takes right-half of the screen
      # 0:0 hint is at right-down part of the screen
      # 0:1 hint is at right-up part of the screen
      # -1:0 hint takes down-half of the screen
      # -1:1 hint takes up-half of the screen
    if {$left >= 0} {
        # left == 0: hx = x + gap
        # left == 1: hx = x - width - gap
        set hx [expr {$x + $gap - $left * (2 * $gap + $width)}]
    }
    if {$up >= 0} {
        # up == 0: hy = y + gap
        # up == 1: hy = y - height - gap
        set hy [expr {$y + $gap - $up * (2 * $gap + $height)}]
    }
    if {$left < 0 && $up < 0} {
        # special case: hint is too large and it overlaps cursor;
        # there is no choice but to show hint window
        # that exceeds the screen bounds
        set left0 [expr {$x > $sw/2}]
        set hx [expr {$x + $gap - $left0 * (2 * $gap + $width)}]
        set hy [expr {$y + $gap}]
    }
    if {$hx < $minX} {set hx $minX}
    if {$hy < $minY} {set hy $minY}
    wm geometry $t +$hx+$hy
    set ::balloon_elem $tag
    set ::balloon_window $t
}
proc set_simple_tooltip {w msg} {
    set delay 200; # ms
    set t .simpleTooltip
    if {$msg ne ""} {
        set toolTipScript [list show_simple_tooltip %W $t $msg]
        set enterScript [list after $delay $toolTipScript]
        set leaveScript [list after cancel $toolTipScript]
        append leaveScript \n [list destroy $t]
    } else {
        set enterScript {}
        set leaveScript {}
    }
    bind $w <Enter> $enterScript
    bind $w <Leave> $leaveScript
}
proc show_simple_tooltip {w t msg} {
    catch {destroy $t}
    toplevel $t -bg black
    wm overrideredirect $t 1
    if {$::tcl_platform(platform) eq "macintosh"} {
        unsupported1 style $t floating sideTitlebar
    }
    label $t.l -text $msg -bg lightyellow -font {Helvetica 11}
    pack $t.l -padx 1 -pady 1
    set height [winfo reqheight $t.l]
    set x [winfo pointerx $w]
    set y [expr {[winfo pointery $w] - $height - 5}]
    wm geometry $t +$x+$y
}
proc changeScrollRegion {node} {
    set c $::chart($node,c)
    correctYaxis $node
    $c configure -scrollregion [$c bbox all]
}
proc chartDivisions {node max} {
    if {$max == 0} {return [list 1 0]}
    if {$max <= 0.5} {
        return [list 0.5 0.25]
    } elseif {$max > 0.5 && $max <= 1} {
        return [list 1 0.5]
    } elseif {$max <= 1.5} {
        return [list 1.5 0.5]
    }
    set nareas [get_sensgraph_nareas $node]
    set sgn    "+"
    regexp {(.+)e([+-])0*(.+)} [format %e $max] -> mant sign exp
    set exp [expr $sign$exp]
    if {abs($mant) < 1.5} {
        set mant [expr {$mant*10}]
        incr exp -1
    }
    set t [expr int(round($mant $sgn 0.49)*pow(10,$exp))]
    if {$t < $nareas} {return [list $t 1]}
    return [list $t [expr {int(double($t)/double($nareas))}]]
}
proc dayFmt {day} {
    if {[llength $day]==0} {return}
    return [string range $day 0 3]-[string range $day 4 5]-[string range $day 6 end]
}
#     $sensor  $node   $c
proc draw_sensor_graph {node sensor day {dbread 1}} {
    global hist chart
    if {![info exists chart($node,c)]} {return}
    set day [remove_braces $day]
    set sensor [remove_braces $sensor]
    set c $chart($node,c)
    set chart($node,name) "    $node.\n$sensor."
    $c delete all
    if {![llength $day]} {
        set day [dayFormat]
    } else {
        append chart($node,name) "   [dayFmt $day]."
    }
    if {$dbread || ![info exists ::chart($node,timedata)]} {
        set ::chart($node,timedata) [getSensData $day $node $sensor]
    }
    set hist($node,ox)   [expr {int(0.04*$chart($node,width))}]; #     X
    set hist($node,oy)   [expr {int(0.04*$chart($node,height))}]; #     Y
    set hist($node,ygap) 15; #       Y    
    set hist($node,yl)   [expr {$chart($node,height) - $hist($node,oy) - $hist($node,ygap)}]; #   Y
    set hist($node,textfont) [get_sensgraph_fontsize $node]
    set hist($node,dl)   3; #     Y (  )
    set hist($node,xpos) 0; #     -     X
    set hist($node,xposinc) 25; # X position increment
    #set hist($node,limit) 500000; #    
    set hist($node,current_sensor) $sensor
    set hist(current_node) $node
    set hist($node,oval_color) red; # point color
    set hist($node,mline_color) red; # graph color
    set hist($node,n) 0; # number of points in current graph
    set hist($node,divs) {}; # divisions tags
    set hist($node,mlc) {}; # mainline coords
    set max [findMaxValue $node $::chart($node,timedata)]
    if {$max==0} {set max 1}
    #        Y
    set divs [chartDivisions $node $max]
    foreach {cmax div} $divs {break}
    set hist($node,ymax) $cmax
    set hist($node,pxd) [expr {double($hist($node,yl))/double($cmax)}]; #     1 
    if {$hist($node,positive) == 0} {
        set hist($node,pxd) [expr {$hist($node,pxd)/2.0}]
    }
    drawYaxis $node $cmax $div
    drawXaxis $node
}
# "" --> "-- ::"
proc ftimeN {date} {
    if {[string length $date] < 8} {return}
    set year  [string range $date 0 3]
    if {[lempty [string trimleft $year "0"]]} {return}
    set month [string range $date 4 5]
    set day   [string range $date 6 7]
    set hrs   [string range $date 8 9]
    set mins  [string range $date 10 11]
    set ss    [string range $date 12 13]
    set fmt   "$day.$month.$year $hrs:$mins:$ss"
    set hrs   [string trimleft $hrs "0"]
    set mins  [string trimleft $mins "0"]
    set ss    [string trimleft $ss "0"]
    if {[lempty $hrs] && [lempty $mins] && [lempty $ss]} {return [lindex $fmt 0]}
    return $fmt
}
proc ftime_sens {tm} {
    return [clockFormat "%d-%m-%Y %X" $tm]
}
proc sens_oval_coords {node timeval xpos} {
    set rad [get_sensgraph_ovalrad $node]
    foreach {time val} $timeval {break}
    set h [expr {int($::hist($node,pxd)*$val)}]
    set x1 [expr {$xpos - $rad}]
    set y1 $h
    set x2 [expr {$xpos + $rad}]
    set y2 $h
    set newc [cconv $node [list $x1 $y1 $x2 $y2]]
    set r $rad
    set coords {}
    foreach {x y} $newc {
        set r [expr {-$r}]
        lappend coords $x [expr {$y+$r}]
    }
    return $coords
}
#     
proc draw_sensor_point {node timeval} {
    global hist chart
    set y  0
    set c  $::chart($node,c)
    foreach {time val} $timeval {break}
    set h  [expr {int($::hist($node,pxd)*$val)}]
    set rcoords [list $::hist($node,xpos) $h]
    set coords [sens_oval_coords $node $timeval $::hist($node,xpos)]
    lappend ::hist($node,mlc) $::hist($node,xpos) $h
    set tag ${time}_$::hist($node,n)$node
    $c create oval $coords -fill $::hist($node,oval_color) -tags $tag -width 0
    group_sens $node ovals$node $tag
    $c raise $tag
    set dispval $val
    if {$val - int($val) == 0} {set dispval [expr {int($val)}]}
    setBalloonHelp $c $node ": [ftime_sens $time]\n: $dispval" -tag $tag
    set every_points 2
    if {$::hist($node,n) - 1 >= 0 && ($::hist($node,n) + 1) % $every_points == 0} {
        #     X   / 
        set dlen 6; #  
        set text [clockFormat "%H:%M" $time]
        if {$::hist($node,positive) == 1} {
            set y1 0
            set y2 $dlen
            set ty [expr {$y2 + 4}];# text Y coordinate
        }
        if {$::hist($node,positive) == -1} {
            set y1 0
            set y2 -$dlen
            set ty [expr {$y2 - 3}]
        }
        if {$::hist($node,positive) == 0} {
            set y1 [expr {$dlen/2}]
            set y2 [expr {-1*$dlen/2}]
            set ty [expr {$y2 - 3}]
        }
        set txtc [cconv $node [list $::hist($node,xpos) $ty]]
        set dlc [cconv $node [list $::hist($node,xpos) $y1 $::hist($node,xpos) $y2]]
        set tag xdl$::hist($node,n)$node
        $c create line $dlc -tags $tag
        set ttag txdl$::hist($node,n)$node
        $c create text $txtc -tags $ttag -text $text
        group_sens $node yaxis$node $tag $ttag
        $c lower $tag
        $c lower $ttag
    }
    incr ::hist($node,n)
    incr ::hist($node,xpos) $::hist($node,xposinc)
    return $rcoords
}
#     
proc append_sensor_data {node} {
    #set val [lindex $timeval 1]
    #set type $::hist($node,positive)
    #if {$val > $::hist($node,ymax) || ($type == 1 && $val < 0) || ($type == -1 && $val > 0)}
    #draw_sensor_graph $node $::hist($node,current_sensor) {}
    #update idletasks
    if {![winfo exists $::chart($node,c)]} {return}
    set xv0 [lindex [$::chart($node,c) xview] 0]
    set xv [lindex [$::chart($node,c) xview] 1]
    draw_sensor_graph $node $::hist($node,current_sensor) {}
    #draw_sensor_point $node $timeval
    #draw_mainline $node
    if {$xv0 != 0 && $xv == 1.0} {$::chart($node,c) xview moveto 1.0}
}
proc cexists {node tag} {
    return [expr {![lempty [$::chart($node,c) gettags $tag]]}]
}
proc drawXaxis {node} {
    #    
    foreach timeval $::chart($node,timedata) {
        draw_sensor_point $node $timeval
    }
    draw_mainline $node
}
#   
proc draw_mainline {node} {
    set c      $::chart($node,c)
    set coords $::hist($node,mlc)
    set tag    mainline$node
    if {[llength $coords] <= 2} {return}
    if {![cexists $node $tag]} {
        $c create line [cconv $node $coords] -fill $::hist($node,mline_color) -tags $tag -width [get_sensgraph_linewidth $node]
        $c lower $tag oy$node
    } else {
        $c coords $tag [cconv $node $coords]
    }
    $c itemconfig $tag -width [get_sensgraph_linewidth $node]
    changeScrollRegion $node
}
# .    
proc get_sensgraph_nareas {node} {
    return 5
    set nareas [expr {int(0.02*$::hist($node,yl))}]
    if {$nareas < 4} {set nareas 4}
    if {$nareas > 9} {set nareas 9}
    return $nareas
}
proc get_sensgraph_fontsize {node} {
    set sz [expr {int(0.04*$::hist($node,yl))}]
    if {$sz < 9} {set sz 9}
    if {$sz > 13} {set sz 13}
    return [list Times $sz]
}
proc get_sensgraph_linewidth {node} {
    set linewidth [expr {int(0.01*$::hist($node,yl))}]; #    0.1%    Y
    if {$linewidth < 3} {set linewidth 3};#   
    if {$linewidth > 6} {set linewidth 6};#   
    return $linewidth
}
proc get_sensgraph_ovalrad {node} {
    set rad [expr {int(0.011*$::hist($node,yl))}]; #   1.1%    Y
    if {$rad < 3} {set rad 3}; #  
    if {$rad > 6} {set rad 6}; #  
    return $rad
}
proc remove_braces {str} {
    set res ""
    regsub -all {\{|\}} $str {} res
    return $res
}
# X&Y coordinates converter
proc cconv {node coords} {
    set newcoords {}
    foreach {x y} $coords {
        set newx [expr {$x + $::hist($node,ox)}]
        set ay [expr {abs($y)}]
        if {$ay > $::hist($node,yl)} {
            set ay $::hist($node,yl)
        } else {
            set ay [expr {$ay + $::hist($node,oy)}]
        }
        if {$::hist($node,positive) != 0} {
            if {$::hist($node,positive) < 0} {
                set newy $ay
            } else {
                set newy [expr {$::chart($node,height) - $ay}]
            }
        } else {
            set newy [expr {$::hist($node,yl)/2 + $::hist($node,ygap) - $y}]
        }
        lappend newcoords $newx $newy
    }
    return $newcoords
}
#   Y
proc drawYaxis {node cmax div} {
    if {$div == 0} {return}
    if {$::hist($node,positive) != 0} {
        set y1 0
        set y2 [expr {$::hist($node,positive)*$::hist($node,yl)}]
    } else {
        set y1 [expr {$::hist($node,yl)/2}]
        set y2 -$y1
    }
    # . Y:
    set coords [cconv $node [list 0 $y1 0 $y2]]
    $::chart($node,c) create line $coords -tags oy$node
    group_sens $node yaxis$node oy$node
    #   
    drawDivisions $node $cmax $div
}
#    Y
proc drawDivisions {node cmax div} {
    if {$div == 0} {return}
    set nareas [expr {1+int($cmax/$div)}]
    loop i 0 $nareas {
        set val [expr {$i*$div}]
        set y [expr {int($::hist($node,pxd)*double($val))}]
        if {$::hist($node,positive) < 0} {
            set val [expr {-1*$val}]
            set y [expr {-1*$y}]
        }
        set tag div$i$node
        drawDivLine $node $tag $y $i $val
        #  X  :
        if {$i == 0} {$::chart($node,c) itemconfig $tag -fill black}
        if {$::hist($node,positive) == 0} {
            set val [expr {-1*$val}]
            set y [expr {-1*$y}]
            set tag n$tag
            drawDivLine $node $tag $y $i $val
        }
    }
}
proc drawDivLine {node tag y i val} {
    #     Y
    set c $::chart($node,c)
    set coords [cconv $node [list 0 $y $::chart($node,width) $y]]
    $c create line $coords -tag $tag -fill grey
    $c lower $tag
    group_sens $node yaxis$node $tag
    lappend ::hist($node,divs) $tag
    set ::hist($node,divcoords,$tag) $coords
    #    Y  
    if {$val == 0} {
        set val [expr {int(abs($val))}]
    }
    $c create text [cconv $node [list -$::hist($node,dl) $y]] \
        -text $val -anchor e -tag ytxt$tag -font $::hist($node,textfont)
    group_sens $node yaxis$node ytxt$tag
    if {$i != 0} {
        $c create line [cconv $node [list -$::hist($node,dl) $y $::hist($node,dl) $y]] -tag dl$tag
        group_sens $node yaxis$node dl$tag
    }
}
proc group_sens {node maintag args} {
    foreach tag $args {
        $::chart($node,c) addtag $maintag withtag $tag
    }
}
proc findMaxValue {node timedata} {
    set max 0
    set haspos 0; # if series has positive values
    set hasneg 0; # if series has negative values
    foreach elt $timedata {
        foreach {time val} $elt {
            if {abs($val) >= $max} {
                set max [expr {abs($val)}]
            }
            if {$val >= 0} {set haspos 1}
            if {$val < 0} {set hasneg 1}
        }
    }
    #  1: only positives
    #  0: negatives & positives
    # -1: only negatives
    set ::hist($node,positive) [expr {$haspos - $hasneg}]
    if {!$haspos && !$hasneg} {
        set ::hist($node,positive) 1; # positives by default
    }
    return $max
}
proc correctYaxis {node} {
    set c $::chart($node,c)
    set bbox [$c bbox all]
    set newx [lindex $bbox 2]
    foreach tag $::hist($node,divs) {
        set coords $::hist($node,divcoords,$tag)
        lset coords 2 $newx
        $c coords $tag $coords; # 
        set ::hist($node,divcoords,$tag) $coords
    }
}
proc sens_chart_window {w0 node {day {}}} {
    global chart
    set w $w0.chart[mask_sensnode $node]
    catch {destroy $w}
    catch {toplevel $w}
    wm title $w "     $node"
    focus -force $w
    set chart(horizfrac) 0.7; # horizontal fraction
    set chart(vertfrac) 0.7; # vertical fraction
    set ww [expr {int($chart(horizfrac)*[winfo screenwidth .])}]
    set wh [expr {int($chart(vertfrac)*[winfo screenheight .])}]
    if {$wh < 400 || $ww < 600} {
        set wh 400
        set ww 600
    }
    set chart($node,w) $w
    wm geometry $w ${ww}x$wh
    update idletasks
    set chart($node,name) "    $node."
    label $w.name -textvar chart($node,name) -font {Helvetica 14 bold}
    pack $w.name -side top -padx 5 -pady 5
    frame $w.main
    pack $w.main -side top -fill both -expand 1
    frame $w.main.chart
    pack $w.main.chart -side left -fill x
    set chart($node,c) $w.main.chart.c
    set chart($node,height) [expr {int($chart(vertfrac)*[winfo height $w])}]
    set chart($node,width)  [expr {int($chart(horizfrac)*[winfo width $w])}]
    set c $chart($node,c)
    canvas $c -width $chart($node,width) -height $chart($node,height) -bg white \
        -relief raised -borderwidth 0 -xscrollincrement 20 \
        -xscrollcommand "$w.main.chart.hscroll set" \
        -scrollregion [list 0 0 $chart($node,width) $chart($node,height)]
    scrollbar $w.main.chart.hscroll -orient horiz -command "$chart($node,c) xview"
    pack $chart($node,c) -side top -fill x -padx 2 -pady 2
    pack $w.main.chart.hscroll -side bottom -fill x
    set ctrl $w.main.ctrl
    frame $ctrl
    pack $ctrl -side left -fill both
    set sns {}
    if {[llength $day] > 0} {
        set sns [getSensList $day $node]
    } else {
        if {[info exists ::sensor_data($node)]} {
            set data [split $::sensor_data($node) \n]
            foreach line $data {
                lappend sns [lrange $line 0 end-1]
            }
        }
    }
    set sns [lsort -unique $sns]
    set chart($node,selected) {}
    foreach s $sns {
        if {$s eq [statesensor]} {
            set chart($node,selected) $s
            break
        }
    }
    if {![llength $chart($node,selected)]} {
      foreach s $sns {
        if {[llength $s]} {
            set chart($node,selected) $s
            break
        }
      }
    }
    #     :
    set i 0
    set f $ctrl.rbs
    frame $f
    pack $f -side top
    foreach sens $sns {
        if {[llength $sens]==0} {continue}
        set dispsens [wrap_lines 40 $sens]
        radiobutton $f.r$i -text $dispsens -variable chart($node,selected) -value $sens \
            -command "draw_sensor_graph $node {$sens} {$day}" -font {Times 13 bold} -anchor w
        pack $f.r$i -fill x -padx 6 -pady 1 -anchor nw
        incr i
    }
    set b $f.buttons
    frame $b
    pack $b -side top
    button $b.h -text "" -font {Times 13} -command "sensgraph_history $w $w0 $node"
    button $b.e -text "" -font {Times 13} -command "exportChartToFile $node {$day}"
    pack $b.h $b.e -side left -pady 5
    if {[llength $chart($node,selected)]} {
        draw_sensor_graph $node $chart($node,selected) $day
        $chart($node,c) xview moveto 1.0; update idletasks
        bind $w <Configure> "reconfig_sensor_window $w $node {$day}"
    } else {
        label $f.nd -text "  "
        pack $f.nd
        if {[llength $day]} {append chart($node,name) "\n  [dayFmt $day]."}
    }
    bind $w <KeyPress-Escape> "destroy $w"
    bind $w <Alt-v> "analyze_node $node"
}
proc checkInitSensorDB {} {
    if {[lempty [info commands db]] || ![info exists ::hist(days)]} {
        # if database handler does not exist by any reason
        catch {thread::send $::dbthread "thdb close"}
        catch {thread::release $::dbthread}
        set ::hist(dbinit) 0
        initSensorDB
    }
}
proc sensgraph_history {w w0 node} {
    checkInitSensorDB
    set dispdays ""; # displayed days
    set tmp [lsort -unique -integer -decreasing $::hist(days)]
    foreach day $tmp {
        lappend dispdays [dayFmt $day]
    }
    set font {Helvetica 12}
    set lw $w.h
    catch {destroy $lw}
    catch {toplevel $lw}
    wm title $lw "     $node"
    focus -force $lw
    label $lw.l -text " :" -font $font
    pack $lw.l -side top
    frame $lw.frame -borderwidth 5
    pack $lw.frame -side top -expand yes -fill y
    scrollbar $lw.frame.yscroll -command "$lw.frame.list yview"
    listbox $lw.frame.list -width 20 -height 10 -setgrid 1 \
        -yscroll "$lw.frame.yscroll set" -font $font
    grid $lw.frame.list -row 0 -column 0 -rowspan 1 -columnspan 1 -sticky news
    grid $lw.frame.yscroll -row 0 -column 1 -rowspan 1 -columnspan 1 -sticky news
    grid rowconfig    $lw.frame 0 -weight 1 -minsize 0
    grid columnconfig $lw.frame 0 -weight 1 -minsize 0
    foreach line $dispdays {
        $lw.frame.list insert end $line
    }
    $lw.frame.list selection set 0
    button $lw.show -text " " -font $font \
        -command "showSensorArchive $w0 $node $lw.frame.list"
    pack $lw.show -side top -pady 6
}
proc showSensorArchive {w0 node lb} {
    set idx [$lb curselection]
    if {$idx ne ""} {
        set day [string map {- ""} [$lb get $idx]]
        if {$day eq [dayFormat]} {set day {}}
        sens_chart_window $w0 $node $day
    }
}
proc chartToHTML5 {node} {
    set coords [cconv $node $::hist($node,mlc)]
    set width  [lindex [$::chart($node,c) bbox all] 2]
    set height $::chart($node,height)
    set name   $::chart($node,name)
    set lw     [get_sensgraph_linewidth $node]
    set rad    [get_sensgraph_ovalrad $node]
    set res "<html><meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\">\n\
  <head>\n\
    <title>$name</title>\n\
    <!--\[if IE]> <script src=\"http://www.botik.ru/~botik/excanvas.js\"></script> <!\[endif]-->\n\
    <script type=\"text/javascript\">\n\
      function drawGraph() {\n\
        var canvas = document.getElementById('sensor_graph');\n\
        if (canvas.getContext) {\n\
            var ctx = canvas.getContext('2d');\n\
            var endAngle = 2*Math.PI;\n\
            ctx.strokeStyle = \"grey\";\n\
            ctx.lineWidth = 1;\n\
            ctx.beginPath();\n\
            ctx.font = \"10px Arial\";\n\
            ctx.textAlign = \"right\";\n\
            ctx.fillStyle = \"grey\";\n"
    # divisions:
    foreach tag $::hist($node,divs) {
        set dcoords $::hist($node,divcoords,$tag)
        foreach {x1 y1 x2 y2} $dcoords {break}
        set txt [$::chart($node,c) itemcget ytxt$tag -text]
        append res "ctx.moveTo($x1,$y1);\n"
        append res "ctx.fillText(\"$txt\",$x1,$y1);\n"
        append res "ctx.lineTo($x2,$y2);\n"
        if {$txt == 0} {
            append res "ctx.strokeStyle = \"black\";\n\
                ctx.stroke();\n\
                ctx.strokeStyle = \"grey\";\n"
        }
    }
    append res "ctx.stroke();\nctx.closePath();\nctx.beginPath();\n"
    append res "ctx.lineWidth = $lw;\nctx.strokeStyle = \"red\";\nctx.fillStyle = \"red\";\n"
    # lines:
    set first 1
    foreach {x y} $coords {
        if {$first} {
            set first 0
            append res "ctx.moveTo($x,$y);\n"
        } else {
            append res "ctx.lineTo($x,$y);\n"
        }
    }
    append res "ctx.font = \"10px Arial\";\n\
      ctx.textAlign = \"center\";\n\
      ctx.fillStyle = \"grey\";\n"
    # circles:
    foreach {x y} $coords {
        append res "ctx.moveTo($x,$y);\n"
        append res "ctx.arc($x,$y,$rad,0,endAngle,true);\n"
    }
    # texts:
    set i 1
    set sgn 1
    foreach timeval $::chart($node,timedata) {x y} $coords {
        foreach {time val} $timeval {break}
        set yc [expr {$y - $sgn*2*$rad}]
        if {$sgn > 0} {append res "ctx.fillText(\"$i\",$x,$yc);\n"}
        incr i
        set sgn [expr {-1*$sgn}]
    }
    append res "ctx.stroke();\nctx.closePath();\n}\n}\n\
    </script>\n\
    <style type=\"text/css\">\n\
      canvas {border: 1px solid black;}\n\
    </style>\n\
  </head>\n\
  <body onload=\"drawGraph();\">\n\
    <h2>$name</h2>\n\
    <canvas id=\"sensor_graph\" width=\"$width\" height=\"$height\">\n\
    <i>\n\
      -    .\n\
    ,  .\n\
        Internet Explorer,    \n\
        \n\
    ( \"Allow Blocked Content\")   .\n\
    </i>\n\
    </canvas>\n<p></p>\n"
    return $res
}

proc table2html {name ncols table filename info node} {
    set tlen  [llength $table]
    set niter [expr {int(ceil($tlen/$ncols))}]
    set html5 [chartToHTML5 $node]
    set result "$html5\n<table border=1 cellspacing=0>\n\
        <tr><td colspan=[expr {$ncols+1}]>$info</td></tr>\n"
    loop i 0 $niter {
        set line [lrange $table [expr {$i*$ncols}] [expr {($i+1)*$ncols - 1}]]
        if {$i == 0} {
            append result "<tr><td>&nbsp;</td>"
        } else {
            append result "<tr><td>$i.</td>"
        }
        foreach el $line {
            if {[llength $el]==0} {
                append result "<td>&nbsp;</td>"
            } else {
                append result "<td>$el</td>"
            }
        }
        append result "</tr>\n"
    }
    append result "</table></body></html>"
    set fd [open $filename "w"]
    fconfigure $fd -encoding utf-8
    puts $fd $result
    close $fd
    return 0
}
proc table2excel {name ncols table filename node {info _}} {
    set ext [file extension $filename]
    if {$ext eq ".html"} {
        table2html $name $ncols $table $filename $info $node
        return 0
    }
    table2biff $name $ncols $table $filename $info
}
#              .xls
proc chart_getSaveFile {ifile node type} {
    set defext ".jpg"
    set savetypes {
        {"JPEG File"      {.jpg}  JPEG}
        {"HTML File"      {.html} TEXT}
        {"Excel Workbook" {.xls}      }
        {"CSV File"       {.csv}  TEXT}
        {"Text File"      {.txt}  TEXT}
    }
    set c $::chart($node,c)
    if {[macPlatform]} {append ifile ".xls"}
    #else {append ifile $defext}
    set filename [tk_getSaveFile -filetypes $savetypes -title " $type  " \
        -initialfile $ifile -initialdir ~ -parent $c -defaultextension $defext]
    if {[lempty $filename]} {return}
    set ext [file extension $filename]
    set xls [expr {$ext eq ".xls" || $ext eq ".html"}]
    update idletasks
    return [list $filename $xls]
}
proc store_int {row col int {bold 0}} {
    if {abs($int) > 65535} {
        set float [expr double($int)]
        return [store_float $row $col $float $bold]
    }
    #INTEGER record: record_type(2) + record_size(2) + row_number(2) + col_number(2) + format(3) + integer_number(2)
    return [binary format s*c*s "0x0002 9 $row $col" "0 [expr $bold<<6] 0" $int]
}
proc store_float {row col float {bold 0}} {
    #NUMBER record: record_type(2) + record_size(2) + row_number(2) + col_number(2) + format(3) + float_number(8)
    return [binary format s*c*d "0x0003 15 $row $col" "0 [expr $bold<<6] 0" $float]
}
proc store_text {row col text {bold 0}} {
    set len [string length $text]
    if {$len > 255} {
        # we have to cut long strings
        set text [string range $text 0 254]
        set len 255
    }
    #      ;
    #       1251
    set codes {}
    foreach char [split $text ""] {
        if {[info exists ::ruscode($char)]} {
            lappend codes $::ruscode($char)
        } else {
            lappend codes [scan $char %c]
        }
    }
    set sz [expr 8+$len]
    #LABEL record: record_type(2) + record_size(2) + row_number(2) + col_number(2) + format(3) + text_length(1) + text($text_length)
    return [binary format s*c*cc* "0x0004 $sz $row $col" "0 [expr $bold<<6] 0" $len $codes]
}
proc store_bof {} {
    #BOF record
    set head [binary format s* "0x0009 4 0x0000 0x0010"]
    #DIMENSION record: is optional
    #append head [binary format s* "0x0000 8 0 65536 0 65536"]
    #CODEPAGE record: windows-1251 (Cyrillic)
    append head [binary format s* "0x0042 2 1251"]
    #FONT records: plain and bold
    append head [binary format s*ca* "0x0031 10 200 0x0000" 5 "Arial"]
    append head [binary format s*ca* "0x0031 10 200 0x0001" 5 "Arial"]
    return $head
}
proc store_eof {} {
    #EOF record
    return [binary format s 0x000A]
}
proc store_value {row col val {bold 0}} {
    if {$row > 65535 || $col > 255} {return}
    #if {[string is integer -strict $val]}
    #    return [store_int $row $col $val $bold]
    #if {[string is double -strict $val]}
    #    return [store_float $row $col $val $bold]
    return [store_text $row $col $val $bold]
}
# simple Excel/BIFF2 writer in pure Tcl;
# BIFF2 is an old format for Excel spreadsheets developed in 1987,
# but it is still supported by all modern Excel viewers/editors
proc table2biff {name ncols table filename info} {
    set tlen  [llength $table]
    set niter [expr {int(ceil($tlen/$ncols))}]
    if {$niter > 65535} {set niter 65535}
    append xls [store_bof][store_value 0 0 $info]
    for {set i 0} {$i < $niter} {incr i} {
        set line [lrange $table [expr {$i*$ncols}] [expr {($i+1)*$ncols - 1}]]
        set row  [expr {$i + 1}]
        for {set j 0} {$j < $ncols} {incr j} {
            set col $j
            set val [lindex $line $j]
            append xls [store_value $row $col $val [expr {($row==1)?1:0}]]
        }
    }
    append xls [store_eof]
    set fd [open $filename w]
    fconfigure $fd -translation binary
    puts -nonewline $fd $xls
    close $fd
    return 0
}
proc exportChartToFile {node day} {
    set ifile "Sensors-$node"
    if {![llength $day]} {
        set day [dayFormat]
    } else {
        append ifile .$day
    }
    set timedata [getSensData $day $node]
    set info $::chart($node,name)
    set name "Sensor data"
    set ncols 2
    set csvsep ";"
    set file_info [chart_getSaveFile $ifile $node ""]
    foreach {filename xls} $file_info {break}
    if {![info exists filename] || [lempty $filename]} {return}
    if {[file extension $filename] eq ".jpg"} {
        update
        canvasToImage $::chart($node,c) $filename
        return
    }
    set total [list "" ""]
    foreach elt $timedata {
        foreach {time val} $elt {break}
        set date [ftime_sens $time]
        lappend total $date $val
    }
    # .xls export
    if {$xls} {
        set res [table2excel $name $ncols $total $filename $node $info]
        return
    }
    # .csv & .txt export
    set f [open $filename w]
    puts $f $info
    set tlen  [llength $total]
    set niter [expr {int(ceil($tlen/$ncols))}]
    loop i 0 $niter {
        set line [lrange $total [expr {$i*$ncols}] [expr {($i+1)*$ncols - 1}]]
        puts $f [join $line $csvsep]
    }
    close $f
}
proc canvasToImage {c fileName} {
    if {![llength $fileName]} {return}
    progress " ..."
    catch {
        package require Img
        set img "canvasPhoto"
        image create photo $img -format window -data $c
        $img write $fileName -format JPEG
        image delete $img
        $c delete $img
        $c dtag $img
    }
    if {[file exists $fileName] && [file size $fileName] > 0} {
        progress " ."
    } else {
        progress ""
    }
}
proc wrap_lines {len s} {
   set s [string trimright $s]
   set t ""
   set i1 [expr {$len - 1}]
   while { [string length $s] > $len } {
      set s1 [string range $s 0 $i1]
      set s3 [string range $s $len end]
      set j  [string last " " $s1]
      if { $j == -1 } {
         append t "$s1\n"
         set s $s3
      } else {
         set s11 [string range $s1 0 [expr {$j - 1}]]
         set s2  [string range $s1 [expr {$j + 1}] end]
         append t "$s11\n"
         set s "$s2$s3"
      }
   }
   append t "$s"
   return $t
}
proc reconfig_sensor_window {w node day} {
    global chart hist
    set day [remove_braces $day]
    if {[lempty $chart($node,selected)]} {return}
    set ww [winfo width $w]
    set wh [winfo height $w]
    set c $chart($node,c)
    set chart($node,width)  [expr {int($chart(horizfrac) * $ww)}]
    set chart($node,height) [expr {int($chart(vertfrac) * $wh)}]
    $c configure -width $chart($node,width) -height $chart($node,height)
    draw_sensor_graph $node $hist($node,current_sensor) $day 0
}
proc encode {str} {
    return [base64::encode -wrapchar "" [encoding convertto cp1251 $str]]
#    return [base64::encode -wrapchar "" $str]
}
proc decode {str} {
#    return [encoding convertfrom cp1251 [base64::decode $str]]
    set res ""
    catch {
        set res [base64::decode $str]
    }
    return $res
}
proc deleteSrvObj {w srvid} {
    global objects srvids
    if {![info exists srvids($srvid)] ||\
        ![info exists objects($srvids($srvid))] ||\
        [lempty $objects($srvids($srvid))]} {return}
    set tag [getTagBySrvID $srvids($srvid)]
    del $w $tag 1 0 0
}
proc delObject {w srvid} {
    global objects
    if {![info exists objects($srvid)] || ![llength $objects($srvid)]} {return}
    set tag [getTagBySrvID $srvid]
    del $w $tag 0 0 0
}
proc delObjectEver {w srvid} {
    global objects
    if {![info exists objects($srvid)] || ![llength $objects($srvid)]} {return}
    set tag [getTagBySrvID $srvid]
    del $w $tag 1 0 0
}
proc parseServerInput {c} {
    if {[windowsPlatform]} {return}
    set lines [split $::bmap(recv) \n]
    foreach line $lines {
        if {[lempty $line]} {continue}
        set line [encoding convertfrom cp1251 [decode $line]]
        catch {handleMessage $c $line}
    }
    set ::bmap(recv) ""
    set ::bmap(len)  0
}
proc httpHandler {c socket token} {
    if {[windowsPlatform]} {
        return [httpHandler_windows $c $socket $token]
    }
    return [httpHandler_unix $c $socket $token]
}
proc httpHandler_windows {c socket token} {
    global received conn
    set n [gets $socket line]
    set line [encoding convertfrom cp1251 [decode $line]]
    #debug recv:$line
    catch {handleMessage $c $line}
    return $n
}
proc httpHandler_unix {c socket token} {
    global received conn
    if {$::bmap(len) != 0} {
        set recv [read $socket $::bmap(len)]
    } else {
        gets $socket recv
    }
    set n [string length $recv]
    set d [string is xdigit -strict [string trim $recv]]
    if {$d} {
        set len [string trim $recv]
        set ::bmap(len) [format %d 0x$len]
        return $n
    }
    append ::bmap(recv) $recv\n
    return $n
}
proc formQuery {args} {
    set result ""
    set sep ""
    foreach args $args {}
    foreach {par val} $args {
        if {[lempty $val]} {continue}
        set q [http::formatQuery $par [encode $val]]
        append result $sep $q
        set sep "&"
    }
    return $result
}
#synchronous HTTP request
#command syntax: sendit $c par1 val1 par2 val2 ...
proc sendit {c args} {
    global conn errorInfo
    if {[llength $args] == 0 || [llength $args] % 2} {return}
    lappend args NADMIN_AUTH $conn(sid)
    #debug "sent:$args"
    set query [formQuery $args]
    if {[catch {
        set token [http::geturl $conn(mainpage) -query $query -handler "httpHandler $c"]
    }]} {
        #alertError "   .\n :\n$errorInfo"
        progress ""
        return 0
    }
    catch {
        set ncode 0
        set ncode [http::ncode $token]
    }
    parseServerInput $c
    if {$ncode ne "" && $ncode != 200 && [http::code $token] != 0} {
        set errstr ":      .\n :\n$ncode:[http::code $token]"
        catch {http::cleanup $token}
        progress ""
        asksendmail $errstr
        return 0
    }
    catch {http::cleanup $token}
    checkTmpObjs $c
    return 1
}
#   ,    
#      ;
#      ,
#     
proc handleBinds {w {bs {}}} {
    global objects plot channels dotbinds localID chbinds binds houseboxes
    #      ...
    set objids {}
    if {[lempty $bs]} {
        foreach {did objid} $dotbinds {
            if {$objid > 0} {
                if {![info exists localID($objid)]} {continue}
                lappend binds($did) $localID($objid)
            } else {
                lappend binds($did) $objid
            }
            set binds($did) [lsort -unique $binds($did)]
        }
        foreach {chid objid} $channels {
            if {![info exists localID($objid)]} {continue}
            lappend chbinds($chid) $localID($objid)
            set chbinds($chid) [lsort -unique $chbinds($chid)]
        }
        set dotbinds {}
        set channels {}
    } else {
        # ( $bs contains local IDs )
        # ...    
        #       
        # (  ) ,   .
        foreach {dotid objids} $bs {break}
        foreach oid $objids {
            lappend houseboxes($oid) $dotid
        }
    }
    changeAllStates $w $objids
}
# remember dot binds
proc setDotBinds {w srv_dotid state srv_objids} {
    global localID binds houseboxes housestates plot
    foreach srv_oid $srv_objids {
        lappend housestates($srv_oid) $state
    }
    if {![info exists localID($srv_dotid)]} {return}
    set did $localID($srv_dotid)
    if {![info exists binds($did)]} {set binds($did) {}}
    foreach srv_oid $srv_objids {
        if {![info exists localID($srv_oid)]} {continue}
        set oid $localID($srv_oid)
        lappend binds($did) $oid
        # house -> boxes
        lappend houseboxes($oid) $did
    }
    # box -> houses
    set binds($did) [lsort -unique $binds($did)]
    set plot(binds) [concat $plot(binds) $binds($did)]
    changeDotState $w $did $state
}
#        
proc changeDotState {w id st} {
    global objects layers
    if {![info exists objects($id)]} {return}
    set obj      $objects($id)
    set oname    [getStr [lindex $obj 2]]
    set curstate [getStr [lindex $obj 5]]
    if {$oname ne ""} {return}
    if {![lcontain {{} -1 0 1} $st]} {return}
    set newstate [getDotState $st]
    if {$curstate eq $newstate} {return}
    set tag     [getTagBySrvID $id]
    set lname   [getStr [lindex $objects($id) 1]]
    set layerID $layers($lname)
    set objID   [getObject $tag]
    setObjectState $id $newstate
    applyParams $w $tag $objID $layerID
    updateBalloon $w $tag
    return
}
#    ,   ,
#     
proc changeAllStates {w {objids {}}} {
    # 1.  :
    if {[array exists ::housestates] && !$::plot(admin)} {
        set objs [array names ::housestates]
        foreach oid $objs {
            set states $::housestates($oid)
            if {$oid < 0 && [info exists ::srvids($oid)]} {
                set oid $::srvids($oid); # to server ID
            }
            if {![info exists ::localID($oid)]} {continue}
            set id $::localID($oid); # to local ID
            computeObjectState $id $states
        }
        array unset ::housestates
        return
    }
    if {!$::plot(admin)} {return}
    # 2.  :
    if {[lempty $objids]} {
        set objids [lsort -unique $::plot(binds)]
    }
    foreach oid $objids {
        if {$oid > 0 && [info exists ::localID($oid)]} {
            set oid $::localID($oid)
        }
        #    ,    
        if {![info exists ::houseboxes($oid)]} {continue}
        set boxes [lsort -unique $::houseboxes($oid)]
        set states {}
        foreach box $boxes {
            if {![info exists ::objects($box)]} {continue}
            set state [lindex $::objects($box) 5]
            if {$state eq [getDotState 0]}  {lappend states 0}
            if {$state eq [getDotState 1]}  {lappend states 1}
            if {$state eq [getDotState -1]} {lappend states -1}
        }
        computeObjectState $oid $states
    }
    set ::plot(binds) {}
    return
}
proc computeObjectState {id states} {
    if {![info exists ::objects($id)]} {return}
    set st0 [set st1 [set stu 0]]
    foreach st $states {
        if {$st==0}  {set st0 1}
        if {$st==1}  {set st1 1}
        if {$st==-1} {set stu 1}
    }
    set obj $::objects($id)
    set oname [getStr [lindex $obj 2]]
    if {$oname ne ""} {return}
    set newstate [getObjState -1]
    #1.          ,  "".
    #2. ,    ,  " (Off)".
    #3. ,    ,  " (On)".
    #4.  "".
    if {$st1 && $st0} {
        set newstate [getObjState 2]
    } elseif {$st0} {
        set newstate [getObjState 0]
    } elseif {$st1} {
        set newstate [getObjState 1]
    } else {
        set newstate [getObjState -1]
    }
    set state [lindex $::objects($id) 5]
    if {$state eq $newstate} {return}
    setObjectState $id $newstate
    set tag     [getTagBySrvID $id]
    set layerID [getLayer $tag]
    applyParams $::plot(c) $tag $id $layerID
}
proc setObjectState {id state} {
    set ::objects($id) [lreplace $::objects($id) 5 5 $state]
}
proc getDotState {stateID} {
    switch -- $stateID {
        0 {return " "}
        1 {return "*"}
        default {return ""}
    }
}
proc getObjState {stateID} {
    switch -- $stateID {
        0 {return " (Off)"}
        1 {return " (On)"}
        2 {return " ()"}
        default {return ""}
    }
}
proc dispatchTmpObjs {w c} {
    global plot localID
    set len     [llength $plot(tmpobjs)]
    set accept  {}
    set acceptr {}
    set reject  {}
    set rejectr {}
    loop i 0 $len {
        if {[lempty $::ttchbox($i)]} {continue}
        set obj [lindex $plot(tmpobjs) $i]
        set id  [lindex $obj 0]
        if {$::ttchbox($i) == 1} {
            lappend accept $id
        } elseif {$::ttchbox($i) == 2} {
            lappend acceptr $id
        } elseif {$::ttchbox($i) == 3} {
            lappend reject $id
        } elseif {$::ttchbox($i) == 4} {
            lappend rejectr $id
        }
    }
    set allAccept [concat $accept $acceptr]
    set allReject [concat $reject $rejectr]
    set modids [join $allAccept "|"]
    set delids [join $allReject "|"]
    closeTmpTable $w
    progress " ..."
    sendit $c modobj "$modids" deltmp "$delids"
    progress ""
    set alltmps [concat $allAccept $allReject]
    foreach id $alltmps {
        if {[info exists localID($id)]} {
            set tag [getTagBySrvID $localID($id)]
        } else {
            set tag [getTagBySrvID $id]
        }
        catch {
            del $c $tag 1 0 0
            removeSelection $c
        }
    }
}
proc showTmpObject {c num} {
    global plot objects
    set obj [lindex $plot(tmpobjs) $num]
    set id  [lindex $obj 0]
    set id2 [makeObject $c $obj]
    if {[lempty [getStr $objects($id2)]]} {return}
    foreach {x y} [getMidCoords $id2] {break}
    if {![info exists x]} {return}
    foreach {X Y} [countCoords2 [list $x $y] 7 $::layers(zoomLevel)] {break}
    moveCenter $c $X $Y 1.0
    showPointer $c $X $Y
    set tag [getTagBySrvID $id2]
    if {[getAllParams $c $tag] ne "-state hidden"} {
        setSelect $c $tag 1
    }
}
proc acceptAllTmpObjs {} {
    global plot
    set len [llength $plot(tmpobjs)]
    loop i 0 $len {
        set ::ttchbox($i) 1
    }
}
proc rejectAllTmpObjs {} {
    global plot
    set len [llength $plot(tmpobjs)]
    loop i 0 $len {
        set ::ttchbox($i) 3
    }
}
proc rowTagCmd {row} {
    if {$row==-1} {return title}
}
proc showTmpTable {c} {
    global plot
    set w $c.tmpobjs
    if {[winfo exists $w]} {return}
    catch {toplevel $w}
    wm title $w " ."
    wm protocol $w WM_DELETE_WINDOW {
        closeTmpTable .plot.c.tmpobjs
    }
    set hfont $::fonts(heads)
    set tfont $::fonts(txt)
    set tfontb $::fonts(txtb)
    set bfont $::fonts(buts)
    focus -force $w
    frame $w.f1
    pack $w.f1 -fill both -expand 1
    label $w.f1.l -text " " -font $hfont
    pack $w.f1.l -fill x -expand 1 -padx 5 -pady 5
    set t $w.f1.tt
    set n [llength $plot(tmpobjs)]
    if {$n==0} {
        alert "   ."
        destroy $w
    }
    table $t \
        -command [list tmpTabCmd $t $c %C] \
        -cols 5 \
        -rows [expr $n + 1] \
        -width 40 \
        -height [expr $plot(tmpmax) + 1] \
        -titlerows 0 \
        -titlecols 0 \
        -roworigin -1 \
        -colorigin 0 \
        -yscrollcommand "$w.f1.sy set" \
        -colstretchmode all \
        -rowstretchmode all \
        -sparsearray 0 \
        -state disabled \
        -wrap 0 \
        -rowheight 2 \
        -justify left \
        -ipadx 3 \
        -cursor top_left_arrow \
        -selecttitles 1 \
        -rowtagcommand rowTagCmd \
        -selectmode browse
    $t tag config r0 -font $tfont
    $t tag config r1 -font $tfont
    $t tag config caps -font $tfontb -bg gray -fg black
    $t tag config OddRow  -font $tfont -bg white
    $t tag config EvenRow -font $tfont -bg white
    $t tag config title -font {Helvetica 11 bold} -fg black
    scrollbar $w.f1.sy -command "$t yview"
    pack $w.f1.sy -side right -fill y
    pack $t -fill both -expand 1 -side left
    $t width 0 17
    $t width 1 17
    $t width 2 17
    $t width 3 17
    $t width 4 17
    $t tag row caps -1
    #::autoscroll::autoscroll $w.f1.sy
    frame $w.f2
    pack $w.f2 -fill both -expand 1
    set b1 $w.f2.g1
    set b2 $w.f2.g2
    frame $b1
    frame $b2
    pack $b2 $b1 -fill both -expand 1 -side left
    button $b1.aa -text " " -font $bfont -command acceptAllTmpObjs -font $bfont
    button $b1.ra -text " " -font $bfont -command rejectAllTmpObjs -font $bfont
    pack $b1.aa $b1.ra -side top -expand 0 -fill x -padx 5 -pady 5
    button $b2.ra -text "" -font $bfont -command "dispatchTmpObjs $w $c" -default active -font $bfont
    button $b2.aa -text "" -font $bfont -command "closeTmpTable $w" -font $bfont
    pack $b2.ra $b2.aa -side top -expand 0 -fill x -padx 5 -pady 5
    bind $w <KeyPress-Return> "$b2.ra invoke"
    bind $w <KeyPress-Escape> "closeTmpTable $w"
}
proc closeTmpTable {w} {
    set ::plot(tmpobjs) {}
    catch {array unset ::ttchbox}
    catch {destroy $w}
}
proc tmpTabCmd {t c cell} {
    global plot
    set spl [split $cell ","]
    set row [lindex $spl 0]
    set col [lindex $spl 1]
    if {$row==-1} {
        set caps [list "" "" " \u2191" "" " \u2193"]
        return [lindex $caps $col]
    }
    if {$col==0} {
        set i     [expr $row+1]
        set obj   [lindex $plot(tmpobjs) $row]
        set ctext "$i. [lindex $obj 2]"
        catch {destroy $t.l$cell}
        set l [label $t.l$cell -text $ctext \
            -fg blue -bg white -cursor hand2 \
            -font $::fonts(txt) -anchor e]
        $t window config $cell -window $l -sticky w -bg white
        $t tag cell r1 $cell
        bind $t.l$cell <ButtonRelease-1> "showTmpObject $c $row"
        return
    }
    set ::ttchbox($row) 0
    set cb [radiobutton $t.cb$cell -relief sunken -variable ::ttchbox($row) -value $col -bg white]
    $t window config $cell -window $cb -sticky news
    return
}
proc checkTmpObjs {c} {
    if {[lempty $::plot(tmpobjs)]} {return}
    showTmpTable $c
}
proc handleMessage {w text} {
    global conn plot tmpchoice
    set kword   [lindex $text 0]
    set msgBody [lrange $text 1 end]
    if {![info exists ::msgcount]} {
        set ::msgcount 0
    }
    if {![info exists ::authmsgcount]} {
        set ::authmsgcount 0
    }
    if {![info exists ::errmsgcount]} {
        set ::errmsgcount 0
    }
    switch -regexp $kword {
        "NADMIN_AUTH" {
            setWindowTitle "(   $conn(org):$conn(login))"
            set conn(sid) $msgBody
            if {![info exists ::first_fetch] && [sensor_data_allowed]} {
                set ::first_fetch 1
                progress " ..."
                informer_fetch3
            }
        }
        "SIZE"        {set plot(size) [getStr $msgBody]; set plot(rem) $plot(size)}
        "OBJECT"      {processObject $w $msgBody}
        "DELOBJ"      {deleteSrvObj $w $msgBody}
        "TMP"         {
            if {![lempty $msgBody]} {
                lappend plot(tmpobjs) $msgBody
            }
        }
        "CHANGE"      {changeID [lindex $msgBody 0] [lindex $msgBody 1]}
        "OK"          {sendit $w feedback 1}
        "TIMESTAMP"   {set plot(ts) $msgBody}
        "TIMEOUT"     {
            #set plot(timeout) $msgBody
        }
        "STATE"       {
            set dot_id  [lindex $msgBody 0]
            set state   [lindex $msgBody 1]
            set obj_ids [lrange $msgBody 2 end]
            if {[llength $state] > 1 && [lempty $obj_ids]} {
                set obj_ids $state
                set state -1
            }
            setDotBinds $w $dot_id $state $obj_ids
        }
        "ERROR"       {
             switch $msgBody {
                "AUTH" - "ERROR_AUTH" {
                    setWindowTitle ""
                    displayDialog "    ."
                    return 0
                }
                "CREATE" {
                    alertError "    ."
                    return 0
                }
                "DELOBJ" {
                    alertError "     ."
                    return 0
                }
                "EMPTY" {
                    alert "   ."
                    set tmpchoice 0
                    return 0
                }
                "PARAM" {
                    alertError "     ."
                    return 0
                }
                "SYSTEM ERROR" {
                    alertError "  ."
                    return 0
                }
                default {
                    if {[lcontain $msgBody "moderate"]} {set tmpchoice 3}
                    if {[string trim $text \n] eq "ERROR authorization data is wrong"} {
                        set conn(auth) [secureAuth $w]
                        if {$conn(auth) && $plot(sendobjects)} {
                            alert "    .      ."
                        } elseif {!$conn(auth)} {
                            displayDialog "   ."
                        }
                        return 0
                    }
                    if {$msgBody eq "authorization data not found"} {
                        setWindowTitle ""
                        if {[incr ::authmsgcount] < 2} {
                            alertError "  "
                        }
                    } else {
                        #if {[incr ::errmsgcount] < 3}
                        alertError ":\n\n$text"
                    }
                    return 0
                }
             }
        }
        default {
            if {![lempty [getStr $text]] && [incr ::msgcount] < 4} {
                #alertError " :\n\n$text"
            }
            return 0
        }
    }
    return 1
}
# processing objects; must be very fast
proc processObject {w objstr} {
    global plot srvids objects localID
    set srvid [lindex $objstr 0]
    if {[info exists localID($srvid)]} {
        set locid $localID($srvid)
        set ch 0
        if {[info exists ::changed($locid)]} {
            set ch $::changed($locid)
        }
        if {!$ch} {
            # recreate object if it wasn't prohibited
            if {[lsearch -exact $::updates(prohibit) $srvid,$plot(ts)] < 0} {
                delObject $w $locid
            } else {return}
        } else {
            # object was changed by local user, BMap must display an 'accept dialog'
            lappend ::updates(recv) $srvid
            set ::updates($srvid) $objstr
            return
        }
    }
    set locid [makeObject $w $objstr]
    set srvids($locid) $srvid
    set srvids($srvid) $locid
    set lname [getStr [lindex $objects($locid) 1]]
    if {$lname eq ""} {
        if {[lsearch -exact $::plot(sysorgs) $::conn(org)] < 0} {
            lappend ::plot(sysorgs) $::conn(org)
        }
    }
    incr plot(rem) -1
    if {$plot(size) > 0 && $plot(rem) > 0} {
        set done [expr {$plot(size) - $plot(rem)}]
        if {$done % 200 == 0} {
            set pc [getPercent $done $plot(size)]
            progress " ...$pc%"
        }
    }
    if {$plot(size) > 0 && $plot(rem) <= 0} {
        set plot(size) 0
        updateCanvas $w 1.0
    }
}
proc getPercent {done size} {
    return [expr {int((double($done)/double($size))*100.0)}]
}
proc sameObjects {id obj} {
    global objects localID
    set obj [convToOld $obj]
    if {[lempty $obj] || [llength $obj] < $objects(nFields)} {return}
    set objstr "[lrange $obj 0 end-1] 0"
    set params  [lindex $objstr 3]
    set newParams "7 $params"
    set objstr [lreplace $objstr 3 3 $newParams]
    return [expr {[lrange $objstr 1 end-1] eq [lrange $objects($localID($id)) 1 end-1]}]
}
proc changeID {old new} {
    global srvids
    set srvids($old) $new
    set srvids($new) $old
}
proc moderateObjs {c} {
    global tmpchoice plot
    set plot(tmpobjs) {}
    progress "  ..."
    sendit $c givetmp "$plot(tmpmax)"
}
proc checkBoxes {boxes} {
    foreach box $boxes {
        set nums [split $box ","]
        if {[llength $nums] != 2 || ![string is integer [lindex $nums 0]] ||\
            ![string is integer [lindex $nums 1]]} {return 0}
    }
    return 1
}
proc checkCoords {coords} {
    if {[expr [llength $coords] % 2] != 0} {return 0}
    foreach crd $coords {
        if {![string is double $crd]} {return 0}
    }
    return 1
}
proc correctFormat {obj} {
    global objects
    if {[lempty [getStr $obj]] || [llength $obj] < 10} {return 0}
    set id      [lindex $obj 0]; # ID.
    set lrName  [lindex $obj 1]; #  .
    set objName [lindex $obj 2]; #  .
    set type    [lindex $obj 3]; # .
    set state   [lindex $obj 4]; # .
    set name    [lindex $obj 5]; # .
    set address [lindex $obj 6]; # .
    set comment [lindex $obj 7]; # .
    set boxes   [lindex $obj 8]; #  .
    set coords  [lindex $obj 9]; # .
    #  ID,  ,  ,     :
    if {[lempty $id] || [lempty $lrName] || [lempty $objName] || \
        [lempty $boxes] || [lempty $coords]} {return 0}
    #   :
    if {[isKey $objName 3] && [lempty $type]}    {return 0}
    if {[isKey $objName 4] && [lempty $state]}   {return 0}
    if {[isKey $objName 5] && [lempty $name]}    {return 0}
    if {[isKey $objName 6] && [lempty $address]} {return 0}
    if {[isKey $objName 7] && [lempty $comment]} {return 0}
    #  :
    if {[string is integer $id] && [info exists objects($lrName)] && \
        [lsearch $objects($lrName) $objName] > -1 && \
        [checkBoxes $boxes] && [checkCoords $coords]} {return 1}
    return 0
}
proc readConfig {c} {
    global plot layers but canvas conn inlayer man_edit man_vis
    # ,     . :
    set vident 0
    if {![file exists $plot(configfile)]} {
        set sz [getCanvasSize $::layers(zoomLevel)]
        set xshift [expr {int($sz*0.65)}]
        set yshift [expr {int($sz*0.64)}]
        centerScreen $c $xshift $yshift
        callHelp
    }
    set body ""
    catch {
        set f [open $plot(configfile) r]
        while {![eof $f]} {
            gets $f line
            if {[string trim $line] eq "set version $plot(version)"} {
                set vident 1
            }
        }
        seek $f 0 start
        set body [read $f]
        close $f
    }
    catch {source $plot(configfile)}
    if {[bm_exe]} {catch {eval $body}}
    loadLayers
    for {set i 0} {$i < $layers(N)} {incr i} {
        if {![info exists layers($i,visible)]} {
            set layers($i,visible)  1
        }
        set man_vis($i) $layers($i,visible)
        if {![info exists layers($i,editable)]} {
            set layers($i,editable) 1
        }
        set man_edit($i) $layers($i,editable)
        if {![info exists layers($i,top)]} {
            set layers($i,top) 0
        }
        set inlayer($i) {}
    }
    set button $but
    setTopLayer $c $layers(top)
    if {![macPlatform]} {
        setInitZoomLevel $c $layers(zoomLevel)
    }
    if {[info exists canvas(cX)] && [info exists canvas(cY)]} {
        centerScreen $c $canvas(cX) $canvas(cY)
    }
    leftTB $button $c
}
proc saveConfig {w} {
    global layers canvas but conn plot
    set cnt [getCenterCoords $w]
    foreach {canvas(cX) canvas(cY)} $cnt {}
    if {[catch {set f [open $plot(configfile) w]} desc]} {
        #alert "    .\n$desc"
        return 1
    }
    for {set i 0} {$i < $layers(N)} {incr i} {
        puts $f " set layers($i,editable) $layers($i,editable)\n\
                 set layers($i,visible)  $layers($i,visible)\n\
                 set layers($i,top)      $layers($i,top)"
    }
    puts $f " set layers(top) $layers(top)\n\
        set layers(zoomLevel) $layers(zoomLevel)\n\
        set canvas(cX) $canvas(cX)\n\
        set canvas(cY) $canvas(cY)"
    if {![lempty $but]}         {puts $f " set but {$but}"}
    if {![lempty $conn(org)]}   {puts $f " set conn(org) $conn(org)"}
    if {![lempty $conn(login)]} {puts $f " set conn(login) $conn(login)"}
    puts $f " set version $plot(version)"
    puts $f " set ::satmap(shiftx) $::satmap(shiftx)"
    puts $f " set ::satmap(shifty) $::satmap(shifty)"
    puts $f " set ::satmap(type) $::satmap(type)"
    puts $f " set ::myImages(showsublayer) $::myImages(showsublayer)"
    puts $f " set ::mmap(shown) $::mmap(shown)"
    puts $f " set ::mmap(mode) $::mmap(mode)"
    close $f
}
proc isNetObj {id} {
    global objects
    set object $objects($id)
    set lname  [getStr [lindex $object 1]]
    return [expr {$lname eq "" || $lname eq ""}]
}
proc isBoxObj {id} {
    global objects
    set object $objects($id)
    set lname  [getStr [lindex $object 1]]
    return [expr {$lname eq ""}]
}
proc isDamagedHouse {id} {
    global objects
    set object $objects($id)
    set oname  [getStr [lindex $object 2]]
    set state  [getStr [lindex $object 5]]
    return [expr {$oname eq "" && $state eq " (Off)"}]
}
proc hideArrows {w dotid} {
    return
    $w delete dotarrows_$dotid
    $w dtag dotarrows_$dotid
}
proc hideDotBinds {w} {
    return
    $w delete dotarrows
    $w dtag dotarrows
    update idletasks
}
proc showDotBinds {w dotid} {
    global binds layers complex plot
    return
    if {![info exists binds($dotid)]} {return}
    if {[lempty $binds($dotid)]} {
        hideArrows $w $dotid
        return
    }
    hideDotBinds $w
    set db   $binds($dotid)
    set tag  [getTagBySrvID $dotid]
    set tags {}
    array set pars [getAllParams $w $tag]
    if {[info exists pars(-state)] && $pars(-state)=="hidden"} {return}
    if {![info exists pars(-radius)] || [lempty $pars(-radius)]} {
        set rad 12
    } else {set rad $pars(-radius)}
    set i -1
    set db [lsort -unique $db]
    foreach id $db {
        set eltag [getTagBySrvID $id]
        set arrtag "dotarrow_${dotid}_[incr i]"
        set res [computeArrowCoords $dotid $id $rad]
        foreach {aw crds} $res {break}
        #    (x2,y2)  (x1,y1)  aw:
        catch {
            $w create line $crds -fill SaddleBrown -width $aw -tags $arrtag -arrow last
        }
        lappend tags $arrtag
    }
    set tags [lsort -unique $tags]
    group $w dotarrows_$dotid $tags
    group $w dotarrows $tags
}
# change arrows coordinates
proc changeDotArrows {w dotid} {
    global binds layers complex plot
    return
    if {![info exists binds($dotid)]} {return}
    if {[lempty $binds($dotid)]} {
        hideArrows $w $dotid
        return
    }
    set db $binds($dotid)
    set tag [getTagBySrvID $dotid]
    array set pars [getAllParams $w $tag]
    if {[info exists pars(-state)] && $pars(-state)=="hidden"} {return}
    if {![info exists pars(-radius)] || [lempty $pars(-radius)]} {
        set rad 12
    } else {set rad $pars(-radius)}
    set i -1
    set db [lsort -unique $db]
    foreach id $db {
        set arrtag "dotarrow_${dotid}_[incr i]"
        set res [computeArrowCoords $dotid $id $rad]
        foreach {aw crds} $res {break}
        #   :
        catch {
            $w coords $arrtag $crds
            $w itemconfigure $arrtag -width $aw
        }
    }
}
proc computeArrowCoords {dotid id rad} {
    global binds layers complex plot
    set w $plot(c)
    set tag  [getTagBySrvID $dotid]
    set text [lindex $complex($tag) 1]
    set crds [$w coords $text]
    set x0   [lindex $crds 0]
    set y0   [lindex $crds 1]
    # .  :
    set area 600
    #        ,
    #  :    .
    #       .
    # .  :
    set maxAW 10
    set eltag [getTagBySrvID $id]
    #  ,  "-smooth on",   :
    set coords [countCoords [getCoords $id] 7]
    catch {
        if {[smoothedObject $eltag]} {
            set npnts [expr {[llength $coords]/2}]
            set newcoords {}
            for {set j 0} {$j < $npnts} {incr j} {
                foreach {x y} [bezierCoords $coords $j] {break}
                lappend newcoords $x $y
            }
            set coords $newcoords
        }
    }
    set x1 [lindex $coords 0]
    set y1 [lindex $coords 1]
    if {[llength $x0]==0 || [llength $y0]==0 || 
        [llength $x1]==0 || [llength $y1]==0} {return}
    set l01 [dist $x0 $y0 $x1 $y1]
    foreach {x y} $coords {
        set l [dist $x0 $y0 $x $y]
        if {$l < $l01} {
            set l01 $l
            set x1 $x
            set y1 $y
        }
    }
    if {int($l01) == 0} {set l01 1}
    set x2  [expr {($rad*($x1-$x0))/$l01+$x0}]
    set y2  [expr {($rad*($y1-$y0))/$l01+$y0}]
    set l21 [dist $x2 $y2 $x1 $y1]
    if {int($l21) == 0} {set l21 1}
    set aw  [expr {int($area/$l21)}]
    if {$aw > $maxAW} {set aw $maxAW}
    return [list $aw [list $x2 $y2 $x1 $y1]]
}
proc smoothOn {sm} {
    return [lcontain {"1" "bezier" "true"} $sm]
}
proc smoothedObject {tag} {
    set w $::plot(c)
    if {[isPolyType [$w type $tag]] && [smoothOn [getOneParam $w $tag -smooth]]} {
        return 1
    }
    return 0
}
#    
proc dist {x1 y1 x2 y2} {
    if {[llength $x1]==0 ||
        [llength $y1]==0 ||
        [llength $x2]==0 ||
        [llength $y2]==0} {return 0}
    set dx [expr {$x2 - $x1}]
    set dy [expr {$y2 - $y1}]
    return [expr {hypot($dx,$dy)}]
}
proc initPan {c} {
    # 1. - :
    unbindAll $c
    # 2.    1:
    setCursor $c pantool1
    bind $c <ButtonPress-1>   "startPan $c %x %y"
    bind $c <ButtonRelease-1> "stopPan $c"
    bind $c <ButtonPress-3>   "showProps $c current"
}
proc startPan {c x y} {
    global canvas
    # 1.    2:
    setCursor $c pantool2
    # 2.   :
    set canvas(panX) [$c canvasx $x]
    set canvas(panY) [$c canvasy $y]
    # 3.      :
    bind $c <Motion> "changePan $c %x %y"
}
proc stopPan {c} {
    # 1.      :
    bind $c <Motion> ""
    # 2.    1:
    setCursor $c pantool1
    # 3.  :
    updateCanvas $c 1.0
}
proc changePan {c x y} {
    set cx  [$c canvasx $x]
    set cy  [$c canvasy $y]
    set dx [expr {int($::canvas(panX) - $cx)}]
    set dy [expr {int($::canvas(panY) - $cy)}]
    $c xview scroll $dx units
    $c yview scroll $dy units
    changeMCRectCoords $c
}
proc toggleMinimap {c w} {
    if {$::mmap(shown)} {
        hideMinimap
    } else {
        showMinimap $c $w
    }
}
proc configMinimap {c w} {
    update idletasks
    if {$::mmap(shown)} {showMinimap $c $w}
    # else hideMinimap
}
proc hideMinimap {} {
    global mmap
    catch {destroy $mmap(m)}
    set mmap(var) "\n"
    set mmap(shown) 0
}
proc changeMinimapGeometry {c} {
    global mmap
    set m $mmap(m)
    if {![winfo exists $m]} {return}
    set rx [winfo rootx $c]
    set ry [winfo rooty $c]
    catch {wm geometry $m "+${rx}+${ry}"}
}
proc showMinimap {c w} {
    global mmap images
    set m $w.mm
    set mmap(var) "\n"
    set mmap(shown) 1
    set mmap(m) $m
    catch {destroy $m}
    catch {toplevel $m}
    wm title $m "."
    wm protocol $m WM_DELETE_WINDOW {hideMinimap}
    wm group $m $w
    wm transient $m $w
    if {![info exists mmap(tag)]} {
        set mmap(tag) mcimg
        set mmap(iniw) 720; # original image width
        if {$mmap(mode) eq "town"} {
            set file [file join . $images(imagedir) "town.gif"]
        } else {
            set file [file join . $images(imagedir) "minimap.gif"]
        }
        image create photo $mmap(tag)_orig -file $file
        image create photo $mmap(tag)
        $mmap(tag) blank
        $mmap(tag) copy $mmap(tag)_orig -subsample 2 2;# shrink 2x
        set mmap(curw) [expr {$mmap(iniw)/2}]
        set mmap(curh) [expr {$mmap(iniw)/2}]
    }
    set rx [winfo rootx $c]
    set ry [winfo rooty $c]
    wm geometry $m "=${mmap(curw)}x$mmap(curh)+${rx}+${ry}"
    set mc $m.c
    set mmap(mc) $mc
    canvas $mc -background white -borderwidth 0 -width $mmap(curw) \
        -height $mmap(curh) -scrollregion [mmapBbox]
    pack $mc -side left -expand 0 -fill none -anchor nw
    foreach {ci cd cm} [mmap_butcoords] {break}
    button $mc.but_inc -text "+" -font {Arial 13} -width 2 -relief flat \
        -command "mmap_expand $m $mc $c"
    $mc create window $ci -window $mc.but_inc -anchor nw -tags but_inc
    button $mc.but_dec -text "-" -font {Arial 13} -width 2 -relief flat \
        -command "mmap_shrink $m $mc $c"
    $mc create window $cd -window $mc.but_dec -anchor nw -tags but_dec
    button $mc.but_mode -text "m" -font {Arial 13} -width 2 -relief flat \
        -command "mmap_mode $c $w"
    $mc create window $cm -window $mc.but_mode -anchor nw -tags but_mode
    if {$mmap(mode) eq "town"} {
        set crds [list 0 0]
    } else {
        set crds [list [expr {-$mmap(curw)/2.0}] [expr {-$mmap(curh)/2.0}]]
    }
    $mc create image $crds -image $mmap(tag) -anchor nw -tags $mmap(tag)
    update idletasks
    changeMinimapGeometry $c
    createRectangle $c $mc
    bind $m <Configure>      "catch {mmap_config $mc $m $c}"
    bind $mc <ButtonPress-1> "initMinimapMove $c $mc %x %y"
    bind $m <FocusIn>        "focus -force $w"
}
proc mmap_mode {c w} {
    global mmap
    if {$mmap(mode) eq "town"} {
       set mmap(mode) "region"
    } else {
       set mmap(mode) "town"
    }
    mmap_mode_apply $c $w
}
proc mmap_mode_apply {c w} {
    global mmap
    unset mmap(tag)
    hideMinimap
    showMinimap $c $w
    # maybe clean memory
}
proc mmap_butcoords {} {
    global mmap
    if {$mmap(mode) eq "town"} {
        set ci [list 0 10]
        set cd [list 30 10]
        set cm [list 60 10]
        return [list $ci $cd $cm]
    }
    set ci [list [expr {-$mmap(curw)/2.0}] [expr {-$mmap(curh)/2.0 + 10}]]
    set cd [list [expr {-$mmap(curw)/2.0 + 30}] [expr {-$mmap(curh)/2.0 + 10}]]
    set cm [list [expr {-$mmap(curw)/2.0 + 60}] [expr {-$mmap(curh)/2.0 + 10}]]
    return [list $ci $cd $cm]
}
proc mmap_expand {m mc c} {
    set w [winfo width $m]
    set h [winfo height $m]
    if {$w > $::mmap(iniw) || $h > $::mmap(iniw)} {return}
    set wid [expr {2*$w}]
    set hei [expr {2*$h}]
    wm geometry $m "=${wid}x$hei"
    mmap_config $mc $m $c
}
proc mmap_shrink {m mc c} {
    set w [winfo width $m]
    set h [winfo height $m]
    set wid [expr {int(0.5*$w)}]
    set hei [expr {int(0.5*$h)}]
    wm geometry $m "=${wid}x$hei"
    mmap_config $mc $m $c
}
proc mmapBbox {} {
    global mmap
    if {$mmap(mode) eq "town"} {
        return [list 0 0 $mmap(curw) $mmap(curh)]
    }
    return [list [expr {-$mmap(curw)/2.0}] [expr {-$mmap(curh)/2.0}] \
                 [expr {$mmap(curw)/2.0}]  [expr {$mmap(curh)/2.0}]]
}
proc mmap_config {mc m c} {
    global mmap
    set wid [winfo width $m]; # current width
    set hei [winfo height $m]; # current height
    set fx  [expr {int(ceil(double($mmap(iniw))/double($wid)))}]
    set fy  [expr {int(ceil(double($mmap(iniw))/double($hei)))}]
    set w   [expr {int(double($mmap(iniw))/double($fx))}]
    set h   [expr {int(double($mmap(iniw))/double($fy))}]
    if {$w > $mmap(iniw) || $h > $mmap(iniw)} {return}
    $mmap(tag) blank
    $mmap(tag) copy $mmap(tag)_orig -subsample $fx $fy; # shrink image
    set mmap(curw) $w
    set mmap(curh) $h
    $mc configure -width $w -height $h -scrollregion [mmapBbox]
    if {$mmap(mode) eq "town"} {
        $mc coords $mmap(tag) 0 0
    } else {
        $mc coords $mmap(tag) [expr {-$mmap(curw)/2.0}] [expr {-$mmap(curh)/2.0}]
    }
    catch {changeMCRectCoords $c}
    foreach {ci cd cm} [mmap_butcoords] {break}
    $mc coords but_inc $ci
    $mc coords but_dec $cd
    $mc coords but_mode $cm
    mmap_drawdots $mc
    update idletasks
}
proc mmap_drawdots {mc} {
    global mmap plot objects
    if {!$plot(admin)} {return}
    if {![winfo exists $mc]} {return}
    $mc delete mmapOvals
    $mc dtag mmapOvals
    set cw [getCanvasSize 7]
    if {$mmap(mode) eq "town"} {
        set cw [expr {$cw/($::canvas(maxSize_px)/32000)}]
    }
    set ch  $cw
    set mcw $mmap(curw)
    set mch $mmap(curh)
    set wratio [expr {double($mcw)/double($cw)}]
    set hratio [expr {double($mch)/double($ch)}]
    set ids [nodesdown]
    set tags {}
    foreach id $ids {
        set crds [getCoords $id]
        set x [lindex $crds 0]
        set y [lindex $crds 1]
        if {[lempty $x] || [lempty $y]} {continue}
        if {![string is double -strict $x] ||
            ![string is double -strict $y]} {continue}
        set mx [expr {$x*$wratio}]
        set my [expr {$y*$hratio}]
        set oc [nodeOvalCoords $mx $my 1.5]
        set tag mco$id
        $mc create oval $oc -tags $tag -fill red -width 0
        lappend tags $tag
        if {![info exists objects($id)]} {continue}
        set name [getStr [lindex $objects($id) 6]]
        setBalloon $mc $tag "$name\n "
    }
    group $mc mmapOvals $tags
}
proc stopMinimapMove {c mc} {
    if {![winfo exists $mc]} {return}
    bind $mc <Motion> ""
    bind $mc <ButtonRelease-1> ""
    updateCanvas $c 1.0
}
proc initMinimapMove {c mc x y} {
    global mmap
    if {![winfo exists $mc]} {return}
    foreach {x1 y1 x2 y2} [$mc coords mcrect] {break}
    set x [$mc canvasx $x]
    set y [$mc canvasy $y]
    if {!($x >= $x1 && $x <= $x2 && $y >= $y1 && $y <= $y2)} {
        moveMinimapRect $c $mc $x $y
        set mmap(lastx) $x
        set mmap(lasty) $y
        return
    }
    # if clicked inside rectangle:
    set mmap(lastx) $x
    set mmap(lasty) $y
    bind $mc <Motion> "minimapMove $c $mc %x %y"
    bind $mc <ButtonRelease-1> "stopMinimapMove $c $mc"
}
proc minimapMove {c mc x y} {
    global mmap layers
    if {![winfo exists $mc]} {return}
    set x [$mc canvasx $x]
    set y [$mc canvasy $y]
    set dx [expr {$x-$mmap(lastx)}]
    set dy [expr {$y-$mmap(lasty)}]
    $mc move mcrect $dx $dy
    changeMCAxesCoords $mc
    set mmap(lastx) $x
    set mmap(lasty) $y
    set scrll [getMinimapScrollUnits $mc $dx $dy]
    foreach {hscr vscr} $scrll {break}
    $c xview scroll $hscr units
    $c yview scroll $vscr units
}
proc getMinimapScrollUnits {mc dx dy} {
    global mmap layers canvas
    if {![winfo exists $mc]} {return}
    set cw [getCanvasSize $layers(zoomLevel)]
    if {$mmap(mode) eq "town"} {
        set cw [expr {$cw/($canvas(maxSize_px)/32000)}]
    }
    set ch  $cw
    set mcw [winfo width $mc]
    set mch [winfo height $mc]
    set ratiow [expr {double($cw)/double($mcw)}]
    set ratioh [expr {double($ch)/double($mch)}]
    set hscr [expr {int($dx*$ratiow)}]
    set vscr [expr {int($dy*$ratioh)}]
    return [list $hscr $vscr]
}
proc moveMinimapRect {c mc x y} {
    global mmap
    if {![winfo exists $mc]} {return}
    foreach {x1 y1 x2 y2} [$mc coords mcrect] {break}
    set rcx [expr {($x1+$x2)/2.0}]
    set rcy [expr {($y1+$y2)/2.0}]
    set dx [expr {$x - $rcx}]
    set dy [expr {$y - $rcy}]
    $mc move mcrect $dx $dy
    changeMCAxesCoords $mc
    set scrll [getMinimapScrollUnits $mc $dx $dy]
    foreach {hscr vscr} $scrll {break}
    $c xview scroll $hscr units
    $c yview scroll $vscr units
    updateCanvas $c 1.0
}
proc createRectangle {c mc} {
    if {![winfo exists $mc]} {return}
    set coords [getMCRectCoords $c $mc]
    $mc create rectangle $coords -tags mcrect -outline red -width 2
    foreach {a1 a2 a3 a4} [getMCAxesCoords $mc $coords] {break}
    $mc create line $a1 -tags mcaxe1 -fill red -width 2
    $mc create line $a2 -tags mcaxe2 -fill red -width 2
    $mc create line $a3 -tags mcaxe3 -fill red -width 2
    $mc create line $a4 -tags mcaxe4 -fill red -width 2
    group $mc mcaxes [list mcaxe1 mcaxe2 mcaxe3 mcaxe4]
}
proc getMCAxesCoords {mc coords} {
    global mmap
    if {![winfo exists $mc]} {return}
    foreach {x1 y1 x2 y2} $coords {break}
    set a1x1 [expr {$x1 + ($x2 - $x1)/2.}]
    set a1x2 $a1x1
    set a1y1 $y1
    set a1y2 [expr {-$mmap(curh)/2.0}]
    set a2x1 $x2
    set a2x2 $mmap(curw)
    set a2y1 [expr {$y1 + ($y2 - $y1)/2.}]
    set a2y2 $a2y1
    set a3x1 $a1x2
    set a3x2 $a3x1
    set a3y1 $y2
    set a3y2 $mmap(curh)
    set a4x1 $x1
    set a4x2 [expr {-$mmap(curw)/2.0}]
    set a4y1 $a2y1
    set a4y2 $a4y1
    set a1 [list $a1x1 $a1y1 $a1x2 $a1y2]
    set a2 [list $a2x1 $a2y1 $a2x2 $a2y2]
    set a3 [list $a3x1 $a3y1 $a3x2 $a3y2]
    set a4 [list $a4x1 $a4y1 $a4x2 $a4y2]
    return [list $a1 $a2 $a3 $a4]
}
proc getMCRectCoords {c mc} {
    global mmap layers canvas
    if {![winfo exists $mc]} {return}
    set cw [getCanvasSize $layers(zoomLevel)]
    if {$mmap(mode) eq "town"} {
        set cw [expr {$cw/($canvas(maxSize_px)/32000)}]
    }
    set ch $cw
    set mcw $mmap(curw)
    set mch $mmap(curh)
    set wratio [expr {double($mcw)/double($cw)}]
    set hratio [expr {double($mch)/double($ch)}]
    set cx1 [$c canvasx 0]
    set cy1 [$c canvasy 0]
    set cx2 [$c canvasx [winfo width $c]]
    set cy2 [$c canvasy [winfo height $c]]
    set mcx1 [expr {$cx1*$wratio}]
    set mcy1 [expr {$cy1*$hratio}]
    set mcx2 [expr {$cx2*$wratio}]
    set mcy2 [expr {$cy2*$hratio}]
    return [list $mcx1 $mcy1 $mcx2 $mcy2]
}
proc changeMCRectCoords {c} {
    global mmap
    if {!$mmap(shown) || ![info exists mmap(mc)]} {return}
    set mc $mmap(mc)
    if {![winfo exists $mc]} {return}
    $mc coords mcrect [getMCRectCoords $c $mc]
    changeMCAxesCoords $mc
    update idletasks
}
proc changeMCAxesCoords {mc} {
    if {![winfo exists $mc]} {return}
    set coords [$mc coords mcrect]
    foreach {c1 c2 c3 c4} [getMCAxesCoords $mc $coords] {break}
    $mc coords mcaxe1 $c1
    $mc coords mcaxe2 $c2
    $mc coords mcaxe3 $c3
    $mc coords mcaxe4 $c4
}
proc getFileName {} {
    return "$::plot(pname)_[clockFormat %d.%m.%Y_%H-%M-%S]"
}
proc dayFormat {{time ""}} {
    return [clockFormat %Y%m%d $time]
}
proc current_date {} {
    return [clockFormat %Y%m%d%H%M%S]
}
proc takeScreenshot {c} {
    set name  [getFileName]
    set types {
        {"JPEG files" .jpg JPEG}
        {"All files"  {.*} ""}
    }
    set fileName [tk_getSaveFile -filetypes $types -initialdir ~ \
        -parent $c -initialfile $name -defaultextension .jpg]
    update
    canvasToImage $c $fileName
}
proc plotChanged {} {
    global objects
    if {![array exists objects]} {return 0}
    set sid [array startsearch objects]
    while {[array anymore objects $sid]} {
        set elt [array nextelement objects $sid]
        set val $objects($elt)
        if {[string is integer $elt] && [lindex $val end]==1} {
            array donesearch objects $sid
            return 1
        }
    }
    array donesearch objects $sid
    return 0
}
proc getChangedObjects {} {
    global objects
    set res {}
    if {![array exists objects]} {return {}}
    set sid [array startsearch objects]
    while {[array anymore objects $sid]} {
        set elt [array nextelement objects $sid]
        set val $objects($elt)
        if {[string is integer $elt] && [lindex $val end]==1} {
            lappend res $elt
        }
    }
    array donesearch objects $sid
    set res [lsort -integer -decreasing $res]
    return $res
}
proc sendObjects {c} {
    global srvids objtype act act_str acfg conn delobjs objects delobjstr images
    #   :
    if {!$conn(auth)} {
        alertError "  . ,   ,      ."
        return
    }
    #     :
    set res [getChangedObjects]
    #    ,   ,    :
    set nall [llength [concat $res $delobjs]]
    if {$nall==0} {
        alert "     ."
        return
    }
    set newobjs {}
    set chobjs  {}
    set s $c.so
    if {[winfo exists $s]} {
        set x [winfo x $s]
        set y [winfo y $s]
    } else {
        set x [expr {[winfo width $c] / 2 - 100}]
        set y [expr {[winfo height $c] / 2 - 100}]
    }
    set hfont $::fonts(heads)
    set tfont $::fonts(txt)
    set tfontb $::fonts(txt)
    set tfontb $::fonts(txtb)
    set bfont $::fonts(buts)
    catch {destroy $s}
    catch {toplevel $s}
    wm title $s " ."
    #wm geometry $s +${x}+${y}
    if {[unixPlatform]} {wm iconbitmap $s @[file join . img botikmap.xbm]}
    catch {wm deiconify $s; raise $s;}
    #focus -force $s
    #setFocus $s
    frame $s.f1
    frame $s.f2
    frame $s.f3
    pack $s.f1
    pack $s.f2 -side top -expand 1 -fill both
    pack $s.f3 -side top -fill x
    label $s.f1.l -text "   " -font $hfont
    pack $s.f1.l
    frame $s.f2.t 
    pack $s.f2.t -fill both -expand 1
    #frame $s.f2.t.l
    frame $s.f2.t.ot
    #pack $s.f2.t.l -expand 1 -fill both -side top
    pack $s.f2.t.ot -expand 1 -fill both
    #label $s.f2.t.l.l1 -text "    " -relief ridge -bd 3 -font $::fonts(txt) -padx 70
    #label $s.f2.t.l.l2 -text "" -relief ridge -bd 3 -font $::fonts(txt) -padx 10
    #label $s.f2.t.l.l3 -text "" -relief ridge -bd 3 -font $::fonts(txt)
    #pack $s.f2.t.l.l1 $s.f2.t.l.l2 -side left
    #pack $s.f2.t.l.l3 -side left -expand 1 -fill x
    set f $s.f2.t.ot
    set width 140
    text $f.txt -yscrollcommand "$f.yscr set" -width $width -wrap word -cursor top_left_arrow
    if {[windowsPlatform]} {$f.txt configure -setgrid 1}
    scrollbar $f.yscr -orient vertical -command "$f.txt yview"
    #::autoscroll::autoscroll $f.yscr
    pack $f.yscr -side right -fill y
    pack $f.txt -expand yes -fill both
    #      :
    set act_str(new)     {"      " "     "}
    #  ,  :
    set act_str(changed) {"      " "  "}
    #  ,    :
    set act_str(deleted) {"      " "  "}
    #  :
    set tp_str(new)      " :"
    set tp_str(changed)  " :"
    set tp_str(deleted)  " :"
    #   :
    set acfg(new,0)      "SeaGreen3"
    set acfg(new,1)      "MistyRose3"
    set acfg(changed,0)  $acfg(new,0)
    set acfg(changed,1)  "RoyalBlue3"
    set acfg(deleted,0)  "MistyRose3"
    set acfg(deleted,1)  $acfg(changed,1)
    #   :
    set tfg(new)         "SeaGreen4"
    set tfg(changed)     "RoyalBlue4"
    set tfg(deleted)     "MistyRose4"
    set acfont           $tfont
    set tpfont           $tfontb
    set dnum             [llength $delobjs]
    set num              [llength $res]
    loop i 0 $num {
        set id           [lindex $res $i]
        set objtype($id) [expr {([info exists srvids($id)]) ? "changed" : "new"}]
        set act($id)     0
        lappend [expr {($objtype($id) eq "changed") ? "chobjs" : "newobjs"}] $id
        set actxt        [lindex $act_str($objtype($id)) $act($id)]
        label $f.txt.l$i -image spinimg -bd 1 -cursor top_left_arrow
        label $f.txt.al$i -text $actxt -fg $acfg($objtype($id),$act($id)) -font $::fonts(txtb) -bd 1 -background "white"
    }
    loop i 0 $dnum {
        set id           [lindex $delobjs $i]
        set objtype($id) "deleted"
        set act($id)     0
        set actxt        [lindex $act_str($objtype($id)) $act($id)]
        label $f.txt.l[expr $i+$num] -image spinimg -bd 1 -cursor top_left_arrow
        label $f.txt.al[expr $i+$num] -text $actxt -bd 1 -background "white" -fg $acfg($objtype($id),$act($id)) -font $::fonts(txtb)
    }
    set nnum [llength $newobjs]
    set cnum [llength $chobjs]
    array set fncd {new 0 changed 0 deleted 0}
    set i 0
    set style1   "-underline 1"
    set style2   "-underline 0"
    set skippars "-font {Courier 2} -background gray86"
    eval [subst "$f.txt tag configure SKIP $skippars"]
    $f.txt delete 1.0 end
    set all [concat $res $delobjs]
    set desclen 0
    foreach id $all {
    set txt ""
    foreach pos {1 2 4 5 6 7 8} {
        set t ""
        if {$objtype($id) eq "deleted"} {
            regsub {\*$} [getStr [lindex $delobjstr($id) $pos]] {} t
        } else {
            regsub {\*$} [getStr [lindex $objects($id) $pos]] {} t
        }
        switch -- $pos {
            1 {if {![lempty $t]} {set txt "(: $t)"}}
            2 {if {![lempty $t]} {set txt "$txt (: $t)"}}
            4 {if {![lempty $t]} {set txt "$txt (: $t)"}}
            5 {if {![lempty $t]} {set txt "$txt (: $t)"}}
            6 {if {![lempty $t]} {set txt "$txt (: $t)"}}
            7 {if {![lempty $t]} {set txt "$txt (: $t)"}}
            8 {if {![lempty $t]} {set txt "$txt (: $t)"}}
            default {}
        }
    }
    $f.txt tag configure ttag$i -font $tpfont -background gray86 -foreground $tfg($objtype($id))
    $f.txt tag configure r$i -background "white" -font $acfont
    set tp $tp_str($objtype($id))
    set desc "  [expr $i+1]. $txt\n"
    if {!$fncd($objtype($id))} {
        $f.txt insert end "$tp\n" ttag$i
        set fncd($objtype($id)) 1
    } else {
        $f.txt insert end "\n" SKIP
    }
    # -:
    $f.txt window create end -window $f.txt.l$i -padx 10
    # :
    $f.txt window create end -window $f.txt.al$i -padx 2
    # :
    $f.txt insert end " - "
    #  :
    $f.txt insert end $desc r$i
    bind $f.txt.l$i <Any-Enter> "$f.txt.l$i configure -relief ridge -bd 2"
    bind $f.txt.l$i <Any-Leave> "$f.txt.l$i configure -relief flat -bd 1"
    bind $f.txt.l$i <ButtonRelease-1> "changeAct $id $f.txt.al$i"
    $f.txt tag bind r$i <Any-Enter> "$f.txt tag configure r$i $style1; $f.txt configure -cursor hand2"
    $f.txt tag bind r$i <Any-Leave> "$f.txt tag configure r$i $style2; $f.txt configure -cursor top_left_arrow"
    if {$objtype($id) eq "deleted"} {
        $f.txt tag bind r$i <ButtonRelease-1> "alert {   }"
    } else {
        $f.txt tag bind r$i <ButtonRelease-1> "findObject $c $id $s"
    }
    incr i
    }
    set h 24
    $f.txt configure -height $h -state disabled
    set buttons [list $s.f3.rev $s.f3.exe $s.f3.cancel]
    button $s.f3.rev -text "" -command "reverse {$newobjs} {$chobjs} {$delobjs} $f.txt.al" \
        -activebackground [activeClr] -highlightbackground [activeClr] \
        -font $bfont
    button $s.f3.exe -text "" -command "send_apply $c {$buttons} {$res} {$delobjs}; destroy $s" \
        -activebackground [activeClr] -highlightbackground [activeClr] \
        -font $bfont -default active
    button $s.f3.cancel -text "" -command "destroy $s" \
        -activebackground [activeClr] -highlightbackground [activeClr] \
        -font $bfont
    pack $s.f3.rev $s.f3.exe $s.f3.cancel -side left -padx 10 -pady 5 -fill both -expand 1
    bind $s <KeyPress-Return> "$s.f3.exe invoke"
    bind $s <KeyPress-Escape> "$s.f3.cancel invoke"
    focus -force $f.txt
    update idletasks
    set sh [winfo screenheight .]
    set wh [winfo height $s]
    if {$wh > $sh} {
        $f.txt configure -height [expr {$h / 2}]
    }
}
proc changeAct {id lbl} {
    global objtype act act_str acfg
    set newact [expr {($act($id)) ? 0 : 1}]
    set txt [lindex $act_str($objtype($id)) $newact]
    $lbl configure -text $txt -fg $acfg($objtype($id),$newact)
    set act($id) $newact
}
proc reverse {new ch del al} {
    set nnum [llength $new]
    set cnum [llength $ch]
    set dnum [llength $del]
    loop i 0 $nnum {
        set id [lindex $new $i]
        changeAct $id $al$i
    }
    loop j 0 $cnum {
        set id [lindex $ch $j]
        changeAct $id $al[expr $j+$i]
    }
    incr j $nnum
    loop k 0 $dnum {
        set id [lindex $del $k]
        changeAct $id $al[expr $k+$j]
    }
}
# remove parenthesis
proc rmbraces {str} {
    return [string map {\{ "" \} ""} $str]
}
proc disableButtons {buts} {
    foreach but $buts {
        catch {$but configure -state disabled}
    }
}
proc enableButtons {buts} {
    foreach but $buts {
        catch {$but configure -state normal}
    }
}
# Sends changes to server,
# changes we can believe in. (C)
proc send_apply {c buts res del} {
    global objtype act objects grid srvids binds delobjs delobjstr plot
    if {[catch {
    disableButtons $buts
    set all  [concat $res $del]
    set anum [llength $all]
    set todelbm   {}; #   .
    set todel     {}; #   .
    set tosave    {}; #   .
    set torecover {}; #   .
    set resobjs   {}
    loop i 0 $anum {
        set id [lindex $all $i]
        if {$act($id)} {
            if {$objtype($id) eq "new"} {
                lappend todelbm $id
            } else {
                if {![lempty $srvids($id)]} {
                    if {$id > 0} {
                        lappend torecover $id
                    } else {
                        lappend torecover $srvids($id)
                    }
                }
            }
        } else {
            if {$objtype($id) eq "deleted"} {
                lappend todel $id
            } else {
                lappend tosave $id
            }
        }
    }
    set torecover [join $torecover "|"]
    set todel     [join $todel "|"]
    foreach obj $todelbm {
        set elt [getTagBySrvID $obj]
        del $c $elt 1 0 0
    }
    foreach obj $tosave {
        set objstr "[lrange $objects($obj) 0 end-1] {[lsort $grid($obj)]}"
        if {[info exists srvids($obj)] && ![lempty $srvids($obj)]} {
            set ::changed($obj) 1
            set objstr [lreplace $objstr 0 0 $srvids($obj)]
        }
        set objstr "[convToNew $objstr]"
        if {[isNetObj $obj] && [getClassByTag [getTagBySrvID $obj]] eq "dot" && ![info exists binds($obj)]} {
            set binds($obj) {}
        }
        if {[info exists binds($obj)]} {
            set newbinds {}
            foreach oid $binds($obj) {
                if {$oid < 0 && [info exists srvids($oid)]} {
                    lappend newbinds $srvids($oid)
                }
            }
            set newbinds [lsort -unique [rmbraces $newbinds]]
            set oldbinds [lsort -unique [rmbraces [lindex $objstr end]]]
            if {![lempty $newbinds] && $oldbinds ne $newbinds} {
                set objstr "$objstr {$newbinds}"
            }
            #unset newbinds
        }
        set objstr [string trim $objstr]
        lappend resobjs [mkpar $objstr]
    }
    set resobjs [join $resobjs "|"]
    progress "  ..."
    set was_saved 0
    #   (   ):
    foreach elt [split $torecover "|"] {
        setChangeStateByID $srvids($elt) 0
    }
    if {![lempty [concat $resobjs $torecover $todel]]} {
        set plot(sendobjects) 1
        set was_saved [sendit $c object "$resobjs" reload "$torecover" delobj "$todel"]
        set plot(sendobjects) 0
    }
    if {$was_saved} {
        foreach elt $tosave {
            setChangeStateByID $elt 0
        }
        updateCache "current"
    }
    #  :
    set delobjs ""
    array unset delobjstr
    array unset act
    array unset objtype
    progress " ."
    }]} {
        asksendmail "     .\n$::errorInfo"
        progress ""
    }
    enableButtons $buts
}
proc setFocus {w} {
    grab $w
}
proc unsetFocus {w} {
    grab release $w
}
proc setChangeStateByID {id state} {
    global objects changed
    catch {set objects($id) [lreplace $objects($id) end end $state]}
    set changed($id) $state
}
proc Exit {c} {
    if {[info exists ::reportNotSent]} {
        set msg [tk_messageBox -icon question -type yesno \
            -title  -parent $c -default no \
            -message "      .\n   ?"]
        if {$msg eq "no"} {
            return
        }
    }
    set objs [getChangedObjects]
    if {[info exists ::delobjs]} {
        set objs [concat $objs $::delobjs]
    }
    catch {db close}
    catch {thread::send $::dbthread "thdb close"}
    catch {thread::release $::dbthread}
    if {[info exists ::dbgfd]} {catch {close $::dbgfd}}
    if {[profilerOn] && $profiler::started} {profiler::end}
    if {[llength $objs]==0} {
        saveConfig $c
        exit
    }
    set msg [tk_messageBox -icon question -type yesnocancel \
        -title "" -parent $c -default yes \
        -message "      ?"]
    if {$msg eq "yes"} {
        sendObjects $c
        saveConfig $c
    } elseif {$msg eq "no"} {
        saveConfig $c
        exit
    } elseif {$msg eq "cancel"} {
        return
    }
}
proc setBalloon {w elt helptext {showanyway 0}} {
    if {$helptext eq "" || (!$::configVars(showObjectHints) && !$showanyway)} {
        $w bind $elt <Enter>  ""
        $w bind $elt <Motion> ""
        $w bind $elt <Leave>  ""
        return
    }
    setBalloonHelp $w $elt "$helptext" -tag $elt
    set bw .balloonHelp$elt
    if {[winfo exists $bw]} {
        if {[info exists ::balloon_elem] && $elt eq $::balloon_elem} {
            # change balloon text in realtime
            showBalloonHelp $w $elt $elt $helptext
        }
    }
}
proc setWindowTitle {str} {
    global plot
    if {[string length $str]==0} {
        set str "( )"
    }
    wm title . "$plot(ver) $str"
}
#  
proc loadPackages {plist} {
    # packages - . ,    -   ,   -  .
    set notsat {}
    foreach {pac ver} $plist {
        #    ,      
        if {![catch {package present $pac}]} {continue}
        if {[catch {package require $pac} eid]} {
            alertError ":     \"$pac\".\n$eid\n\   ."
            exit
        } elseif {$pac eq "tls"} {
            http::register https 443 ::tls::socket
        } elseif {$pac eq "style"} {
            style::use as
        }
        if {![llength $notsat]} {continue}
        #   ,    .
        #    ,     .
        set versions [package versions $pac]
        set sat 0
        foreach v $versions {
            if {[package vsatisfies $v $ver]} {set sat 1}
        }
        if {!$sat} {lappend notsat $pac $ver}
    }
    if {[llength $notsat]} {
        if {[llength $notsat]==2} {
            alert "!   [lindex $notsat 0]\n   ([lindex $notsat 1]).\n   ."
            return
        }
        set packs {}
        set verss {}
        foreach {pac ver} $notsat {
            lappend packs $pac
            lappend verss $ver
        }
        alert "!   $packs\n   ($verss).\n   ."
        return
    }
}
#      ,
#       
#     .
proc stackTraceOn {} {
    trace add variable ::errorInfo write {
        set level [info level]
        if {[info exists ::_processed($level)]} {return}
        set ::_processed($level) 1
        catch {
            append ::stackTrace [lindex [info level $level] 0]:\n
            set locals [lsort [info locals]]
            foreach varName $locals {
                if {[array exists $varName]} {
                    append ::stackTrace \t$varName\[\]=[array get $varName]\n
                } else {
                    append ::stackTrace \t$varName=[set $varName]\n
                }
            }
        }
    }
}
proc stackTraceOff {} {
    trace remove variable ::errorInfo write {
        set level [info level]
        if {[info exists ::_processed($level)]} {return}
        set ::_processed($level) 1
        catch {
            append ::stackTrace [lindex [info level $level] 0]:\n
            set locals [lsort [info locals]]
            foreach varName $locals {
                if {[array exists $varName]} {
                    append ::stackTrace \t$varName\[\]=[array get $varName]\n
                } else {
                    append ::stackTrace \t$varName=[set $varName]\n
                }
            }
        }
    }
}
#     
proc cutLine {w} {
    global objects nodes
    set nodes(lastNode) [getTag $w current]
    set spl [split $nodes(lastNode) "+"]
    set tag0 [lindex $spl 0]
    set tag0 [getComplexTag $w $tag0]
    set class [getClass $w $tag0]
    if {$class ne "line"} {
        alert " \" \"        ().\n,  , , ."
        return
    }
    set gap 15
    regexp {(\d+)$} $nodes(lastNode) n
    removeSelection $w
    set coords [$w coords $tag0]
    set nc [expr [llength $coords]/2]
    if {$n == 0} {
        alert "   ."
        return     
    }
    if {$n == $nc - 1} {
        alert "   ."
        return
    }
    set coords1 [lrange $coords 0 [expr 2*$n+1]]
    set x [lindex $coords1 end-1]
    set y [expr [lindex $coords1 end] + $gap]
    set coords2 [concat $x $y [lrange $coords [expr 2*$n+2] end]]
    if {[llength $coords2] == 2} {return}
    set objnum [lindex [split $tag0 "_"] 1]
    set la [getLayer $tag0]
    set tag $class${la}_${objnum}_[getID]
    $w coords $tag0 $coords1
    setParams $w $tag0
    getAllParams $w $la $objnum
    $w create $class $coords2 -tags $tag
    put $w $tag
    set id   [takeID $tag]
    set type [getParam $tag0 4]
    set name [getParam $tag0 6]
    set addr [getParam $tag0 7]
    set comm [getParam $tag0 8]
    set objects($id) [lreplace $objects($id) 4 4 $type]
    set objects($id) [lreplace $objects($id) 6 6 $name]
    set objects($id) [lreplace $objects($id) 7 7 $addr]
    set objects($id) [lreplace $objects($id) 8 8 $comm]
    applyParams $w "$tag 1" $objnum {}
    setSelect $w $tag 1
    setChangeState $w $tag0 1
    setChangeState $w $tag  1
}
proc initCutline {w} {
    unbindAll $w
    $w configure -cursor target
    bind $w <ButtonPress-1> "cutLine $w"
}
#     
proc checkNetObjs {c} {
    global objects srvids binds
    set all [array names objects]
    set res {}
    foreach id $all {
        if {[info exists srvids($id)] && [isBoxObj $id] && [getClass $c [getTagBySrvID $id]] eq "dot"} {
            if {![info exists binds($id)] || [lempty $binds($id)]} {
                lappend res $id
            }
        }
    }
    if {[lempty $res]} {
        alert "  ."
        return
    }
    printSrchResults $c $res
}
proc checkNetObjs2 {c} {
    if {![array exists ::binds] && ![array exists ::localID]} {
        alert "  ."
        return
    }
    #     
    #   ,        
    set all   [array names ::binds]
    set res   {}
    set boxes {}
    set chboxes {}
    getSensorIDs
    foreach id $all {
        if {[lempty $::binds($id)]} {
            set val [lindex $::objects($id) 6]
            if {[info exists ::sensor_list] && [string match "box-*" $val] && [lcontain $::sensor_list $id]} {
                lappend res $id
            }
        } else {
            lappend boxes $id
        }
    }
    #     ,
    #   ,     
    if {[array exists ::localID]} {
        set allids [array names ::localID]
        foreach id $allids {
            set id $::localID($id)
            set oname [lindex $::objects($id) 2]
            if {$oname ne ""} {continue}
            if {![info exists ::chbinds($id)] || [lempty $::chbinds($id)]} {
                lappend res $id
            } else {
                lappend chboxes [lindex $::chbinds($id) 0] [lindex $::chbinds($id) 1]
            }
        }
    }
    set chboxes [lsort -unique $chboxes]
    #     
    #   ,    
    set nochboxes [diff $boxes $chboxes]
    set res [concat $res $nochboxes]
    if {[lempty $res]} {
        alert "  ."
        return
    }
#    set res [lsort -unique $res]
    printSrchResults $c $res
}
proc initGraph {c} {
#    loadModule graph.tcl
    if {!$::plot(usegraph)} {return}
    loadPackages {struct::graph 2.0.1}
    struct::graph network
}
#   ,   
proc showBoundChannels {c} {
    set chans {}
    if {[array exists ::localID]} {
        set allids [array names ::localID]
        foreach id $allids {
            set id $::localID($id)
            set oname [lindex $::objects($id) 2]
            if {$oname ne ""} {continue}
            if {[info exists ::chbinds($id)] && ![lempty $::chbinds($id)]} {
                lappend chans $id
            }
        }
    }
    if {[lempty $chans]} {
        alert "  ."
        return
    }
    printSrchResults $c $chans
}
proc g_setNodeState {id newstate} {
    if {!$::plot(usegraph) || ![network node exists $id]} {return}
    if {[lempty $newstate]} {set newstate 0}
    network node set $id state $newstate
}
proc g_addNode {id {replace 0}} {
    if {!$::plot(usegraph) || ![info exists ::objects($id)]} {
        return
    }
    if {![info exists ::binds($id)]} {
        set ::binds($id) {}
    }
    if {[info exists ::changed($id)] && $::changed($id) && !$replace} {
        return
    }
    if {[network node exists $id]} {
        #network node delete $id
        return
    }
    set type  [getStr [lindex $::objects($id) 4]]
       set type  [string trimright $type "*"]
    set state 1
    network node insert $id
#    network node set $id type  $type
#    network node set $id state $state
    network node set $id binds $::binds($id)
}
proc g_addArc {id {replace 0}} {
    if {!$::plot(usegraph) || ![info exists ::objects($id)]} {return}
    if {![info exists ::chbinds($id)]} {
        return
    }
    if {[info exists ::changed($id)] && $::changed($id) && !$replace} {
        return
    }
    set nid1 [lindex $::chbinds($id) 0]
    set nid2 [lindex $::chbinds($id) 1]
    if {![network node exists $nid1] || ![network node exists $nid2]} {return}
    if {[network arc exists $id]} {
        return
        #network arc delete $id
    }
    set type  [getStr [lindex $::objects($id) 4]]
       set type  [string trimright $type "*"]
    set state 1
    network arc insert $nid1 $nid2 $id
    lappend ::arcs_added $id
    #network arc set $id type  $type
    #network arc set $id state $state
}
proc g_addAllArcs {} {
    if {!$::plot(usegraph)} {return}
    foreach {chan oid} $::channels {
        g_addArc $chan
    }
    set ::channels {}
    set arcs [network arcs]
}
#          
proc g_modArcBinds {id} {
    if {!$::plot(usegraph)} {return}
    if {![info exists ::chbinds($id)]} {
        catch {
            network arc delete $id
        }
    } else {
        g_addArc $id 1
    }
}
#  /    
proc g_modNodeBinds {id} {
    if {!$::plot(usegraph) || ![info exists ::binds($id)]} {return}
    #network arc set $id binds $::binds($id)
}
proc g_delObject {id} {
    if {!$::plot(usegraph)} {return}
    if {[network arc exists $id]} {
        network arc delete $id
    } elseif {[network node exists $id]} {
        network node delete $id
    }
    return
}
#     ,    
proc bf_walk {nodes} {
    set alladj {}
    if {[lempty $nodes]} {
        #   
        return
    }
    foreach node $nodes {
        set adj [network arcs -adj $node]
        foreach arc $adj {
            if {[info exists ::gray($arc)]} {continue}
            set anode [network node opposite $node $arc]
            network arc delete $arc
            network arc insert $node $anode $arc
            set ::gray($arc) 1
            if {![lcontain $alladj $anode]} {
                lappend alladj $anode
            }
        }
    }
    bf_walk $alladj
}
proc g_drawGraph {c} {
    if {!$::plot(usegraph)} {return}
    set nodes [network nodes]
    set arcs  [network arcs]
    set center $::localID(45324); # pole-router
    bf_walk $center

    set shapes(*)       shape=box,style=filled,color=blue
    set shapes()       shape=triangle,style=filled,color=green
    set shapes()     shape=diamond,style=filled,color=red
    set shapes() shape=circle,style=filled,color=grey
    set shapes()    shape=Mdiamond
    set shapes()     shape=invtriangle
    set shapes()     shape=box3d,style=filled,color=black
    set shapes()     shape=diamond,style=filled,color=red
    set shapes()     shape=tripleoctagon,style=filled,color=sienna

    set labels(*)       H
    set labels()       S
    set labels()     ""
    set labels() O
    set labels()    A
    set labels()     E
    set labels()     P
    set labels() !
    set labels()     A

    set style(FOMM-100*) color=blue,style=bold
    set style(FOMM-10)   color=blue
    set style(FOSM-1000) color=blue,style=bold,weight=5
    set style(FOSM-100)  color=blue,style=bold
    set style(SFTP-100)  color=red,style=bold
    set style(SFTP)      color=red
    set style(PK75)      color=grey
    set style(Radio11)   color=green
    set style(Radio5)    color=green
    set style(Radio2)    color=green
    set style()    color=khaki
    set style()    color=black

    set fname network.dot
    set f [open $fname w]
    puts $f "digraph B \{\n\tgraph \[splines=true,overlap=false\];"; #edge \[dir=none\];

    foreach node $nodes {
        if {[network node degree $node]==0} {continue}
        set type [getStr [lindex $::objects($node) 4]]
        set name [getStr [lindex $::objects($node) 6]]
        set addr [getStr [lindex $::objects($node) 7]]
        set comm [getStr [lindex $::objects($node) 8]]
        set pars ""
        set info ""
        if {![lempty $name]} {
            append info ": $name "
        }
        if {![lempty $addr]} {
            append info ": $addr "
        }
        if {![lempty $comm]} {
            #append info ": $comm"
        }
        if {![info exists shapes($type)]} {
            set type ""
        }
        if {$type eq ""} {
            set label \"$name\"
            set pars fontsize=20,
        } else {
            set label $labels($type)
        }
        #set info [string map {\\n " " ? ""  \#} $info]
        if {![lempty $info]} {
            append pars tooltip=\"$info\"
        }
        set pars $shapes($type),label=$label,charset="windows-1251",$pars
        puts $f "\t$node \[$pars\];"
    }
    foreach arc $arcs {
        set type [getStr [lindex $::objects($arc) 4]]
        if {![info exists style($type)]} {
            set type ""
        }
        set pars $style($type)
        set node1 [network arc source $arc]
        set node2 [network arc target $arc]
        puts $f "\t$node1 -> $node2 \[$pars\];"

    }
    puts $f "\}"
    close $f
    
    set out [file rootname $fname].svg
    set new [file rootname $fname]2.svg
    exec "E:\\Program Files\\Graphviz2.16\\bin\\dot.exe" $fname -Tsvg -o $out
    
    set f [open $out r]
    set r [open $new w]

    gets $f line
    puts $r "<?xml version=\"1.0\" encoding=\"windows-1251\" standalone=\"no\"?>"
    loop i 0 7 {
        gets $f line
        puts $r $line
    }
    gets $f line
    set w [string trim [lindex [split [lindex $line 1] "="] 1] {\" "pt"}]
    set h [string trim [lindex [split [lindex $line 2] "="] 1] {\" "pt"}]
    set neww [expr $w/2]
    set newh [expr $h/2]
    puts $r "<svg width=\"${neww}pt\" height=\"${newh}pt\""
    while {![eof $f]} {
        gets $f line
        puts $r $line
    }
    
    #exec $::env(comspec) /c start network.dot.svg
    close $f
    close $r
    file delete -force $out
    file rename -force $new $out
    return
}
proc findExecutable {progname varname} {
    upvar 1 $varname result
    set progs [auto_execok $progname]
    if {[llength $progs]} {
        set result [lindex $progs 0]
    }
    return [llength $progs]
}
proc findBrowser {} {
    if {[info exists ::env(BROWSER)]} {
        return $::env(BROWSER)
    }
    # a lot of GUI browsers exist for Linux/UNIX
    set browsers {firefox mozilla-firefox epiphany epiphany-browser seamonkey iceweasel \
                icecat iceape chimera2 galeon mozilla konqueror hotjava \
                netscape opera dillo netsurf flock-browser conkeror \
                kazehakase midori strata skipstone swiftfox amaya google-chrome \
                x-www-browser safari xdg-open}
    set tmp {}
    foreach bro $browsers {
        if {[findExecutable $bro tmp]} {
            set ::env(BROWSER) $tmp
            return $tmp
        }
    }
    return
}
proc showURL {url} {
    if {[macPlatform]} {
        exec open $url; # this just opens default Web browser on Mac OS
    } elseif {[unixPlatform]} {
        findBrowser
        if {[info exists ::env(BROWSER)] && [catch {exec $::env(BROWSER) $url} err]} {
            alertError "   URL (by $::env(BROWSER)):\n$url\n$err"
        }
    } elseif {[windowsPlatform]} {
        catch {
            if {[string match *.htm $url]} {
                set url [regsub -nocase {\.htm} $url {\.ht%6D}]
            }
            exec rundll32 url.dll,FileProtocolHandler $url
        }
    }
}
proc versionHandler {token} {
    set data {}
    catch {
        upvar #0 $token state
        set data [split $state(body) "\n"]
    }
    set btver 0
    set newver 0
    foreach line $data {
        set spl [split $line ":"]
        set app [lindex $spl 1]
        set ver [lindex $spl 2]
        if {$app eq "BotikTools"} {set btver $ver}
        if {$app eq $::plot(pname)} {set newver $ver}
    }
    if {$::plot(version) < $newver} {
        add2Version "-" ::plot(ver)
        set answer [selfUpdate $::plot(pname) $::plot(version) $newver $btver]
        if {$answer eq "yes"} {showURL $::dlurl}
    }
    # else add2Version "*" ::plot(ver)
    return [string length $state(body)]
}
proc checkVersion {} {
    catch {http::geturl $::versionurl -command versionHandler -timeout $::conn(timeout)}
}
proc readData {chan} {
    if {[eof $chan]} {
         catch {close $chan}
         return
    }
    set nbytes 0
    if {[catch {set nbytes [gets $chan data]} code]} {
         catch {close $chan}
         return
    }
    if {$nbytes <= 0} {return}
    protoHandler [getStr $data]
}
proc urldecode {str} {
    # rewrite "+" back to space
    # protect \ from quoting another '\'
    set str [string map [list + { } "\\" "\\\\"] $str]
    # prepare to process all %-escapes
    regsub -all -- {%([A-Fa-f0-9][A-Fa-f0-9])} $str {\\u00\1} str
    # process \u unicode mapped chars
    return [encoding convertfrom utf-8 [subst -novariables -nocommands $str]]
}
proc protoHandler {req} {
    set scheme $::plot(scheme)
    set req [string trim [string tolower $req]]
    if {![string match "$scheme*" $req]} {return}
    set part [string range $req [string length $scheme] end]
    set part [string trim $part /\\]
    set eqpos [string first "=" $part]
    if {$eqpos <= 0} {return}
    set param [string range $part 0 [expr {$eqpos - 1}]]
    if {![lcontain {id box name point address search} $param]} {return}
    set value [urldecode [string range $part [expr {$eqpos + 1}] end]]
    set value [string trim [string tolower $value]]
    switch -- $param {
        id - box - name - address - search {
            searchAndDisplay $value $param
        }
        point {
            foreach {x y} [split $value ,] {break}
            if {![info exists x]} {return}
            foreach {X Y} [countCoords2 [list $x $y] 7 $::layers(zoomLevel)] {break}
            if {![info exists X]} {return}
            set w $::plot(c)
            wm deiconify .; update
            moveCenter $w $X $Y 1.0
            showPointer $w $X $Y
        }
        default {}
    }
    # botikmap://box=box-per1p2.botik.ru
    # botikmap://point=x,y
    # botikmap://id=10924
    # botikmap://address=some addr (maybe Cyrillic, with spaces)
    # botikmap://search=name or addr or comment
}
proc searchAndDisplay {value mode} {
    if {$mode eq "box"} {set value [string map {"," { } ";" { }} $value]}
    set res [searchObjects $value $mode]
    if {[llength $res]==1} {
        wm deiconify .; update
        findObject $::plot(c) $res ""; # if one object found
        return
    }
    if {[llength $res] > 1} {
        wm deiconify .; update
        printSrchResults $::plot(c) $res; # if many objects found
        return
    }
    set word ""
    if {[lcontain {box name} $mode]} {set word "  "}
    if {$mode eq "id"}      {set word "  "}
    if {$mode eq "address"} {set word "  "}
    if {$mode eq "search"}  {set word "  "}
    alert "$word \"$value\"    ."
}
proc searchObjects {query mode} {
    global objects srvids
    if {![array exists objects]} {return}
    set sid [array startsearch objects]
    set res {}
    while {[array anymore objects $sid]} {
        set elt [array nextelement objects $sid]
        set val $objects($elt)
        set name [string tolower [getStr [lindex $val 6]]]
        set addr [string tolower [getStr [lindex $val 7]]]
        set comm [string tolower [getStr [lindex $val 8]]]
        switch -- $mode {
            id {
                if {[string is integer -strict $query] && [info exists srvids($query)] && $elt eq $srvids($query)} {
                    lappend res $elt
                }
            }
            box - name {
                if {![string length $name]} {continue}
                if {[lsearch -ascii -exact $query $name] > -1 || $query eq $name} {
                    lappend res $elt
                }
            }
            address {
                if {![string length $addr]} {continue}
                if {[regexp -nocase $query $addr]} {lappend res $elt}
            }
            search {
                if {[string length $name] && [regexp -nocase $query $name]} {
                    lappend res $elt
                }
                if {[string length $addr] && [regexp -nocase $query $addr]} {
                    lappend res $elt
                }
                if {[string length $comm] && [regexp -nocase $query $comm]} {
                    lappend res $elt
                }
            }
            default {}
        }
    }
    array donesearch objects $sid
    return [lsort -unique $res]
}
proc acceptConn {chan clientaddr clientport} {
    if {[catch {
        fconfigure $chan -buffering line -blocking 0
        fileevent $chan readable [list readData $chan]
    } code]} {
        catch {close $chan}
    }
}
proc startServer {} {
    catch {socket -server acceptConn -myaddr 127.0.0.1 8556}
}
proc initGUI {} {
    global plot layers fonts
    wm title    . $plot(ver)
    if {[unixPlatform]} {wm geometry . 800x600}
    wm state    . normal
    wm protocol . WM_DELETE_WINDOW {Exit .plot.c}
    if {[windowsPlatform]} {wm state . zoomed}
    if {[windowsPlatform]} {wm iconbitmap . -default [file join . img botikmap.ico]}
    if {[unixPlatform]} {wm iconbitmap . @[file join . img botikmap.xbm]}
    set w .plot
    frame $w
    pack $w -side left -fill both -expand yes
    frame $w.top
    pack $w.top -side top -fill x
    frame $w.left
    pack $w.left -side left -fill y
    frame $w.left.toolbar
    set layers(toolbar) $w.left.styleToolbar
    frame $w.left.styleToolbar
    set layers(tb) $w.left.toolbar
    pack $w.left.toolbar $w.left.styleToolbar -ipady 5 -side top
    set fonts(txt) {Times 11}; # text font
    frame $w.top.statusBar2
    label $w.top.statusBar2.statusObjInfo -textvar status(objInfo) -anchor w -font $fonts(txt)
    pack $w.top.statusBar2.statusObjInfo  -side left -fill x
    pack $w.top.statusBar2 -side bottom -fill x
    frame $w.top.statusBar
    label $w.top.statusBar.statusCoords -textvar status(coords) -anchor w -font $fonts(txt)
    label $w.top.statusBar.statusZoomLevel -textvar status(zoomLevel) -anchor w -font $fonts(txt)
    label $w.top.statusBar.statusHint -textvar status(hint) -anchor w -font $fonts(txt)
    label $w.top.statusBar.statusProgr -textvar progress -anchor w -font $fonts(txt)
    pack $w.top.statusBar.statusCoords $w.top.statusBar.statusZoomLevel \
        $w.top.statusBar.statusHint $w.top.statusBar.statusProgr \
        -side left -padx 2 -fill both
    pack $w.top.statusBar -side bottom -fill x -pady 3 
    set c $w.c
    set plot(c) $c
    set plot(w) $w
    frame $w.grid
    canvas $c -relief raised -background white \
        -borderwidth 1 -xscrollincrement 1 -yscrollincrement 1
    pack $c -side left -expand yes -fill both
    pack $w.grid -expand yes -fill both -padx 1 -pady 1
    grid rowconfig    $w.grid 0 -weight 1 -minsize 0
    grid columnconfig $w.grid 0 -weight 1 -minsize 0
    grid $c -padx 1 -in $w.grid -pady 1 \
        -row 0 -column 0 -rowspan 1 -columnspan 1 -sticky news
    update
    initVars $c $w
    initBinds $c
    initGridBoxes
    readConfig $c
    initMainRects $c
    loadAllImages
    initScrolls $c $w
    #  :
    setImgButtons $c $w.top 3 3 left 24 24 0 0 normal [subst { 
        imgopen  "" {fileDialog $c open}
        saveas   "" {fileDialog $c save}
        help     "" {callHelp}
        layerman "" {layerManager $c}
        srch     "" {search $c}
    }]
    #       :
    setImgButtons $c $w.left.toolbar 1 1 top 31 31 1 0 normal [subst {
        select     "" {leftTB select  $c}
        pantool    "" {leftTB pantool $c}
        zoom       "" {leftTB zoom    $c}
        addremnode "" {leftTB addremnode $c}
        chSmooth   "" {leftTB chSmooth $c}
        cutline    " " {leftTB cutline $c}
    }]
    # center     "" {leftTB center  $c}
    #  :
    #setButton $c $w.top dot       "" "chooseCenter $w $c"  normal left {} gotopoint
    #setButton $c $w.top bind      "" "bindDotObjs $c"      normal left {} binddot
    setButton $c $w.top auth      "" "auth $c"             normal left {} authb
    setButton $c $w.top saveimg   "" "takeScreenshot $c"   normal left {} saveimg
    setButton $c $w.top send      "" "sendObjects $c"      normal left {} send
    #setButton $c $w.top mod       "" "moderateObjs $c"     normal left {} mod
    #setButton $c $w.top imgupdate "" "updateCanvas $c 1.0" normal left {} imgupdate
    setButton $c $w.top tbminimap "" "toggleMinimap $c $w" normal left mmap(var) tbminimap
    setSensButton $c
    setButton $c $w.top sub       "" "toggleSublayer $c"   normal left {} showsub
    initZoomMenu $w.top $c
    initLayerMenu $w.top $c
    if {[profilerOn]} {profiler::begin}
    startServer
    readCache
    initMapsMenu $w.top $c
    configMinimap $c $w
    parseCommandLine
    auth $c
    checkVersion
}
proc profilerOn {} {
    return [lcontain [info procs] "debugprof"]
}
proc progress {str} {
    set ::progress $str
    update idletasks
}
proc readCache {} {
    global plot
    update
    if {[file exists $plot(cache_file)] && [file size $plot(cache_file)] > 0} {
        readFromFile $plot(c) $plot(cache_file) 1
    }
    if {![file exists $plot(cachetime_file)] || [file size $plot(cachetime_file)] == 0} {
        catch {
        set f [open $plot(cachetime_file) w]
        puts $f $plot(ts)
        close $f
        }
    }
    catch {
    set f [open $plot(cachetime_file) r]
    gets $f line
    close $f
    if {[string length $line]==14} {
        set plot(ts) [string trim $line]
    }
    set date [ftimeN $plot(ts)]
    if {[llength $date]} {
        progress "   $date"
    }
    setWindowTitle ""
    }
}
proc parseCommandLine {} {
    global argc argv
    if {$argc == 0} {return}
    set req [getStr [lindex $argv 0]]
    protoHandler $req
}
proc testCacheAuthdata {} {
    global plot conn
    catch {
    set f [open $plot(cachetime_file) r]
    gets $f ntime
    gets $f org
    gets $f login
    close $f
    set org [string trim $org]
    set login [string trim $login]
    if {[llength $org] && [llength $login] &&
        ($org ne $conn(org) || $login ne $conn(login))} {
        set plot(ts) [string repeat "0" 14]
    }}
}
proc updateCache {{time "ts"}} {
    global plot conn
    catch {
    if {$time eq "ts"} {
        set tm $plot(ts)
    } else {
        set tm [clockFormat %Y%m%d%H%M%S]
    }
    set f [open $plot(cache_file) w]
    savePlotToFile $plot(c) $f 1
    close $f
    set f [open $plot(cachetime_file) w]
    puts $f $tm
    if {$conn(auth)==1} {
        puts $f $conn(org)
        puts $f $conn(login)
    }
    close $f
    }
}

loadPackages {Tcl 8.4 Tk 8.4 Tclx 8.4 base64 2.3 http 2.4 tls 1.4 mime 1.4 smtp 1.3.5}
http::register https 443 ::tls::socket
loadModule report.tcl
loadModule net.tcl
if {[windowsPlatform]} {
    loadPackages {Tktable 2.8 autoscroll 1.0 tile 0.7.3 informer 1.0 sqlite3 3}
    namespace import -force ttk::*
    if {[bm_exe]} {
        set ::widget(label) label
        set ::widget(radiobutton) radiobutton
    } else {
        set ::widget(label) tk::label
        set ::widget(radiobutton) tk::radiobutton
    }
} else {
    set ::widget(label) label
    set ::widget(radiobutton) radiobutton
}
if {[unixPlatform]} {catch {source bgerror.tcl}}

#source prof.tcl
#profiler::add [info procs]
#source uptodate.tcl
#uptodate [self_path] [self_mtime]

initGUI
